/* DUPLICATOR MYSQL SCRIPT CREATED ON : 2017-02-24 19:36:38 */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` mediumblob NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=InnoDB AUTO_INCREMENT=614 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=509 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=236 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=39 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=39 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=76 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;


/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("7", "ThemingBasics_2017_March", "58b08b43348408082170224193635", "20", "2017-02-24 19:36:38", "kevinmcmillan", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-02-24 19:36:35\";s:7:\"Version\";s:6:\"1.1.32\";s:9:\"VersionWP\";s:5:\"4.7.2\";s:9:\"VersionDB\";s:6:\"5.5.42\";s:10:\"VersionPHP\";s:6:\"5.6.10\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";i:7;s:4:\"Name\";s:24:\"ThemingBasics_2017_March\";s:4:\"Hash\";s:29:\"58b08b43348408082170224193635\";s:8:\"NameHash\";s:54:\"ThemingBasics_2017_March_58b08b43348408082170224193635\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:57:\"/Applications/MAMP/htdocs/theming-basics/wp-snapshots/tmp\";s:8:\"StoreURL\";s:50:\"http://localhost:8888/theming-basics/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"ThemingBasics_2017_March_58b08b43348408082170224193635_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";s:13:\"kevinmcmillan\";s:7:\"Archive\";O:11:\"DUP_Archive\":13:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:4:\"File\";s:66:\"ThemingBasics_2017_March_58b08b43348408082170224193635_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:40:\"/Applications/MAMP/htdocs/theming-basics\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":6:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":4:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":5:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":2:{s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-02-24 19:36:35\";s:7:\"Version\";s:6:\"1.1.32\";s:9:\"VersionWP\";s:5:\"4.7.2\";s:9:\"VersionDB\";s:6:\"5.5.42\";s:10:\"VersionPHP\";s:6:\"5.6.10\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";N;s:4:\"Name\";s:24:\"ThemingBasics_2017_March\";s:4:\"Hash\";s:29:\"58b08b43348408082170224193635\";s:8:\"NameHash\";s:54:\"ThemingBasics_2017_March_58b08b43348408082170224193635\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:57:\"/Applications/MAMP/htdocs/theming-basics/wp-snapshots/tmp\";s:8:\"StoreURL\";s:50:\"http://localhost:8888/theming-basics/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";r:22;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";s:68:\"ThemingBasics_2017_March_58b08b43348408082170224193635_installer.php\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:52;}s:8:\"Database\";O:12:\"DUP_Database\":12:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:67:\"ThemingBasics_2017_March_58b08b43348408082170224193635_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:10:\"\0*\0Package\";r:1;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}}s:9:\"Installer\";r:74;s:8:\"Database\";r:87;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "http://localhost:8888/theming-basics", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "http://localhost:8888/theming-basics", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "Theming Basics", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "Just another WordPress site", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "kevinmc@shaw.ca", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "2", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "closed", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "20", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%category%/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("29", "rewrite_rules", "a:92:{s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:31:\".+?/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:41:\".+?/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:61:\".+?/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\".+?/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\".+?/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:37:\".+?/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:22:\"(.+?)/([^/]+)/embed/?$\";s:63:\"index.php?category_name=$matches[1]&name=$matches[2]&embed=true\";s:26:\"(.+?)/([^/]+)/trackback/?$\";s:57:\"index.php?category_name=$matches[1]&name=$matches[2]&tb=1\";s:46:\"(.+?)/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&feed=$matches[3]\";s:41:\"(.+?)/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&feed=$matches[3]\";s:34:\"(.+?)/([^/]+)/page/?([0-9]{1,})/?$\";s:70:\"index.php?category_name=$matches[1]&name=$matches[2]&paged=$matches[3]\";s:41:\"(.+?)/([^/]+)/comment-page-([0-9]{1,})/?$\";s:70:\"index.php?category_name=$matches[1]&name=$matches[2]&cpage=$matches[3]\";s:30:\"(.+?)/([^/]+)(?:/([0-9]+))?/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&page=$matches[3]\";s:20:\".+?/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:30:\".+?/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:50:\".+?/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:45:\".+?/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:45:\".+?/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:26:\".+?/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:38:\"(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:33:\"(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:14:\"(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:26:\"(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:33:\"(.+?)/comment-page-([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&cpage=$matches[2]\";s:8:\"(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";}", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:2:{i:0;s:25:\"duplicator/duplicator.php\";i:1;s:47:\"show-current-template/show-current-template.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("37", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("39", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("40", "template", "twentysixteen", "yes");
INSERT INTO `wp_options` VALUES("41", "stylesheet", "twentysixteen", "yes");
INSERT INTO `wp_options` VALUES("42", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("43", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("44", "comment_registration", "", "yes");
INSERT INTO `wp_options` VALUES("45", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("46", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("47", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("48", "db_version", "38590", "yes");
INSERT INTO `wp_options` VALUES("49", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("50", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("51", "blog_public", "0", "yes");
INSERT INTO `wp_options` VALUES("52", "default_link_category", "0", "yes");
INSERT INTO `wp_options` VALUES("53", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("54", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("55", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("56", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("57", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("58", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("59", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("60", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("61", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("62", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("63", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("64", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("65", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("66", "image_default_link_type", "none", "yes");
INSERT INTO `wp_options` VALUES("67", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("68", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("69", "close_comments_for_old_posts", "", "yes");
INSERT INTO `wp_options` VALUES("70", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("71", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("72", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("73", "page_comments", "", "yes");
INSERT INTO `wp_options` VALUES("74", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("75", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("76", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("77", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("78", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("79", "widget_text", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("80", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("81", "uninstall_plugins", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("82", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("83", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("84", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("85", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("86", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `wp_options` VALUES("88", "site_icon", "0", "yes");
INSERT INTO `wp_options` VALUES("89", "medium_large_size_w", "768", "yes");
INSERT INTO `wp_options` VALUES("90", "medium_large_size_h", "0", "yes");
INSERT INTO `wp_options` VALUES("91", "initial_db_version", "36686", "yes");
INSERT INTO `wp_options` VALUES("92", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:61:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("93", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("94", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("95", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("96", "widget_archives", "a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("97", "widget_meta", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("98", "sidebars_widgets", "a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:5:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:10:\"archives-2\";i:3;s:12:\"categories-2\";i:4;s:6:\"meta-2\";}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("99", "widget_pages", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("100", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("101", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("102", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("103", "cron", "a:4:{i:1488007691;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1488050910;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1488051105;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("116", "auto_core_update_notified", "a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:15:\"kevinmc@shaw.ca\";s:7:\"version\";s:5:\"4.5.6\";s:9:\"timestamp\";i:1487960197;}", "yes");
INSERT INTO `wp_options` VALUES("238", "theme_mods_twentysixteen", "a:1:{s:18:\"nav_menu_locations\";a:2:{s:7:\"primary\";i:7;s:6:\"social\";i:8;}}", "yes");
INSERT INTO `wp_options` VALUES("239", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("301", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("307", "duplicator_version_plugin", "1.1.32", "yes");
INSERT INTO `wp_options` VALUES("315", "current_theme", "Twenty Sixteen", "yes");
INSERT INTO `wp_options` VALUES("316", "theme_mods_theming-basics", "a:3:{i:0;b:0;s:18:\"nav_menu_locations\";a:4:{s:7:\"primary\";i:7;s:6:\"social\";i:8;s:7:\"footer1\";i:7;s:7:\"footer2\";i:7;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1468289924;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `wp_options` VALUES("317", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("318", "theme_mods_twentyfourteen", "a:3:{i:0;b:0;s:18:\"nav_menu_locations\";a:2:{s:7:\"primary\";i:7;s:6:\"social\";i:8;}s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1467582267;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";N;s:9:\"sidebar-3\";N;}}}", "yes");
INSERT INTO `wp_options` VALUES("319", "widget_widget_twentyfourteen_ephemera", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("351", "duplicator_settings", "a:10:{s:7:\"version\";s:6:\"1.1.32\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";b:0;s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";b:0;s:20:\"storage_htaccess_off\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("385", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("413", "duplicator_package_active", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-02-24 19:36:35\";s:7:\"Version\";s:6:\"1.1.32\";s:9:\"VersionWP\";s:5:\"4.7.2\";s:9:\"VersionDB\";s:6:\"5.5.42\";s:10:\"VersionPHP\";s:6:\"5.6.10\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";N;s:4:\"Name\";s:24:\"ThemingBasics_2017_March\";s:4:\"Hash\";s:29:\"58b08b43348408082170224193635\";s:8:\"NameHash\";s:54:\"ThemingBasics_2017_March_58b08b43348408082170224193635\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:57:\"/Applications/MAMP/htdocs/theming-basics/wp-snapshots/tmp\";s:8:\"StoreURL\";s:50:\"http://localhost:8888/theming-basics/wp-snapshots/\";s:8:\"ScanFile\";s:64:\"ThemingBasics_2017_March_58b08b43348408082170224193635_scan.json\";s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":13:{s:10:\"FilterDirs\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:40:\"/Applications/MAMP/htdocs/theming-basics\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:5:\"Files\";a:0:{}s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":6:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":4:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":5:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":2:{s:4:\"Core\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;}s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2017-02-24 19:36:35\";s:7:\"Version\";s:6:\"1.1.32\";s:9:\"VersionWP\";s:5:\"4.7.2\";s:9:\"VersionDB\";s:6:\"5.5.42\";s:10:\"VersionPHP\";s:6:\"5.6.10\";s:9:\"VersionOS\";s:6:\"Darwin\";s:2:\"ID\";N;s:4:\"Name\";s:24:\"ThemingBasics_2017_March\";s:4:\"Hash\";s:29:\"58b08b43348408082170224193635\";s:8:\"NameHash\";s:54:\"ThemingBasics_2017_March_58b08b43348408082170224193635\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:9:\"StorePath\";s:57:\"/Applications/MAMP/htdocs/theming-basics/wp-snapshots/tmp\";s:8:\"StoreURL\";s:50:\"http://localhost:8888/theming-basics/wp-snapshots/\";s:8:\"ScanFile\";N;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";N;s:6:\"WPUser\";N;s:7:\"Archive\";r:22;s:9:\"Installer\";O:13:\"DUP_Installer\":12:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:12:\"OptsSSLAdmin\";i:0;s:12:\"OptsSSLLogin\";i:0;s:11:\"OptsCacheWP\";i:0;s:13:\"OptsCachePath\";i:0;s:10:\"OptsURLNew\";s:0:\"\";s:10:\"\0*\0Package\";r:52;}s:8:\"Database\";O:12:\"DUP_Database\":12:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:10:\"\0*\0Package\";r:52;s:25:\"\0DUP_Database\0dbStorePath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}}}s:9:\"Installer\";r:74;s:8:\"Database\";r:87;}", "yes");
INSERT INTO `wp_options` VALUES("459", "_transient_theming_basics_categories", "2", "yes");
INSERT INTO `wp_options` VALUES("460", "theme_mods_midterm", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:4:{s:7:\"primary\";i:7;s:6:\"social\";i:8;s:7:\"footer1\";i:7;s:7:\"footer2\";i:7;}s:12:\"header_image\";s:13:\"remove-header\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1487964871;s:4:\"data\";a:2:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:5:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:10:\"archives-2\";i:3;s:12:\"categories-2\";i:4;s:6:\"meta-2\";}}}}", "yes");
INSERT INTO `wp_options` VALUES("502", "_transient_twentysixteen_categories", "2", "yes");
INSERT INTO `wp_options` VALUES("583", "_site_transient_timeout_theme_roots", "1487966750", "no");
INSERT INTO `wp_options` VALUES("584", "_site_transient_theme_roots", "a:1:{s:13:\"twentysixteen\";s:7:\"/themes\";}", "no");
INSERT INTO `wp_options` VALUES("587", "_site_transient_timeout_browser_178b05872a06bb6e5b247c8fdfeddd3b", "1488569523", "yes");
INSERT INTO `wp_options` VALUES("588", "_site_transient_browser_178b05872a06bb6e5b247c8fdfeddd3b", "a:9:{s:8:\"platform\";s:9:\"Macintosh\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:12:\"56.0.2924.87\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("589", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1488007925", "no");
INSERT INTO `wp_options` VALUES("590", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:49:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"https://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 01 Feb 2017 15:58:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"https://wordpress.org/?v=4.8-alpha-40109\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 4.7.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Jan 2017 19:34:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4676\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:357:\"WordPress 4.7.2 is now available. This is a security release for all previous versions and we strongly encourage you to update your sites immediately. WordPress versions 4.7.1 and earlier are affected by three security issues: The user interface for assigning taxonomy terms in Press This is shown to users who do not have permissions to use it. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Aaron D. Campbell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2142:\"<p>WordPress 4.7.2 is now available. This is a <strong>security release</strong> for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>WordPress versions 4.7.1 and earlier are affected by three security issues:</p>\n<ol>\n<li>The user interface for assigning taxonomy terms in Press This is shown to users who do not have permissions to use it. Reported by David Herrera of <a href=\"https://www.alleyinteractive.com/\">Alley Interactive</a>.</li>\n<li><code>WP_Query</code> is vulnerable to a SQL injection (SQLi) when passing unsafe data. WordPress core is not directly vulnerable to this issue, but we&#8217;ve added hardening to prevent plugins and themes from accidentally causing a vulnerability. Reported by <a href=\"https://github.com/mjangda\">Mo Jangda</a> (batmoo).</li>\n<li>A cross-site scripting (XSS) vulnerability was discovered in the posts list table. Reported by <a href=\"https://iandunn.name/\">Ian Dunn</a> of the WordPress Security Team.</li>\n<li>An unauthenticated privilege escalation vulnerability was discovered in a REST API endpoint. Reported by <a href=\"https://twitter.com/MarcS0h\">Marc-Alexandre Montpas</a> of Sucuri Security. *</li>\n</ol>\n<p>Thank you to the reporters of these issues for practicing <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">responsible disclosure</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.7.2</a> or venture over to Dashboard → Updates and simply click “Update Now.” Sites that support automatic background updates are already beginning to update to WordPress 4.7.2.</p>\n<p>Thanks to everyone who contributed to 4.7.2.</p>\n<p>* Update: An additional serious vulnerability was fixed in this release and public disclosure was delayed. For more information on this vulnerability, additional mitigation steps taken, and an explanation for why disclosure was delayed, please read <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/\">Disclosure of Additional Security Fix in WordPress 4.7.2</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4676\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress 4.7.1 Security and Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"https://wordpress.org/news/2017/01/wordpress-4-7-1-security-and-maintenance-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Jan 2017 03:53:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4650\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:375:\"WordPress 4.7 has been downloaded over 10 million times since its release on December 6, 2016 and we are pleased to announce the immediate availability of WordPress 4.7.1. This is a security release for all previous versions and we strongly encourage you to update your sites immediately. WordPress versions 4.7 and earlier are affected by eight security issues: [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Aaron D. Campbell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6520:\"<p>WordPress 4.7 has been <a href=\"https://wordpress.org/download/counter/\">downloaded over 10 million times</a> since its release on December 6, 2016 and we are pleased to announce the immediate availability of WordPress 4.7.1. This is a <strong>security release</strong> for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>WordPress versions 4.7 and earlier are affected by eight security issues:</p>\n<ol>\n<li>Remote code execution (RCE) in PHPMailer &#8211; <em>No specific issue appears to affect WordPress</em> or any of the major plugins we investigated but, out of an abundance of caution, we updated PHPMailer in this release. This issue was fixed in PHPMailer thanks to <a href=\"https://legalhackers.com/\">Dawid Golunski</a> and <a href=\"https://twitter.com/Zenexer\">Paul Buonopane</a>.</li>\n<li>The REST API exposed user data for all users who had authored a post of a public post type. WordPress 4.7.1 limits this to only post types which have specified that they should be shown within the REST API. Reported by <a href=\"https://poststatus.com/\">Krogsgard</a> and <a href=\"https://ithemes.com/\">Chris Jean</a>.</li>\n<li>Cross-site scripting (XSS) via the plugin name or version header on <code>update-core.php</code>. Reported by <a href=\"https://dominikschilling.de/\">Dominik Schilling</a> of the WordPress Security Team.</li>\n<li>Cross-site request forgery (CSRF) bypass via uploading a Flash file. Reported by <a href=\"https://twitter.com/Abdulahhusam\">Abdullah Hussam</a>.</li>\n<li>Cross-site scripting (XSS) via theme name fallback. Reported by <a href=\"https://pentest.blog/\">Mehmet Ince</a>.</li>\n<li>Post via email checks <code>mail.example.com</code> if default settings aren&#8217;t changed. Reported by John Blackbourn of the WordPress Security Team.</li>\n<li>A cross-site request forgery (CSRF) was discovered in the accessibility mode of widget editing. Reported by <a href=\"https://dk.linkedin.com/in/ronni-skansing-36143b65\">Ronnie Skansing</a>.</li>\n<li>Weak cryptographic security for multisite activation key. Reported by <a href=\"https://itsjack.cc/\">Jack</a>.</li>\n</ol>\n<p>Thank you to the reporters for practicing <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">responsible disclosure</a>.</p>\n<p>In addition to the security issues above, WordPress 4.7.1 fixes 62 bugs from 4.7. For more information, see the <a href=\"https://codex.wordpress.org/Version_4.7.1\">release notes</a> or consult the <a href=\"https://core.trac.wordpress.org/query?milestone=4.7.1\">list of changes</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.7.1</a> or venture over to Dashboard → Updates and simply click “Update Now.” Sites that support automatic background updates are already beginning to update to WordPress 4.7.1.</p>\n<p>Thanks to everyone who contributed to 4.7.1: <a href=\"https://profiles.wordpress.org/aaroncampbell/\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/jorbin/\">Aaron Jorbin</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein/\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/afercia/\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/azaozz/\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/gitlost/\">bonger</a>, <a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone Gorges</a>, <a href=\"https://profiles.wordpress.org/chandrapatel/\">Chandra Patel</a>, <a href=\"https://profiles.wordpress.org/christian1012/\">Christian Chung</a>, <a href=\"https://profiles.wordpress.org/dlh/\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dshanske/\">David Shanske</a>, <a href=\"https://profiles.wordpress.org/dd32/\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/ocean90/\">Dominik Schilling (ocean90)</a>, <a href=\"https://profiles.wordpress.org/dreamon11/\">DreamOn11</a>, <a href=\"https://profiles.wordpress.org/chopinbach/\">Edwin Cromley</a>, <a href=\"https://profiles.wordpress.org/iseulde/\">Ella van Dorpe</a>, <a href=\"https://profiles.wordpress.org/pento/\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/hristo-sg/\">Hristo Pandjarov</a>, <a href=\"https://profiles.wordpress.org/jnylen0/\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/jblz/\">Jeff Bowen</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt/\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jpry/\">Jeremy Pry</a>, <a href=\"https://profiles.wordpress.org/joehoyle/\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/joemcgill/\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/johnbillion/\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/kkoppenhaver/\">Keanan Koppenhaver</a>, <a href=\"https://profiles.wordpress.org/obenland/\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/laurelfulford/\">laurelfulford</a>, <a href=\"https://profiles.wordpress.org/tyxla/\">Marin Atanasov</a>, <a href=\"https://profiles.wordpress.org/mattyrob/\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/monikarao/\">monikarao</a>, <a href=\"https://profiles.wordpress.org/natereist/\">Nate Reist</a>, <a href=\"https://profiles.wordpress.org/celloexpressions/\">Nick Halsey</a>, <a href=\"https://profiles.wordpress.org/nikschavan/\">Nikhil Chavan</a>, <a href=\"https://profiles.wordpress.org/nullvariable/\">nullvariable</a>, <a href=\"https://profiles.wordpress.org/sirbrillig/\">Payton Swick</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc/\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/presskopp/\">Presskopp</a>, <a href=\"https://profiles.wordpress.org/rachelbaker/\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/rmccue/\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/sanketparmar/\">Sanket Parmar</a>, <a href=\"https://profiles.wordpress.org/sebastianpisula/\">Sebastian Pisula</a>, <a href=\"https://profiles.wordpress.org/sfpt/\">sfpt</a>, <a href=\"https://profiles.wordpress.org/shazahm1hotmailcom/\">shazahm1</a>, <a href=\"https://profiles.wordpress.org/sstoqnov/\">Stanimir Stoyanov</a>, <a href=\"https://profiles.wordpress.org/stevenkword/\">Steven Word</a>, <a href=\"https://profiles.wordpress.org/szaqal21/\">szaqal21</a>, <a href=\"https://profiles.wordpress.org/timph/\">timph</a>, <a href=\"https://profiles.wordpress.org/voldemortensen/\">voldemortensen</a>, <a href=\"https://profiles.wordpress.org/vortfu/\">vortfu</a>, and <a href=\"https://profiles.wordpress.org/westonruter/\">Weston Ruter</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4650\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:36:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n	\n\n\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"WordPress 4.7 “Vaughan”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"https://wordpress.org/news/2016/12/vaughan/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 06 Dec 2016 19:27:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4596\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:240:\"Version 4.7 of WordPress, named “Vaughan” in honor of legendary jazz vocalist Sarah \"Sassy\" Vaughan, is available for download or update in your WordPress dashboard. New features in 4.7 help you get your site set up the way you want it.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"enclosure\";a:3:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:60:\"https://wordpress.org/news/files/2016/12/starter-content.mp4\";s:6:\"length\";s:7:\"3736020\";s:4:\"type\";s:9:\"video/mp4\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:59:\"https://wordpress.org/news/files/2016/12/edit-shortcuts.mp4\";s:6:\"length\";s:7:\"1127483\";s:4:\"type\";s:9:\"video/mp4\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:3:\"url\";s:58:\"https://wordpress.org/news/files/2016/12/video-headers.mp4\";s:6:\"length\";s:7:\"1549803\";s:4:\"type\";s:9:\"video/mp4\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:45498:\"<p>Version 4.7 of WordPress, named “Vaughan” in honor of legendary jazz vocalist Sarah &#8220;Sassy&#8221; Vaughan, is available for download or update in your WordPress dashboard. New features in 4.7 help you get your site set up the way you want it.</p>\n<div id=\"v-AHz0Ca46-1\" class=\"video-player\"><video id=\"v-AHz0Ca46-1-video\" width=\"632\" height=\"354\" poster=\"https://videos.files.wordpress.com/AHz0Ca46/wp4-7-vaughan-r8-mastered_scruberthumbnail_0.jpg\" controls=\"true\" preload=\"metadata\" dir=\"ltr\" lang=\"en\"><source src=\"https://videos.files.wordpress.com/AHz0Ca46/wp4-7-vaughan-r8-mastered_dvd.mp4\" type=\"video/mp4; codecs=&quot;avc1.64001E, mp4a.40.2&quot;\" /><source src=\"https://videos.files.wordpress.com/AHz0Ca46/wp4-7-vaughan-r8-mastered_fmt1.ogv\" type=\"video/ogg; codecs=&quot;theora, vorbis&quot;\" /><div><img alt=\"Introducing WordPress 4.7\" src=\"https://i1.wp.com/videos.files.wordpress.com/AHz0Ca46/wp4-7-vaughan-r8-mastered_scruberthumbnail_0.jpg?resize=632%2C354&#038;ssl=1\" data-recalc-dims=\"1\" /></div><p>Introducing WordPress 4.7</p></video></div>\n<hr />\n<h2 style=\"text-align:center\">Presenting Twenty Seventeen</h2>\n<p>A brand new default theme brings your site to life with immersive featured images and video headers.</p>\n<p><img class=\"alignnone wp-image-4618 size-large\" src=\"https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Twenty-Seventeen-1.jpg?resize=632%2C356&#038;ssl=1\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Twenty-Seventeen-1.jpg?resize=1024%2C576&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Twenty-Seventeen-1.jpg?resize=300%2C169&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Twenty-Seventeen-1.jpg?resize=768%2C432&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Twenty-Seventeen-1.jpg?w=1600&amp;ssl=1 1600w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Twenty-Seventeen-1.jpg?w=1264&amp;ssl=1 1264w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></p>\n<p>Twenty Seventeen focuses on business sites and features a customizable front page with multiple sections. Personalize it with widgets, navigation, social menus, a logo, custom colors, and more. Our default theme for 2017 works great in many languages, on any device, and for a wide range of users.</p>\n<hr />\n<h2 style=\"text-align:center\">Your Site, Your Way</h2>\n<p>WordPress 4.7 adds new features to the customizer to help take you through the initial setup of a theme, with non-destructive live previews of all your changes in one uninterrupted workflow.</p>\n<h3>Theme Starter Content</h3>\n<div style=\"width: 632px;\" class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<video class=\"wp-video-shortcode\" id=\"video-4596-1\" width=\"632\" height=\"346\" loop=\"1\" autoplay=\"1\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"https://wordpress.org/news/files/2016/12/starter-content.mp4?_=1\" /><a href=\"https://wordpress.org/news/files/2016/12/starter-content.mp4\">https://wordpress.org/news/files/2016/12/starter-content.mp4</a></video></div>\n<p>To help give you a solid base to build from, individual themes can provide starter content that appears when you go to customize your brand new site. This can range from placing a business information widget in the best location to providing a sample menu with social icon links to a static front page complete with beautiful images. Don’t worry &#8211; nothing new will appear on the live site until you’re ready to save and publish your initial theme setup.</p>\n<div style=\"float: left;width: 48%;margin: 0\">\n<h3>Edit Shortcuts</h3>\n<div style=\"width: 300px;\" class=\"wp-video\"><video class=\"wp-video-shortcode\" id=\"video-4596-2\" width=\"300\" height=\"173\" poster=\"https://wordpress.org/news/files/2016/12/4.7-—-Edit-Shortcuts.jpg\" loop=\"1\" autoplay=\"1\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"https://wordpress.org/news/files/2016/12/edit-shortcuts.mp4?_=2\" /><a href=\"https://wordpress.org/news/files/2016/12/edit-shortcuts.mp4\">https://wordpress.org/news/files/2016/12/edit-shortcuts.mp4</a></video></div>\n<p>Visible icons appear to show you which parts of your site can be customized while live previewing. Click on a shortcut and get straight to editing. Paired with starter content, getting started with customizing your site is faster than ever.</p>\n</div>\n<div style=\"float: right;width: 48%;margin: 0\">\n<h3>Video Headers</h3>\n<div style=\"width: 300px;\" class=\"wp-video\"><video class=\"wp-video-shortcode\" id=\"video-4596-3\" width=\"300\" height=\"173\" poster=\"https://wordpress.org/news/files/2016/12/4.7-—-Header-Video.jpg\" loop=\"1\" autoplay=\"1\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"https://wordpress.org/news/files/2016/12/video-headers.mp4?_=3\" /><a href=\"https://wordpress.org/news/files/2016/12/video-headers.mp4\">https://wordpress.org/news/files/2016/12/video-headers.mp4</a></video></div>\n<p>Sometimes a big atmospheric video as a moving header image is just what you need to showcase your wares; go ahead and try it out with Twenty Seventeen. Need some video inspiration? Try searching for sites with video headers available for download and use.</p>\n</div>\n<div style=\"clear: both\"></div>\n<div style=\"float: left;width: 48%;margin: 0\">\n<h3>Smoother Menu Building</h3>\n<p><img class=\"wp-image-4606 size-medium alignright\" src=\"https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-Nav.jpg?resize=300%2C158&#038;ssl=1\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-Nav.jpg?resize=300%2C158&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-Nav.jpg?w=760&amp;ssl=1 760w\" sizes=\"(max-width: 300px) 100vw, 300px\" data-recalc-dims=\"1\" /></p>\n<p>Many menus for sites contain links to the pages of your site, but what happens when you don’t have any pages yet? Now you can add new pages while building menus instead of leaving the customizer and abandoning your changes. Once you’ve published your customizations, you’ll have new pages ready for you to fill with content.</p>\n</div>\n<div style=\"float: right;width: 48%;margin: 0\">\n<h3>Custom CSS</h3>\n<p><img class=\"wp-image-4607 size-medium alignright\" src=\"https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-CSS.jpg?resize=300%2C158&#038;ssl=1\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-CSS.jpg?resize=300%2C158&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-CSS.jpg?w=760&amp;ssl=1 760w\" sizes=\"(max-width: 300px) 100vw, 300px\" data-recalc-dims=\"1\" /></p>\n<p>Sometimes you just need a few visual tweaks to make your site perfect. WordPress 4.7 allows you to add custom CSS and instantly see how your changes affect your site. The live preview allows you to work quickly without page refreshes slowing you down.</p>\n</div>\n<div style=\"clear: both\"></div>\n<hr />\n<div style=\"float: left;width: 48%;margin: 0\">\n<h3>PDF Thumbnail Previews</h3>\n<p><img class=\"wp-image-4609 size-medium alignright\" src=\"https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-PDF.jpg?resize=300%2C158&#038;ssl=1\" srcset=\"https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-PDF.jpg?resize=300%2C158&amp;ssl=1 300w, https://i1.wp.com/wordpress.org/news/files/2016/12/4.7-—-PDF.jpg?w=760&amp;ssl=1 760w\" sizes=\"(max-width: 300px) 100vw, 300px\" data-recalc-dims=\"1\" /></p>\n<p>Managing your document collection is easier with WordPress 4.7. Uploading PDFs will generate thumbnail images so you can more easily distinguish between all your documents.</p>\n</div>\n<div style=\"float: right;width: 48%;margin: 0\">\n<h3>Dashboard in your language</h3>\n<p><img class=\"wp-image-4608 size-medium alignright\" src=\"https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Language.jpg?resize=300%2C158&#038;ssl=1\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Language.jpg?resize=300%2C158&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-Language.jpg?w=760&amp;ssl=1 760w\" sizes=\"(max-width: 300px) 100vw, 300px\" data-recalc-dims=\"1\" /></p>\n<p>Just because your site is in one language doesn’t mean that everybody helping manage it prefers that language for their admin. Add more languages to your site and a user language option will show up in your user’s profiles.</p>\n</div>\n<div style=\"clear: both\"></div>\n<hr />\n<h2 style=\"text-align:center\">Introducing REST API Content Endpoints</h2>\n<p>WordPress 4.7 comes with REST API endpoints for posts, comments, terms, users, meta, and settings.</p>\n<p><img class=\"size-large wp-image-4600 alignnone\" src=\"https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-API.jpg?resize=632%2C205&#038;ssl=1\" alt=\"\" srcset=\"https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-API.jpg?resize=1024%2C332&amp;ssl=1 1024w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-API.jpg?resize=300%2C97&amp;ssl=1 300w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-API.jpg?resize=768%2C249&amp;ssl=1 768w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-API.jpg?w=1264&amp;ssl=1 1264w, https://i2.wp.com/wordpress.org/news/files/2016/12/4.7-—-API.jpg?w=1896&amp;ssl=1 1896w\" sizes=\"(max-width: 632px) 100vw, 632px\" data-recalc-dims=\"1\" /></p>\n<p>Content endpoints provide machine-readable external access to your WordPress site with a clear, standards-driven interface, paving the way for new and innovative methods of interacting with sites through plugins, themes, apps, and beyond. Ready to get started with development? <a href=\"https://developer.wordpress.org/rest-api/reference/\">Check out the REST API reference.</a></p>\n<hr />\n<h2 style=\"text-align:center\">Even More Developer Happiness <img src=\"https://s.w.org/images/core/emoji/2.2.1/72x72/1f60a.png\" alt=\"😊\" class=\"wp-smiley\" style=\"height: 1em; max-height: 1em;\" /></h2>\n<h3><a href=\"https://make.wordpress.org/core/2016/11/03/post-type-templates-in-4-7/\">Post Type Templates</a></h3>\n<p>By opening up the page template functionality to all post types, theme developers have even more flexibility with the WordPress template hierarchy.</p>\n<h3>More Theme API Goodies</h3>\n<p>WordPress 4.7 includes <a href=\"https://make.wordpress.org/core/2016/09/09/new-functions-hooks-and-behaviour-for-theme-developers-in-wordpress-4-7/\">new functions, hooks, and behavior</a> for theme developers.</p>\n<h3><a href=\"https://make.wordpress.org/core/2016/10/04/custom-bulk-actions/\">Custom Bulk Actions</a></h3>\n<p>List tables, now with more than bulk edit and delete.</p>\n<h3><a href=\"https://make.wordpress.org/core/2016/09/08/wp_hook-next-generation-actions-and-filters/\"><code>WP_Hook</code></a></h3>\n<p>The code that lies beneath actions and filters has been overhauled and modernized, fixing bugs along the way.</p>\n<h3>Settings Registration API</h3>\n<p>register_setting() <a href=\"https://make.wordpress.org/core/2016/10/26/registering-your-settings-in-wordpress-4-7/\">has been enhanced</a> to include type, description, and REST API visibility.</p>\n<h3><a href=\"https://make.wordpress.org/core/2016/10/12/customize-changesets-technical-design-decisions/\">Customize Changesets</a></h3>\n<p>Customize changesets make changes in the customizer persistent, like autosave drafts. They also make exciting new features like starter content possible.</p>\n<hr />\n<h2 style=\"text-align:center\">The Squad</h2>\n<p>This release was led by <a href=\"https://helen.blog\">Helen Hou-Sandí</a>, backed up by <a href=\"https://profiles.wordpress.org/jbpaul17\">Jeff Paul</a> and <a href=\"http://aaron.jorb.in/\">Aaron Jorbin</a> as Release Deputies, and with the help of these fine individuals. There are 482 contributors with props in this release—the most ever—with 205 of them contributing for the first time. Pull up some sassy Sarah Vaughan on your music service of choice, and check out some of their profiles:</p>\n<a href=\"https://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"https://profiles.wordpress.org/abrightclearweb\">abrightclearweb</a>, <a href=\"https://profiles.wordpress.org/ibachal\">Achal Jain</a>, <a href=\"https://profiles.wordpress.org/achbed\">achbed</a>, <a href=\"https://profiles.wordpress.org/acmethemes\">Acme Themes</a>, <a href=\"https://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"https://profiles.wordpress.org/adammacias\">adammacias</a>, <a href=\"https://profiles.wordpress.org/mrahmadawais\">Ahmad Awais</a>, <a href=\"https://profiles.wordpress.org/ahmadawais\">ahmadawais</a>, <a href=\"https://profiles.wordpress.org/airesvsg\">airesvsg</a>, <a href=\"https://profiles.wordpress.org/ajoah\">ajoah</a>, <a href=\"https://profiles.wordpress.org/akibjorklund\">Aki Bj&#246;rklund</a>, <a href=\"https://profiles.wordpress.org/akshayvinchurkar\">akshayvinchurkar</a>, <a href=\"https://profiles.wordpress.org/schlessera\">Alain Schlesser</a>, <a href=\"https://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"https://profiles.wordpress.org/xavortm\">Alex Dimitrov</a>, <a href=\"https://profiles.wordpress.org/ironpaperweight\">Alex Hon</a>, <a href=\"https://profiles.wordpress.org/alex27\">alex27</a>, <a href=\"https://profiles.wordpress.org/allancole\">allancole</a>, <a href=\"https://profiles.wordpress.org/arush\">Amanda Rush</a>, <a href=\"https://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"https://profiles.wordpress.org/andrewp-2\">Andreas Panag</a>, <a href=\"https://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"https://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"https://profiles.wordpress.org/rarst\">Andrey \"Rarst\" Savchenko</a>, <a href=\"https://profiles.wordpress.org/andizer\">Andy Meerwaldt</a>, <a href=\"https://profiles.wordpress.org/kelderic\">Andy Mercer</a>, <a href=\"https://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"https://profiles.wordpress.org/aniketpant\">Aniket Pant</a>, <a href=\"https://profiles.wordpress.org/anilbasnet\">Anil Basnet</a>, <a href=\"https://profiles.wordpress.org/ankit-k-gupta\">Ankit K Gupta</a>, <a href=\"https://profiles.wordpress.org/ahortin\">Anthony Hortin</a>, <a href=\"https://profiles.wordpress.org/antisilent\">antisilent</a>, <a href=\"https://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"https://profiles.wordpress.org/zuige\">Antti Kuosmanen</a>, <a href=\"https://profiles.wordpress.org/apokalyptik\">apokalyptik</a>, <a href=\"https://profiles.wordpress.org/artoliukkonen\">artoliukkonen</a>, <a href=\"https://profiles.wordpress.org/ideag\">Arunas Liuiza</a>, <a href=\"https://profiles.wordpress.org/attitude\">attitude</a>, <a href=\"https://profiles.wordpress.org/backermann\">backermann</a>, <a href=\"https://profiles.wordpress.org/b-07\">Bappi</a>, <a href=\"https://profiles.wordpress.org/bcole808\">Ben Cole</a>, <a href=\"https://profiles.wordpress.org/kau-boy\">Bernhard Kau</a>, <a href=\"https://profiles.wordpress.org/binarymoon\">BinaryMoon</a>, <a href=\"https://profiles.wordpress.org/birgire\">Birgir Erlendsson (birgire)</a>, <a href=\"https://profiles.wordpress.org/bjornw\">BjornW</a>, <a href=\"https://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"https://profiles.wordpress.org/boblinthorst\">boblinthorst</a>, <a href=\"https://profiles.wordpress.org/boboudreau\">boboudreau</a>, <a href=\"https://profiles.wordpress.org/gitlost\">bonger</a>, <a href=\"https://profiles.wordpress.org/boonebgorges\">Boone B. Gorges</a>, <a href=\"https://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"https://profiles.wordpress.org/brainstormforce\">Brainstorm Force</a>, <a href=\"https://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"https://profiles.wordpress.org/brianhogg\">Brian Hogg</a>, <a href=\"https://profiles.wordpress.org/krogsgard\">Brian Krogsgard</a>, <a href=\"https://profiles.wordpress.org/bronsonquick\">Bronson Quick</a>, <a href=\"https://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"https://profiles.wordpress.org/caseypatrickdriscoll\">Casey Driscoll</a>, <a href=\"https://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"https://profiles.wordpress.org/chandrapatel\">Chandra Patel</a>, <a href=\"https://profiles.wordpress.org/chaos-engine\">Chaos Engine</a>, <a href=\"https://profiles.wordpress.org/cheeserolls\">cheeserolls</a>, <a href=\"https://profiles.wordpress.org/chesio\">chesio</a>, <a href=\"https://profiles.wordpress.org/ketuchetan\">chetansatasiya</a>, <a href=\"https://profiles.wordpress.org/choongsavvii\">choong</a>, <a href=\"https://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"https://profiles.wordpress.org/chredd\">chredd</a>, <a href=\"https://profiles.wordpress.org/chrisjean\">Chris Jean</a>, <a href=\"https://profiles.wordpress.org/cmmarslender\">Chris Marslender</a>, <a href=\"https://profiles.wordpress.org/chris_d2d\">Chris Smith</a>, <a href=\"https://profiles.wordpress.org/chrisvanpatten\">Chris Van Patten</a>, <a href=\"https://profiles.wordpress.org/chriswiegman\">Chris Wiegman</a>, <a href=\"https://profiles.wordpress.org/chriscct7\">chriscct7</a>, <a href=\"https://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"https://profiles.wordpress.org/christian1012\">Christian Chung</a>, <a href=\"https://profiles.wordpress.org/cwpnolen\">Christian Nolen</a>, <a href=\"https://profiles.wordpress.org/needle\">Christian Wach</a>, <a href=\"https://profiles.wordpress.org/christophherr\">Christoph Herr</a>, <a href=\"https://profiles.wordpress.org/clarionwpdeveloper\">Clarion Technologies</a>, <a href=\"https://profiles.wordpress.org/claudiosanches\">Claudio Sanches</a>, <a href=\"https://profiles.wordpress.org/claudiosmweb\">Claudio Sanches</a>, <a href=\"https://profiles.wordpress.org/claudiolabarbera\">ClaudioLaBarbera</a>, <a href=\"https://profiles.wordpress.org/codemovementpk\">codemovement.pk</a>, <a href=\"https://profiles.wordpress.org/coderkevin\">coderkevin</a>, <a href=\"https://profiles.wordpress.org/codfish\">codfish</a>, <a href=\"https://profiles.wordpress.org/coreymcollins\">coreymcollins</a>, <a href=\"https://profiles.wordpress.org/curdin\">Curdin Krummenacher</a>, <a href=\"https://profiles.wordpress.org/cgrymala\">Curtiss Grymala</a>, <a href=\"https://profiles.wordpress.org/cdog\">Cătălin Dogaru</a>, <a href=\"https://profiles.wordpress.org/danhgilmore\">danhgilmore</a>, <a href=\"https://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber </a>, <a href=\"https://profiles.wordpress.org/danielkanchev\">Daniel Kanchev</a>, <a href=\"https://profiles.wordpress.org/danielpietrasik\">Daniel Pietrasik</a>, <a href=\"https://profiles.wordpress.org/mte90\">Daniele Scasciafratte</a>, <a href=\"https://profiles.wordpress.org/dllh\">Daryl L. L. Houston (dllh)</a>, <a href=\"https://profiles.wordpress.org/davepullig\">Dave Pullig</a>, <a href=\"https://profiles.wordpress.org/goto10\">Dave Romsey (goto10)</a>, <a href=\"https://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"https://profiles.wordpress.org/turtlepod\">David Chandra Purnama</a>, <a href=\"https://profiles.wordpress.org/dlh\">David Herrera</a>, <a href=\"https://profiles.wordpress.org/dglingren\">David Lingren</a>, <a href=\"https://profiles.wordpress.org/davidmosterd\">David Mosterd</a>, <a href=\"https://profiles.wordpress.org/dshanske\">David Shanske</a>, <a href=\"https://profiles.wordpress.org/davidbhayes\">davidbhayes</a>, <a href=\"https://profiles.wordpress.org/folletto\">Davide \'Folletto\' Casali</a>, <a href=\"https://profiles.wordpress.org/deeptiboddapati\">deeptiboddapati</a>, <a href=\"https://profiles.wordpress.org/delphinus\">delphinus</a>, <a href=\"https://profiles.wordpress.org/deltafactory\">deltafactory</a>, <a href=\"https://profiles.wordpress.org/denis-de-bernardy\">Denis de Bernardy</a>, <a href=\"https://profiles.wordpress.org/valendesigns\">Derek Herman</a>, <a href=\"https://profiles.wordpress.org/pcfreak30\">Derrick Hammer</a>, <a href=\"https://profiles.wordpress.org/derrickkoo\">Derrick Koo</a>, <a href=\"https://profiles.wordpress.org/dimchik\">dimchik</a>, <a href=\"https://profiles.wordpress.org/dineshc\">Dinesh Chouhan</a>, <a href=\"https://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"https://profiles.wordpress.org/dipeshkakadiya\">dipeshkakadiya</a>, <a href=\"https://profiles.wordpress.org/dmsnell\">dmsnell</a>, <a href=\"https://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"https://profiles.wordpress.org/dotancohen\">Dotan Cohen</a>, <a href=\"https://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"https://profiles.wordpress.org/doughamlin\">doughamlin</a>, <a href=\"https://profiles.wordpress.org/dreamon11\">DreamOn11</a>, <a href=\"https://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"https://profiles.wordpress.org/duncanjbrown\">duncanjbrown</a>, <a href=\"https://profiles.wordpress.org/dungengronovius\">dungengronovius</a>, <a href=\"https://profiles.wordpress.org/dylanauty\">DylanAuty</a>, <a href=\"https://profiles.wordpress.org/hurtige\">Eddie Hurtig</a>, <a href=\"https://profiles.wordpress.org/oso96_2000\">Eduardo Reveles</a>, <a href=\"https://profiles.wordpress.org/chopinbach\">Edwin Cromley</a>, <a href=\"https://profiles.wordpress.org/electricfeet\">ElectricFeet</a>, <a href=\"https://profiles.wordpress.org/eliorivero\">Elio Rivero</a>, <a href=\"https://profiles.wordpress.org/iseulde\">Ella Iseulde Van Dorpe</a>, <a href=\"https://profiles.wordpress.org/elyobo\">elyobo</a>, <a href=\"https://profiles.wordpress.org/enodekciw\">enodekciw</a>, <a href=\"https://profiles.wordpress.org/enshrined\">enshrined</a>, <a href=\"https://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"https://profiles.wordpress.org/pushred\">Eric Lanehart</a>, <a href=\"https://profiles.wordpress.org/eherman24\">Evan Herman</a>, <a href=\"https://profiles.wordpress.org/flixos90\">Felix Arntz</a>, <a href=\"https://profiles.wordpress.org/fencer04\">Fencer04</a>, <a href=\"https://profiles.wordpress.org/florianbrinkmann\">Florian Brinkmann</a>, <a href=\"https://profiles.wordpress.org/mista-flo\">Florian TIAR</a>, <a href=\"https://profiles.wordpress.org/foliovision\">FolioVision</a>, <a href=\"https://profiles.wordpress.org/fomenkoandrey\">fomenkoandrey</a>, <a href=\"https://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"https://profiles.wordpress.org/fjarrett\">Frankie Jarrett</a>, <a href=\"https://profiles.wordpress.org/frankiet\">frankiet</a>, <a href=\"https://profiles.wordpress.org/akeif\">Fred</a>, <a href=\"https://profiles.wordpress.org/frozzare\">Fredrik Forsmo</a>, <a href=\"https://profiles.wordpress.org/fuscata\">fuscata</a>, <a href=\"https://profiles.wordpress.org/gma992\">Gabriel Maldonado</a>, <a href=\"https://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"https://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"https://profiles.wordpress.org/geekysoft\">Geeky Software</a>, <a href=\"https://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"https://profiles.wordpress.org/goranseric\">Goran &#352;erić</a>, <a href=\"https://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"https://profiles.wordpress.org/grantderepas\">Grant Derepas</a>, <a href=\"https://profiles.wordpress.org/tivnet\">Gregory Karpinsky (@tivnet)</a>, <a href=\"https://profiles.wordpress.org/hardeepasrani\">Hardeep Asrani</a>, <a href=\"https://profiles.wordpress.org/henrywright\">Henry Wright</a>, <a href=\"https://profiles.wordpress.org/hiddenpearls\">hiddenpearls</a>, <a href=\"https://profiles.wordpress.org/hnle\">Hinaloe</a>, <a href=\"https://profiles.wordpress.org/hristo-sg\">Hristo Pandjarov</a>, <a href=\"https://profiles.wordpress.org/hugobaeta\">Hugo Baeta</a>, <a href=\"https://profiles.wordpress.org/polevaultweb\">Iain Poulson</a>, <a href=\"https://profiles.wordpress.org/iamjolly\">iamjolly</a>, <a href=\"https://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"https://profiles.wordpress.org/ianedington\">Ian Edington</a>, <a href=\"https://profiles.wordpress.org/idealien\">idealien</a>, <a href=\"https://profiles.wordpress.org/igmoweb\">Ignacio Cruz Moreno</a>, <a href=\"https://profiles.wordpress.org/imath\">imath</a>, <a href=\"https://profiles.wordpress.org/imnok\">Imnok</a>, <a href=\"https://profiles.wordpress.org/implenton\">implenton</a>, <a href=\"https://profiles.wordpress.org/ionutst\">Ionut Stanciu</a>, <a href=\"https://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"https://profiles.wordpress.org/krstarica\">Ivan</a>, <a href=\"https://profiles.wordpress.org/ivdimova\">ivdimova</a>, <a href=\"https://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"https://profiles.wordpress.org/jakept\">Jacob Peattie</a>, <a href=\"https://profiles.wordpress.org/whyisjake\">Jake Spurlock</a>, <a href=\"https://profiles.wordpress.org/jnylen0\">James Nylen</a>, <a href=\"https://profiles.wordpress.org/jamesacero\">jamesacero</a>, <a href=\"https://profiles.wordpress.org/japh\">Japh</a>, <a href=\"https://profiles.wordpress.org/jaredcobb\">Jared Cobb</a>, <a href=\"https://profiles.wordpress.org/jayarjo\">jayarjo</a>, <a href=\"https://profiles.wordpress.org/jdolan\">jdolan</a>, <a href=\"https://profiles.wordpress.org/jdoubleu\">jdoubleu</a>, <a href=\"https://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"https://profiles.wordpress.org/cheffheid\">Jeffrey de Wit</a>, <a href=\"https://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"https://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"https://profiles.wordpress.org/jimt\">jimt</a>, <a href=\"https://profiles.wordpress.org/jipmoors\">Jip Moors</a>, <a href=\"https://profiles.wordpress.org/jmusal\">jmusal</a>, <a href=\"https://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"https://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"https://profiles.wordpress.org/joemcgill\">Joe McGill</a>, <a href=\"https://profiles.wordpress.org/joelcj91\">Joel James</a>, <a href=\"https://profiles.wordpress.org/johanmynhardt\">johanmynhardt</a>, <a href=\"https://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"https://profiles.wordpress.org/zyphonic\">John Dittmar</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"https://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"https://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"https://profiles.wordpress.org/johnpgreen\">johnpgreen</a>, <a href=\"https://profiles.wordpress.org/kenshino\">Jon (Kenshino)</a>, <a href=\"https://profiles.wordpress.org/jonathanbardo\">Jonathan Bardo</a>, <a href=\"https://profiles.wordpress.org/jbrinley\">Jonathan Brinley</a>, <a href=\"https://profiles.wordpress.org/daggerhart\">Jonathan Daggerhart</a>, <a href=\"https://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"https://profiles.wordpress.org/spacedmonkey\">Jonny Harris</a>, <a href=\"https://profiles.wordpress.org/jonnyauk\">jonnyauk</a>, <a href=\"https://profiles.wordpress.org/jordesign\">jordesign</a>, <a href=\"https://profiles.wordpress.org/jorritschippers\">JorritSchippers</a>, <a href=\"https://profiles.wordpress.org/joefusco\">Joseph Fusco</a>, <a href=\"https://profiles.wordpress.org/jjeaton\">Josh Eaton</a>, <a href=\"https://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"https://profiles.wordpress.org/joshcummingsdesign\">joshcummingsdesign</a>, <a href=\"https://profiles.wordpress.org/joshkadis\">joshkadis</a>, <a href=\"https://profiles.wordpress.org/joyously\">Joy</a>, <a href=\"https://profiles.wordpress.org/jrf\">jrf</a>, <a href=\"https://profiles.wordpress.org/jrgould\">JRGould</a>, <a href=\"https://profiles.wordpress.org/juanfra\">Juanfra Aldasoro</a>, <a href=\"https://profiles.wordpress.org/juhise\">Juhi Saxena</a>, <a href=\"https://profiles.wordpress.org/nukaga\">Junko Nukaga</a>, <a href=\"https://profiles.wordpress.org/justinbusa\">Justin Busa</a>, <a href=\"https://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"https://profiles.wordpress.org/jshreve\">Justin Shreve</a>, <a href=\"https://profiles.wordpress.org/jtsternberg\">Justin Sternberg</a>, <a href=\"https://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"https://profiles.wordpress.org/kacperszurek\">kacperszurek</a>, <a href=\"https://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"https://profiles.wordpress.org/kalenjohnson\">KalenJohnson</a>, <a href=\"https://profiles.wordpress.org/codebykat\">Kat Hagan</a>, <a href=\"https://profiles.wordpress.org/kkoppenhaver\">Keanan Koppenhaver</a>, <a href=\"https://profiles.wordpress.org/keesiemeijer\">keesiemeijer</a>, <a href=\"https://profiles.wordpress.org/kellbot\">kellbot</a>, <a href=\"https://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"https://profiles.wordpress.org/khag7\">Kevin Hagerty</a>, <a href=\"https://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"https://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"https://profiles.wordpress.org/ixkaito\">Kite</a>, <a href=\"https://profiles.wordpress.org/kjbenk\">kjbenk</a>, <a href=\"https://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"https://profiles.wordpress.org/koenschipper\">koenschipper</a>, <a href=\"https://profiles.wordpress.org/kokarn\">kokarn</a>, <a href=\"https://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"https://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"https://profiles.wordpress.org/kouratoras\">Konstantinos Kouratoras</a>, <a href=\"https://profiles.wordpress.org/kuchenundkakao\">kuchenundkakao</a>, <a href=\"https://profiles.wordpress.org/kuldipem\">kuldipem</a>, <a href=\"https://profiles.wordpress.org/laurelfulford\">Laurel Fulford</a>, <a href=\"https://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"https://profiles.wordpress.org/leobaiano\">Leo Baiano</a>, <a href=\"https://profiles.wordpress.org/littlebigthing\">LittleBigThings (Csaba)</a>, <a href=\"https://profiles.wordpress.org/lucasstark\">Lucas Stark</a>, <a href=\"https://profiles.wordpress.org/lukecavanagh\">Luke Cavanagh</a>, <a href=\"https://profiles.wordpress.org/lgedeon\">Luke Gedeon</a>, <a href=\"https://profiles.wordpress.org/lukepettway\">lukepettway</a>, <a href=\"https://profiles.wordpress.org/lyubomir_popov\">lyubomir_popov</a>, <a href=\"https://profiles.wordpress.org/mageshp\">mageshp</a>, <a href=\"https://profiles.wordpress.org/mahesh901122\">Mahesh Waghmare</a>, <a href=\"https://profiles.wordpress.org/mangeshp\">Mangesh Parte</a>, <a href=\"https://profiles.wordpress.org/manishsongirkar36\">Manish Songirkar</a>, <a href=\"https://profiles.wordpress.org/mantismamita\">mantismamita</a>, <a href=\"https://profiles.wordpress.org/mbootsman\">Marcel Bootsman</a>, <a href=\"https://profiles.wordpress.org/tyxla\">Marin Atanasov</a>, <a href=\"https://profiles.wordpress.org/mariovalney\">Mario Valney</a>, <a href=\"https://profiles.wordpress.org/clorith\">Marius L. J.</a>, <a href=\"https://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"https://profiles.wordpress.org/mrwweb\">Mark Root-Wiley</a>, <a href=\"https://profiles.wordpress.org/mapk\">Mark Uraine</a>, <a href=\"https://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"https://profiles.wordpress.org/markshep\">markshep</a>, <a href=\"https://profiles.wordpress.org/matrixik\">matrixik</a>, <a href=\"https://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"https://profiles.wordpress.org/jaworskimatt\">Matt Jaworski</a>, <a href=\"https://profiles.wordpress.org/mattking5000\">Matt King</a>, <a href=\"https://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"https://profiles.wordpress.org/veraxus\">Matt van Andel</a>, <a href=\"https://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"https://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"https://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"https://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"https://profiles.wordpress.org/maximeculea\">Maxime Culea</a>, <a href=\"https://profiles.wordpress.org/mayukojpn\">Mayo Moriyama</a>, <a href=\"https://profiles.wordpress.org/mbelchev\">mbelchev</a>, <a href=\"https://profiles.wordpress.org/mckernanin\">mckernanin</a>, <a href=\"https://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"https://profiles.wordpress.org/mhowell\">mhowell</a>, <a href=\"https://profiles.wordpress.org/michaelarestad\">Michael Arestad</a>, <a href=\"https://profiles.wordpress.org/michael-arestad\">Michael Arestad</a>, <a href=\"https://profiles.wordpress.org/michalzuber\">michalzuber</a>, <a href=\"https://profiles.wordpress.org/mauteri\">Mike Auteri</a>, <a href=\"https://profiles.wordpress.org/mihai2u\">Mike Crantea</a>, <a href=\"https://profiles.wordpress.org/mdgl\">Mike Glendinning</a>, <a href=\"https://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"https://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"https://profiles.wordpress.org/mikeschroder\">Mike Schroder</a>, <a href=\"https://profiles.wordpress.org/mikeviele\">Mike Viele</a>, <a href=\"https://profiles.wordpress.org/dimadin\">Milan Dinić</a>, <a href=\"https://profiles.wordpress.org/modemlooper\">modemlooper</a>, <a href=\"https://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"https://profiles.wordpress.org/deremohan\">Mohan Dere</a>, <a href=\"https://profiles.wordpress.org/monikarao\">monikarao</a>, <a href=\"https://profiles.wordpress.org/morettigeorgiev\">morettigeorgiev</a>, <a href=\"https://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"https://profiles.wordpress.org/mor10\">Morten Rand-Hendriksen</a>, <a href=\"https://profiles.wordpress.org/mt8biz\">moto hachi ( mt8.biz )</a>, <a href=\"https://profiles.wordpress.org/mrbobbybryant\">mrbobbybryant</a>, <a href=\"https://profiles.wordpress.org/nnaimov\">Naim Naimov</a>, <a href=\"https://profiles.wordpress.org/natereist\">Nate Reist</a>, <a href=\"https://profiles.wordpress.org/natewr\">NateWr</a>, <a href=\"https://profiles.wordpress.org/nathanrice\">nathanrice</a>, <a href=\"https://profiles.wordpress.org/nazgul\">Nazgul</a>, <a href=\"https://profiles.wordpress.org/greatislander\">Ned Zimmerman</a>, <a href=\"https://profiles.wordpress.org/celloexpressions\">Nick Halsey </a>, <a href=\"https://profiles.wordpress.org/nikeo\">Nicolas GUILLAUME</a>, <a href=\"https://profiles.wordpress.org/nikschavan\">Nikhil Chavan</a>, <a href=\"https://profiles.wordpress.org/nikv\">Nikhil Vimal</a>, <a href=\"https://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"https://profiles.wordpress.org/rabmalin\">Nilambar Sharma</a>, <a href=\"https://profiles.wordpress.org/noplanman\">noplanman</a>, <a href=\"https://profiles.wordpress.org/nullvariable\">nullvariable</a>, <a href=\"https://profiles.wordpress.org/odie2\">odie2</a>, <a href=\"https://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"https://profiles.wordpress.org/hideokamoto\">Okamoto Hidetaka</a>, <a href=\"https://profiles.wordpress.org/orvils\">orvils</a>, <a href=\"https://profiles.wordpress.org/oskosk\">oskosk</a>, <a href=\"https://profiles.wordpress.org/ottok\">Otto Kek&#228;l&#228;inen</a>, <a href=\"https://profiles.wordpress.org/ovann86\">ovann86</a>, <a href=\"https://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"https://profiles.wordpress.org/patilvikasj\">patilvikasj</a>, <a href=\"https://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"https://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"https://profiles.wordpress.org/sirbrillig\">Payton Swick</a>, <a href=\"https://profiles.wordpress.org/pdufour\">pdufour</a>, <a href=\"https://profiles.wordpress.org/piewp\">Perdaan</a>, <a href=\"https://profiles.wordpress.org/peterwilsoncc\">Peter Wilson</a>, <a href=\"https://profiles.wordpress.org/phh\">phh</a>, <a href=\"https://profiles.wordpress.org/php\">php</a>, <a href=\"https://profiles.wordpress.org/delawski\">Piotr Delawski</a>, <a href=\"https://profiles.wordpress.org/pippinsplugins\">pippinsplugins</a>, <a href=\"https://profiles.wordpress.org/pjgalbraith\">pjgalbraith</a>, <a href=\"https://profiles.wordpress.org/pkevan\">pkevan</a>, <a href=\"https://profiles.wordpress.org/pratikchaskar\">Pratik</a>, <a href=\"https://profiles.wordpress.org/pressionate\">Pressionate</a>, <a href=\"https://profiles.wordpress.org/presskopp\">Presskopp</a>, <a href=\"https://profiles.wordpress.org/procodewp\">procodewp</a>, <a href=\"https://profiles.wordpress.org/quasel\">quasel</a>, <a href=\"https://profiles.wordpress.org/rachelbaker\">Rachel Baker</a>, <a href=\"https://profiles.wordpress.org/rahulsprajapati\">Rahul Prajapati</a>, <a href=\"https://profiles.wordpress.org/superpoincare\">Ramanan</a>, <a href=\"https://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"https://profiles.wordpress.org/ramiabraham\">ramiabraham</a>, <a href=\"https://profiles.wordpress.org/ranh\">ranh</a>, <a href=\"https://profiles.wordpress.org/redsand\">Red Sand Media Group</a>, <a href=\"https://profiles.wordpress.org/youknowriad\">Riad Benguella</a>, <a href=\"https://profiles.wordpress.org/rianrietveld\">Rian Rietveld</a>, <a href=\"https://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"https://profiles.wordpress.org/rpayne7264\">Robert D Payne</a>, <a href=\"https://profiles.wordpress.org/rnoakes3rd\">Robert Noakes</a>, <a href=\"https://profiles.wordpress.org/d4z_c0nf\">Rocco Aliberti</a>, <a href=\"https://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"https://profiles.wordpress.org/rommelxcastro\">Rommel Castro</a>, <a href=\"https://profiles.wordpress.org/fronaldaraujo\">Ronald Ara&#250;jo</a>, <a href=\"https://profiles.wordpress.org/magicroundabout\">Ross Wintle</a>, <a href=\"https://profiles.wordpress.org/guavaworks\">Roy Sivan</a>, <a href=\"https://profiles.wordpress.org/ryankienstra\">Ryan Kienstra</a>, <a href=\"https://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"https://profiles.wordpress.org/ryanplas\">Ryan Plas</a>, <a href=\"https://profiles.wordpress.org/welcher\">Ryan Welcher</a>, <a href=\"https://profiles.wordpress.org/salcode\">Sal Ferrarello</a>, <a href=\"https://profiles.wordpress.org/samikeijonen\">Sami Keijonen</a>, <a href=\"https://profiles.wordpress.org/solarissmoke\">Samir Shah</a>, <a href=\"https://profiles.wordpress.org/samuelsidler\">Samuel Sidler</a>, <a href=\"https://profiles.wordpress.org/sandesh055\">Sandesh</a>, <a href=\"https://profiles.wordpress.org/smyoon315\">Sang-Min Yoon</a>, <a href=\"https://profiles.wordpress.org/sanketparmar\">Sanket Parmar</a>, <a href=\"https://profiles.wordpress.org/pollyplummer\">Sarah Gooding</a>, <a href=\"https://profiles.wordpress.org/sayedwp\">Sayed Taqui</a>, <a href=\"https://profiles.wordpress.org/schrapel\">schrapel</a>, <a href=\"https://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"https://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"https://profiles.wordpress.org/scrappyhuborg\">scrappy@hub.org</a>, <a href=\"https://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"https://profiles.wordpress.org/seancjones\">seancjones</a>, <a href=\"https://profiles.wordpress.org/sebastianpisula\">Sebastian Pisula</a>, <a href=\"https://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"https://profiles.wordpress.org/sgr33n\">Sergio De Falco</a>, <a href=\"https://profiles.wordpress.org/sfpt\">sfpt</a>, <a href=\"https://profiles.wordpress.org/shayanys\">shayanys</a>, <a href=\"https://profiles.wordpress.org/shazahm1hotmailcom\">shazahm1</a>, <a href=\"https://profiles.wordpress.org/shprink\">shprink</a>, <a href=\"https://profiles.wordpress.org/simonlampen\">simonlampen</a>, <a href=\"https://profiles.wordpress.org/skippy\">skippy</a>, <a href=\"https://profiles.wordpress.org/smerriman\">smerriman</a>, <a href=\"https://profiles.wordpress.org/snacking\">snacking</a>, <a href=\"https://profiles.wordpress.org/soean\">Soeren Wrede</a>, <a href=\"https://profiles.wordpress.org/solal\">solal</a>, <a href=\"https://profiles.wordpress.org/sstoqnov\">Stanimir Stoyanov</a>, <a href=\"https://profiles.wordpress.org/metodiew\">Stanko Metodiev</a>, <a href=\"https://profiles.wordpress.org/sharkomatic\">Steph</a>, <a href=\"https://profiles.wordpress.org/sswells\">Steph Wells</a>, <a href=\"https://profiles.wordpress.org/sillybean\">Stephanie Leary</a>, <a href=\"https://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"https://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"https://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"https://profiles.wordpress.org/stevenlinx\">stevenlinx</a>, <a href=\"https://profiles.wordpress.org/stubgo\">stubgo</a>, <a href=\"https://profiles.wordpress.org/sudar\">Sudar Muthu</a>, <a href=\"https://profiles.wordpress.org/patilswapnilv\">Swapnil V. Patil</a>, <a href=\"https://profiles.wordpress.org/swapnild\">swapnild</a>, <a href=\"https://profiles.wordpress.org/szaqal21\">szaqal21</a>, <a href=\"https://profiles.wordpress.org/takahashi_fumiki\">Takahashi Fumiki</a>, <a href=\"https://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"https://profiles.wordpress.org/karmatosed\">Tammie Lister</a>, <a href=\"https://profiles.wordpress.org/tapsboy\">tapsboy</a>, <a href=\"https://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"https://profiles.wordpress.org/team\">team</a>, <a href=\"https://profiles.wordpress.org/tg29359\">tg29359</a>, <a href=\"https://profiles.wordpress.org/tharsheblows\">tharsheblows</a>, <a href=\"https://profiles.wordpress.org/the\">the</a>, <a href=\"https://profiles.wordpress.org/themeshaper\">themeshaper</a>, <a href=\"https://profiles.wordpress.org/thenbrent\">thenbrent</a>, <a href=\"https://profiles.wordpress.org/thomaswm\">thomaswm</a>, <a href=\"https://profiles.wordpress.org/tfrommen\">Thorsten Frommen</a>, <a href=\"https://profiles.wordpress.org/tierra\">tierra</a>, <a href=\"https://profiles.wordpress.org/tnash\">Tim Nash</a>, <a href=\"https://profiles.wordpress.org/timmydcrawford\">Timmy Crawford</a>, <a href=\"https://profiles.wordpress.org/timothyblynjacobs\">Timothy Jacobs</a>, <a href=\"https://profiles.wordpress.org/timph\">timph</a>, <a href=\"https://profiles.wordpress.org/tkama\">Tkama</a>, <a href=\"https://profiles.wordpress.org/tnegri\">tnegri</a>, <a href=\"https://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"https://profiles.wordpress.org/tjnowell\">Tom J Nowell</a>, <a href=\"https://profiles.wordpress.org/tomdxw\">tomdxw</a>, <a href=\"https://profiles.wordpress.org/toro_unit\">Toro_Unit (Hiroshi Urabe)</a>, <a href=\"https://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"https://profiles.wordpress.org/transl8or\">transl8or</a>, <a href=\"https://profiles.wordpress.org/traversal\">traversal</a>, <a href=\"https://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"https://profiles.wordpress.org/nmt90\">Triet Minh</a>, <a href=\"https://profiles.wordpress.org/trishasalas\">Trisha Salas</a>, <a href=\"https://profiles.wordpress.org/tristangemus\">tristangemus</a>, <a href=\"https://profiles.wordpress.org/truongwp\">Truong Giang</a>, <a href=\"https://profiles.wordpress.org/tsl143\">tsl143</a>, <a href=\"https://profiles.wordpress.org/tywayne\">Ty Carlson</a>, <a href=\"https://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"https://profiles.wordpress.org/utkarshpatel\">Utkarsh</a>, <a href=\"https://profiles.wordpress.org/valeriutihai\">Valeriu Tihai</a>, <a href=\"https://profiles.wordpress.org/vishalkakadiya\">Vishal Kakadiya</a>, <a href=\"https://profiles.wordpress.org/voldemortensen\">voldemortensen</a>, <a href=\"https://profiles.wordpress.org/vortfu\">vortfu</a>, <a href=\"https://profiles.wordpress.org/vrundakansara-1\">Vrunda Kansara</a>, <a href=\"https://profiles.wordpress.org/webbgaraget\">webbgaraget</a>, <a href=\"https://profiles.wordpress.org/webmandesign\">WebMan Design &#124; Oliver Juhas</a>, <a href=\"https://profiles.wordpress.org/websupporter\">websupporter</a>, <a href=\"https://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"https://profiles.wordpress.org/earnjam\">William Earnhardt</a>, <a href=\"https://profiles.wordpress.org/williampatton\">williampatton</a>, <a href=\"https://profiles.wordpress.org/wolly\">Wolly aka Paolo Valenti</a>, <a href=\"https://profiles.wordpress.org/wraithkenny\">WraithKenny</a>, <a href=\"https://profiles.wordpress.org/yale01\">yale01</a>, <a href=\"https://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"https://profiles.wordpress.org/yogasukma\">Yoga Sukma</a>, <a href=\"https://profiles.wordpress.org/oxymoron\">Zach Wills</a>, <a href=\"https://profiles.wordpress.org/tollmanz\">Zack Tollman</a>, <a href=\"https://profiles.wordpress.org/vanillalounge\">Ze Fontainhas</a>, <a href=\"https://profiles.wordpress.org/zhildzik\">zhildzik</a>, and <a href=\"https://profiles.wordpress.org/zsusag\">zsusag</a>.\n<p>&nbsp;<br />\nSpecial thanks go to <a href=\"https://ramiabraham.com/\">Rami Abraham</a> for producing the release video and the many fine haiku we saw in the <a href=\"https://wordpress.org/news/2016/10/wordpress-4-7-beta-1/\">beta</a> and <a href=\"https://wordpress.org/news/2016/11/wordpress-4-7-release-candidate/\">RC</a> announcement posts.</p>\n<p>Finally, thanks to all the community translators who worked on WordPress 4.7. Their efforts bring WordPress 4.7 fully translated to 52 languages at release time with more on the way. Additionally, the WordPress 4.7 release video has been captioned into 44 languages.</p>\n<p>If you want to follow along or help out, check out <a href=\"https://make.wordpress.org/\">Make WordPress</a> and our <a href=\"https://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress &#8211; we hope you enjoy!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4596\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Moving Toward SSL\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/news/2016/12/moving-toward-ssl/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Dec 2016 17:20:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4588\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:327:\"We’re at a turning point: 2017 is going to be the year that we’re going to see features in WordPress which require hosts to have HTTPS available. Just as JavaScript is a near necessity for smoother user experiences and more modern PHP versions are critical for performance, SSL just makes sense as the next hurdle [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1627:\"<p>We’re at a turning point: 2017 is going to be the year that we’re going to see features in WordPress which require hosts to have HTTPS available. Just as JavaScript is a near necessity for smoother user experiences and more modern PHP versions are critical for performance, SSL just makes sense as the next hurdle our users are going to face.</p>\n<p>SSL basically means the link between your browser and the server is encrypted. SSL used to be difficult to implement, and often expensive or slow. Modern browsers, and the incredible success of projects like <a href=\"https://letsencrypt.org/\">Let&#8217;s Encrypt</a> have made getting a certificate to secure your site fast, free, and something we think every host should support by default, especially in a post-Snowden era. Google also weighs <a href=\"https://security.googleblog.com/2014/08/https-as-ranking-signal_6.html\">SSL as a search engine ranking factor</a> and will begin <a href=\"http://motherboard.vice.com/read/google-will-soon-shame-all-websites-that-are-unencrypted-chrome-https\">flagging unencrypted sites in Chrome</a>.</p>\n<p>First, early in 2017, we will only promote hosting partners that provide a SSL certificate by default in their accounts. Later we will begin to assess which features, such as API authentication, would benefit the most from SSL and make them only enabled when SSL is there.</p>\n<p>Separately, I also think the performance improvements in PHP7 are particularly impressive, and major kudos to everyone who worked on that. We will consider whether hosts use PHP7 by default for new accounts next year as well.</p>\n<p>&nbsp;</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4588\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 4.7 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"https://wordpress.org/news/2016/11/wordpress-4-7-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Nov 2016 04:26:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4579\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:328:\"The release candidate for WordPress 4.7 is now available. RC means we think we’re done, but with millions of users and thousands of plugins and themes, it’s possible we’ve missed something. We hope to ship WordPress 4.7 on Tuesday, December 6, but we need your help to get there. If you haven’t tested 4.7 yet, [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4331:\"<p>The release candidate for WordPress 4.7 is now available.</p>\n<p>RC means we think we’re done, but with millions of users and thousands of plugins and themes, it’s possible we’ve missed something. We hope to ship WordPress 4.7 on <strong>Tuesday, December 6</strong>, but we need <em>your</em> help to get there. If you haven’t tested 4.7 yet, now is the time! To test WordPress 4.7, you can use the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin or you can <a href=\"https://wordpress.org/wordpress-4.7-RC1.zip\">download the release candidate here</a> (zip).</p>\n<p>WordPress 4.7 is a jam-packed release, with a number of features focused on getting a theme set up for the first time. Highlights include a <a href=\"http://2017.wordpress.net/\">new default theme</a>, video headers, custom CSS, customizer edit shortcuts, PDF thumbnail previews, user admin languages, REST API content endpoints, post type templates, and more.</p>\n<p>We’ve made <a href=\"https://core.trac.wordpress.org/log/trunk/src?action=stop_on_copy&amp;mode=stop_on_copy&amp;rev=39353&amp;stop_rev=39263&amp;limit=200&amp;verbose=on&amp;sfp_email=&amp;sfph_mail=\">quite a few refinements</a> since releasing Beta 4 a week ago, including usability and accessibility enhancements for video headers, media and page template support in starter content, and polishing of how custom CSS can be migrated to and extended by plugins and themes. The REST API endpoints saw a number of bugfixes and notably now have anonymous comment off by default.</p>\n<p>Not sure where to start with testing? Try setting up a fresh site on a new installation with Twenty Seventeen (hint: head into customizing your site before touching any pages or widgets) and taking notes on what you enjoyed and what got you stuck. For more details about what&#8217;s new in version 4.7, check out the <a href=\"https://wordpress.org/news/2016/10/wordpress-4-7-beta-1/\">Beta 1</a>, <a href=\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-2/\">Beta 2</a>, <a href=\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-3/\">Beta 3</a>, and <a href=\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-4/\">Beta 4</a> blog posts.</p>\n<p><strong>Think you’ve found a bug?</strong> Please post to the <a href=\"https://wordpress.org/support/forum/alphabeta/\">Alpha/Beta support forum</a>. If any known issues come up, you’ll be able to <a href=\"https://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p><strong>Developers</strong>, please test your plugins and themes against WordPress 4.7 and update your plugin’s <em>Tested up to</em> version in the readme to 4.7. If you find compatibility problems please be sure to post to the support forums so we can figure those out before the final release – we work hard to avoid breaking things. An in-depth field guide to developer-focused changes is coming soon on the <a href=\"https://make.wordpress.org/core/\">core development blog</a>.</p>\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a> And if you haven&#8217;t yet done so, now is a great time to <a href=\"https://wordpressdotorg.polldaddy.com/s/wordpress-2016-survey\">take the Annual WordPress Survey</a> and send it on to your friends.</p>\n<p>Happy testing! And now for another <a href=\"https://profiles.wordpress.org/ramiabraham\">Rami Abraham</a> haiku break.</p>\n<p><em>Select your language</em><br />\n<em>Then let your users choose theirs</em><br />\n<em><code>get_user_locale()</code></em></p>\n<p><em>Theme authors rejoice</em><br />\n<em>Any option may employ</em><br />\n<em>Selective refresh</em></p>\n<p><em>Custom header video</em><br />\n<em>Make sure to <code>add_theme_support</code></em><br />\n<em>Bling above the fold</em></p>\n<p><em>A new template dawns</em><br />\n<em>A hierarchy member</em><br />\n<em>Post-type templates live</em></p>\n<p><em>PDF updates</em><br />\n<em>Pack a parade of polish</em><br />\n<em>Prettier previews</em></p>\n<p><em>Template Post Type: New</em><br />\n<em>Template Post Type: And Useful</em><br />\n<em>Template Post Type: Thing</em></p>\n<p><em>Let lists live lively</em><br />\n<em>Laud <code>wp_list_sort()</code></em><br />\n<em>Less laconic lists</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4579\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.7 Beta 4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Nov 2016 01:51:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4576\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"WordPress 4.7 Beta 4 is now available! This software is still in development, so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2019:\"<p>WordPress 4.7 Beta 4 is now available!</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.7-beta4.zip\">download the beta here</a> (zip).</p>\n<p>For more information on what’s new in 4.7, check out the <a href=\"https://wordpress.org/news/2016/10/wordpress-4-7-beta-1/\">Beta 1,</a> <a href=\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-2/\">Beta 2</a>, and <a href=\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-3/\">Beta 3</a> blog posts, along with <a href=\"https://make.wordpress.org/core/tag/4-7+dev-notes/\">in-depth developer guides on make/core</a>. We’ve made <a href=\"https://core.trac.wordpress.org/log/trunk/src?action=stop_on_copy&amp;mode=stop_on_copy&amp;rev=39262&amp;stop_rev=39201&amp;limit=200&amp;verbose=on&amp;sfp_email=&amp;sfph_mail=\">about 60 changes</a> in the last few days for beta 4, including tweaks to Twenty Seventeen, custom CSS, and the REST API content endpoints.</p>\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</p>\n<p><em>We are almost there<br />\nPlease test your plugins and themes<br />\nRC coming soon<br />\n</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4576\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:33:\"\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"WordCamp US 2017-2018 in Nashville\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"https://wordpress.org/news/2016/11/wordcamp-us-2017-2018-in-nashville/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Nov 2016 23:24:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"WordCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4571\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:330:\"The title says it all. We had some great applications for cities to host WordCamp US after we finish up in Philadelphia this year, and the city chosen for 2017-2018 is Nashville, Tennessee. Based on the other great applications we got I&#8217;m also excited about the pipeline of communities that could host it in future [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1022:\"<p><img class=\"aligncenter\" src=\"https://i0.wp.com/wpdotorg.files.wordpress.com/2008/07/27492741871_c6fcebcad3_k-e1479248587522.jpg?resize=632%2C253&#038;ssl=1\" data-recalc-dims=\"1\" /></p>\n<p>The title says it all. We had some great applications for cities to host <a href=\"http://us.wordcamp.org/\">WordCamp US</a> after we finish up in Philadelphia this year, and the city chosen for 2017-2018 is <strong>Nashville, Tennessee</strong>.</p>\n<p>Based on the other great applications we got I&#8217;m also excited about the pipeline of communities that could host it in future years as WordCamp US travels across the United States and gives us an opportunity to learn and love a new city, as we have with Philadelphia.</p>\n<p>By the way, if you haven&#8217;t yet, now is a great time to <a href=\"https://wordpressdotorg.polldaddy.com/s/wordpress-2016-survey\">take the Annual WordPress Survey</a> and ask your friends to as well.</p>\n<p><a href=\"https://www.flickr.com/photos/143951935@N07/27492741871\">Photo Credit</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4571\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.7 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 11 Nov 2016 03:30:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4566\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"WordPress 4.7 Beta 3 is now available! This software is still in development, so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3120:\"<p>WordPress 4.7 Beta 3 is now available!</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.7-beta3.zip\">download the beta here</a> (zip).</p>\n<p>For more information on what’s new in 4.7, check out the <a href=\"https://wordpress.org/news/2016/10/wordpress-4-7-beta-1/\">Beta 1</a> and <a href=\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-2/\">Beta 2</a> blog posts, along with <a href=\"https://make.wordpress.org/core/tag/4-7+dev-notes/\">in-depth field guides on make/core</a>. Some of the changes in Beta 3 include:</p>\n<ul>\n<li><strong>REST API:</strong> The <code>unfiltered_html</code> capability is now respected and <code>rest_base</code> has been added to response objects of <code>wp/v2/taxonomies</code> and <code>wp/v2/types</code>, while <code>get_allowed_query_vars()</code> and the <code>rest_get_post</code> filter have been removed.</li>\n<li><strong>Roles/Capabilities:</strong> Added meta-caps for comment, term, and user meta, which are currently only used in the REST API.</li>\n<li><strong>I18N:</strong> Added the ability to change user&#8217;s locale back to site&#8217;s locale. (<a href=\"https://core.trac.wordpress.org/ticket/38632\">#38632</a>)</li>\n<li><strong>Custom CSS:</strong> Renamed the <code>unfiltered_css</code> meta capability to <code>edit_css</code> and added revisions support to the <code>custom_css</code> post type.</li>\n<li><strong>Edit shortcuts:</strong> Theme authors should take a look at <a href=\"https://make.wordpress.org/core/2016/11/10/visible-edit-shortcuts-in-the-customizer-preview/\">the developer guide to the customizer preview&#8217;s visible edit shortcuts</a> and update their themes to take advantage of them if not already implementing selective refresh.</li>\n<li><strong>Various bug fixes:</strong> We’ve made <a href=\"https://core.trac.wordpress.org/log/trunk/src?action=stop_on_copy&amp;mode=stop_on_copy&amp;rev=39200&amp;stop_rev=39143&amp;limit=200&amp;verbose=on&amp;sfp_email=&amp;sfph_mail=\">over 50 changes</a> in the last week.</li>\n</ul>\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</p>\n<p><em>Building the future</em><br />\n<em>A global community</em><br />\n<em>Stronger together</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4566\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.7 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2016/11/wordpress-4-7-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 04 Nov 2016 17:39:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4552\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"WordPress 4.7 Beta 2 is now available! This software is still in development, so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4240:\"<p>WordPress 4.7 Beta 2 is now available!</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.7-beta2.zip\">download the beta here</a> (zip).</p>\n<p>Notable changes since WordPress 4.7 Beta 1:</p>\n<ul>\n<li><strong>Twenty Seventeen:</strong> The theme wasn&#8217;t being installed on upgrades &#8211; sorry about that! Now you should see it if you&#8217;re upgrading an existing site. There are also plenty of fixes, especially for the header and small screen views.</li>\n<li><strong>Edit shortcuts:</strong> These are always visible while editing (hide them on bigger screens by collapsing the controls) and should now work properly in Firefox. (<a href=\"https://core.trac.wordpress.org/ticket/27403\">#27403</a> and <a href=\"https://core.trac.wordpress.org/ticket/38532\">#38532</a>)</li>\n<li><strong>REST API endpoints:</strong> There have been a number of changes over the past week; your attention is requested on the following:\n<ul>\n<li>The <code>DELETE</code> response format has changed and may need to be accounted for. (<a href=\"https://core.trac.wordpress.org/ticket/38494\">#38494</a>)</li>\n<li>Enabled querying by multiple post statuses. (<a href=\"https://core.trac.wordpress.org/ticket/38420\">#38420</a>)</li>\n<li>Return an error when JSON decoding fails. (<a href=\"https://core.trac.wordpress.org/ticket/38547\">#38547</a>)</li>\n</ul>\n</li>\n<li><strong>More developer notes</strong>\n<ul>\n<li><a href=\"https://make.wordpress.org/core/2016/10/28/fine-grained-capabilities-for-taxonomy-terms-in-4-7/\">Fine grained capabilities for taxonomy terms</a></li>\n<li><a href=\"https://make.wordpress.org/core/2016/10/29/wp_taxonomy-in-4-7/\"><code>WP_Taxonomy</code></a></li>\n<li><a href=\"https://make.wordpress.org/core/2016/11/02/wp_list_sort-and-wp_list_util-in-4-7/\"><code>wp_list_sort()</code> and <code>WP_List_Util</code></a></li>\n<li><a href=\"https://make.wordpress.org/core/2016/11/03/post-type-templates-in-4-7/\">Post type templates</a></li>\n<li><a href=\"https://make.wordpress.org/core/2016/11/03/new-post-type-labels-in-4-7/\">New post type labels</a></li>\n<li><a href=\"https://make.wordpress.org/core/2016/11/03/attributes-for-resource-hints-in-4-7/\">Attributes for resource hints</a></li>\n</ul>\n</li>\n<li><strong>Various bug fixes:</strong> We’ve made <a href=\"https://core.trac.wordpress.org/log/trunk/src?action=stop_on_copy&amp;mode=stop_on_copy&amp;rev=39142&amp;stop_rev=38995&amp;limit=200&amp;verbose=on&amp;sfp_email=&amp;sfph_mail=\">almost 150 changes</a> in the last week.</li>\n</ul>\n<p>For more of what’s new in version 4.7, <a href=\"https://wordpress.org/news/2016/10/wordpress-4-7-beta-1/\">check out the Beta 1 blog post</a>.</p>\n<p>If you want a more in-depth view of what major changes have made it into 4.7, <a href=\"https://make.wordpress.org/core/tag/4-7/\">check out posts tagged with 4.7 on the main development blog</a>, or look at a <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;resolution=fixed&amp;milestone=4.7&amp;group=component&amp;order=priority\">list of everything</a> that’s changed. There will be more developer notes to come, so keep an eye out for those as well.</p>\n<p>Do you speak a language other than English? <a href=\"https://translate.wordpress.org/projects/wp/dev\">Help us translate WordPress into more than 100 languages!</a></p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</p>\n<p>Happy testing!</p>\n<p><em>Ya es la hora</em><br />\n<em> Time for another beta</em><br />\n请您帮下忙!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4552\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:39:\"\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:4:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 4.7 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/news/2016/10/wordpress-4-7-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 28 Oct 2016 04:30:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:3:\"4.7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4535\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"WordPress 4.7 Beta 1 is now available! This software is still in development, so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Helen Hou-Sandi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6895:\"<p>WordPress 4.7 Beta 1 is now available!</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 4.7, try the <a href=\"https://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"https://wordpress.org/wordpress-4.7-beta1.zip\">download the beta here</a> (zip).</p>\n<p>WordPress 4.7 is slated for release on <a href=\"https://make.wordpress.org/core/4-7/\">December 6</a>, but we need your help to get there. We&#8217;ve been working on a lot of things, many of them to make getting your site set up the way you want it much easier. Here are some of the bigger items to test and help us find as many bugs as possible in the coming weeks:</p>\n<ul>\n<li><a href=\"http://2017.wordpress.net/\"><strong>Twenty Seventeen</strong></a> &#8211; A brand new default theme brings your site to life with immersive featured images, video headers, and subtle animations. With a focus on business sites, it features multiple sections on the front page as well as widgets, navigation and social menus, a logo, and more. Personalize its asymmetrical grid with a custom color scheme and showcase your multimedia content with post formats. Our default theme for 2017 works great in many languages, for any abilities, and on any device.</li>\n<li><strong>Video Headers</strong> &#8211; Sometimes a big atmospheric video as a moving header image is just what you need to showcase your wares; go ahead and try it out with Twenty Seventeen. Need some video inspiration? Try searching for sites with video headers available for download and use.</li>\n<li><strong>Set up your site in one flow</strong> &#8211; From finding and installing themes right inside the customizer, to automatically staged theme-specific starter content, to clickable shortcuts that jump directly to editing an item from the preview pane, to adding pages while you&#8217;re building a nav menu or setting a static front page: getting a new site spun up and ready to share with a friend or a coworker is faster and easier than it&#8217;s ever been. Note: starter content appears when live previewing brand new sites and is currently only available in Twenty Seventeen. We&#8217;ll be expanding this to other bundled themes very soon, and perhaps to sites with existing content in future releases of WordPress.</li>\n<li><strong>Custom CSS with live previews</strong> &#8211; Ever needed to hide or tweak the look of something in your theme or from a plugin? Now you can do it with CSS and live preview the results while customizing your site. CSS can be a powerful tool; you may find that you won&#8217;t need the theme editor or child themes anymore.</li>\n<li><strong>User admin languages</strong> &#8211; Just because your site is in one language doesn&#8217;t mean that everybody helping manage it prefers that language for their admin. To try this out, you&#8217;ll need to have more than one language installed, which will make a user language option available in your profile.</li>\n<li><strong>PDF thumbnail previews</strong> &#8211; Uploading PDFs will now generate thumbnail images so you can more easily distinguish between all your documents.</li>\n</ul>\n<p>As always, there have been exciting changes for developers to explore as well, such as:</p>\n<ul>\n<li><strong>REST API content endpoints</strong> &#8211; If you only test one thing as a developer, please test these. This phase is particularly helpful for people building plugins, themes, and in-admin interfaces. Can you build the things you need? Are these ready for release, and is the world ready for them? (<a href=\"https://core.trac.wordpress.org/ticket/38373\">#38373</a>)</li>\n<li><strong><code>WP_Hook</code></strong> &#8211; The code that lies beneath actions and filters has been overhauled. You likely aren&#8217;t affected, but if you&#8217;ve done things to the <code>$wp_filter</code> global or experienced funky recursion bugs in the past, <a href=\"https://make.wordpress.org/core/2016/09/08/wp_hook-next-generation-actions-and-filters/\">please take a moment to read the dev note</a> and test your code.</li>\n<li><a href=\"https://make.wordpress.org/core/2016/10/04/custom-bulk-actions/\"><strong>Custom bulk actions</strong></a> &#8211; List tables, now with more than bulk edit and delete.</li>\n<li>Expanded <a href=\"https://make.wordpress.org/core/2016/10/26/registering-your-settings-in-wordpress-4-7/\"><strong>Settings Registration API</strong></a> via <code>register_setting()</code>.</li>\n<li>For theme developers: <strong>Post type templates</strong> (<a href=\"https://core.trac.wordpress.org/ticket/18375\">#18375</a>)</li>\n<li><strong><a href=\"https://make.wordpress.org/core/2016/09/09/new-functions-hooks-and-behaviour-for-theme-developers-in-wordpress-4-7/\">More goodies for theme developers!</a></strong></li>\n<li><strong>Locale switching</strong> (<a href=\"https://core.trac.wordpress.org/ticket/26511\">#26511</a>)</li>\n<li><a href=\"https://make.wordpress.org/core/2016/10/11/comment-allowed-checks-in-wordpress-4-7/\"><strong>Comment allowed checks</strong></a> have the potential for a back-compat break.</li>\n</ul>\n<p>If you want a more in-depth view of what major changes have made it into 4.7, <a href=\"https://make.wordpress.org/core/tag/4-7/\">check out posts tagged with 4.7 on the main development blog</a>, or look at a <a href=\"https://core.trac.wordpress.org/query?status=closed&amp;resolution=fixed&amp;milestone=4.7&amp;group=component&amp;order=priority\">list of everything</a> that’s changed. There will be more developer notes to come, so keep an eye out for those as well.</p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"https://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We’d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on WordPress Trac</a>, where you can also find <a href=\"https://core.trac.wordpress.org/tickets/major\">a list of known bugs</a>.</p>\n<p>Happy testing, and please enjoy this extended haiku break, courtesy of <a href=\"https://profiles.wordpress.org/ramiabraham\">Rami Abraham</a><em>.</em></p>\n<p><em>Exquisite endpoints</em><br />\n<em>Extol epic exabytes</em><br />\n<em>Enabling earthlings</em></p>\n<p><em>Careful interfaces</em><br />\n<em>Considerately conjured</em><br />\n<em>Customizer chic</em></p>\n<p><em>Ring in the new year</em><br />\n<em>With elegance and balance</em><br />\n<em>Twenty Seventeen</em></p>\n<p><em>Hooks hook healthily</em><br />\n<em>17817</em><br />\n<em>Sane iterations</em></p>\n<p><em>Admin in your tongue<br />\nOne site, many languages<br />\nWe all speak WordPress</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:7:\"post-id\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"4535\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:32:\"https://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:30:\"com-wordpress:feed-additions:1\";a:1:{s:4:\"site\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"14607090\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 24 Feb 2017 19:32:05 GMT\";s:12:\"content-type\";s:34:\"application/rss+xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:6:\"x-olaf\";s:3:\"⛄\";s:13:\"last-modified\";s:29:\"Wed, 01 Feb 2017 15:58:56 GMT\";s:4:\"link\";s:63:\"<https://wordpress.org/news/wp-json/>; rel=\"https://api.w.org/\"\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20160704050813\";}", "no");
INSERT INTO `wp_options` VALUES("591", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1488007925", "no");
INSERT INTO `wp_options` VALUES("592", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1487964725", "no");
INSERT INTO `wp_options` VALUES("593", "_transient_timeout_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "1488007926", "no");
INSERT INTO `wp_options` VALUES("594", "_transient_feed_d117b5738fbd35bd8c0391cda1f2b5d9", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WPTavern: Cloudflare Memory Leak Exposes Private Data\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66488\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wptavern.com/cloudflare-memory-leak-exposes-private-data\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5730:\"<p><a href=\"https://www.cloudflare.com/\">Cloudflare</a>, a content distribution network used by many popular sites, <a href=\"https://blog.cloudflare.com/incident-report-on-memory-leak-caused-by-cloudflare-parser-bug/\">published detailed information</a> about a security vulnerability that leaked user information, some of which was private, including passwords, private messages, etc. The vulnerability was <a href=\"https://bugs.chromium.org/p/project-zero/issues/detail?id=1139#c19\">discovered</a> by security researcher <a href=\"https://twitter.com/taviso\">Tavis Ormandy,</a> a member of Google&#8217;s <a href=\"https://googleprojectzero.blogspot.co.uk/\">Project Zero</a> team.</p>\n<p>The issue stems from a memory leak in an HTML parser named cf-html that was created to replace an older parser based on <a href=\"https://en.wikipedia.org/wiki/Ragel\">Ragel.</a></p>\n<p>&#8220;It turned out that the underlying bug that caused the memory leak had been present in our Ragel-based parser for many years but no memory was leaked because of the way the internal NGINX buffers were used,&#8221; John Graham-Cumming, <span class=\"st\">Chief Technology Officer at Cloudflare</span> said. &#8220;Introducing cf-html subtly changed the buffering which enabled the leakage even though there were no problems in cf-html itself.&#8221;</p>\n<p>The earliest date information was leaked was September 22nd, 2016 when <a href=\"https://support.cloudflare.com/hc/en-us/articles/227227647-How-do-I-use-Automatic-HTTPS-Rewrites-\">Automatic HTTP Rewrites</a> were enabled. This was the first of three features introduced that used the parser. The other two are <a href=\"https://support.cloudflare.com/hc/en-us/articles/200170016-What-is-Email-Address-Obfuscation-\">email obfuscation</a> and <a href=\"https://support.cloudflare.com/hc/en-us/articles/200170036-What-does-Server-Side-Excludes-SSE-do-\">Server-side Excludes</a>.</p>\n<p>The greatest period of impact was between February 13th and February 17th. The leaked information ended up in publicly available cached webpages. Cloudflare worked with major search engine providers to have the cached pages scrubbed before publicly announcing details of the bug.</p>\n<p>&#8220;With the help of Google, Yahoo, Bing and others, we found 770 unique URIs that had been cached and which contained leaked memory,&#8221; Graham-Cumming said. &#8220;Those 770 unique URIs covered 161 unique domains. The leaked memory has been purged with the help of the search engines. We also undertook other search expeditions looking for potentially leaked information on sites like Pastebin and did not find anything.&#8221;</p>\n<h2>1Password is Not Affected</h2>\n<p>Earlier reports indicated that 1Password was among the sites affected. Jeffrey Goldberg, a 1Password employee, <a href=\"https://blog.agilebits.com/2017/02/23/three-layers-of-encryption-keeps-you-safe-when-ssltls-fails/\">assured users</a> that the Cloudflare data leak does not affect 1Password.</p>\n<p>&#8220;At the moment, we want to assure and remind everyone that we designed 1Password with the expectation that SSL/TLS can fail,&#8221; Goldberg said. &#8220;Indeed it is for incidents like this that we deliberately made this design.&#8221;</p>\n<p>&#8220;No secrets are transmitted between 1Password clients and 1Password.com when you sign in and use the service. Our sign-in uses <a href=\"https://en.wikipedia.org/wiki/Secure_Remote_Password_protocol\">SRP</a>, which means that server and client prove their identity to each other without transmitting any secrets. This means that users of 1Password do not need to change their Master Passwords.&#8221;</p>\n<h2>Change Your Passwords</h2>\n<p><a href=\"https://twitter.com/thesquashsh\">Nick Sweeting</a> has used a number of web scrapers to compile a list of sites that use Cloudflare. The list is available on <a href=\"https://github.com/pirate/sites-using-cloudflare\">GitHub</a> and currently contains 4,287,625 domains that are possibly affected. Popular domains in the list include:</p>\n<ul>\n<li>authy.com</li>\n<li>coinbase.com</li>\n<li>digitalocean.com</li>\n<li>patreon.com</li>\n<li>bitpay.com</li>\n<li>news.ycombinator.com</li>\n<li>producthunt.com</li>\n<li>medium.com</li>\n<li>4chan.org</li>\n<li>yelp.com</li>\n<li>okcupid.com</li>\n</ul>\n<p>The bug also affects mobile apps as HTTP header data for apps such as Discord, FitBit, and Uber have been discovered in search engine caches. NowSecure <a href=\"https://www.nowsecure.com/blog/2017/02/23/cloudflare-cloudbleed-bugs-impact-mobile-apps/\">published a list</a> that includes 200 iOS apps that use Cloudflare services.</p>\n<p>Users are strongly encouraged to change their passwords regardless if a site uses Cloudflare or not. Those who use Cloudflare should generate new API keys and consider forcing a password change to users.</p>\n<p>Two factor authentication should be enabled where possible so that the password is not the only credential needed to access an account. Mobile users should log out of mobile applications and log back in to create a new active token. To force all users on a WordPress site to logout and re-login, <a href=\"https://wpstudio.com/cloudflare-security-precaution-alert/\">WPStudio recommends</a> changing the salt keys in wp-config.php.</p>\n<p>Although major search engines are actively scrubbing cached pages, the leaks have been occurring for at least four months. There&#8217;s no telling who may have already scraped those pages and archived the data. There&#8217;s also the possibility that someone discovered the vulnerability before Ormandy and has been parsing cached pages for months. This is why it&#8217;s important that at a minimum, you change your passwords.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Feb 2017 19:03:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WPTavern: Google’s New Perspective Project Filters Online Comments Based on Toxicity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66464\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"https://wptavern.com/googles-new-perspective-project-filters-online-comments-based-on-toxicity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5970:\"<a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/mobile-reading.jpg?ssl=1\"><img /></a>photo credit: <a href=\"https://stocksnap.io/photo/RY5J4XBYJV\">Martino Pietropoli</a>\n<p>Online harassment is a hot topic right now, as Twitter&#8217;s perennial battle with trolls heats up, forcing the company to develop new features to combat abuse. Technology companies are scrambling to create solutions that will make their communities safer for users and now Google is taking on the challenge of online harassment as part of its <a href=\"https://jigsaw.google.com\" target=\"_blank\">Jigsaw</a> technology incubator. Jigsaw&#8217;s engineers and researchers tackle geopolitical problems like attacks on free speech, injustice, corruption, and violent extremism.</p>\n<p><a href=\"https://www.perspectiveapi.com/\" target=\"_blank\">Perspective</a> is Jigsaw&#8217;s latest project aimed at improving the comment sections of websites, which can become hotbeds of harassment when left unmoderated. It turns out that eliminating the darker aspects of human behavior, especially when combatting those operating under the cloak of online anonymity, has proven to be an exquisite challenge best suited to the bots.</p>\n<p>The Perspective project uses machine learning to identify and filter comments for toxicity. Its API scores comments based on &#8220;the perceived impact a comment might have on a conversation.&#8221; Publishers can then use that information to offer real-time feedback to commenters and speed up moderation. The <a href=\"https://www.perspectiveapi.com/\" target=\"_blank\">live demo</a> allows readers to filter the comments based on a sliding scale of toxicity that they are willing to engage.</p>\n<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/google-jigsaw-perspective-project.png?ssl=1\"><img /></a></p>\n<p>The Perspective site also includes a Writing Demo that delivers real-time feedback for the toxicity level as you type. The model defines toxic as &#8220;a rude, disrespectful, or unreasonable comment that is likely to make you leave a discussion.&#8221;</p>\n<h3>Developers Can Request Access to the Perspective API and Major Publications are Already Experimenting with It</h3>\n<p>Toxic commenting and trolls are especially rampant on news sites, requiring moderators to be constantly vigilant and ready to neutralize threats to civil discourse. This is why the New York Times employs 14 full-time moderators to manually review the 11,000 comments that come in each day. Despite the efforts of this dedicated team, commenting is only available on 10% of Times articles due to the moderation load.</p>\n<p>As a partner on this project, the New York Times <a href=\"http://www.nytco.com/the-times-is-partnering-with-jigsaw-to-expand-comment-capabilities/\" target=\"_blank\">open sourced 10 years of moderated comment archives</a> to help the Jigsaw team build the machine learning models that will improve conversations on the web. The publication is currently creating an open source moderation tool to expand community discussion to other areas of the Times.</p>\n<p>The Wikimedia Foundation is also <a href=\"https://meta.wikimedia.org/wiki/Research:Detox\" target=\"_blank\">collaborating with Jigsaw</a> to develop tools for automating detection of toxic comments and analyzing their impact in discussions at scale. These tools are aimed at mitigating the personal attacks levied at volunteer editors in an effort to improve overall community health.</p>\n<p>The Perspective project is still in its early days of research and development, but developers can <a href=\"https://groups.google.com/forum/#!forum/perspective-announce/join\" target=\"_blank\">sign up</a> to request an API key. Google will be open sourcing the experiments, models, and research data gained from testing machine learning as a tool for improving online discussion.</p>\n<p>As WordPress powers more than 27% of all websites, a plugin built with the Perspective API could have a major impact on raising the standard of discourse for a large segment of comment-enabled sites. Many publications that might otherwise value thoughtful discussion, have resorted to turning comments off entirely because of the burden of moderation.</p>\n<p>Those who rattle off the tired internet maxim that says &#8220;<em>Never read the comments</em>&#8221; speak to the pervasive toxicity that has invaded online discourse, but they also betray their own fragility in engaging commenters who sabotage discussions with incivility. Readers don&#8217;t always have the emotional energy to deal with rude comments that slipped through moderation. While some may find Reddit-style wild west commenting to be spirited and amusing, there are plenty of others who find it demoralizing.</p>\n<p>One thing I appreciate about the Perspective project&#8217;s demo is that its aim isn&#8217;t to edit or change the comments to be less toxic but rather it offers the reader a way to filter based on the individual&#8217;s comfort level. With clear warnings in place and a default view set on the safer side, the publication is no longer obligated to overly-censor comments for the lowest threshold of offense.</p>\n<p>The Perspective project is experimenting with using machine learning to wrangle the human factor of interacting online. It&#8217;s come to the point that moderating comments and weeding out toxicity has become overwhelming for those trying to run a publication. The most encouraging aspect of this experiment is that Google put engineers, designers, and researchers on this problem because <a href=\"https://wptavern.com/why-comments-still-matter\" target=\"_blank\">comments still matter</a>. This new technology affirms the importance of public discourse on the web and aims to preserve comments as a safe place for conversations. I&#8217;m interested to see what WordPress developers can build with the Perspective API once it is available.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Feb 2017 04:17:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: WordPress Community Summit 2017 Set for June 13-14 in Paris\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66439\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"https://wptavern.com/wordpress-community-summit-2017-set-for-june-13-14-in-paris\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3561:\"<p>WordPress contributor teams are getting ready for the next <a href=\"https://make.wordpress.org/core/2017/02/23/planning-for-community-summit-2017/\" target=\"_blank\">Community Summit</a>, which will be held in Paris leading up to WordCamp Europe on June 13-14. This is the first time the event will be held outside the United States, making it more accessible to European community members who may have been unable to attend previous summits.</p>\n<p>The summit provides an opportunity for those who contribute to WordPress and its surrounding community to tackle difficult topics that require in-person discussion or collaboration. This year the organizing team is <a href=\"https://wptavern.com/wordpress-community-team-proposes-new-selection-process-for-2017-summit-attendees\" target=\"_blank\">trying a new selection process for attendees</a>. Instead of the previous invitation-only system, contributor teams are identifying the challenging issues they want to discuss and then nominating attendees who will represent diverse viewpoints on these particular topics.</p>\n<p>For example, a few <a href=\"https://make.wordpress.org/core/2017/02/23/planning-for-community-summit-2017/\" target=\"_blank\">proposed topics for the core team</a> include discussions about the future of JavaScript in core, how to attract more JavaScript-first developers to build on WordPress, and technology version support policies (PHP, MySQL, browsers, etc.) Theme Review Team contributors have <a href=\"https://make.wordpress.org/themes/2017/02/18/community-submit-2017/\" target=\"_blank\">proposed</a> discussion on how to allow for more experimentation and ways to improve the leadership of the team and the theme author and reviewer experiences.</p>\n<p>Each of the 16 contributor teams tagged in the announcement has until March 3rd to create a list of topics and representatives, including contributors who are willing to help organize the event. An <a href=\"https://wceurope.polldaddy.com/s/community-summit-2017-call-for-non-active-contributors\" target=\"_blank\">application form</a> is open for those who represent other interests within the WordPress community but are not part of one of the contributor teams. The summit will be limited to 180 attendees (the capacity for the venue).</p>\n<p>The call for sponsors will be published next week, but promotional activities will not be incorporated into the event. The organizing team is also working on finding sponsors to cover travel expenses for contributors who have financial barriers to attending.</p>\n<p>&#8220;The idea of this event sponsorship is about supporting the project and the community,&#8221; summit organizer Rocio Valdivia said. &#8220;So, there aren’t levels of exposure associated with each price level other than the label that will show up in the make/summit p2 page for it and on the sidebar. We’ll add links to their sites, logos, and a huge thanks at event to all sponsors, regardless how much they’ve sponsored. The sponsorship levels are about the desire and financial ability of the companies to contribute to the summit, not about a marketing thing.&#8221;</p>\n<p>The summit is closed to the public and the press, but there is a decent level of transparency around the topics attendees plan to discuss if you peruse the make.wordpress.org blogs. If contributor teams publish notes from the discussions as they have in previous years, the wider community will be able to follow along to see if the summit precipitates meaningful progress for the project.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Feb 2017 22:05:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"Akismet: Akismet WordPress Plugin 3.3 Now Available\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1923\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://blog.akismet.com/2017/02/23/akismet-wordpress-plugin-3-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1366:\"<p>Version 3.3 of <a href=\"http://wordpress.org/plugins/akismet/\">the Akismet plugin for WordPress</a> is available.</p>\n<p><a href=\"https://akismet.files.wordpress.com/2017/02/akismet-3-3-dashboard.png\"><img /></a> In addition to a handful of bug fixes, version 3.3 refreshes the Akismet settings page design and adds an improved first-run experience. Now, when you activate Akismet for the first time, it will offer to check your current Pending queue for spam, and for especially large pending queues, it will show a progress indicator.</p>\n<p>For full details on all of the changes since version 3.2, see <a href=\"https://plugins.trac.wordpress.org/log/akismet/trunk?rev=1602266&stop_rev=1501241&verbose=on\">the changelog</a>.</p>\n<p>To upgrade, visit the Updates page of your WordPress dashboard and follow the instructions. If you need to download the plugin zip file directly, links to all versions are available in <a href=\"http://wordpress.org/plugins/akismet/\">the WordPress plugins directory</a>.</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1923/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1923/\" /></a> <img alt=\"\" border=\"0\" src=\"https://pixel.wp.com/b.gif?host=blog.akismet.com&blog=116920&post=1923&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Feb 2017 18:08:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Christopher Finke\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: WPWeekly Episode 264 – REST API, Disqus, and Happy Birthday Discourse\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=66421&preview=true&preview_id=66421\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"https://wptavern.com/wpweekly-episode-264-rest-api-disqus-and-happy-birthday-discourse\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4422:\"<p>In this episode, Marcus Couch and I discuss the news of the week. We introduce a new segment of the show called &#8220;What&#8217;s on WordPress.tv?&#8221; where we highlight three videos to check out. We also share details of <a href=\"https://central.wordcamp.org/schedule/\">upcoming WordCamps </a>in the month of March.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://halfelf.org/2017/case-rest-api/\">A Case for REST API</a><br />\n<a href=\"https://wptavern.com/buddypress-2-8-boosts-minimum-php-requirement-adds-twenty-seventeen-companion-stylesheet\">BuddyPress 2.8 Boosts Minimum PHP Requirement, Adds Twenty Seventeen Companion Stylesheet</a><br />\n<a href=\"https://wptavern.com/disqus-hits-sites-with-unwanted-advertising-plans-to-charge-large-publishers-a-monthly-fee-to-remove-ads\">Disqus Hits Sites with Unwanted Advertising, Plans to Charge Large Publishers a Monthly Fee to Remove Ads</a><br />\n<a href=\"https://wptavern.com/how-to-check-if-installed-plugins-are-no-longer-in-the-plugin-directory\">How to Check if Installed Plugins Are No Longer in the Plugin Directory</a><br />\n<a href=\"https://blog.discourse.org/2017/02/discourses-fourth-birthday/\">Happy Fourth Birthday Discourse</a></p>\n<h2>What&#8217;s On WordPress.TV?</h2>\n<h3>WordCamp Manila 2016</h3>\n<p><a href=\"http://wordpress.tv/2017/02/12/andrew-dela-serna-how-we-work-in-automattic/\">Andrew dela Serna: How We Work in Automattic</a></p>\n<p>Learn what it’s like to work at Automattic, the tools they use, our culture, the people, how to apply and what’s next for the company.</p>\n<h3>WordCamp Waukesha 2017</h3>\n<p><a href=\"http://wordpress.tv/2017/02/09/ryan-erwin-digital-marketing-strategy-and-seo/\">Ryan Erwin: Digital Marketing, Strategy and SEO</a></p>\n<p>Ryan Erwin discussed digital marketing strategy for business as it relates to on and off page SEO, content marketing, and conversion optimization. He reviews how to plan, implement, and analyze your strategic initiatives.</p>\n<h3>WordPress Community Interview Series</h3>\n<p><a href=\"http://wordpress.tv/2017/02/20/wordpress-community-interview-with-isabelle-garcia/\">WordPress Community Interview With Isabelle Garcia</a></p>\n<p>Isabelle Garcia is a front-end web developer and social media geek. She is a “Digital Nomad” and travels the world working remotely. She has no fixed base, no office. Isabel likes to frequent local libraries, not to borrow books but to take advantage of the quiet atmosphere.</p>\n<p>While other digital nomads meet at coffee shops or co-working spaces, she likes to spend entire days and even weekends in the common areas and desks of public libraries.</p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/really-simple-click-to-call/\">Really Simple Click To Call Bar</a> adds a customizable click-to-call bar to the bottom of the browser window on mobile devices. It enables users to easily call you from their phone and automatically adds events if you&#8217;re using Google Analytics Universal. Perfect for small businesses like restaurants, retail stores, or any lead generation that relies on phone calls.</p>\n<p><a href=\"https://wordpress.org/plugins/html-table/\">Responsive tables</a> lets you create and display tables easily on your website with shortcodes. HTML tables can be used to display pricing, comparisons, DBMS tables and much more.</p>\n<p><a href=\"https://wordpress.org/plugins/wp-demo-buddy/\">WP Demo Buddy</a> instantly creates a dedicated expiring Demo/Trial instance of WordPress with any WordPress Plugin and Theme to each of your website visitors. Your website visitors can test drive your plugins securely before they buy or test drive the plugins you review/sell on your website.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, March 1st 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #264:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Feb 2017 22:29:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WPTavern: Zerif Lite Returns to WordPress.org after 5-Month Suspension and 63% Decline in Revenue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=64347\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"https://wptavern.com/zerif-lite-returns-to-wordpress-org-after-5-month-suspension-and-63-decline-in-revenue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7365:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2016/09/zerif-lite.png?ssl=1\"><img /></a></p>\n<p>In October 2016, Zerif Lite was <a href=\"https://wptavern.com/zerif-lite-suspended-from-wordpress-theme-directory-300k-users-left-without-updates\">suspended from the WordPress Themes Directory</a> after failure to comply with the Theme Review Team&#8217;s guidelines. The suspension left 300,000 users (including those using Zerif Lite child themes) without maintenance and security updates.</p>\n<p>After five months of fixes and several rounds of review, <a href=\"https://wordpress.org/themes/zerif-lite/\" target=\"_blank\">Zerif Lite</a> has returned to the directory with the same functionality but a significantly altered user experience. Users are now required to install a plugin for the features that were previously deemed to be &#8220;faux custom post types,&#8221; violations of the content vs. presentation guideline for WordPress.org-hosted themes. These include small custom content blocks that appear on the homepage for things like team info and testimonials.</p>\n<p>&#8220;We will work on making sure it is all clear for people, but I still don’t understand or agree with the requirement,&#8221; ThemeIsle CEO Ionut Neagu said. &#8220;I think <a href=\"http://torstenlandsiedel.de/2017/02/21/questions/\" target=\"_blank\">Torsten phrased it better</a>: &#8216;Why do the guidelines of the Theme Review Team forbid the usage of Shortcodes/CPTs/etc. due to problems when switching themes, if, in the meantime, the Plugin Review Team explicitly allows those plugins which only work for one theme, which brings the entire idea (function remains intact after switching themes) to absurdity?\'&#8221;</p>\n<p>At the time of suspension, Neagu estimated that Zerif Lite&#8217;s unavailability on WordPress.org would diminish the company&#8217;s revenue by 50%.</p>\n<p>&#8220;What was interesting is that revenue continued to decrease for all those months and we are now at around $45k/month instead of $120k,&#8221; Neagu said. &#8220;That revenue won’t be back as the theme is live. A big part of success/sales before was that we had a great demo, a very easy-to-set-up theme, and ‘better’ upsells.&#8221;</p>\n<p>Neagu said the company has seen no significant increase in revenue during the first few days the theme has been back in the directory. His team has considered releasing the theme under a completely different name but is committed to supporting the current version for at least the next two years. Meanwhile, they have built newer themes like <a href=\"https://themeisle.com/themes/hestia/\" target=\"_blank\">Hestia</a> to be capable of importing Zerif content seamlessly into its design to avoid the lock-in effect.</p>\n<p>Neagu said the experience of losing so much revenue has not changed the company&#8217;s strategy for distribution. They will continue to add new themes to WordPress.org but Neagu said they would be lucky to add two per year, given the limitation of one theme per account and a 6-7 month waiting period in the queue.</p>\n<p>Zerif Lite&#8217;s suspension was a controversial decision. Many who commented on our first <a href=\"https://wptavern.com/zerif-lite-suspended-from-wordpress-theme-directory-300k-users-left-without-updates\" target=\"_blank\">post</a> about the issue were pleased to see the Theme Review Team finally throw the book at ThemeIsle after the company had been allowed to skirt the requirements for more than a year without resolving the issues. Others saw the situation as an opportunity to re-examine the directory&#8217;s requirements.</p>\n<p>&#8220;Perhaps the rules surrounding theme submission to the repo should be relaxed for everyone – limited only to security concerns perhaps, let the market sort out the rest,&#8221; <a href=\"https://twitter.com/bradley_kirby\" target=\"_blank\">Bradley Kirby</a>, author of the Wallace theme, said. &#8220;Is it possible that absolute data portability isn’t an expectation or desire from most end users? That they expect to do some manual porting of data when they change themes? That they prize other features like site design and built-in functionality over something like data portability?&#8221;</p>\n<p>Zerif Lite has been at the center of the Theme Review Team&#8217;s discussions regarding data portability for the past two years after the team began <a href=\"https://wptavern.com/wordpress-theme-review-team-is-cracking-down-on-violations-of-the-presentation-vs-functionality-guideline\" target=\"_blank\">cracking down on violations of the Presentation vs. Functionality guideline</a>. The spotlight shined on Zerif Lite during that discussion eventually culminated in its suspension, as Neagu was forced to comply or have his theme removed.</p>\n<p>&#8220;I think our goal should just be to provide the best experience for the users, not just to comply without thinking about what users want,&#8221; Neagu said. &#8220;At least this is my goal &#8211; to build the best products that will help people to build their sites.&#8221;</p>\n<h3>The Risks of Using WordPress.org as a Primary Distribution Channel</h3>\n<p>WordPress.org is arguably the most effective way for a theme company to reach mass quantities of users with a freemium theme. The directory lends a great deal of credibility to its listings because of the stringent guidelines and rigorous review process. Failure to comply with these guidelines ultimately ended up sinking ThemeIsle&#8217;s flagship theme and Neagu is not optimistic that the previous revenue will return.</p>\n<p>&#8220;During this whole time, a thing that caught me off guard was some of people’s comments wondering if it was even safe to use a theme that was removed from the repo in the first place,&#8221; Neagu said. &#8220;I mean, in the user’s mind, and understandably so, there must have been something wrong with the theme since it got removed, right?&#8221; He said this experience caused him to see things differently.</p>\n<p>&#8220;Being listed in the official repository doesn’t only get you downloads and/or sales, but also trust and credibility in the eyes of your potential users,&#8221; Neagu said. &#8220;Unfortunately, most of the users who install themes directly via their WP dashboards are not very experienced, and they have no reason to research the web a bit more to find out what happened to the theme they heard about. In other words, if someone types &#8216;zerif&#8217; into the search field in their dashboard and they find nothing, they just move on.&#8221;</p>\n<p>Neagu said that in spite of differences Themeisle has had with the Theme Review Team, the company will continue to contribute and be part of the community. The theme&#8217;s suspension, re-working, and re-installment is an interesting case of what can happen when a company&#8217;s sales strategy is at odds with WordPress.org&#8217;s requirements.</p>\n<p>&#8220;Our products are focused towards beginners, being super easy to setup with built-in demo content, so they are not niched products that we can distribute in different communities,&#8221; Neagu said.</p>\n<p>&#8220;It is obvious that relying on a third-party marketplace is the worst scenario, but WordPress.org is the default solution: if you want to reach a large mass of people, you need to be there.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Feb 2017 21:47:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"BuddyPress: BuddyPress 2.8.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=264058\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://buddypress.org/2017/02/buddypress-2-8-1-maintenance-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:536:\"<p>BuddyPress 2.8.1 is now available. This maintenance release fixes four bugs, including two regressions in BuddyPress 2.8.0. See the <a href=\"https://buddypress.trac.wordpress.org/milestone/2.8.1\">Trac milestone</a> or the <a href=\"https://codex.buddypress.org/releases/version-2.8.1/\">official changelog</a> for more details.</p>\n<p>Version 2.8.1 is a recommended update for all BP installations. Update via the WordPress Dashboard, or download manually from <a href=\"https://wordpress.org/plugins/buddypress/\">wordpress.org</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Feb 2017 19:41:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Boone Gorges\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:115:\"WPTavern: WordPress Core Editor Team Publishes UI Prototype for “Gutenberg,” an Experimental Block Based Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65960\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:119:\"https://wptavern.com/wordpress-core-editor-team-publishes-ui-prototype-for-gutenberg-an-experimental-block-based-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3690:\"<p>In the past few weeks, the WordPress Core Editor team, <a href=\"https://wptavern.com/matt-mullenweg-announces-tech-and-design-leads-for-new-focus-based-development-cycle\">led by</a> Automattic employees Matías Ventura and Joen Asmussen, have been hard at work creating a new <a href=\"https://make.wordpress.org/core/2017/01/17/editor-technical-overview/\">content creation experience</a>. The team recently <a href=\"https://wordpress.github.io/gutenberg/\">published a UI prototype </a>for Gutenberg, an experimental block based editor. The editor displays content-specific toolbars when an element is selected and provides a way to move blocks up and down.</p>\n<img />Block Based Editor UI Prototype\n<p>While the goal is to reinvent WordPress&#8217; current editor, there&#8217;s no guarantee that the prototype will end up as the final product and is in a high state of flux.</p>\n<p>&#8220;The UI prototype exists mostly to serve as a non-static mockup,&#8221; Asmussen said. &#8220;It&#8217;s like a sandbox we&#8217;re building to test some of our mockups and assumptions, to see if they hold water or not. To that extent, it&#8217;s already been successful in informing us of things that worked well, and not so well.&#8221; The code that powers the editor is made up of about 90% JavaScript.</p>\n<p>One of the concerns in revamping the editor is accessibility. Joe Dolson <a href=\"https://make.wordpress.org/accessibility/2017/02/17/revising-the-wordpress-editor-gutenberg-and-accessibility/\">highlighted this concern</a> in a post on the Make WordPress Accessible site. Dolson notes that the accessibility team will work in tandem with the editor team to make the new editor as accessible as possible.</p>\n<p>&#8220;From an accessibility perspective, this is both an incredible opportunity to build a powerful and flexible experience for all users and an enormous risk that we could end up reducing the effectiveness of the editor for users with disabilities, or require them to use a 2nd-class editor without these enhanced editing capabilities,&#8221; Dolson said.</p>\n<p>&#8220;We in the WordPress accessibility community embrace the challenge of creating a great new experience, and want to assure the community that we are going to do everything we can to make sure that any new editor experience is as accessible as we can possibly make it.&#8221;</p>\n<p>Although the prototype&#8217;s functionality is limited, the team is interested to hear about your experience and expectations with using the editor. Some questions to consider during testing include:</p>\n<ul>\n<li>Talk through each step, what does this do?</li>\n<li>What does this feel like?</li>\n<li>As you use it, what is missing you feel should be there?</li>\n</ul>\n<p>Many users have already <a href=\"https://make.wordpress.org/design/2017/02/09/initial-editor-blocks-prototype-editor-testing/\">shared their experiences</a>, providing valuable insight that is fueling rapid improvements to the <a href=\"https://github.com/WordPress/gutenberg/\">project</a> on<a href=\"https://github.com/WordPress/gutenberg/\"> GitHub</a>.</p>\n<p>The best way to get involved and contribute to this project is to subscribe to the <a href=\"https://make.wordpress.org/design/\">Make WordPress Design</a> blog and provide feedback by commenting on posts. You can also submit pull requests or issues on <a href=\"https://github.com/WordPress/gutenberg/\">GitHub</a>. Weekly meetings dedicated to the Editor component are held on Wednesday at 19:00 CET on <a href=\"https://make.wordpress.org/chat/\">Slack</a> in the <a href=\"https://make.wordpress.org/design/tag/core-editor/\">#core-editor</a> channel.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Feb 2017 18:31:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"HeroPress: A Sense Of True Freedom\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1610\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://heropress.com/essays/sense-true-freedom/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9233:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/02/022217-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: At any given time, I am who I want to be, & I\'m right where I want to be.\" /><p>It’s 7:30 in the morning in Rio de Janeiro, Brazil. The hostel’s cat just came to say “Good morning” and I just finished my night shift on the WPMU DEV forum. It’s my third day in Rio after spending the last 40 days in Bogota, Colombia. Traveling is in my blood or at least, it is now.</p>\n<p>I’m a full-time digital nomad and I have been for over a year now.</p>\n<blockquote><p>I’m single, I’m female and because of WordPress, I can travel around the world and work at the same time.</p></blockquote>\n<p>I started using WordPress in 2009, but I like to think that everything started in 2011 when I attended my first WordCamp in Poland. I remember I was extremely shy, scared and bit lost on the first day of WordCamp.</p>\n<p>It was a different world to me or at least in contrast to what I had at home – a small city in South East Poland. It was different because for the first time in a long time since college, I felt like I fit in with everyone there. They were a right fit for me and so was that place.</p>\n<p>Since that first WordCamp, I also attended many more in Poland as well as in other countries. Later, I went on to be the lead organizer of WordPress meetups in Wrocław and two WordCamps in Poland. I was also a speaker for many Polish events and for one WordCamp Paris.</p>\n<p>If not for the WordPress community and the friends I met on that very first WordCamp, I wouldn’t have been able to achieve any of those accomplishments.</p>\n<blockquote><p>But how could I have become a full-time digital nomad, you ask?</p></blockquote>\n<p>In 2015, I was stuck. I had a great, steady job in Wrocław. I was working with WordPress and everything was perfect, at least, that’s what I thought at the time.</p>\n<p>I achieved almost everything that society around me was expecting: a partner, apartment, a great job and the next step would have been getting married and having kids. Suddenly, I was sinking.</p>\n<p>For a year, the only moments where I was truly happy was when I was attending WordCamps and WordPress meetups – when I was with my “tribe”, my friends.</p>\n<p>Then, in May of 2015, something incredible happened: one of my friends sent me a link to a list of 70 companies which offered positions working remotely. Three of them were related to WordPress: Automattic, OnTheGoSystems and Incsub.</p>\n<p>That same day, I feverishly filled out an application for a position as a Support Star at Incsub, the parent company to WPMU DEV.</p>\n<p>After a wait full of agonizing anticipation, I finally got the job and six months later, I bought a one-way ticket to Japan, then one to Australia.</p>\n<blockquote><p>This was just the start of my life as a digital nomad.</p></blockquote>\n<p>Working at WPMU DEV remotely with partial dedicated hours and the rest being flexible allowed me to move and work while traveling.</p>\n<p>The people I work with comprise the best team ever. My boss, Tim, is incredibly supportive and is willing to help when something bad happens. I didn’t need to be worried about my job when my plans suddenly made a turn for the worse, which did happen. When I had to fly back to Poland in the middle of the week due to family emergencies, it wasn’t a problem.</p>\n<p>I always felt safe in the WordPress community and now I’m grateful to also feel safe with the people I work with even though we’re spread out across the globe and across many cultures.</p>\n<p>Even though I’m confident in my choice of being a digital nomad now, that wasn’t always the case. This was especially true since I apparently managed to make quite the big scandal in my hometown because “good girls” don’t run away.</p>\n<p>To my dismay, I was constantly told, “Study hard and you will get a nice, steady job in an office with insurance and a guaranteed retirement.”</p>\n<p>How could I not want that? After all, that’s supposed to be the dream of every woman, right? That’s what I was constantly told, anyway.</p>\n<p>Luckily, my best friend (who I had met at a WordCamp!) was there for me and said, “Don’t let them get to you. You are far away and they can’t hurt you.”</p>\n<p>Since then, I stood with my decision to finally be free and happy.</p>\n<p>Growing up in small city and being interested in computers and IT was not easy to say the least. Those aren’t traditionally considered subjects that interest girls. It also became all the more difficult when I realized this was something I wanted to do and nothing else.</p>\n<p>There weren’t many people around me in my hometown who understood what I wanted to do and even fewer people who would support me. Unfortunately, this is still true. It became tougher when I was diagnosed with heavy bipolar disorder.</p>\n<blockquote><p>At that time, everything sucked. I was lost and hopeless.</p></blockquote>\n<p>Compounding my stress, it was around then that I realized I also suffered from the impostor syndrome – the belief that you don’t know enough about the industry you’re in to be capable of doing your job and that you never will despite anything you do.</p>\n<p>There was an ugly feeling that crept in: I wanted to be somewhere else and I want to be different.</p>\n<p>Fortunately, every time I attended a WordCamp or WordPress meetup, these thoughts would melt away because I felt completely supported.</p>\n<p>It didn’t matter that I’m a girl or that I’m delightfully weird. What did matter was that I was knowledgeable about WordPress, my skills were growing quickly and that I could contribute to the community using my organizational skills.</p>\n<p>During these meetings, I don’t ever remember someone assuming that I’m a graphic designer because I’m a girl and “girls know color.” There’s nothing wrong with being a graphic designer, but assuming someone is based solely on their gender – there’s definitely something wrong with that.</p>\n<p>In reality, I’m a theme developer and in the WordPress community, that wasn’t unusual.</p>\n<p>It helped me gain confidence in myself and my skills. With that confidence, I found courage to start a life where I’m no longer wanting to be somewhere else or be someone else.</p>\n<blockquote><p>At any given time, I am who I want to be and I’m right where I want to be.</p></blockquote>\n<p>Solo traveling isn’t always peaches and cream or sunshine, lollipops and rainbows everywhere, especially when I’m sick and inevitably alone. All things considered, I wouldn’t swap it out for what many would consider to be a “normal” life – whatever that is – and instead, I think it&#8217;s important for people to do what makes them happy and not just what others expect of them.</p>\n<p>As a digital nomad, I was able to go to WordCamps in Tokyo, Belgrade, the US, Singapore and Vienna. I have met many new people and I have collected incredible memories along the way.</p>\n<p>This year and in many more to come, while others may doubt my choices, I’ll be happy, traveling to more WordCamps and enjoying a sense of true freedom just because I can.</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: A Sense Of True Freedom\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=A%20Sense%20Of%20True%20Freedom&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fsense-true-freedom%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: A Sense Of True Freedom\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fsense-true-freedom%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fsense-true-freedom%2F&title=A+Sense+Of+True+Freedom\" rel=\"nofollow\" target=\"_blank\" title=\"Share: A Sense Of True Freedom\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/sense-true-freedom/&media=https://heropress.com/wp-content/uploads/2017/02/022217-150x150.jpg&description=A Sense Of True Freedom\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: A Sense Of True Freedom\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/sense-true-freedom/\" title=\"A Sense Of True Freedom\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/sense-true-freedom/\">A Sense Of True Freedom</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 22 Feb 2017 12:00:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Kasia Świderska\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Solving the Mystery of How People Actually Use WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65557\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"https://wptavern.com/solving-the-mystery-of-how-people-actually-use-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9727:\"<p>I’m in favor of <a href=\"https://wptavern.com/wordpress-telemetry-proposal-addresses-long-standing-privacy-concerns-as-gdpr-compliance-deadline-looms#comment-208658\">WordPress collecting more anonymized usage data</a> that could help make informed decisions on changes or improvements to core, such as tracking changes to the WordPress user interface, which buttons or settings are used most often, etc.</p>\n<p>A good example of when this data could have come in handy is the recent <a href=\"https://wptavern.com/wordpress-4-7-removes-the-underline-and-justify-buttons-from-the-editor\">removal of the justify and underline buttons</a> from the editor in WordPress 4.7. During <a href=\"https://core.trac.wordpress.org/ticket/27159#comment:82\">the discussion</a> on whether they should be removed or not, a number of people questioned if there was any user data available that would indicate how much they’re used and help gauge the impact of removing them.</p>\n<p>The only data available to help make an informed decision was provided by Mel Choyce. Choyce <a href=\"https://core.trac.wordpress.org/ticket/27159#comment:29\">shared statistics</a> from WordPress.com and its variety of editor interfaces that indicated Bold, Italic, and Links are used the most while Lists and Blockquotes are the second most used buttons.</p>\n<p>The Center and Left alignment buttons are used often, but the data doesn’t determine if people are using them to align text or images. Information on which headings are used most was not available. The team did not have any usage data specific to the WordPress core editor.</p>\n<p>In the ticket, Andrew Ozz, who maintains the TinyMCE component, <a href=\"https://core.trac.wordpress.org/ticket/27159#comment:103\" rel=\"nofollow\">chimed in</a> and agreed that good user data is needed.</p>\n<p>In an effort to obtain usage data before removing the buttons, Ozz <a href=\"https://core.trac.wordpress.org/ticket/27159#comment:104\">created a small plugin</a> to perform testing with five existing and first-time users. Interestingly, he discovered that both types of users clicked on the kitchen sink button to display the second row of buttons and didn&#8217;t click the button to hide them again.</p>\n<p>Ozz also shared other results from his limited testing.</p>\n<blockquote><p>I know these test results are extremely limited and cannot be used when making a decision, but they are an indication of what &#8216;real&#8217; testing may reveal. In this case it shows that moving buttons to the bottom row will have no effect on the usage of these buttons as they will still be visible at all times.</p>\n<p>This super limited testing also indicated another (much bigger) problem: somebody mentioned this some time ago (think it was @mor10), around 20% of the WordPress users don’t even know there is a second editor toolbar, and some feel &#8216;pretty stupid&#8217; after discovering it. I think this is bad UX and something that can be fixed easily by having the second toolbar open by default, and fixing it is more important and will improve the UX for these 20% of users a lot.</p></blockquote>\n<p>Imagine how useful it would be for core developers or others if there was usage data like this on a grander scale that could fuel rapid improvements and help discover and eliminate pain points.</p>\n<p>Matt Mullenweg, co-creator of the WordPress project, has <a href=\"https://core.trac.wordpress.org/ticket/38418\">closed the ticket</a> with the Telemetry Proposal as it&#8217;s not within the <a href=\"https://wptavern.com/state-of-the-word-2016-mullenweg-pushes-calypso-as-future-of-wordpress-interface-proposes-major-changes-to-release-cycle\">three project focus areas</a> for 2017.</p>\n<p>&#8220;There is no part of current or potential WP development that is being held back by the lack of this existing, as there are easy and current ways to answer questions with data to the extent it would inform our decisions,&#8221; Mullenweg said.</p>\n<p>Morten Rand-Hendriksen <a href=\"https://core.trac.wordpress.org/ticket/38418#comment:11\">responded to the closure</a> saying that the quantitative user testing falls squarely within the Customizer focus area.</p>\n<p>&#8220;I would argue since the release of the Customizer some years back, it has gone through a multi-year large-scale quantitative user test with incremental tweaks and improvements,&#8221; Rand-Hendriksen said.</p>\n<p>&#8220;This is in line with standard agile development. At this juncture, the Customizer can be considered mature, and moving a mature solution forward requires hard data on usage, use cases, and user needs. This goes beyond standard user testing to large-scale data collection, which is what this ticket aims at addressing.&#8221;</p>\n<h2>Perspective From a WordPress Release Lead</h2>\n<p>There are WordPress core developers who have shown interest in a similar system. At the start of the WordPress 4.7 development cycle, Drew Jaynes, who led the WordPress 4.2 release cycle, <a href=\"https://make.wordpress.org/core/2016/08/17/wordpress-4-7-whats-on-your-mind/#comment-30573\">expressed interest</a> in creating an opt-in data collection system.</p>\n<p>The idea received positive feedback that included people offering to help. I asked Jaynes what his thoughts are on such a system and how it could benefit core development.</p>\n<p>&#8220;There&#8217;s some discussion about what form that collection should take initially, but I think there&#8217;s consensus that it should be opt-in, and take one of two forms (or a hybrid of the two): active (surveys in the admin) or passive (anonymized usage) data collection,&#8221; Jaynes said.</p>\n<p>&#8220;Either way, I think having this data available would benefit the entire community, regardless of the obvious practicable application within core development.</p>\n<p>&#8220;All of that data can and should be used to inform decision-making in WordPress going forward. The core team really needs to hit the reset button on the concept of the 80/20 rule, including what and whom it represents.</p>\n<p>&#8220;We should be building modern WordPress for the modern WordPress user, and resting on Matt&#8217;s instincts coupled with the core team&#8217;s experience is no longer enough to maintain positive forward momentum.&#8221;</p>\n<p>Jaynes cites the editor as an example of where having the data would be helpful and that without it, pursuing an idealized &#8216;modern editor&#8217; in WordPress is premature. The data could also help provide insight into improving the new user experience.</p>\n<p>&#8220;A common complaint is that the WordPress admin can be really overwhelming to new users,&#8221; Jaynes said. &#8220;Having real data about how frequently the various core screens are used could really inform decisions about maybe paring it down, or hiding some things over time that are used less and less.&#8221;</p>\n<p>While collecting data could help with making informed decisions, he doesn&#8217;t think it should stop the core team from experimentation.</p>\n<p>&#8220;I think having real, citable data could really reduce the amount of backlash we&#8217;ve seen with a few releases in the last couple of years,&#8221; Jaynes said. &#8220;Areas where core team decisions left some group of users feeling jilted.&#8221;</p>\n<p>&#8220;It&#8217;s worth mentioning that there&#8217;s absolutely value in allowing the core team to experiment, as long as we&#8217;re careful not to latch onto something that got merged as the only way we&#8217;ll ever need to solve that problem; that&#8217;s where we get into trouble.&#8221;</p>\n<h2>Who Are The 80/20 Users of WordPress?</h2>\n<p>The most striking statement in Rand-Hendriksen&#8217;s proposal is that WordPress development is occurring without having any idea who the 80% or 20% of users are.</p>\n<p>&#8220;During the development of WordPress 4.7, I was involved in several conversations centered around <em>assumed use</em> of features,&#8221; Rand-Hendriksen said.</p>\n<p>&#8220;The general argument was that based on the 80/20 rule, certain features should be added while others should be removed. I kept bringing up the well-known fact we don’t have a clue what features 80%, or even 20%, of WordPress users actually use so any claim of validity in the 80/20 rule is guesswork at best.&#8221;</p>\n<p>Collecting usage data is standard practice. Microsoft Windows, Mozilla Firefox, Chrome, iOS, and a number of other software projects have opt-in data collection systems that are used to improve the product. They also provide insight into how customers are using their products.</p>\n<p>WordPress development on the other hand relies on the support forums, data collected from WordPress.com, limited user testing, verbal feedback at WordCamps, and other small data points. Collecting usage data from WordPress could show trends and provide evidence for changes related to the <a href=\"https://wordpress.org/about/philosophy/\">decisions not options philosophy</a> of WordPress development.</p>\n<p>Collecting usage data isn&#8217;t going to solve all of WordPress&#8217; woes but having it available to make more informed decisions is better than not having any data at all. Although an opt-in data collection system in WordPress won&#8217;t be a core focus any time soon, it&#8217;s encouraging to see the idea has merit and is something some core developers are interested in seeing become a reality.</p>\n<p>I&#8217;d gladly opt-in and share my usage data with WordPress.org as long as it was anonymized and displayed publicly in aggregate. Would you?</p>\nNote: There is a poll embedded within this post, please visit the site to participate in this post\'s poll.\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Feb 2017 02:07:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"WPTavern: BuddyPress 2.8 Boosts Minimum PHP Requirement, Adds Twenty Seventeen Companion Stylesheet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66090\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"https://wptavern.com/buddypress-2-8-boosts-minimum-php-requirement-adds-twenty-seventeen-companion-stylesheet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2774:\"<p><a href=\"https://buddypress.org/2017/02/buddypress-2-8-0-san-matteo/\" target=\"_blank\">BuddyPress 2.8</a> “San Matteo,” was released last week, led by long-time BuddyPress contributor Slava Abakumov. The release was named for <a href=\"http://www.sanmatteopanuozzo.com/\" target=\"_blank\">San Matteo Panuozzo</a>, an NYC pizza restaurant that specializes in panuozzo, a more portable pizza-sandwich hybrid. Following suit with the previous release, 2.8 focuses on improvements for developers and site builders, the project&#8217;s new target audience as of 2016.</p>\n<p>As part of an effort to modernize the plugin&#8217;s codebase and prepare it for better integration with the BP REST API project, this release <a href=\"https://codex.buddypress.org/getting-started/buddypress-2-8-will-require-php-5-3/\" target=\"_blank\">boosts the minimum PHP requirement to 5.3</a>. In BuddyPress versions 2.7+, the plugin will display a notice in the dashboard if it detects that the server doesn&#8217;t meet the minimum requirements for running 2.8. The change is not likely to affect many BuddyPress sites as only a small sliver (5.7%) of WordPress sites are running on PHP 5.2.</p>\n<p>This release also adds a companion stylesheet for <a href=\"https://wordpress.org/themes/twentyseventeen/\" target=\"_blank\">Twenty Seventeen</a>. This stylesheet is important for providing a good first impression of BuddyPress for those who are trying try out the plugin with WordPress&#8217; latest default theme. A <a href=\"https://codex.buddypress.org/themes/bp-theme-compatibility-and-the-wordpress-default-themes/twenty-seventeen-theme/\" target=\"_blank\">new BP codex page</a> gives sample code for changing Twenty Seventeen&#8217;s default two-column layout to be a full-width layout.</p>\n<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/02/buddypress-twenty-seventeen.png?ssl=1\"><img /></a></p>\n<p>The 2.8 release brings improvements to the “Activate Pending Accounts” screen, making it easier for site managers to confirm or reject new registrants. Clicking on the username of a pending account will now display profile data that the user entered at signup.</p>\n<p>Other improvements for developers include the following:</p>\n<ul>\n<li>New filters and actions for the Messages component</li>\n<li>Support for List-Unsubscribe header in emails</li>\n<li>More flexible Group search</li>\n<li>New filter enables choice of which PHPMailer should be used when sending BuddyPress emails</li>\n</ul>\n<p>BuddyPress 2.8 was made possible by 44 volunteer contributors. For a full list of all the changes in this release, check out the official <a href=\"https://codex.buddypress.org/releases/version-2-8-0/\" target=\"_blank\">2.8.0 changelog</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 21 Feb 2017 00:33:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: Composing a WordPress Development Environment with Docker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66335\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://wptavern.com/composing-a-wordpress-development-environment-with-docker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6432:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2015/03/petersuhm.jpeg?ssl=1\"><img /></a>This post was contributed by guest author <a href=\"http://petersuhm.com/\" target=\"_blank\">Peter Suhm</a>. Peter is a web developer from the Land of the Danes. He is the creator of <a href=\"https://wptavern.com/wp-pusher-aims-to-provide-pain-free-deployment-of-wordpress-themes-and-plugins-from-github\" target=\"_blank\">WP Pusher</a> and a huge travel addict, bringing his work along with him as he goes.<br />\n&nbsp;</p>\n<hr />\n<p>In the last few years, a wave of virtualization technologies have swept through our WordPress development environments. The one that&#8217;s sounded the most promising to me has been Docker: lightweight and flexible. Yet, until recently, getting Docker up and running was an overwhelming task &#8211; especially on a non-Linux machine. If you managed to get it up and running in a virtual machine (using Vagrant or similar), getting port-forwarding to work would make you give up and just use Vagrant instead.</p>\n<p>Now it&#8217;s different.</p>\n<p>With (a stable) Docker for Mac and Windows and <a href=\"https://docs.docker.com/compose/\" target=\"_blank\">Docker Compose</a> at hand, getting Docker up and running is easy and pain-free. With Docker Compose you can tell Docker exactly what you want your WordPress development environment to look like and it will take care of it.</p>\n<h3>What is Docker?</h3>\n<p>Docker is a technology that makes it really simple to create isolated containers for your applications and websites to run in. These containers can be combined and modified to fit the needs of your applications. Docker is utilizing the Linux Containers technology (LXC) where multiple isolated environments can share the same Linux kernel &#8211; making it very lightweight compared to something like Vagrant.</p>\n<p>The Docker ecosystem is built around containers. In the Docker Hub, you can find an endless number of containers that other people have built or you can build your own using a Dockerfile. When building your own, you can start from scratch using the base Ubuntu image or extend someone else&#8217;s image.</p>\n<p>You can share local directories with your containers and link the networks, so they can talk to each other &#8211; just like you know it from other virtualization technologies. However, this is where it gets complicated which leads me to Docker Compose:</p>\n<h3>What is Docker Compose?</h3>\n<p>Docker Compose is what makes Docker available to mortals like you and me. As the name implies, Docker Compose is a tool for composing Docker containers. That means defining your services (containers), setting up the network between them, sharing local directories with them, and a few more things.</p>\n<p>With Docker Compose you create a simple file in the root of your project that describes the setup required by your application/website. For a WordPress theme that might mean a container to run WordPress, a container to run MySQL and a container to run Gulp or Grunt. This can very easily be defined in a docker-compose.yml file that can then be shared with your team members. This means that you can now share your WordPress theme, including an isolated WordPress environment to run it in. Hurray for virtualization!</p>\n<h3>Why use Docker?</h3>\n<p>There are a few reasons why Docker is an attractive technology for me. Here are the most important requirements I have for my development environment and how Docker solves them:</p>\n<ul>\n<li><strong>Clean Mac:</strong> In an ideal world, I prefer not to install anything related to my development environment directly on my Mac. I work on so many different projects that this gets unmanageable. When one thing works, another doesn&#8217;t. I also travel a lot and should something happen to my computer, I want to be able to set up a new machine in minutes.</li>\n<li><strong>Shareable:</strong> I often work in teams, so sharing my development environment with teammates is crucial. This is possible with Vagrant, but it&#8217;s still very tricky to keep environments in sync across teams.</li>\n<li><strong>Lightweight:</strong> This is important, especially when on the road. Try running a few Vagrant boxes compared to a few Docker containers and see what I mean.</li>\n<li><strong>Extendable:</strong> Extending Docker is very easy. For example, I could extend the official WordPress container and build it with WP Pusher pre-installed, since I (obviously) always use it.</li>\n<li><strong>Mirror production:</strong> My development environment needs to be as close to production as possible. With Docker this is easy, since Docker can be used in production as well.</li>\n</ul>\n<h3>My Docker development environment</h3>\n<p>This is the very simple Docker setup I use for development of my WP Pusher plugin: A WordPress and a MySQL container. Both of them use the official Docker Hub images, so setting it up is very easy.</p>\n<p>My <code>docker-compose.yml</code> file looks like this:</p>\n<p></p>\n<p>It describes two services: a MySQL 5.7 database and WordPress running on PHP 5.6 and Apache. The database is using a volume on my local machine, so data will be persisted every time I shut off the container. My current directory (in this case a plugin) is mounted into the <code>wp-content/plugins</code> directory. This allows me to work on my plugin in a completely isolated WordPress environment &#8211; without installing anything, besides Docker, on my Mac. The WordPress container forwards port 80 to my local machine, so I can access it as &#8220;localhost&#8221; in my browser.</p>\n<p>If you want to try it for yourself, and have Docker installed on your machine, just add the file to your plugin (or theme) and run:</p>\n<p><code>$ docker-compose up -d</code></p>\n<p>In order to see which containers are running, just run:</p>\n<p><code>$ docker ps</code></p>\n<p>This a very simple setup that is easy to extend and build upon.</p>\n<p>I hope this post made you curious about Docker and WordPress. Thanks for reading along!</p>\n<h3>Links</h3>\n<ul>\n<li><a href=\"https://docs.docker.com/compose/\" target=\"_blank\">Docker Compose</a></li>\n<li><a href=\"https://hub.docker.com/\" target=\"_blank\">Docker Hub</a></li>\n<li><a href=\"https://blog.wppusher.com/the-easiest-way-to-use-docker-for-wordpress-development/\" target=\"_blank\">My Docker setup for WP Pusher</a></li>\n</ul>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 20 Feb 2017 18:23:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:115:\"WPTavern: Disqus Hits Sites with Unwanted Advertising, Plans to Charge Large Publishers a Monthly Fee to Remove Ads\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66098\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"https://wptavern.com/disqus-hits-sites-with-unwanted-advertising-plans-to-charge-large-publishers-a-monthly-fee-to-remove-ads\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7974:\"<p>When Disqus <a href=\"https://blog.disqus.com/our-plans-for-2017\" target=\"_blank\">announced</a> it would be releasing new, subscription-based versions later this year, users didn&#8217;t expect to have the new advertising model injected into their sites without notice. Disqus CEO Daniel Ha said the company would release finalized pricing and provide more details well in advance of its planned March release, but users are reporting that the advertising has already been forced into their comments without warning.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Why did <a href=\"https://twitter.com/disqus\">@disqus</a> just add a bunch of ads to my site without my permission? <a href=\"https://t.co/CzXTTuGs67\">https://t.co/CzXTTuGs67</a> <a href=\"https://t.co/y2QbFFzM8U\">pic.twitter.com/y2QbFFzM8U</a></p>\n<p>&mdash; Harry Campbell (@TheRideShareGuy) <a href=\"https://twitter.com/TheRideShareGuy/status/826921387273052160\">February 1, 2017</a></p></blockquote>\n<p></p>\n<p>&#8220;We are one of the lucky 5% who now has to pay if we don&#8217;t want really irrelevant and horribly spammy links just plopped on our site with zero warning,&#8221; BabyCenter Social Media Manager Dina Vernon Freeman said. &#8220;Unless our users (mainly millennial parents) should care about overpaying for dentures! We&#8217;re looking for other platforms ASAP.&#8221;</p>\n<p>Brian O&#8217;Neill, who manages Slugger O&#8217;Toole, a site with more than 70,000 readers, was also hit with unwanted advertising on his site.</p>\n<p>&#8220;Disqus has started to put ads into our comments section of our site without even telling us,&#8221; O&#8217;Neill said in a <a href=\"https://sluggerotoole.com/2017/02/02/bear-with-us-as-we-try-to-remove-those-terrible-disqus-ads-from-the-comments-area/\" target=\"_blank\">post</a> explaining the new ads to the site&#8217;s readers. &#8220;As you can imagine I am extremely annoyed at this – I hate crappy online ads as much as you do. Supposedly we can remove the ads if we pay them $10 a month, but as yet there is no mechanism on their site to do this.&#8221; O&#8217;Neill said he is also exploring alternative commenting systems if he is unable to remove the advertising.</p>\n<p>Disqus responded to user complaints with a post to clarify that <a href=\"https://blog.disqus.com/advertising-will-remain-optional-for-over-95-of-sites-on-disqus\" target=\"_blank\">advertising will remain optional for more than 95% of the sites on Disqus</a>.</p>\n<p>&#8220;Larger, commercial, sites that elect to use the free version of Disqus will be supported by configurable advertising and have the option to earn revenue through the Reveal program,&#8221; Disqus Marketing Manager Mario Paganini said. &#8220;For small, non-commercial sites, advertising will be optional. These sites will be able to use Disqus’ ads-optional subscription, free of charge.&#8221;</p>\n<p>Publishers asked in the comments when the option to pay to remove ads will become available, as an option to pay isn&#8217;t currently in place.</p>\n<p>&#8220;Larger sites will be able to run a paid subscription version of Disqus that includes the ability to remove ads along with additional features,&#8221; Paganini said. &#8220;We are aiming to have this available in the next couple of months. We will be making periodic updates on our blog and talking to publishers in the meantime.&#8221;</p>\n<p>Disqus is moving to focus on its larger publishers but has already attracted angry criticism from publishers that were not properly informed of the changes. Over the years the company has experimented with different ways of monetizing the commenting platform, often frustrating users in the process of making important changes.</p>\n<p>In 2014, Disqus began experimenting with advertising in the form of &#8220;Sponsored Comments&#8221; that users could not turn off without contacting support. This move drew <a href=\"https://ma.tt/2014/11/disqus-spam-ads/\" target=\"_blank\">criticism from WordPress co-founder Matt Mullenweg</a> who essentially called out the ads as little more than comment spam. After a negative reaction from its community, Disqus quietly discontinued the Sponsored Comments and scrubbed the <a href=\"https://blog.disqus.com/heads-up-were-testing-a-new-form-of-advertising\" target=\"_blank\">announcement post</a> from the internet.</p>\n<h3>Disqus Delivers Low-Quality Ads</h3>\n<p>Disqus has struggled to land on an effective advertising model that will convince users to get on board. Its <a href=\"https://help.disqus.com/customer/portal/articles/2069645-reveal-f-a-q-\" target=\"_blank\">Reveal advertising program</a> is notorious for serving low-quality ads and has inspired little confidence in users who have tried it. The following is one of the tamer examples:</p>\n<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/02/disqus-ads.png?ssl=1\"><img /></a></p>\n<p>&#8220;I think if you had somewhat decent advertising you might convince people that it&#8217;s worth it, but I had to yank it from one of my sites because it was all &#8216;Ron Paul wants you to buy gold!&#8217; and &#8217;22 times the photos showed too much!\'&#8221; Paul King, an author who writes for multiple publications, commented on Disqus&#8217; most recent advertising announcement. &#8220;Just put in a tier of non-spam advertising that&#8217;s actually relevant or charge based on comments or something.&#8221;</p>\n<p>Twitter is filled with complaints from users who are dissatisfied with the questionable quality of Disqus&#8217; advertising. Many are searching for alternatives.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/disqus\">@disqus</a> We\'ve disabled ads straight away (they are literally ALL scams) &#8211; if you force those ads on us, we\'re dropping you like a hot potato</p>\n<p>&mdash; That\'s Nonsense (@thatsnonsense) <a href=\"https://twitter.com/thatsnonsense/status/828739990486208512\">February 6, 2017</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Why <a href=\"https://twitter.com/disqus\">@disqus</a> think it\'s acceptable to serve disgusting, misogynistic ads (OR ANY ADS) on people\'s blogs without asking is beyond me.</p>\n<p>&mdash; Rosie (@RosieLondoner) <a href=\"https://twitter.com/RosieLondoner/status/828642646478426112\">February 6, 2017</a></p></blockquote>\n<p></p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">I\'m removing <a href=\"https://twitter.com/hashtag/disqus?src=hash\">#disqus</a> from <a href=\"https://t.co/PSlovlA6Tm\">https://t.co/PSlovlA6Tm</a> since they\'ve suddenly turned on (notably creepy) ads with no warning.</p>\n<p>&mdash; James Britt <img src=\"https://s.w.org/images/core/emoji/2.2.1/72x72/1f3a7.png\" alt=\"🎧\" class=\"wp-smiley\" /> (@jamesbritt) <a href=\"https://twitter.com/jamesbritt/status/826922670407172096\">February 1, 2017</a></p></blockquote>\n<p></p>\n<p>This recent move to turn on advertising without publishers&#8217; permission is another communication blunder in the same vein as the previous attempt at Sponsored Comments. Disqus has failed to find a communication strategy that respects users&#8217; content while leading the company towards its goals at the same time. With spam-quality ads deploying network-wide, the company can certainly expect that some users will be willing to pay the $10/month to turn them off. Sadly, the experience of paying to turn off offensive ads feels more like getting mugged on your way to work than upgrading your service.</p>\n<p>The <a href=\"https://wordpress.org/plugins/disqus-comment-system/\" target=\"_blank\">Disqus Comment System</a> plugin has been hovering around 200,000 active sites for the past two years and its ratings continue to plummet on WordPress.org. Unless Disqus is able to dramatically improve its advertising network before its official March release, we may see a mass exodus to other commenting systems.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 18 Feb 2017 00:16:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WPTavern: How to Check if Installed Plugins Are No Longer in the Plugin Directory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66106\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"https://wptavern.com/how-to-check-if-installed-plugins-are-no-longer-in-the-plugin-directory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9904:\"<p>When we wrote about <a href=\"https://wptavern.com/why-plugins-sometimes-disappear-from-the-wordpress-plugin-directory\">why plugins sometimes disappear</a> from the WordPress plugin directory, it generated a healthy discussion in the comments. One of the topics of discussion brought up is whether or not <a href=\"https://wptavern.com/why-plugins-sometimes-disappear-from-the-wordpress-plugin-directory#comment-209733\">users should be notified</a> when a plugin disappears and if so, how?</p>\n<p>Currently, when a plugin is hidden on the directory, users are not notified. If it&#8217;s removed due to a security vulnerability and the author chooses not to fix it or move the plugin somewhere else such as <a href=\"https://github.com/\">GitHub</a>, users are left in the dark.</p>\n<p>Donna Cavalier shared a <a href=\"https://wordpress.org/support/topic/plugin-is-missing-on-the-wordpress-org-directory/\">recent example</a> of why users should be notified. Contact Form DB is a popular plugin that saves contact form submissions from many popular Contact Forms plugins to the database. As of <a href=\"https://web.archive.org/web/20161030050515/https://wordpress.org/plugins/contact-form-7-to-database-extension/\">October 30th, 2016</a>, it was actively installed on more than 400K sites.</p>\n<p>Approximately <a href=\"https://wordpress.org/support/topic/plugin-is-missing-on-the-wordpress-org-directory/\">one month ago</a>, the plugin was hidden due to a security vulnerability. Instead of releasing a patch, Michael Simpson, creator of Contact Form DB, moved the plugin <a href=\"https://github.com/mdsimpson/contact-form-7-to-database-extension/releases\">to GitHub</a> and subsequently released a <a href=\"https://github.com/mdsimpson/contact-form-7-to-database-extension/releases/tag/v2.10.30\">new version</a> that patched the vulnerability. Simpson says the person on the plugin review team that he spoke with was condescending, unprofessional, and rubbed him the wrong way.</p>\n<p>&#8220;I’m happy to address any issues and meet any standards, but I’m at the limit of my patience,&#8221; Simpson said.</p>\n<p>&#8220;I try to be a good citizen and give back to the community. I’ve put in countless hours for close to seven years now. When I’m treated like this, it seems WordPress doesn’t value me or my contribution to its community.</p>\n<p>&#8220;Anyway, I put the code on GitHub and I will continue to support it. But at this point I’m not sure I want to deal with people like this to re-list the plugin on this site. I don’t need the frustration.&#8221;</p>\n<p><strong>If you use Contact Form DB, please <a href=\"https://github.com/mdsimpson/contact-form-7-to-database-extension/releases/tag/v2.10.30\">update to 2.10.30</a> as soon as possible as it contains the aforementioned security fix.</strong></p>\n<p>It&#8217;s impossible for Contact Form DB users to automatically install updates from GitHub without installing an <a href=\"https://wptavern.com/github-updater-4-1-to-add-remote-installation-for-wordpress-plugins-and-themes\">updater plugin</a>. This leaves thousands of sites at risk.</p>\n<h2>How to Know When Installed Plugins Are No Longer in the Directory</h2>\n<p>In the comments of <a href=\"https://wptavern.com/why-plugins-sometimes-disappear-from-the-wordpress-plugin-directory\">our article</a>, Tavern reader Central Geek <a href=\"https://wptavern.com/why-plugins-sometimes-disappear-from-the-wordpress-plugin-directory#comment-209776\">shared links</a> to a couple of plugins aimed at providing useful information such as, whether a <a href=\"https://wordpress.org/plugins/vendi-abandoned-plugin-check/\">plugin has been abandoned</a> and <a href=\"https://wordpress.org/plugins/better-plugin-compatibility-control/\">better plugin compatibility information</a>.</p>\n<p>One of the plugins he mentions is called <a href=\"https://wordpress.org/plugins/no-longer-in-directory/\">No Longer in Directory, </a>developed by <a href=\"https://profiles.wordpress.org/whitefirdesign/\">White Fir Design</a>. The plugin adds a page to the WordPress backend that informs users if any of the plugins that are installed are available in the plugin directory. It also separately lists installed plugins that haven&#8217;t been updated in two years or more.</p>\n<p><img /></p>\n<p>The check is performed using the plugin directory&#8217;s folder name. The author notes that this could lead to plugins that have never been in the plugin directory to be flagged if they use the same name as a plugin that was in the directory in the past. If you encounter this situation, you&#8217;re encouraged to create a new thread on the <a href=\"https://wordpress.org/support/plugin/no-longer-in-directory\">plugin&#8217;s support forum</a>.</p>\n<p>So far, No Longer in Directory is actively installed on more than 1K sites. Out of a total of <a href=\"https://wordpress.org/support/plugin/no-longer-in-directory/reviews/\">six reviews</a>, its average rating is 4.8 out of 5 stars. I tested the plugin with WordPress 4.8 alpha and didn&#8217;t encounter any issues.</p>\n<p>If this is a feature you&#8217;d like to see implemented in WordPress, consider <a href=\"https://wordpress.org/ideas/topic/alert-when-installed-plugins-have-been-removed-from-the-plugin-directory\">voting for it</a>. So far, the idea has 43 votes with a five-star average rating. <a href=\"https://profiles.wordpress.org/ipstenu\">Mika Epstein</a>, Plugin Directory Representative, <a href=\"https://wordpress.org/ideas/topic/alert-when-installed-plugins-have-been-removed-from-the-plugin-directory#post-22481\">responded to the idea</a> four years ago noting that it was being worked on.</p>\n<p>As Epstein mentioned in our previous article, explaining WHY a plugin has been closed is complex.</p>\n<p>“Obviously the last thing we want are people getting hacked, but it presents us with a few options and they all have flaws,&#8221; she said.</p>\n<p>&#8220;We’ve not been able to determine a way to tell people ‘This plugin is gone, don’t use it’ and ‘This plugin is gone, but use it if you want.’ without putting users at risk.”</p>\n<h2>If a Plugin Is Permanently Removed From the Directory, Users Should Be Notified</h2>\n<p>I believe users should be informed if a plugin is permanently removed from the directory. It doesn&#8217;t make sense to notify users if it&#8217;s temporarily hidden due to violating a guideline or a security issue. Plus, between upgrade and admin notices, users are receiving enough notifications as it is.</p>\n<p>I&#8217;m unsure if the notification should be an admin notice as we&#8217;ve <a href=\"https://wptavern.com/please-stop-abusing-wordpress-admin-notices\">already documented</a> how plugin authors are using them to advertise. Users are increasingly getting annoyed by them and they&#8217;re usefulness is in decline.</p>\n<p>There&#8217;s also the question as to who is responsible for informing users. This responsibility should fall squarely on the plugin author. If I was a plugin author and not interested in someone <a href=\"https://wptavern.com/adopt-me-plugin-tag-is-now-in-use-on-wordpress-org\">adopting my plugin</a> and wanted it removed from the directory, I&#8217;d do so by pushing out one last update.</p>\n<p>I&#8217;d explain in the plugin&#8217;s description and changelog that support and updates would no longer occur and that users should seek alternatives. I might even suggest a few that come to mind. Then, after about a month, I&#8217;d submit a request to the plugin review team to permanently remove it.</p>\n<p>This would give users a heads up and plenty of time to seek out an alternative. The Post Template plugin is a good example of this idea in action. Here is the notice it displayed on all of its settings pages before it disappeared.</p>\n<blockquote><p><strong>Since version 4.0.0, the plugin has been released under a commercial license. New features such as addition of custom fields to the templates have been added. Furthermore, this version is discontinued, which means that no further bug fixes, new features and compatibility fixes for new WordPress versions will be implemented. If you want to buy the latest version of Post Template, please visit the plugin web page.</strong></p></blockquote>\n<p>By notifying users ahead of time, the responsibility shifts to the user to find an alternative.</p>\n<p><a href=\"https://wordpress.org/support/topic/plugin-is-missing-on-the-wordpress-org-directory/page/2/#post-8726059\">Simpon </a>said he&#8217;ll work to get the plugin re-listed but it may take some time as he&#8217;s swamped with work. At the time of publishing, <a href=\"https://wordpress.org/plugins/contact-form-7-to-database-extension/\">the plugin</a> is not available on WordPress.org.</p>\n<h2>An Unfortunate Situation for Users of Contact Form DB</h2>\n<p>While <a href=\"https://wordpress.org/support/topic/plugin-is-missing-on-the-wordpress-org-directory/page/2/\">users sympathized</a> with Simpson over his decision, I think it&#8217;s partly irresponsible. If a plugin has a security vulnerability, patching it and making it available as soon as possible should take precedence over how one feels about a situation.</p>\n<p>Instead of putting aside differences and pushing out an update to patch a security vulnerability, Simpson chose to move the plugin and the patched version to GitHub. The decision not to work with the plugin review team has put thousands of sites at risk with no easy way for users to update.</p>\n<p>Hopefully, Simpson will work with the team to get a patched version of Contact Form DB back onto the directory as soon as possible. Until then, if you use Contact Form DB, please <a href=\"https://github.com/mdsimpson/contact-form-7-to-database-extension/releases/tag/v2.10.30\">update to 2.10.30</a> manually as it patches the security vulnerability.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 17 Feb 2017 08:52:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"WPTavern: WPWeekly Episode 263 – Plugins Disappearing, WordCamp Miami, and OSTraining\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=66103&preview=true&preview_id=66103\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"https://wptavern.com/wpweekly-episode-263-plugins-disappearing-wordcamp-miami-and-ostraining\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3129:\"<p>In this episode, <a href=\"http://marcuscouch.com/\">Marcus Couch</a> and I discuss the news making headlines including, WordCamp Miami in its 9th year, OSTraining partnering with GoDaddy to release training videos, and why plugins sometimes disappear from the WordPress plugin directory. We also provide an update on the REST API vulnerability that is actively being exploited to deface webpages.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://wptavern.com/wordpress-rest-api-vulnerability-exploits-continue\">WordPress REST API Vulnerability Exploits Continue</a><br />\n<a href=\"https://wptavern.com/google-changes-the-wording-of-its-wordpress-update-notifications\">Google Webmaster Tools Fixes Confusing Messages About Updating WordPress</a><br />\n<a href=\"https://wptavern.com/wordcamp-miami-2017-to-host-javascript-track-ama-spots-and-2-day-kids-camp\">WordCamp Miami 2017 to Host JavaScript Track, AMA Spots, and 2-Day Kids’ Camp</a><br />\n<a href=\"https://wptavern.com/ostraining-partners-with-godaddy-to-launch-free-wordpress-beginner-course-on-youtube\">OSTraining Partners with GoDaddy to Launch Free WordPress Beginner Course on YouTube</a><br />\n<a href=\"https://wptavern.com/why-plugins-sometimes-disappear-from-the-wordpress-plugin-directory\">Why Plugins Sometimes Disappear From the WordPress Plugin Directory</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/mobile-featured-image/\">Mobile Featured Image</a> allows users to add a featured image specifically for mobile devices. The new image can be a resized version of your featured image or an entirely new image targeted especially at mobile viewers.</p>\n<p><a href=\"https://wordpress.org/plugins/fb-messenger-bot/\">FB Messenger Bot for WooCommerce</a> automatically messages clients from your Facebook page, WooCommerce, or Gravity Forms. The plugin creates a &#8216;send to Facebook&#8217; button at the end of the WooCommerce Sales process or on the Gravity Forms thank you page.</p>\n<p><a href=\"https://wordpress.org/plugins/restrict-new-users-by-domain/\">Restrict New Users by Domain </a>makes it easy to whitelist or blacklist email domains that new users can use when registering. If using the whitelist, only new users who enter an email domain on the whitelist will be allowed to create an account. If using the blacklist, a user who enters an email domain on the blacklist will be unable to register.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, February 22nd 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #263:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Feb 2017 23:01:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Post Status: LoopConf in review\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://poststatus.com/?post_type=poststatus_notes&p=33889\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://poststatus.com/loopconf/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:46039:\"<p><a href=\"https://loopconf.com/\">LoopConf</a> is a developer centric conference, and LoopConf &#8220;2.1&#8221; took place in Salt Lake City in early February. This second iteration of the event was a great one, with informative, diverse talks, a laid back atmosphere, and it was very well organized &#8212; which is especially impressive considering the challenges that mother nature caused. As an added bonus, you can now <a href=\"https://www.youtube.com/playlist?list=PLod7ww284cBH0DZshlVXRR5XtpaIZXfTF\">watch all the talks for free</a>.</p>\n<p>Originally planned for Miami last year, LoopConf was postponed due to a hurricane in southern Florida &#8212; hence the &#8220;.1&#8221; above &#8212; and rescheduled closer to organizer Ryan Sullivan&#8217;s home in Salt Lake City. Despite the postponement, most attendees were still able to make it, and some folks (like me) could only go to the newly scheduled event.</p>\n<p>Salt Lake City was unseasonably warm, making it a pleasant few days, mixed with great food and company. It was also a pleasure to be able to meet more people from local companies, including the newly minted BlueHost and MOJO headquarters downtown.</p>\n<p>Post Status was at LoopConf as a media partner, and <a href=\"https://poststatus.com/profiles/brian-richards/\">Brian Richards</a> and I took a lot of pictures, as well as several video interviews.</p>\n<h3>What to know about LoopConf</h3>\n<p>In our first video interview, Ryan talked about the origins of LoopConf, and described what he hoped attendees would get out of the event:</p>\n<p></p>\n<p>I hope to see a future LoopConf 3, and I think the venue and atmosphere worked really well in Salt Lake City.</p>\n<h3>A small sampling of valuable talks</h3>\n<p>There were many great talks. I didn&#8217;t attend them all, as I was working on other stuff for much of the two days, but the feedback was pretty universally positive, and every talk I did attend, I found valuable.</p>\n<h4>The competitive landscape for WordPress</h4>\n<p><img /></p>\n<p>The first day kicked off with a great talk by Pantheon co-founder Josh Koenig, who spoke on the <a href=\"https://youtu.be/BsKkFf4vDyw?list=PLod7ww284cBH0DZshlVXRR5XtpaIZXfTF\">competitive landscape for WordPress</a>, including opportunities and risks. It was a really excellent start to the event.</p>\n<h4>Empathetic communication</h4>\n<p><img /></p>\n<p>I met Sharon Steed prior to her talk, and she spoke about <a href=\"https://www.youtube.com/watch?v=Ke9hfBKebxc\">empathetic communication</a>. And due to her own journey as a communicator, going through life with a stutter, it has impacted how she thinks about communication and how she advises her clients.</p>\n<p>There were two quotes I loved: &#8220;Technology cannot replace the social aspect of face-to-face communication.&#8221; And, &#8220;Silence kills collaboration.&#8221; I think greater empathy in our ecosystem and society in general is pivotal.</p>\n<h3>Put an &#8220;S&#8221; on it</h3>\n<p><img /></p>\n<p>I don&#8217;t know anyone who knows more about HTTPS than Zack Tollman, who directed the effort to make WIRED&#8217;s website fully HTTPS. They learned many lessons, and he <a href=\"https://youtu.be/McAzEj2iXaA?list=PLod7ww284cBH0DZshlVXRR5XtpaIZXfTF\">shares them in his outstanding talk</a>.</p>\n<h4>Bootstrapping a WordPress business</h4>\n<p><img /></p>\n<p>The <a href=\"https://poststatus.com/jason-cohen-wp-engine-founder/\">most recent podcast</a> episode featured a video interview and extended audio interview with <a href=\"https://wpengine.com\">WP Engine</a> founder and LoopConf keynote speaker Jason Cohen, which I highly recommend you check out. Jason is full of knowledge, and my interview with him pairs well with his keynote talk.</p>\n<p>Jason&#8217;s talk will certainly get you thinking about whether you should raise your prices, that&#8217;s for sure.</p>\n<h4>Watch them all!</h4>\n<p>Don&#8217;t take my word for which talks to see. I just feature these because I got a lot out of them in the moment. However, in general I found this lineup to be one of the most proficient groups of speakers I&#8217;ve seen yet at a WordPress event.</p>\n<p>Check out <a href=\"https://www.youtube.com/playlist?list=PLod7ww284cBH0DZshlVXRR5XtpaIZXfTF\">the whole playlist</a>.</p>\n<h3>Pictures</h3>\n<p>Here are pictures from the three days of workshops and talks.</p>\n\n<a href=\"https://poststatus.com/loopconf/loopconf2-0004/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0004-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0008/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0008-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0011/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0011-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0017/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0017-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0018/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0018-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0019/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0019-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0021/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0021-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0028/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0028-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0033/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0033-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0036/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0036-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0039/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0039-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0051/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0051-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0052/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0052-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0053/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0053-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0056/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0056-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0057/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0057-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0062/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0062-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0063/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0063-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0068/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0068-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0075/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0075-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0077/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0077-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0079/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0079-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0086/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0086-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0087/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0087-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0088/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0088-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0091/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0091-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0115/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0115-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0129/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0129-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0135/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0135-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0136/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0136-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0146/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0146-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-0149/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-0149-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1735/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1735-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1746/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1746-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1757/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1757-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1775/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1775-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1778/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1778-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1795/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1795-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1808/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1808-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1809/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1809-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1812/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1812-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1818/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1818-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1819/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1819-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1824/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1824-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1826/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1826-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1831/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1831-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1836/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1836-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1841/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1841-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1854/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1854-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1856/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1856-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1862/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1862-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1868/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1868-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1894/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1894-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1897/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1897-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1911/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1911-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1921/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1921-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1928/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1928-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1936/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1936-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1937/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1937-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1954/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1954-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1968/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1968-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1978/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1978-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1979/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1979-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1983/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1983-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1986/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1986-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1991/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1991-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-1996/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-1996-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2005/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2005-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2015/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2015-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2030/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2030-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2042/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2042-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2043/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2043-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2049/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2049-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2062/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2062-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2079/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2079-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2080/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2080-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2093/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2093-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2103/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2103-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2106/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2106-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2119/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2119-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2151/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2151-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2163/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2163-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2172/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2172-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2180/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2180-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2194/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2194-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2215/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2215-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2240/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2240-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2253/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2253-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2290/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2290-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2291/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2291-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2293/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2293-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2311/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2311-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2330/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2330-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2334/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2334-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2370/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2370-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2377/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2377-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2380/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2380-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2390/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2390-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2413/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2413-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2447/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2447-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2466/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2466-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2487/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2487-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2511/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2511-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2515/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2515-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2517/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2517-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2521/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2521-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2528/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2528-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2531/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2531-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2532/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2532-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2533/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2533-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2536/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2536-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2538/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2538-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2541/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2541-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2542/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2542-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2546/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2546-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2561/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2561-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2570/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2570-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2590/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2590-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2597/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2597-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2599/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2599-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2615/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2615-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2617/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2617-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-2652/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-2652-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9825/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9825-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9826/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9826-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9828/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9828-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9830/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9830-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9831/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9831-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9833/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9833-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9835/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9835-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9837/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9837-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9839/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9839-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9846/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9846-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9848/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9848-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9850/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9850-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9851/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9851-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9859/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9859-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9863/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9863-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9866/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9866-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9868/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9868-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9876/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9876-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9879/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9879-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9885/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9885-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9887/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9887-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9888/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9888-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9892/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9892-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9895/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9895-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9904/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9904-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9905/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9905-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9911/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9911-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9914/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9914-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9929/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9929-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9933/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9933-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9940/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9940-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9941/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9941-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9949/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9949-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9953/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9953-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9956/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9956-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9960/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9960-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9962/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9962-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9965/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9965-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9967/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9967-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9969/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9969-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9970/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9970-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9971/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9971-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9976/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9976-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9993/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9993-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9986/\"><img width=\"100\" height=\"150\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9986-100x150.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n<a href=\"https://poststatus.com/loopconf/loopconf2-9981/\"><img width=\"150\" height=\"100\" src=\"https://cdn.poststatus.com/wp-content/uploads/2017/02/loopconf2-9981-150x100.jpg\" class=\"attachment-thumbnail size-thumbnail\" alt=\"\" /></a>\n\n<p>You are welcome to use these pictures however you wish. If you&#8217;d like to credit Brian Richards or myself, or Post Status, we&#8217;d appreciate it &#8212; but it&#8217;s not required. Pictures he took show Canon 6D in the meta description, and pictures I took show Canon 70D in the description.</p>\n<h3>More interviews from LoopConf</h3>\n<p>I&#8217;ll have more interviews from LoopConf over the coming days and weeks. I chatted with several core contributors and developers about specific experiences they&#8217;ve had with WordPress. Keep an eye out for those!</p>\n<h3>A fun, niche event with a lot of value</h3>\n<p>LoopConf was pretty laid back, and did a lot of things really well.</p>\n<p>For one, I&#8217;m super jealous of how quickly they got the videos uploaded, and they&#8217;ve generously made them available for free for everyone. Also, there were no noticeable event hiccups, and the team was always available to help with whatever attendees may need.</p>\n<p>The venue itself was really nice, as you can hopefully see in the pictures, and the whole place was laid out in a way that made both the talks and the hallway track highly accessible. And sponsors were in the center of the whole event, which was great.</p>\n<p>I found that the size of the event (I&#8217;d guess around 200 people) made it so that conversations were easy to have, and we were able to go in-depth. And because everything from breakfast to dinner to the after party were at the venue, it made everything super convenient.</p>\n<p>If and when there&#8217;s a LoopConf 3, you should go! I&#8217;ve also found this general theme to be true at other niche WordPress events &#8212; including <a href=\"https://adayofrest.hm\">A Day of REST</a> (specific to the REST API in WordPress, which you should go to next month!) and <a href=\"https://pressnomics.com\">PressNomics</a> (a WordPress business event, which you should go to in April!), and even my own <a href=\"https://poststatus.com/publish\">Publish</a> event (which may have a second iteration later this year).</p>\n<p>To learn more about LoopConf, <a href=\"https://loopconf.com/\">check out the website</a>. And definitely take advantage of all of those <a href=\"https://www.youtube.com/playlist?list=PLod7ww284cBH0DZshlVXRR5XtpaIZXfTF\">free videos</a>!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 16 Feb 2017 20:00:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"WPTavern: Matt Mullenweg Responds to Security Rant: Digital Signatures for WordPress Updates Are Important but Not a Priority\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66076\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:135:\"https://wptavern.com/matt-mullenweg-responds-to-security-rant-digital-signatures-for-wordpress-updates-are-important-but-not-a-priority\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8422:\"<p>Scott Arciszewski, Chief Development Officer for Paragon Initiative Enterprises, who is most widely known for his <a href=\"https://paragonie.com/blog/2017/02/cryptographically-secure-php-development\">cryptography engineering work</a>, published a post on Medium criticizing Matt Mullenweg, co-creator of the WordPress open-source software project, for not caring enough about security. Arciszewski has since retracted the post but you can <a href=\"http://web.archive.org/web/20170214062414/https://medium.com/@CiPHPerCoder/stopmullware-on-the-security-of-27-of-the-websites-on-the-internet-298a7e5b6871\">read it</a> via the Wayback Machine.</p>\n<p>Arciszewski is working on a project known as <a href=\"https://download.libsodium.org/doc/\">libsodium</a>, a core extension to PHP 7.2 which allows for encryption, decryption, signatures, password hashing and more. Its goal is to enable developers to build higher-level cryptographic tools.</p>\n<p>WordPress&#8217; automatic update system is handled through api.wordpress.org. Since updates do not have a digital signature, if api.wordpress.org were compromised, attackers could send malicious updates to thousands or millions of sites. This scenario was at the forefront of people&#8217;s minds late last year after Wordfence <a href=\"https://www.wordfence.com/blog/2016/11/hacking-27-web-via-wordpress-auto-update/\">published details</a> of a complex security vulnerability that could have compromised the update servers.</p>\n<p>Arciszewski suggests offline code signing and elliptic curve cryptography as solutions, &#8220;The key that can produce a valid signature for a file isn’t stored on the server (only the file itself and a valid signature are), so even if the server gets hacked, attackers can’t just add trojan horse malware to the file,&#8221; he said.</p>\n<p><a href=\"http://php.net/manual/en/book.openssl.php\">OpenSSL</a> is an extension of PHP and is commonly used as public-key cryptography but it only supports RSA which Arciszewski deems inadequate. Since WordPress is written in PHP and supports versions 5.2-7+, Arciszewski needed to create a solution that was as compatible. This inspired him to create <a href=\"http://web.archive.org/web/20170214062414/https://github.com/paragonie/sodium_compat\">sodium_compat</a> that adds <a href=\"https://ed25519.cr.yp.to/\">Ed25519 signature verification</a> to WordPress&#8217; automatic updater.</p>\n<p>Arciszewski submitted a number of patches to WordPress but was told by Dion Hulse, WordPress core developer, that the sodium_compat library could not be merged into core until it passed a security audit by a third-party. Audits can cost a lot of money so Arciszewski&#8217;s plan was to see if Automattic could take on some of the cost or crowd-source the funds. However, his project was put on hold after Mullenweg informed Hulse to stop working on the feature as it&#8217;s not related to the three core focus areas of the Editor, Customizer, and the REST API.</p>\n<p>Arciszewski described the decision as irresponsible and that every user has a reason to be alarmed, &#8220;The WordPress team has shown that they are not responsible enough to govern their impressive ownership of the Internet (with the exception of some folks powerless to correct the organization’s course),&#8221; he said. &#8220;This act of negligence <em class=\"markup--em markup--p-em\">will</em> put the rest of the web in harm’s way.&#8221;</p>\n<h2>Update Signing is Important but Not a Priority</h2>\n<p>Mullenweg <a href=\"https://medium.com/@photomatt/wordpress-and-update-signing-51501213e1\">responded to the post</a> on Medium.com with one of his own and reiterated the WordPress development team&#8217;s commitment to security.</p>\n<p>&#8220;Everyone involved takes their responsibility very seriously, and the growth of WordPress has meant many thoughtful, hard-working people have gotten involved and think of the security of WP sites holistically, from every angle,&#8221; he said.</p>\n<p>Mullenweg also clarified what attacks would be stopped by implementing digital signatures to WordPress updates.</p>\n<p>&#8220;It could stop a man in the middle attack, where someone modifies the update files on the network in between your blog and WordPress.org, or it could stop a situation where the part of .org that serves the update is compromised but the signing part isn’t, and someone decided to send out updates even though they know they’ll be rejected,&#8221; he said.</p>\n<p>The team is unaware of any WordPress sites that have been attacked this way. While the possibility exists, the extent of the damage would likely be limited. The update servers are monitored around the clock and since many large webhosting companies automatically scan their customer&#8217;s sites for malware, the malicious update would likely be discovered quickly.</p>\n<p>Mullenweg describes what would happen if an update server was compromised.</p>\n<p>&#8220;We would turn it off really quickly, notify the world there was an issue, fix the problem, turn it back on, and notify the specific sites or hosts as able,&#8221; he said. Although WordPress <a href=\"https://w3techs.com/technologies/details/cm-wordpress/all/all\">powers 27.5%</a> of the top 10 million sites tracked by Alexa, it&#8217;s highly unlikely that number of sites would be compromised.</p>\n<p>He goes on to say that there are easier ways to compromise a WordPress site and listed the biggest issues to WordPress security based on impact.</p>\n<ol class=\"postList\">\n<li id=\"6e1f\" class=\"graf graf--li graf-after--p\">Sites not updating core.</li>\n<li id=\"8121\" class=\"graf graf--li graf-after--li\">Sites not updating plugins.</li>\n<li id=\"9cf6\" class=\"graf graf--li graf-after--li\">Sites not updating themes.</li>\n<li id=\"0f5b\" class=\"graf graf--li graf-after--li\">Weak passwords, without brute-force protection or two-factor authentication.</li>\n<li id=\"9601\" class=\"graf graf--li graf-after--li\">Hosts (professional or ad-hoc) not scanning and fixing sites.</li>\n<li id=\"3b2e\" class=\"graf graf--li graf-after--li\">Hypothetical issues not seen in practice, which distract from the above existing priorities.</li>\n</ol>\n<p>Mullenweg confirms that he offered to donate to the audit of sodium_compat a day before Arciszewski published his post. Even if the library passed an audit, the code couldn&#8217;t immediately be added to core, &#8220;You would also need to do some significant work on the server-side to isolate the signing from the update server, so it’s worthwhile in the first place,&#8221; he said.</p>\n<p>And if the code were added to core, only the sites that updated to the version that has the cryptographic library and the update checking would be able to take advantage of it. WordPress.org would still need to send updates to older versions that don&#8217;t have update checking. These sites would still be vulnerable to receiving a malicious update.</p>\n<p>Mullenweg says that digital signatures and update signing will end up in WordPress eventually but it&#8217;s not a priority as there are other security issues in front of it, &#8220;We are prioritizing those issues above a nice-to-have, defense in-depth effort,&#8221; he said.</p>\n<p>&#8220;A good approach would be to build the server-side first, because doing that properly, say with an <a href=\"https://en.wikipedia.org/wiki/Hardware_security_module\">HSM</a>, is the difficult and important part; then get the packages signed; then test out verification in a plugin because we don’t want to break auto-updates; and then finally merge into core and set the client to reject non-signed updates. On the client side we need to pick a cryptography library, and get it audited.&#8221;</p>\n<p>Mullenweg ended his post explaining why he published his response on Medium instead of his <a href=\"http://ma.tt\">personal site</a>. &#8220;Seems to be the most popular place for rants like this. I also wanted to try out the famous Medium editor,&#8221; he said.</p>\n<h2>What&#8217;s Next For sodium_compat</h2>\n<p>While the prospects don&#8217;t look good for his library being added to WordPress in 2017, Arciszewski says there are plenty of other PHP projects that could benefit from it, &#8220;For their sake, I’m still strongly inclined to pursue an independent third-party cryptography audit, and attempt to crowd-fund the cost,&#8221; he said.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Feb 2017 23:48:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"BuddyPress: BuddyPress 2.8.0 – “San Matteo”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=263791\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://buddypress.org/2017/02/buddypress-2-8-0-san-matteo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8634:\"<p>BuddyPress 2.8.0 &#8220;San Matteo&#8221; is now available for download from the WordPress.org plugin repository, or right from your WordPress Dashboard. &#8220;San Matteo&#8221; focuses on various improvement for developers, site builders and site managers.</p>\n<h2 class=\"headline-title\">For Developers &amp; Site Builders</h2>\n<h3 class=\"headline-title\">Modernizing the Codebase</h3>\n<p>To continue the migration of legacy code to modern standards and techniques necessary for the <code>BP REST API</code> project and other new features moving forward, <a href=\"https://codex.buddypress.org/getting-started/buddypress-2-8-will-require-php-5-3/\">BuddyPress 2.8 requires at least PHP 5.3</a>. This will allow us to build better, robust, and secure code, benefiting developers and users now and in the future.</p>\n<h3 class=\"feature-title\">More helpful &#8220;Activate Pending Accounts&#8221; screen</h3>\n<p><img class=\"size-full wp-image-263800 aligncenter\" src=\"https://buddypress.org/wp-content/uploads/1/2017/02/pending-accounts.png\" alt=\"\" width=\"800\" height=\"500\" /></p>\n<p>When you click on the username on the &#8220;Users &gt; Manage Signups&#8221; page, you can now view profile data entered by the user at the time of registration.</p>\n<h3 class=\"feature-title\">Support for <code>List-Unsubscribe</code> header in emails</h3>\n<p><img class=\"size-full wp-image-263802 aligncenter\" src=\"https://buddypress.org/wp-content/uploads/1/2017/02/list-unsubscribe.png\" alt=\"\" width=\"800\" height=\"500\" /></p>\n<p>Allow users to unsubscribe from BuddyPress email notifications in some email clients such as Gmail (web), when properly configured.</p>\n<h3 class=\"feature-title\">Twenty Seventeen Companion Style sheet</h3>\n<p><img class=\"size-full wp-image-263803 aligncenter\" src=\"https://buddypress.org/wp-content/uploads/1/2017/02/twenty-seventeen.png\" alt=\"\" width=\"800\" height=\"500\" /></p>\n<p>BuddyPress looks great in WordPress&#8217;s latest default theme with the new Twenty Seventeen companion style sheet.</p>\n<p>To change the default two-column page layout to a full-width layout as seen in the image, add the <a href=\"https://codex.buddypress.org/themes/bp-theme-compatibility-and-the-wordpress-default-themes/twenty-seventeen-theme/\">following code</a> to the <code>functions.php</code> file of your Twenty Seventeen child theme.</p>\n<h4 class=\"feature-title\">More hooks for Messages</h4>\n<p>We&#8217;ve added new filters and actions for different methods throughout the Messages component.</p>\n<h4 class=\"feature-title\">A more flexible Group search</h4>\n<p>The new <code>search_column</code> parameter allows developers to specify which columns should be matched, as well as where wildcard characters should be placed, when searching via <code>BP_Groups_Group::get()</code>.</p>\n<h4 class=\"feature-title\">Alphabetical sorting for Groups widget</h4>\n<p>The groups widget can now be sorted alphabetically, in addition to sorting the results by recently active, popular, and newest groups.</p>\n<h4 class=\"feature-title\">Enable choice of <code>PHPMailer</code></h4>\n<p>Developers can specify which <code>PHPMailer</code> should be used when sending BuddyPress with a new filter.</p>\n<h4 class=\"title\">Localization Improvements</h4>\n<p>We continue to improve our localization internals, making it easier for translation editors to ensure that BuddyPress will be available for everyone in their own language.</p>\n<h4 class=\"title\">Developer Reference</h4>\n<p>Regular updates to inline code documentation make it easier for developers to understand how BuddyPress works.</p>\n<h4 class=\"title\">Accessibility Upgrades</h4>\n<p>Continued improvements for universal access help make BuddyPress back- and front-end screens usable for everyone (and on more devices).</p>\n<p><strong>…and much more!</strong></p>\n<p>Read about all the bug fixes and feature enhancements introduced in BuddyPress 2.8.0 at our <a href=\"https://codex.buddypress.org/releases/version-2-8-0/\">official 2.8.0 changelog</a>.</p>\n<p><strong>Thank You to Our Contributors</strong></p>\n<p>Many, many thanks to all those who contributed during this development cycle. This is a volunteer-run project, and these contributors freely gave of their time and expertise to make BuddyPress better than ever:</p>\n<p><a href=\"https://profiles.wordpress.org/dontdream/\">Andrea Tarantini (dontdream)</a>, <a href=\"https://profiles.wordpress.org/ankit-k-gupta/\">Ankit K Gupta (ankit-k-gupta)</a>, <a href=\"https://profiles.wordpress.org/angeljs/\">angeljs</a>, <a href=\"https://profiles.wordpress.org/boonebgorges/\">Boone B Gorges (boonebgorges)</a>, <a href=\"https://profiles.wordpress.org/thebrandonallen/\">Brandon Allen (thebrandonallen)</a>, <a href=\"https://profiles.wordpress.org/bhargavbhandari90/\">Bunty (bhargavbhandari90)</a>,<a href=\"https://profiles.wordpress.org/ketuchetan/\">chetansatasiya (ketuchetan)</a>, <a href=\"https://profiles.wordpress.org/chiragpatel/\">Chirag Patel (chiragpatel)</a>, <a href=\"https://profiles.wordpress.org/danbp/\">danbp</a>, <a href=\"https://profiles.wordpress.org/dcavins/\">David Cavins (dcavins)</a>, <a href=\"https://profiles.wordpress.org/wpdennis/\">Dennis (wpdennis)</a>, <a href=\"https://profiles.wordpress.org/Dianakc/\">Diana K. Cury (Dianakc)</a>, <a href=\"https://profiles.wordpress.org/finzend/\">finzend</a>, <a href=\"https://profiles.wordpress.org/hnla/\">Hugo (hnla)</a>,<a href=\"https://profiles.wordpress.org/jdgrimes/\">J.D. Grimes (jdgrimes)</a>, <a href=\"https://profiles.wordpress.org/johnjamesjacoby/\">John James Jacoby (johnjamesjacoby)</a>, <a href=\"https://profiles.wordpress.org/jonas-lundman/\">Jonas Lundman (jonas-lundman)</a>, <a href=\"https://profiles.wordpress.org/jonieske/\">jonieske</a>, <a href=\"https://profiles.wordpress.org/jreeve/\">jreeve</a>, <a href=\"https://profiles.wordpress.org/lakrisgubben/\">lakrisgubben</a>, <a href=\"https://profiles.wordpress.org/Offereins\">Laurens Offereins (Offereins)</a>, <a href=\"https://profiles.wordpress.org/lgreenwoo/\">lgreenwoo</a>,<a href=\"https://profiles.wordpress.org/maccast/\">maccast</a>, <a href=\"https://profiles.wordpress.org/imath/\">Mathieu Viet (imath)</a>, <a href=\"https://profiles.wordpress.org/mchansy/\">mchansy</a>, <a href=\"https://profiles.wordpress.org/mercime/\">mercime</a>, <a href=\"https://profiles.wordpress.org/tw2113/\">Michael Beckwith (tw2113)</a>, <a href=\"https://profiles.wordpress.org/modemlooper/\">modemlooper</a>, <a href=\"https://profiles.wordpress.org/m_uysl/\">Mustafa Uysal (m_uysl)</a>, <a href=\"https://profiles.wordpress.org/nickmomrik/\">Nick Momrik (nickmomrik)</a>, <a href=\"https://profiles.wordpress.org/DJPaul/\">Paul Gibbs (DJPaul)</a>,<a href=\"https://profiles.wordpress.org/pareshradadiya/\">paresh.radadiya (pareshradadiya)</a>, <a href=\"https://profiles.wordpress.org/petya/\">Petya Raykovska</a>, <a href=\"https://profiles.wordpress.org/r-a-y/\">r-a-y</a>, <a href=\"https://profiles.wordpress.org/rekmla/\">rekmla</a>, <a href=\"https://profiles.wordpress.org/espellcaste/\">Renato Alves (espellcaste)</a>, <a href=\"https://profiles.wordpress.org/rogercoathup/\">Roger Coathup (rogercoathup)</a>, <a href=\"https://profiles.wordpress.org/DarkWolf/\">Salvatore (DarkWolf)</a>,<a href=\"https://profiles.wordpress.org/sanket.parmar/\">Sanket Parmar (sanket.parmar)</a>, <a href=\"https://profiles.wordpress.org/slaffik/\">Slava Abakumov (slaffik)</a>, <a href=\"https://profiles.wordpress.org/stagger-lee/\">Stagger Lee (stagger-lee)</a>, <a href=\"https://profiles.wordpress.org/netweb/\">Stephen Edgar (netweb)</a>, <a href=\"https://profiles.wordpress.org/mahype/\">Sven Wagener (mahype)</a>, <a href=\"https://profiles.wordpress.org/wordpressrene/\">wordpressrene</a>.</p>\n<h2>PanuozzoPress</h2>\n<p>BuddyPress 2.8 is called &#8220;San Matteo&#8221; after <a href=\"http://www.sanmatteopanuozzo.com/\">a great pizza restaurant</a> in New York City. San Matteo specializes in the &#8220;panuozzo&#8221;, a pizza-sandwich hybrid native to Salerno, Italy. The proprietor of San Matteo is a friendly fellow who insists on speaking Italian even to customers who don&#8217;t understand a word of it. If you find yourself in the neighborhood, be sure to stop by for a great pizza.</p>\n<h2>Time to Go Get 2.8.0!</h2>\n<p>Grab BuddyPress 2.8.0 &#8220;San Matteo&#8221; from the <a href=\"https://wordpress.org/plugins/buddypress/\">wordpress.org plugin repository</a>, or right from your WordPress Dashboard.</p>\n<p><strong>Questions, comments, feature requests, or bug reports?</strong> Please use our <a href=\"https://buddypress.org/support/\">support forums</a> or our <a href=\"https://buddypress.trac.wordpress.org/\">development tracker</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Feb 2017 22:38:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Slava Abakumov\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"HeroPress: Not every hero wears a cape\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1605\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://heropress.com/essays/not-every-hero-wears-cape/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8188:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/02/021517-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: Sometimes the biggest heroes are the people who notice that someone else feels out of place, extend their hand, and welcome them in.\" /><h3>I almost didn’t go to my first WordCamp</h3>\n<p>I started working with WordPress in 2010. A client requested I use WordPress and a Revolution theme they’d purchased to build their new site. When I was done, I submitted it to the theme showcase, and Brian Gardner reached out to tell me how much he’d liked it.</p>\n<p>I continued working with Brian and his themes as Revolution became Revolution 2, and then StudioPress and Genesis. That led to me designing and developing Family Tree, one of the first commercial themes targeted at women entrepreneurs. It was released in May of 2011.</p>\n<p>Right around the release of my first theme, Brian asked if I was going to be at WordCamp San Francisco. There was going to be a Genesis Connect event there, and he wanted me to be there. I really wanted to go, but didn’t know how I was going to pull it off.</p>\n<p>See, after a years long struggle I had recently been diagnosed with bipolar disorder.</p>\n<blockquote><p>I was trying to rebuild my design career with WordPress, but I was really struggling.</p></blockquote>\n<p>I felt like flying to San Francisco to see my internet friends was a luxury I couldn’t afford.</p>\n<p>But when I mentioned it to my wife, she told me we’d find a way. She started hitting travel sites and found a cheap airline ticket. Then she went on AirBnB and booked me a couch in the lobby of an art gallery in the Tenderloin&#8211;it was the cheapest thing we could find. I left on August 11, 2011, three days before my 40th birthday.</p>\n<h3>My first day of WordCamp SF was a nightmare</h3>\n<p>I have pretty severe social anxiety, so my plan was to maintain a low profile and keep to myself until I could meet up with some of my Genesis friends. About 20 minutes into the first talk I went to I was totally lost, so I thought I’d sneak out and hit lunch early. It seemed like a solid plan.</p>\n<p>My foot had fallen asleep during the presentation, though, and as I stood up to sneak out my ankle buckled and I fell. Every head in the auditorium whipped around to stare at me slowly rolling down the aisle. It was painfully obvious to me that not only did I not belong, but I had just made a very public ass of myself and was mortified.</p>\n<h3>Then the WordPress Community stepped in</h3>\n<p>There was already a huge crowd in the courtyard when I managed to slink out of the auditorium. I felt like someone had dropped me back into my junior high cafeteria. I stood in the massive line, wanting nothing more than to find a quiet corner to nurse my wounded pride, call my wife, maybe cry a little, and tell her that coming had been a huge waste of time and money.</p>\n<blockquote><p>If that’s how my day had panned out, my WordPress story might have been a lot different. Instead, I ran into my first ambassador of the WordPress community.</p></blockquote>\n<p>This kind of goofy guy in front of me started chatting me up.</p>\n<p>I told him it was my first WordCamp. He asked me where I was from, and we discovered we lived maybe an hour away from each other: me in San Diego, him in Orange County. He invited me to eat lunch with his group. And that’s how I wound up sitting at a table eating lunch with Steve Zehngut and his crew.</p>\n<p>These people were more like me: marketers and designers, theme authors and SEO specialists, food bloggers and digital nomads. I started to feel like I might belong there, after all. The phone call I made to my wife after lunch was about how much fun I was having, and how many cool people I was meeting.</p>\n<p>Later that day I went to dinner with the crew from Genesis and met even more amazing people I’d only known online. After that, there was a huge Genesis Connect happy hour. The more people I met and talked to, the more friends I made. On Sunday, before one of the final presentations, an auditorium of my new friends sang “Happy Birthday” to me. (I won’t lie&#8211;it was cool but also almost as embarrassing as falling down the first day, lol!)</p>\n<h3>One person can make a difference</h3>\n<p>If Steve hadn’t asked me to eat lunch with his group that day, I might have never gone to another WordCamp. Instead, when WordCamp San Diego 2012 came around Dre Armeda encouraged me to submit a speaker application, and I gave my first talk. For six years now I’ve spoken at every local WordCamp that’s accepted my speaker application, trying to inspire other people to get and stay involved in our community.</p>\n<p>I spent some time looking at the 2011 WCSF attendees list when I was writing this essay. Some of my best friends (and best WordCamp stories) can be directly linked to that list. Even the people I may not have met at that event came into my life because of that event.</p>\n<h3>Six degrees of a lunch invitation</h3>\n<p>I don’t remember whether or not I met Alex Vasquez in San Francisco, but he’s one of the people who actually wants an honest answer when he asks how I’ve been. I’m pretty sure I didn’t meet Andy Stratton there, but I eventually travelled to Baltimore to speak at the WordCamp he and Drew Poland organized. I’m positive I didn’t cross paths with Karim Marucchi, but he eventually became my boss, mentor, and go-to puppy picture friend. And those are just the connections from one event that happened 6 years ago.</p>\n<blockquote><p>WordCamp San Francisco taught me that being a hero doesn’t have to be a huge, dramatic thing.</p></blockquote>\n<p>Sometimes the biggest heroes are the people who notice that someone else feels out of place, extend their hand, and welcome them in. Of all of the lessons I’ve learned in WordPress, that’s the most important one. Thanks, Steve!</p>\n<p><em>(P.S. If anyone knows where I can find some adult Superman Underoos in stock, LMK. WordCamp San Diego is coming up at the end of March, and I never got Steve a proper thank you gift.)</em></p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Not every hero wears a cape\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Not%20every%20hero%20wears%20a%20cape&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fnot-every-hero-wears-cape%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Not every hero wears a cape\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fnot-every-hero-wears-cape%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fnot-every-hero-wears-cape%2F&title=Not+every+hero+wears+a+cape\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Not every hero wears a cape\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/not-every-hero-wears-cape/&media=https://heropress.com/wp-content/uploads/2017/02/021517-150x150.jpg&description=Not every hero wears a cape\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Not every hero wears a cape\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/not-every-hero-wears-cape/\" title=\"Not every hero wears a cape\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/not-every-hero-wears-cape/\">Not every hero wears a cape</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 15 Feb 2017 12:00:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Chris Ford\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WPTavern: Open Source Leadership Summit to Live Stream Keynote Sessions February 14-16\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66058\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"https://wptavern.com/open-source-leadership-summit-to-live-stream-keynote-sessions-february-14-16\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1865:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/02/open-source-leadership-summit.png?ssl=1\"><img /></a></p>\n<p>The Linux Foundation&#8217;s <a href=\"http://events.linuxfoundation.org/events/open-source-leadership-summit\" target=\"_blank\">Open Source Leadership Summit</a> is happening in Lake Tahoe, CA, February 14-16, 2017. The invitation-only event brings together open source technology leaders to collaborate across different projects and share best practices.</p>\n<p>The organizers will be live streaming all of the <a href=\"https://osleadershipsummit2017.sched.com/overview/type/Keynote\" target=\"_blank\">keynote sessions</a> for free throughout the three-day event for a total of 17 presentations. A few sample topics and speakers include:</p>\n<ul>\n<li>State of the Union &#8211; Jim Zemlin, Executive Director of the Linux Foundation</li>\n<li>A Conversation with Linus Torvalds (with Jim Zemlin)</li>\n<li>State of Blockchain &#8211; Christopher Ferris, CTO of Open Technology, IBM</li>\n<li>Security and Privacy in a Hyper-connected World &#8211; Bruce Schneier, Security Expert</li>\n<li>Building and Motivating Engineering Teams &#8211; Camille Fournier, Senior Thinker and Raconteur</li>\n<li>How Cross-Foundation Collaboration is a Win for Open Source &#8211; Abby Kearns, Executive Director, Cloud Foundry Foundation</li>\n</ul>\n<p>Anyone who wants to join the keynote sessions via live stream will need to <a href=\"http://events.linuxfoundation.org/events/open-source-leadership-summit/program/live-video-stream\" target=\"_blank\">sign up</a> ahead of the event. The keynotes will be broadcast in Pacific Daylight Time and viewers can return to the signup page to watch live. Viewers are encouraged to use the event&#8217;s official #lfosls hashtag to tweet about the sessions as they are watching.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Feb 2017 06:32:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Why Plugins Sometimes Disappear From the WordPress Plugin Directory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66033\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"https://wptavern.com/why-plugins-sometimes-disappear-from-the-wordpress-plugin-directory\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4548:\"<p>Nearly 50K publicly available plugins call the <a href=\"https://wordpress.org/plugins/\">WordPress plugin directory</a> home but once in awhile a few of them seem to disappear. There is usually a good reason for why this happens but the only information available to the public is a page that says the plugin cannot be found. If the plugin is popular enough, concerned users will <a href=\"https://wptavern.com/contact-me\">contact us</a> and ask to investigate what happened.</p>\n<p><a href=\"https://profiles.wordpress.org/ipstenu\">Mika Epstein</a>, Plugin Directory Representative, says there are a number of reasons for why a plugin can end up hidden from view, &#8220;The most well-known, but not the most common, is security issues,&#8221; Epstein said.</p>\n<p>&#8220;Plugins are removed and, by default, hidden mostly because we&#8217;re on bbPress 1.0 and there is not as granular a control with post statuses when compared to WordPress itself.&#8221;</p>\n<p>The plugin review team has three options to choose from when altering a plugin&#8217;s visibility, active, closed, and disabled. Although rarely used, when a plugin is disabled, it is hidden from view but updates are able to be pushed out.</p>\n<p>I asked Epstein why there&#8217;s not more detailed information when a plugin is hidden and the answer is complex, &#8220;The lack of information is partly technical as bbPress 1.0 is limited and partly because we can&#8217;t all agree on the <em>right</em> way to disclose, when to disclose, and when <em>not</em> to disclose,&#8221; she said.</p>\n<p>&#8220;Obviously the last thing we want are people getting hacked, but it presents us with a few options and they all have flaws. We&#8217;ve not been able to determine a way to tell people &#8216;This plugin is gone, don&#8217;t use it&#8217; and &#8216;This plugin is gone, but use it if you want.&#8217; without putting users at risk.&#8221;</p>\n<p>Epstein uses WooCommerce and Jetpack as examples, &#8220;Let&#8217;s say I close Jetpack today and tell people &#8216;WordPress decided not to support it anymore.&#8217; But tomorrow I close WooCommerce and tell people &#8216;I can&#8217;t tell you why.&#8217; That means an intelligent person knows that WooCommerce is <em>probably</em> vulnerable.&#8221;</p>\n<p>It&#8217;s a conundrum without an easy solution. The team typically closes plugins which makes the plugin&#8217;s page disappear. This has the added benefit of making it more difficult to determine if the plugin ever existed. Then the team contacts and works with the developer directly.</p>\n<p>Most closures are done with the knowledge of the plugin author as they are often the ones who request that their plugins be closed.</p>\n<h2>The New WordPress Plugin Directory Will Modernize Plugin Administration</h2>\n<p><a href=\"https://wptavern.com/new-wordpress-plugin-directory-now-in-open-beta\">Announced</a> at WordCamp Europe 2016, the WordPress plugin directory redesign has been in <a href=\"https://wordpress.org/plugins-wp/\">open beta</a> for about eight months.</p>\n<img />WordPress Plugin Directory Redesign\n<p>In addition to bringing a fresh new look to plugin pages, the migration away from bbPress to WordPress will help make the plugin review team&#8217;s job easier, &#8220;Like far too many things in Plugin Land, everything depends on modernizing the backend to something that is functional.&#8221; Epstein said.</p>\n<p>&#8220;Once the new directory is out and I have some more people trained to do reviews properly, then we&#8217;ll have the bandwidth to sit down and really figure out a <strong>best</strong> solution.</p>\n<p>&#8220;A stopgap might be making the page say &#8216;This plugin is no longer available.&#8217; But I&#8217;m personally not sure if that would make FUD better or worse.&#8221;</p>\n<p>If you discover that a plugin you rely on has suddenly vanished from the directory, don&#8217;t panic. Depending on the issue, plugins usually reappear within a week unless the author has requested that it be closed.</p>\n<p>To learn what&#8217;s involved and how the plugin review team does its job, listen to <a href=\"https://wptavern.com/wpweekly-episode-231-an-inside-look-at-the-plugin-review-process-with-mika-epstein\">episode 231</a> of WordPress Weekly. I also encourage you to read our <a href=\"https://wptavern.com/behind-the-scenes-in-the-wordpress-plugin-directory-with-mika-epstein\">detailed interview</a> with Epstein published in 2014, in which most of the information is still accurate.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 14 Feb 2017 03:37:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: WordPress REST API Vulnerability Exploits Continue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=66011\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wptavern.com/wordpress-rest-api-vulnerability-exploits-continue\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:10607:\"<a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2014/04/emergency.jpg?ssl=1\"><img /></a>photo credit: <a href=\"https://flic.kr/p/dLUWMb\">Code &#038; Martini</a> by <a href=\"https://www.flickr.com/photos/ivanavasilj/\">Ivana Vasilj</a> &#8211; cc license\n<p>It has been nearly two weeks since the WordPress security team <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/\" target=\"_blank\">disclosed</a> an unauthenticated privilege escalation vulnerability in a REST API endpoint in 4.7 and 4.7.1. The vulnerability was patched silently and disclosure was delayed for a week to give WordPress site owners a head start on updating to 4.7.2. Last week <a href=\"https://wptavern.com/wordpress-rest-api-vulnerability-is-being-actively-exploited-hundreds-of-thousands-of-sites-defaced\" target=\"_blank\">hundreds of thousands of vulnerable sites had already been defaced</a> and the damage reports are still rolling in.</p>\n<p>Over the weekend the attacks increased and WordPress security firms have seen more attempts blocked by their firewalls. <a href=\"https://sucuri.net/\" target=\"_blank\">Sucuri</a>, the website security firm that reported the vulnerability to WordPress, was tracking the &#8220;Hacked by w4l3XzY3&#8221; campaign last week and estimated 66,000 defacements. That particular campaign has now passed 260,000 pages indexed by Google. It is one of nearly two dozen defacement campaigns targeting the vulnerability.</p>\n<p>&#8220;During the past 24 hours we have seen an average growth in defaced pages per campaign of 44%,&#8221; Wordfence CEO Mark Maunder <a href=\"https://www.wordfence.com/blog/2017/02/rapid-growth-in-rest-api-defacements/\" target=\"_blank\">said</a> on Friday. &#8220;The total number of defaced pages for all these campaigns, as indexed by Google has grown from 1,496,020 to 1,893,690. That is a 26% increase in total defaced pages in just 24 hours.&#8221;</p>\n<p>Maunder referenced a <a href=\"https://www.google.com/trends/explore?date=2017-01-01%202017-12-31&q=%22Hacked%20By%20MuhmadEmad%22,%22Hacked%20By%20SA3D%20HaCk3D%22,%22by%20w4l3XzY3%22,%22Hacked%20By%20Imam%22,%22Hacked%20By%20BALA%20SNIPER%22\" target=\"_blank\">Google Trends chart</a> which he said demonstrates the success the defacement campaigns have had over the past week. The spike began on the day WordPress disclosed the vulnerability.</p>\n<p> &q;</p>\n<p>However, White Fir Design, another company that offers security services, <a href=\"https://www.whitefirdesign.com/blog/2017/02/10/unreliable-claim-that-1-5-million-wordpress-pages-defaced-is-reminder-of-the-terribleness-of-security-companiesjournalists/\" target=\"_blank\">disputes Wordfence&#8217;s claims</a> that 1.8 million pages were hacked. The ~2  million pages figure is cited in reports from <a href=\"http://www.bbc.com/news/technology-38930428\" target=\"_blank\">BBC</a>, <a href=\"http://www.theinquirer.net/inquirer/news/3004423/wordpress-hacking-spree-sees-15-million-web-pages-defaced\" target=\"_blank\">The Enquirer</a>, <a href=\"https://arstechnica.com/security/2017/02/virally-growing-attacks-on-unpatched-wordpress-sites-affects-2m-pages/\" target=\"_blank\">Ars Technica</a>, <a href=\"http://www.cio.com/article/3168761/security/recent-wordpress-vulnerability-used-to-deface-1-5-million-pages.html\" target=\"_blank\">CIO.com</a>, and other publications. White Fir Design contends that the hacked pages that have been indexed by Google are not an accurate representation.</p>\n<p>Sucuri CTO Daniel Cid also does not fully agree with Wordfence&#8217;s assessment of the situation. After doing some research over the weekend, Sucuri estimates more than 50,000 sites hacked with 20-30 pages per site defaced. This would be roughly a million on the lower end of the estimate and ranges up to 1.5 million.</p>\n<p>Sucuri is also starting to see more serious attempts on the REST API vulnerability in the form of <a href=\"https://blog.sucuri.net/2017/02/rce-attempts-against-the-latest-wordpress-rest-api-vulnerability.html\" target=\"_blank\">remote code execution (RCE) attacks</a> on sites using plugins that allow for PHP execution from within posts and pages. One such campaign attempts to inject a PHP include to add content from a compromised site and then inject a backdoor hidden in /wp-content/uploads.</p>\n<p>&#8220;Defacements don’t offer economic returns, so that will likely die soon,&#8221; Cid said. &#8220;What will remain are attempts to execute commands (RCE) as it gives the attackers full control of a site – and offers multiple ways to monetize – and SPAM SEO / affiliate link / ad injections. We are starting to see them being attempted on a few sites, and that will likely be the direction this vulnerability will be misused in the coming days, weeks and possibly months.&#8221;</p>\n<p>Hackers are targeting any sites that haven&#8217;t updated to 4.7.2 &#8211; there doesn&#8217;t seem to be any pattern among them. A quick look at the Google results for the most active campaigns shows that compromised sites include blogs, media, government, education, sports, medical, and technology websites.</p>\n<h3>Why the REST API is Enabled by Default</h3>\n<p>The WordPress REST API is enabled by default, as the plan is for more admin and plugin functionality to rely on the REST API in the future. After the recent attacks, several users <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/#comment-32110\" target=\"_blank\">commented</a> on the vulnerability disclosure to ask why it is enabled by default.</p>\n<p>&#8220;The security issue is in a feature I do not use on any of my sites (REST API) and yet still, this feature is first enabled by default and second since WordPress 4.7 you even need a plugin – which could introduce further security issues – to disable the feature?&#8221; one user (@helios2121) <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/#comment-32123\" target=\"_blank\">commented</a> on the post. &#8220;Please rethink your approach to security. Make features that not everyone needs opt-in. Or <em>at least</em> give a way to opt out without requiring additional plugins.&#8221;</p>\n<p>Morten Rand-Hendriksen opened a trac ticket to discuss <a href=\"https://core.trac.wordpress.org/ticket/39806#ticket\" target=\"_blank\">disabling the REST API by default</a> and only enabling it when the site admin requests it, or a theme or plugin is dependent on it.</p>\n<p>Core Committer Sergey Biryukov confirmed that the plan is to introduce more core functionality that relies on REST API. &#8220;Turning off the REST API is like turning off admin-ajax.php — both will break your site,&#8221; Biryukov said.</p>\n<p>Rand-Hendriksen asked why the content endpoints cannot be protected by default while allowing the REST API to be on by default for admin purposes. Another user asked why the Users endpoint isn&#8217;t protected by default (i.e. <a href=\"https://news.microsoft.com/wp-json/wp/v2/users\" target=\"_blank\">https://news.microsoft.com/wp-json/wp/v2/users</a> or <a href=\"https://www.obama.org/wp-json/wp/v2/users\" target=\"_blank\">https://www.obama.org/wp-json/wp/v2/users</a>), which &#8220;makes it easier than ever to get all the usernames&#8221; on any site using 4.7+.</p>\n<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/02/users-endpoint.png?ssl=1\"><img /></a></p>\n<p>&#8220;If you really want to disable the REST API on your site(s), this is our current recommendation: restrict it to authenticated users,&#8221; Core Committer James Nylen said. &#8220;However, we want to continue to increase adoption and usage of the REST API, and I expect that even this modification will break more and more WP functionality as time goes on, such as API-driven themes and embeds.&#8221;</p>\n<p>Nylen recommends the <a href=\"https://wordpress.org/plugins/disable-json-api/\" target=\"_blank\">Disable JSON API</a> plugin for those who want to follow that recommendation on sites using WordPress 4.7+. The plugin currently has more than 10,000 active installs.</p>\n<p>The WordPress security team worked diligently to mitigate the attacks by helping hosts and security firms put protections in place before the issue was made public. However, the <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/\" target=\"_blank\">full disclosure of the vulnerability</a> was buried on the Make/Core blog, a site that is not widely read among regular WordPress site owners. The link to the disclosure was published as an addendum to <a href=\"https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\" target=\"_blank\">the previous post</a> on the WordPress news blog a week later.</p>\n<p>&#8220;While I appreciate the responsible disclosure of this issue and the effort to resolve it, I hope you consider making future announcements via a new post on the WordPress News site, rather than just appending an update to a previous post,&#8221; user @johnrork <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/#comment-32105\" target=\"_blank\">commented</a> on the official disclosure. &#8220;I am probably not the only one who could have avoided being compromised had this shown up as a new item in my RSS reader on Wednesday.&#8221;</p>\n<p>Those who read the Make blogs had a head start on fixing their own sites and/or their clients&#8217; sites. Those who depend on the WordPress news blog for information on security updates probably read the post when it was initially published and never returned to see the update a week later. An issue this severe warranted WordPress&#8217; transparency in a new post on its news blog. This would have also automatically sent out a tweet to more than half a million followers on the official WordPress account and the Facebook account which has more than a million likes.</p>\n<p>Fortunately, the number of vulnerable sites that also have plugins that could allow attackers to piggyback on this vulnerability is a much smaller number. Defaced sites are embarrassing but easy to fix. In most cases administrators need only update to 4.7.2 and roll back the defaced posts to the most recent revision. Most site owners have no idea how fast exploits begin to pop up after public disclosure, but this situation provided a gentle reminder of the importance of updating WordPress and the benefit of leaving automatic updates on.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 13 Feb 2017 22:59:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WPTavern: 10up Unveils ElasticPress.io: Elasticsearch as a Service for WordPress Sites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65981\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"https://wptavern.com/10up-unveils-elasticpress-io-elasticsearch-as-a-service-for-wordpress-sites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:7053:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/elasticpress-logo.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://10up.com\" target=\"_blank\">10up</a> launched <a href=\"https://www.elasticpress.io/\" target=\"_blank\">ElasticPress.io</a> this week, its new Elasticsearch SaaS product with plans starting at $299/month. <a href=\"https://github.com/elastic/elasticsearch\" target=\"_blank\">Elasticsearch</a> is an open source, distributed search engine that speeds up searching by using JSON documents to store data in indices. The indices store mapping fields to the corresponding documents and the engine searches the index instead of a site&#8217;s entire database.</p>\n<p>Elasticsearch can perform near-real-time searches and is highly scalable, but the setup is technically demanding. It is used by many large companies, such as GitHub, Soundcloud, Etsy, Netflix, Cisco, and Samsung. It is also one of the most popular enterprise search engines for WordPress sites, as searching WordPress tables with thousands or even millions of records is simply not going to be fast.</p>\n<p>The WordPress plugin directory has a dozen plugins for using and extending Elasticsearch but 10up&#8217;s <a href=\"https://wordpress.org/plugins/elasticpress/\" target=\"_blank\">ElasticPress</a> is by far the most popular with more than a thousand installs. After supporting the plugin for several years, along with many enterprise clients using Elasticsearch, 10up decided to create a hosted service that integrates with ElasticPress.</p>\n<p>&#8220;The reason we created this solution for our clients, and that we’re now making this public, is that we don’t think anyone has provided a super easy, end-to-end (plugin to hosted service) that offers all of the benefits of Elasticsearch and our ElasticPress plugin, while being completely agnostic to your site hosting,&#8221; 10up founder Jake Goldman said.</p>\n<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/elasticpress.png?ssl=1\"><img /></a></p>\n<p>ElasticPress.io is an end-to-end solution that is specifically tailored for those using the ElasticPress plugin. This is one of the key differences between managing your own Elasticsearch infrastructure with a service like AWS. ElasticPress.io controls both the hosting and the plugin, allowing the service to optimize performance for both.</p>\n<p>&#8220;There are a number of really neat use cases for ElasticPress on our roadmap that add either risk (security) or headaches (complicated setup and management procedures) if you can’t control both ends,&#8221; Goldman said. &#8220;For instance, there are optional Elasticsearch modules (just like there are optional Apache and Nginx modules) for features like indexing media that many hosted Elastic services don’t enable by default or support. We also want to be able to index and handle content that isn’t public, and many hosted Elastic services aren’t locked down / secured end-to-end with the website by default.&#8221;</p>\n<h3>How ElasticPress.io&#8217;s Pricing Compares to Competitors</h3>\n<p><a href=\"https://www.elastic.co/\" target=\"_blank\">Elastic</a>, the creators of Elasticsearch were one of the first companies to launch Elasticsearch as a service in 2012. Two years later the company raised $70 million in a Series C funding round. Dozens of other Elasticsearch as a service companies have sprouted up since then, with pricing ranging from under $20 to tens of thousands of dollars depending on the resources offered.</p>\n<p>The ElasticPress.io service is the first of its kind in the WordPress ecosystem. Most hosting companies do not have it built into their enterprise level plans. WordPress.com VIP is one of the few that offers Elasticsearch for sites on its <a href=\"https://vip.wordpress.com/our-services/#hosting-plans\" target=\"_blank\">plans</a> which range from $5,000 &#8211; $25,000 per month. WP Engine has an Elasticsearch solution as part of its <a href=\"https://wpengine-labs.com/\" target=\"_blank\">Labs program</a>, which is based on a fork of ElasticPress. However, the solution has not yet been officially added to the company&#8217;s enterprise plans.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/10up\">@10up</a> <a href=\"https://twitter.com/mgibbs189\">@mgibbs189</a> <a href=\"https://twitter.com/cabgfx\">@cabgfx</a> <a href=\"https://twitter.com/sbangnielsen\">@sbangnielsen</a> <a href=\"https://twitter.com/SearchWP\">@SearchWP</a> ElasticPress plus lower cost providers is still extremely powerful for under $12 a month</p>\n<p>&mdash; Scott Kingsley Clark (@scottkclark) <a href=\"https://twitter.com/scottkclark/status/830165095045033984\">February 10, 2017</a></p></blockquote>\n<p></p>\n<p>For the most part, developers who have to implement Elasticsearch for a WordPress site are faced with hosting their own instance and managing it themselves. This is the most cost effective option but comes with a great deal more responsibility.</p>\n<p>&#8220;Elasticsearch is a quickly evolving platform, and they don’t exactly have the same commitment to infinite backwards compatibility that WordPress has these days,&#8221; Goldman said. &#8220;Major Elasticsearch upgrades can break old integrations. That means the site owner needs to either worry about automatic version upgrades breaking their site, or has to manage their upgrades carefully. By controlling the integration with Elastic on the website site and controlling the hosting, we can carefully handle version upgrades for customers while making sure nothing breaks.&#8221;</p>\n<p>10up is aiming at the higher end of the market where customers are looking for convenience and access to the creators of ElasticPress for support. Goldman anticipates many of those customers will be similar to the product&#8217;s existing customers who simply need a robust keyword search or related content engine that will &#8220;just work.&#8221; ElasticPress.io is also targeting smaller and mid-tier businesses that are experiencing performance bottlenecks with WordPress&#8217; native query engine.</p>\n<p>&#8220;Those customers are typically relying on rather complicated faceting / filtering of content, the classic use-case being a WooCommerce store where customers are constantly filtering on a handful of unique (unique = hard to cache) meta data all the time,&#8221; Goldman said. &#8220;That’s where ElasticPress really shines: our native WooCommerce support and optimization take those very taxing queries and makes them lightning fast.&#8221;</p>\n<p>As the service is fairly unique in the WordPress space, ElasticPress.io&#8217;s <a href=\"https://www.elasticpress.io/#pricing\" target=\"_blank\">pricing</a> has room to evolve as 10up learns from its customers. The plans currently range from $299 &#8211; $999 per month with increasing storage space and tiered support response times. Goldman said they haven&#8217;t ruled out other pricing points and may explore more pricing options in the future.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 11 Feb 2017 06:33:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"Post Status: Jason Cohen, founder of WP Engine, on growing your company well — Draft Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=33802\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://poststatus.com/jason-cohen-wp-engine-founder/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2499:\"<p>Welcome to the Post Status <a href=\"https://poststatus.com/category/draft\">Draft podcast</a>, which you can find <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">on iTunes</a>, <a href=\"https://play.google.com/music/m/Ih5egfxskgcec4qadr3f4zfpzzm?t=Post_Status__Draft_WordPress_Podcast\">Google Play</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, and <a href=\"http://simplecast.fm/podcasts/1061/rss\">via RSS</a> for your favorite podcatcher. In this episode, I interview <a href=\"https://twitter.com/asmartbear\">Jason Cohen</a>, the founder of WP Engine and current CTO.</p>\n<p>I talked to Jason about a whole lot of things, mostly to do with growing well. Whether you&#8217;re growing revenue, company size, or personal development &#8212; this is a conversation about growth, and how to do it well.</p>\n<p>Unlike many entrepreneurs in the WordPress space, WP Engine isn&#8217;t Jason&#8217;s first business. He&#8217;s done this before, and made plenty of mistakes. He talks about what he&#8217;s done differently at WP Engine and how its made him a happier person.</p>\n<p>This interview took place at LoopConf, and <a href=\"https://www.youtube.com/watch?v=b_CmkUT25BE\">Jason was a keynote presenter</a>. His LoopConf talk pairs well with our discussion.</p>\n<p>You can catch the first segment on video, and the entire conversation is on the audio podcast.</p>\n<p></p>\n<!--[if lt IE 9]><script>document.createElement(\'audio\');</script><![endif]-->\n<a href=\"https://audio.simplecast.com/60233.mp3\">https://audio.simplecast.com/60233.mp3</a>\n<p><a href=\"https://audio.simplecast.com/60233.mp3\">Direct Download</a></p>\n<h3>Links</h3>\n<ul>\n<li><a href=\"https://wpengine.com/\">WP Engine</a></li>\n<li><a href=\"https://loopconf.com/\">LoopConf</a></li>\n<li><a href=\"https://blog.asmartbear.com/\">Jason&#8217;s blog</a></li>\n</ul>\n<h3>Sponsor: iThemes</h3>\n<p>This episode is sponsored by <a href=\"https://ithemes.com/?utm_source=post_status&utm_medium=banner&utm_campaign=ps_ads\">iThemes</a>. The team at iThemes offers WordPress plugins, themes and training to help take the guesswork out of building, maintaining and securing WordPress websites. For more information, check out their <a href=\"https://ithemes.com/?utm_source=post_status&utm_medium=banner&utm_campaign=ps_ads\">website</a> and thank you to iThemes for being a Post Status partner.</p>\n<p><em>Photo by Brian Richards for Post Status</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 11 Feb 2017 04:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Brian Krogsgard\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: In Case You Missed It – Issue 17\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=65984&preview=true&preview_id=65984\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wptavern.com/in-case-you-missed-it-issue-17\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8994:\"<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2016/01/ICYMIFeaturedImage.png?ssl=1\" rel=\"attachment wp-att-50955\"><img /></a>photo credit: <a href=\"http://www.flickr.com/photos/112901923@N07/16153818039\">Night Moves</a> &#8211; <a href=\"https://creativecommons.org/licenses/by-nc/2.0/\">(license)</a>There’s a lot of great WordPress content published in the community but not all of it is featured on the Tavern. This post is an assortment of items related to WordPress that caught my eye but didn’t make it into a full post.</p>\n<h2>Interviewed for WordPress.tv</h2>\n<p>A few weeks ago, Marcus Couch and I were interviewed by John Parkinson. Parkinson is a volunteer moderator and performs community outreach for WordPress.tv. In the interview, we discuss the benefits of WordPress.tv, the WordPress community, WordCamps, and more. I encourage you to check out his <a href=\"https://blog.wordpress.tv/tag/interview/\">other community interviews</a> as well.</p>\n<p></p>\n<h2 class=\"selectionShareable\">WooCommerce and WordPress Used to Sell Stress Cubes</h2>\n<p>CNBC has <a href=\"http://www.cnbc.com/2017/01/30/a-24-year-old-made-345000-by-beating-kickstarters-to-market.html\">an interesting story</a> that features a 24-year-old who made $345K in two months selling <a href=\"https://stresscube.com/\">Stress Cubes</a>, a knock-off of the Fidget Cube. The Fidget Cube raised <a href=\"https://www.kickstarter.com/projects/antsylabs/fidget-cube-a-vinyl-desk-toy\">nearly 6.5M dollars</a> in crowdfunding money.</p>\n<p>The Fidget Cube experienced significant delays in shipping due to manufacturing issues. The 24-year-old contacted suppliers in China, purchased 1,000 plastic cubes, created a similar product, and shipped it to market before the Fidget Cube had a chance to reach backers. He used WordPress and WooCommerce to sell Stress Cubes grossing him nearly $350K in two months.</p>\n<h2>Why WordPress in Education</h2>\n<p>Jared Bennett <a href=\"https://dev.commons.hwdsb.on.ca/2017/02/08/why-wordpress-in-education/\">explains</a> how the <a href=\"http://www.hwdsb.on.ca/\">Hamilton Wentworth District School Board</a> uses WordPress.  &#8220;We run over 100 individual school websites on a WordPress Multisite Network, and back in May of 2011, we launched the HWDSB Commons: a second Multisite Network which now hosts over 8,000 blogs for over 30,000 users,&#8221; Bennett said.</p>\n<p>Bennett <a href=\"https://github.com/hwdsbcommons/\">shares links</a> to plugins the team created to solve specific issues such as comment moderation in BuddyPress and blocking specific modules in Jetpack. Since WordPress is free as in beer, it allows his school board to spend public money in a more responsible way.</p>\n<p>&#8220;In the WordPress ecosystem we operate in, I pay for functionality to be developed, and I share it openly on platforms like the WordPress plugin repository, or on sites like <a href=\"https://github.com/hwdsbcommons/\">Github,</a>&#8221; Bennett said.</p>\n<p>&#8220;The money you would have spent to enable the previously developed functionality, you can now spend on something else, something that I might benefit from. Think about how much more responsible this model is, particularly when we are talking about spending public money.</p>\n<p>&#8220;We are all contributing; and the community benefits from those contributions; and our money — and the functionality of our platforms — improves exponentially faster than if we were all spending our money paying the private company over and over for code that has already been paid for by previous customers.&#8221;</p>\n<p>To learn more about WordPress in education, listen to <a href=\"https://wptavern.com/wpweekly-episode-261-wordpress-for-schools-with-cameron-barrett\">episode 261</a> of WordPress Weekly where we interview Cameron Barrett, founder of <a href=\"http://schoolpress.co/\">SchoolPresser, LLC</a>. Barrett explains how he negotiated and helped migrate Newark New Jersey’s public school system from a proprietary CMS to WordPress.</p>\n<h2>WP101 Plugin Now Has WooCommerce and Jetpack Videos</h2>\n<p>The <a href=\"https://wp101plugin.com/\">WP101 plugin</a> has added Jetpack and WooCommerce training videos. This is in addition to the Yoast SEO and WordPress training videos.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Huge update for our WP101 Plugin! It now includes WooCommerce and Jetpack videos. That’s 90 videos for your clients! <a href=\"https://t.co/6jtzj1JgkC\">https://t.co/6jtzj1JgkC</a> <a href=\"https://t.co/CByYvd61Xi\">pic.twitter.com/CByYvd61Xi</a></p>\n<p>&mdash; WordPress 101 (@WP101) <a href=\"https://twitter.com/WP101/status/829455708802408452\">February 8, 2017</a></p></blockquote>\n<p></p>\n<h1 class=\"entry-title\">Adding Meta Fields to a Widget Sidebar Section</h1>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Example for how to add meta fields/controls to a widget sidebar section in the customizer: <a href=\"https://t.co/aMadLioQn6\">https://t.co/aMadLioQn6</a> <a href=\"https://twitter.com/hashtag/javascript?src=hash\">#javascript</a> <a href=\"https://twitter.com/hashtag/WordPress?src=hash\">#WordPress</a></p>\n<p>&mdash; Weston Ruter ⚡ (@westonruter) <a href=\"https://twitter.com/westonruter/status/829799276976828417\">February 9, 2017</a></p></blockquote>\n<p></p>\n<h2>WP Sessions Developer Survey</h2>\n<p>WP Sessions is conducting a <a href=\"http://wpsessions.com/developer-survey/\">developer survey</a> to find out about the tools developers use. Results will be anonymized and shared in aggregate in a few weeks.</p>\n<h2>Widget Logic Has a New Maintainer</h2>\n<p><a href=\"https://wordpress.org/plugins/widget-logic/\">Widget Logic</a>, a popular plugin actively installed on more than 300K sites, has a <a href=\"https://profiles.wordpress.org/wpchefgadget/\">new maintainer</a> named <a href=\"https://profiles.wordpress.org/wpchefgadget/#content-plugins\">WPChef</a>. The plugin was created nine years ago by <a href=\"https://profiles.wordpress.org/alanft/\">Alanft</a>. Prior to WPChef gaining commit access, the last time Widget Logic was updated was <a href=\"https://plugins.trac.wordpress.org/browser/widget-logic/tags/0.57?rev=1592418\">two years ago</a>.</p>\n<p>After gaining access, WPChef released Widget Logic 5.7.0. This version fixed a PHP 7 compatibility issue, a conflict with WPML, added a new default load logic point, and a Ukrainian translation. In addition to bug fixes, a global admin notice to install Limit Login Attempts Reloaded was also added. Limit Login Attempts Reloaded is a separate plugin owned and maintained by WPChef.</p>\n<p><img />Limit Login Attempts Reloaded Admin NoticeThe wording of the notice and appearing globally caused some users to <a href=\"https://wordpress.org/support/topic/incorrect-widget-logic-team-security-recommendation/\">be concerned</a> or upset. Some users responded to the update by <a href=\"https://wordpress.org/support/plugin/widget-logic/reviews/?filter=1\">writing 1-star reviews</a>. After a user <a href=\"https://wordpress.org/support/topic/taking-over-and-forking-this-plugin/#post-8781763\">described the notice</a> as sounding like fake news, WPChef changed it.</p>\n<h2>From SupportPress to Help Scout!</h2>\n<p>The WordPress.org community team is moving away from <a href=\"https://supportpress.com/\">SupportPress</a> to Help Scout. The move opens up a number of possibilities as Help Scout offers a lot of features that are non-existent in SupportPress.</p>\n<blockquote class=\"wp-embedded-content\"><p><a href=\"https://make.wordpress.org/community/2017/02/09/moving-from-supportpress-to-help-scout/\">Moving from SupportPress to Help Scout</a></p></blockquote>\n<p></p>\n<h2>Plush Wapuu!</h2>\n<p>In what is a traditional part of this series, I end each issue by featuring a Wapuu design. For those who don&#8217;t know, Wapuu is the <a href=\"http://wapuu.jp/2015/12/12/wapuu-origins/\">unofficial mascot</a> of the WordPress project.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\"><a href=\"https://twitter.com/hashtag/Wapuu?src=hash\">#Wapuu</a> army is taking over <a href=\"https://twitter.com/hashtag/WordCamp?src=hash\">#WordCamp</a> US <img src=\"https://s.w.org/images/core/emoji/2.2.1/72x72/1f60d.png\" alt=\"😍\" class=\"wp-smiley\" /><a href=\"https://twitter.com/hashtag/wcus?src=hash\">#wcus</a> <a href=\"https://twitter.com/hashtag/wcus2016?src=hash\">#wcus2016</a> <a href=\"https://t.co/Giyt3KFsnF\">pic.twitter.com/Giyt3KFsnF</a></p>\n<p>&mdash; Musannif (@mzahir) <a href=\"https://twitter.com/mzahir/status/805133225127510016\">December 3, 2016</a></p></blockquote>\n<p></p>\n<p>This plush Wapuu which was given away at WordCamp US 2016 as part of the event&#8217;s swag was a huge hit with attendees and their children. I have one myself and the quality is superb.</p>\n<p>That&#8217;s it for issue seventeen. If you recently discovered a cool resource or post related to WordPress, please share it with us in the comments.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Feb 2017 22:16:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"BuddyPress: BuddyPress 2.8.0 Release Candidate 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"https://buddypress.org/?p=263679\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://buddypress.org/2017/02/buddypress-2-8-0-release-candidate-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1158:\"<p>BuddyPress 2.8.0 Release Candidate 1 is now available for testing. Please <a href=\"https://downloads.wordpress.org/plugin/buddypress.2.8.0-RC1.zip\">download the 2.8.0-RC1 zip</a> or get a copy via our Subversion repository.</p>\n<p>This is our last chance to find any bugs that slipped through the beta process. So please test with your themes and plugins. We plan to release BuddyPress 2.8.0 next Wednesday, February 15.</p>\n<p>A detailed changelog will be part of our official release notes, but you can get a quick overview by reading the post about the <a href=\"https://buddypress.org/2017/01/buddypress-2-8-0-beta-1/\">2.8.0 Beta 1</a> release.</p>\n<p>Release Candidate means we are in string freeze, so translators should feel confident in finishing their BuddyPress translations in <a href=\"https://translate.wordpress.org/projects/wp-plugins/buddypress\">GlotPress</a>.</p>\n<p>Let us know of any issues you find in <a href=\"https://buddypress.org/support\">the support forums</a> and/or on <a href=\"https://buddypress.trac.wordpress.org\">our development tracker</a>.</p>\n<p>Thanks in advance for giving the release candidate a test drive!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Feb 2017 20:51:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Slava Abakumov\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"WPTavern: Creative Commons’ New Search Tool is Now in Beta, Pulls CC Images from Multiple Sources\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65809\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"https://wptavern.com/creative-commons-new-search-tool-is-now-in-beta-pulls-cc-images-from-multiple-sources\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5467:\"<p>If you&#8217;ve been wearing out Unsplash images on your blog, it&#8217;s time to take another look at Creative Commons. The site has just <a href=\"https://creativecommons.org/2017/02/07/new-cc-search/\" target=\"_blank\">launched the beta</a> of its new multi-source search interface. Unlike the <a href=\"https://search.creativecommons.org/\" target=\"_blank\">current search tool</a>, which will only search one source by sending the visitor offsite, <a href=\"https://ccsearch.creativecommons.org/\" target=\"_blank\">CC Search</a> loads the results from multiple sources onsite.</p>\n<p>The Commons includes approximately 1.1 billion works in various formats &#8211; literary works, videos, photos, audio, scientific research, and other formats. As half of these works are estimated to be images, the prototype for the new search tool focuses on this format.</p>\n<p>&#8220;Our goal is to cover the whole commons, but we wanted to develop something people could test and react to that would be useful at launch,&#8221; Creative Commons CEO Ryan Merkley said. &#8220;To build our beta, we settled on a goal to represent one percent of the known Commons, or about 10 million works, and we chose a vertical slice of images only, to fully explore a purpose-built interface that represented one type but many providers.&#8221;</p>\n<p>CC Search currently pulls CC-licensed images from Rijksmuseum, Flickr, 500px, the New York Public Library, and the Metropolitan Museum of Art. This includes 200,000 new images from the collection of <a href=\"https://creativecommons.org/2017/02/07/met-announcement/\" target=\"_blank\">375,000 digital works that the Met released under CC0</a> this week.</p>\n<p>In addition to the new search interface, the beta includes social tools that allow users to curate and share their own lists, add tags and favorites, and save searches. One-click attribution is built in, making it easy for users to properly attribute the works.</p>\n<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/cc-search.png?ssl=1\"><img /></a></p>\n<p>As Creative Commons is a small organization and fairly lean on resources, the new search was built by a single contractor over seven months. Software engineer Liza Daly was selected to <a href=\"https://hackernoon.com/cc-search-developer-notes-and-reflection-418271194682#.6f8mudh02\" target=\"_blank\">research and build a proof-of-concept for CC Search</a>, a project which she understood to be &#8220;a front door to the universe of openly licensed content.&#8221;</p>\n<p>&#8220;CC Search is meant to make material more discoverable regardless of where it is hosted,&#8221; Daly said. &#8220;For this reason (and for obvious cost-saving objectives), we decided to host only image metadata — title, creator name, any known tags or descriptions — and link directly to the provider for image display and download. A consequence of this is that CC Search only includes images which are currently available on the web; CC is not collecting or archive any images itself.&#8221;</p>\n<p>Daly built the search feature on AWS cloud infrastructure using Python, Django, Postgres, and Elasticsearch. The beta has estimated hosting costs of $1,400/month. She opted for Python, because she was most familiar with it.</p>\n<p>&#8220;As the prototype evolved, we decided the opportunity for an engaging front door to the Commons lay in curation and personalization,&#8221; Daly said. &#8220;Because of its dedicated maintenance team and frequent patch management, I chose Django as the web framework.&#8221; She chose Elasticsearch over Solr (and other options) primarily because of the AWS’s Elasticsearch-as-a-service.</p>\n<p>&#8220;CC Search is not, at this time, a particularly sophisticated search application; image metadata is relatively simple and when dealing with a heterogeneous content set from a diversity of providers, one tends towards a lowest-common-denominator approach — our search can only be as rich as our weakest data source,&#8221; Daly said. &#8220;There is much to be improved here.&#8221;</p>\n<p>Daly also described an interesting idea for adding a blockchain-type architecture that would record licensing transactions, sharing, and gratitude in a distributed way. This idea falls outside of the scope of the MVP but may be something the project&#8217;s future developers will consider when implementing the final version.</p>\n<p>&#8220;A long-term goal of this project is to facilitate not only search and discovery, but also reuse and &#8216;gratitude,\'&#8221; Daly said. &#8220;A frequent complaint about open licenses in general — both for creative works and software code — is that contributing to the commons can be a thankless task. There are always more consumers than contributors, and there’s no open web equivalent to a Facebook &#8216;like.\'&#8221;</p>\n<p>Other future improvements that the team will consider based on user feedback include adding more content partners, more tools for customizing lists, allowing users to search from their own curated material, and giving trusted users the ability to push metadata back into the collection. Search filters may also be expanded to allow for searching by color, drilling down into tags, and searching public lists.</p>\n<p>Check out the beta for the new CC Search at <a href=\"https://ccsearch.creativecommons.org/\" target=\"_blank\">ccsearch.creativecommons.org</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 10 Feb 2017 05:42:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Google Webmaster Tools Fixes Confusing Messages About Updating WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65787\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"https://wptavern.com/google-changes-the-wording-of-its-wordpress-update-notifications\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4148:\"<p>In 2009, <a href=\"https://webmasters.googleblog.com/2009/11/new-software-version-notifications-for.html\">Google announced</a> it would send notifications via <a href=\"https://www.google.com/webmasters/tools/\">Webmaster Tools</a> to site owners that new versions of software are available E.g. Joomla, Drupal, or WordPress.</p>\n<p>WordPress 4.7.2 <a href=\"https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\">was released</a> at the end of January. It patched a critical security vulnerability with the REST API that is <a href=\"https://wptavern.com/wordpress-rest-api-vulnerability-is-being-actively-exploited-hundreds-of-thousands-of-sites-defaced\">being actively exploited</a> in the wild. Site owners who updated to 4.7.2 are <a href=\"https://productforums.google.com/forum/?hl=en#!category-topic/webmasters/QwkXrbyzKBA\">receiving Google Alerts</a> that their sites are out of date.</p>\n<blockquote><p>Recommended WordPress update available for<span dir=\"ltr\"><a>http://www.example.com/</a></span></p>\n<div dir=\"ltr\">\n<div>\n<p>To: Webmaster of <span dir=\"ltr\"><a>http://www.example.com/</a></span>,</p>\n<p>Google has detected that your site is currently running WordPress 4.7.0 or 4.7.1, an older version of WordPress. Outdated or unpatched software can be vulnerable to hacking and malware exploits that harm potential visitors to your site. Therefore, we suggest you update the software on your site as soon as possible.</p>\n<p>Following are one or more example URLs where we found pages that have outdated software. The list is not exhaustive.</p>\n<p dir=\"ltr\"><a href=\"https://www.example.com/123/\" target=\"_blank\" rel=\"nofollow\">https://www.example.com/123/</a></p>\n<p dir=\"ltr\"><a href=\"https://www.example.com/456/\" target=\"_blank\" rel=\"nofollow\">https://www.example.com/456/</a></p>\n<p dir=\"ltr\"><a href=\"https://www.example.com/789/\" target=\"_blank\" rel=\"nofollow\">https://www.example.com/789/</a></p>\n</div>\n</div>\n</blockquote>\n<p dir=\"ltr\">Some of the people who received notices thought the email was a phishing attempt as WordPress is misspelled using a lower-case p. Others <a href=\"https://productforums.google.com/d/msg/webmasters/QwkXrbyzKBA/z_4hg5s5BwAJ\">expressed confusion and anxiety</a> receiving notices despite having already updated their sites.</p>\n<p dir=\"ltr\">WordPress powered sites contain a meta generator that Google uses to detect which version is running.</p>\n<p dir=\"ltr\">&lt; meta name=&#8221;generator&#8221; content=&#8221;WordPress 4.7.1&#8243; /&gt;</p>\n<p dir=\"ltr\">However, Google does not monitor pages in real-time. If a site owner updates to WordPress 4.7.2 but the page indexed by Google is running 4.7.1, they&#8217;ll receive a notice.</p>\n<p dir=\"ltr\">Juan Felipe Rincón, Webmaster Outreach at Google, <a href=\"https://productforums.google.com/d/msg/webmasters/QwkXrbyzKBA/25QwebHfBwAJ\">responded </a>to the forum thread and confirmed the issues reported by users, &#8220;Definitely a problem on our end,&#8221; Rincón said.</p>\n<p dir=\"ltr\">&#8220;We&#8217;re sorry for causing confusion in the messaging and for the swirl this created for many of you and your users or client base.&#8221;</p>\n<p dir=\"ltr\">Google was aware that notices would be sent to site owners who already updated but chose to send them anyway due to the seriousness of the vulnerability.</p>\n<p dir=\"ltr\">&#8220;However, we underestimated the number of sites that had already patched, and our messaging gave no room for interpretation or letting website owners know that if they had already upgraded they could ignore the message safely,&#8221; Rincón said.</p>\n<p dir=\"ltr\">Google has implemented the following changes to improve its update notification system:</p>\n<ul>\n<li dir=\"ltr\">Messages have stopped being delivered for now but will resume shortly.</li>\n<li dir=\"ltr\">The messages have been reworded to be clearer.</li>\n<li dir=\"ltr\">Additional checks have been added to reduce the number of notifications sent to owners who already updated.</li>\n</ul>\n<p>If you&#8217;ve updated WordPress to 4.7.2, you can safely disregard the notices.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 09 Feb 2017 23:55:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"WPTavern: WordCamp Miami 2017 to Host JavaScript Track, AMA Spots, and 2-Day Kids’ Camp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65831\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"https://wptavern.com/wordcamp-miami-2017-to-host-javascript-track-ama-spots-and-2-day-kids-camp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4451:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/wordcamp-miami-2017.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://2017.miami.wordcamp.org/\" target=\"_blank\">WordCamp Miami</a> is sporting an 80&#8217;s theme this year for its 9th year running. The team of 12 organizers is expecting more than 800 attendees and will host 60+ local and global speakers, including new speakers from India, Australia, Poland, Canada, and other international locations.</p>\n<p>As in previous years, WordCamp Miami is a multi-day smorgasbord of WordPress networking and educational opportunities with workshops for all ages. The event is bringing back the two-day Kids&#8217; Camp and Kids&#8217; Panel it hosted last year. David Bisset, one of the organizers, is expecting approximately 50 attendees and said the team is seeing an even greater increase of parents and kids than previous years, based on more kids&#8217; tickets being purchased earlier.</p>\n<p>This year the Kids&#8217; Camp will focus on blogging and coding and children will even get their own attendee bags. Kids will also receive free hosting and a free domain name, thanks to a donation from a sponsor. The <a href=\"https://2017.miami.wordcamp.org/2017/01/17/speaker-call-opening-for-kids/\" target=\"_blank\">call for speakers for kids</a> aged 7-18 is now open.</p>\n<p>WordCamp Miami will be hosting three workshops on the Friday leading up to the main event: a Beginner&#8217;s workshop, a Freelance workshop, and the WP REST API / BuddyCamp workshop. This is the fifth consecutive year for BuddyCamp and attendees will have the opportunity to learn more about building mobile applications with BuddyPress and the WordPress REST API.</p>\n<p>The &#8220;Learn JavaScript Deeply&#8221; track is returning in 2017, featuring local and international JS developers. So far WordCamp Miami is the only camp to have an entire track devoted to JavaScript. Organizers have designed the format of the track to be duplicated by other camps that want to include more JS content.</p>\n<p>The event&#8217;s organizers usually attempt to get &#8220;<a href=\"https://2017.miami.wordcamp.org/2017/02/03/why-its-important-for-outside-the-bubble-perspectives-at-wordcamps/\" target=\"_blank\">outside the WordPress bubble</a>&#8221; by inviting speakers with experience in other platforms to share with attendees. This year&#8217;s lineup includes two sessions from members of the Drupal and Joomla communities. Mike Herchel, a front-end web developer at Lullabot, will present a session titled “WordPress &amp; Drupal: Community and Contribution Differences and Lessons.” Aleksander Kuczek, CEO of Perfect Dashboard and a Joomla Extension Directory team member, will be speaking about how Joomla handles plugin contributions.</p>\n<p>Other focus topics during the main event include customizing/extending WordPress, e-commerce, mental health, content marketing, and building a better business (from freelancers to agencies). Organizers have also reduced the time for speakers a little in order to introduce some &#8220;AMA&#8221; spots. The new format will feature prominent people in the community who will be available to simply answer questions from attendees. The guests for the AMA spots are still being finalized, but Bisset said one example is a representative from Sucuri and will be available to answer any questions regarding security.</p>\n<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/02/rate-my-talk.gif?ssl=1\"><img /></a>WordCamp Miami will also debut the &#8220;<a href=\"http://davidbisset.com/results-of-my-live-rate-my-talk-with-emoji-at-wpcampus/\" target=\"_blank\">Rate My Talk With Emoji</a>&#8221; app that Bisset developed for attendees to give &#8220;live speaker feedback&#8221; while sessions are happening. He said the team is hoping to have the speakers decide on which emoji should be available, but if there are problems with pre-event testing they will pre-select emoji. At this time they are not planning on including any negative ones. Speakers will have access to their results after the conference.</p>\n<p>WordCamp Miami would not be possible without the event&#8217;s army of volunteers. Bisset said organizers are still looking for <a href=\"http://davidbisset.us6.list-manage2.com/subscribe?u=8f9242549d66d09eceb714b54&id=046ea0475e\" target=\"_blank\">volunteers</a> to help out before and during the event.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 09 Feb 2017 20:22:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"WPTavern: OSTraining Partners with GoDaddy to Launch Free WordPress Beginner Course on YouTube\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65805\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"https://wptavern.com/ostraining-partners-with-godaddy-to-launch-free-wordpress-beginner-course-on-youtube\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4409:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/ostraining-logo.png?ssl=1\"><img /></a></p>\n<p><a href=\"https://www.ostraining.com\" target=\"_blank\">OSTraining</a> has launched a free <a href=\"https://www.youtube.com/playlist?list=PLtaXuX0nEZk-rRfsl8lclMY5TncDmAUBm\" target=\"_blank\">40-video WordPress Beginner course</a> on YouTube, thanks to a sponsorship from GoDaddy. The open source software education site has created more than 3,000 videos for PHP platforms like WordPress, Joomla, Magento, and Drupal. This particular course, which has all new information for WordPress 4.7, was inspired by the company&#8217;s success in launching a free Drupal 8 course in 2016.</p>\n<p>&#8220;The original idea was a happy accident,&#8221; CEO Steve Burge said. &#8220;We did a <a href=\"https://www.kickstarter.com/projects/stevebure/drupal-8-training-videos-help-us-make-drupal-magic\" target=\"_blank\">Kickstarter project</a> based around the launch of Drupal 8. That involved about 200 free videos, spread over several classes. The main class was &#8216;The Drupal 8 Beginner class&#8217; and it went viral, getting over <a href=\"https://www.ostraining.com/blog/news/1-million/\" target=\"_blank\">1 million views in a year</a>.&#8221;</p>\n<p>The Kickstarter campaign raised more than $12K towards its $10K funding goal. It was the first time OSTraining produced a free course. Once the videos were released, Burge and his team were amazed by how popular the course became.</p>\n<p>&#8220;It led us to re-think our business approach,&#8221; Burge said. &#8220;Rather than putting everything behind a paywall, we realized the power of giving away our best beginner material. From a business perspective, that made sense so long as we could find a sponsor.&#8221;</p>\n<p>OSTraining worked with Topher DeRosia to film the WordPress Beginner course after securing a sponsorship from GoDaddy. Although the company has done multiple versions of its beginner class over the years, with updates for changes in each release, WordPress 4.7 presents a new opportunity for content longevity.</p>\n<p>&#8220;We hope that by targeting 4.7 this class will last longer than most, because the new release cycle means a new version won&#8217;t be here in a couple of months,&#8221; Burge said.</p>\n<p>In addition to beginner topics like how to install WordPress, write posts, and use the media library, the course also includes information on getting started with WordPress plugins like NinjaForms and Jetpack. The last few videos cover more advanced topics like security, spam, staging, and performance.</p>\n<p>Although the <a href=\"https://www.youtube.com/channel/UCpJf6LGZ0a4n9Lj4aVt9spg/\" target=\"_blank\">official WordPress YouTube channel</a> doesn&#8217;t have much educational content for beginners, the WordPress community in general is gaining a stronger presence on YouTube. Searching for &#8220;WordPress&#8221; turns up more than five million videos in many different languages. Educational topics like &#8220;How to make a WordPress website&#8221; and other tutorials are the most popular.</p>\n<p>WordPress businesses are also starting to see the value of having a solid presence on YouTube. Last year Automattic started beefing up its <a href=\"https://www.youtube.com/channel/UCvP5cfpfIgkb0Dt8o7Qt21A\" target=\"_blank\">channel</a> with a steady stream of new videos, including ads and tutorials for WordPress.com. Other large WordPress companies like <a href=\"https://www.youtube.com/user/iThemescom\" target=\"_blank\">iThemes</a>, <a href=\"https://www.youtube.com/user/wpbeginner/\" target=\"_blank\">WPBeginner</a>, and <a href=\"https://www.youtube.com/user/yoastcom/\" target=\"_blank\">Yoast</a> are publishing hundreds of free videos to YouTube, generating millions of views and thousands of subscribers.</p>\n<p>After finding success on YouTube with the free Drupal 8 videos, OSTraining has also launched a free <a href=\"https://www.youtube.com/playlist?list=PLtaXuX0nEZk9eL59JGE3ny-_GAU-z5X5D\" target=\"_blank\">Magento 2</a> course and has a free Joomla course on the way.</p>\n<p>&#8220;Getting more than 1 million views of the Drupal class really opened our eyes,&#8221; Burge said. &#8220;It&#8217;s almost like the difference between free, open source software and expensive, closed source software. You can reach so many more people by giving it away free.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 09 Feb 2017 05:48:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"Dougal Campbell: Good Breakdown of Recent WordPress Vulnerability\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"http://dougal.gunters.org/?p=81297\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"http://dougal.gunters.org/blog/2017/02/08/good-breakdown-of-recent-wordpress-vulnerability/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2977:\"<div class=\"featured-image align-right\"><img width=\"150\" height=\"150\" src=\"http://dougal.gunters.org/wordpress/wp-content/uploads/2008/10/wordpress-wednesday-150x150.png\" class=\"attachment-post-thumbnail size-post-thumbnail wp-post-image\" alt=\"\" /></div><p>The <a href=\"https://blog.sucuri.net/\">Sucuri Blog</a> has a good dissection of the recent critical <a href=\"https://blog.sucuri.net/2017/02/content-injection-vulnerability-wordpress-rest-api.html\">WordPress REST API vulnerability</a>. I won&#8217;t rehash the details here, but I did want to point out that this is why developers should remember to follow these two rules of defensive programming:</p>\n<ol>\n<li>Sanitize inputs as early as possible</li>\n<li>Sanitize outputs as late as possible</li>\n</ol>\n<p>In this case, there was a failure to follow the first rule. There are a couple of different places where this could have been handled better.</p>\n<p>For one, unless there is a good reason to allow <strong><code>GET</code></strong> or <strong><code>POST</code></strong> variables to override a URL placeholder parameter, then that should be handled appropriately. If there is a reason for it, then those values should be forced to comply with the regular expression or data type that is expected.</p>\n<p>The other failure, beyond simple sanitizing, is that the logic of the <strong><code>update_item_permission_check()</code></strong> method simply didn&#8217;t properly account for the failure to retrieve a valid result from <strong><code>get_post()</code></strong>. This function will return post data either as an object or an array (depending on parameters), or <strong><code>null</code></strong> upon failure. The logic of the first conditional was looking for a valid post <em>and</em> invalid permissions on the post as an error condition:</p>\n<pre><code>if ( $post &amp;&amp; ! $this-&gt;check_update_permission( $post ) ) {\n    return new WP_Error( \'rest_cannot_edit\', \n        __( \'Sorry, you are not allowed to edit this post.\' ), \n        array( \'status\' =&gt; rest_authorization_required_code() ) );\n}</code></pre>\n<p>Instead, it should have reversed the valid post logic, and looked for <em>not</em> a valid post, <em>or</em> invalid permissions:</p>\n<pre><code>if ( <strong>! $post ||</strong> ! $this-&gt;check_update_permission( $post ) ) {\n    return new WP_Error( \'rest_cannot_edit\', \n        __( \'Sorry, you are not allowed to edit this post.\' ), \n        array( \'status\' =&gt; rest_authorization_required_code() ) );\n}</code></pre>\n<p>And for good measure, it should probably check whether the return value was an instance of <strong><code>WP_Error</code></strong>, for future-proofing. This small change would have detected an invalid post ID, and still performed a valid permissions check for existing posts.</p>\n<p>Okay boys and girls, let&#8217;s say it all together now&#8230; &#8220;Security is hard.&#8221;</p>\n<p>&nbsp;</p>\n<div class=\"yarpp-related-rss yarpp-related-none\">\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 09 Feb 2017 01:46:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Dougal Campbell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WPTavern: WPWeekly Episode 262 – Interview With Morten Rand-Hendriksen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=65818&preview=true&preview_id=65818\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"https://wptavern.com/wpweekly-episode-262-interview-with-morten-rand-hendriksen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2668:\"<p>On this episode, <a href=\"http://marcuscouch.com/\">Marcus Couch</a> and I are joined by <a href=\"https://mor10.com/\">Morten Rand-Hendriksen</a> to discuss his <a href=\"https://mor10.com/the-case-for-wordpress-telemetry/\">WordPress Telemetry proposal</a>. We discuss the potential benefits of having an opt-in usage data collection system that could help core developers and others make informed decisions. Rand-Hendriksen also shares what he&#8217;s learned from <a href=\"https://www.lynda.com/Morten-Rand-Hendriksen/725535-1.html\">teaching WordPress</a> at Lynda.com, on how difficult it is for new users to grasp WordPress.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://wptavern.com/blogvault-security-breach-infects-customers-sites-with-malware\">BlogVault Security Breach Infects Customers’ Sites With Malware</a><br />\n<a href=\"https://wptavern.com/wordpress-rest-api-vulnerability-is-being-actively-exploited-hundreds-of-thousands-of-sites-defaced\">WordPress REST API Vulnerability is Being Actively Exploited, Hundreds of Thousands of Sites Defaced</a><br />\n<a href=\"https://wptavern.com/wp-super-cache-1-4-9-patches-multiple-xss-vulnerabilities\">WP Super Cache 1.4.9 Patches Multiple XSS Vulnerabilities</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/content-locker/\">Content Locker</a> is a tool that allows you to configure content to be behind a paywall. Visitors can pay for content by liking, sharing, or registering an account.</p>\n<p><a href=\"https://wordpress.org/plugins/wp-jump/\">WP Jump</a> allows you to bookmark your site in the admin bar. This plugin is useful if you have several, local or online, WordPress installations.</p>\n<p><a href=\"https://wordpress.org/plugins/sidebar-content-clone/\">Sidebar Content Clone</a> is a handy solution for easily duplicating or cloning all widgets from one sidebar to another sidebar. It can also clear all widgets from a sidebar with a single click.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, February 15th 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #262:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 09 Feb 2017 01:03:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WPTavern: WP Super Cache 1.4.9 Patches Multiple XSS Vulnerabilities\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65664\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"https://wptavern.com/wp-super-cache-1-4-9-patches-multiple-xss-vulnerabilities\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2318:\"<p><a href=\"https://wordpress.org/plugins/wp-super-cache/\">WP Super Cache</a> is a <a href=\"https://odd.blog/2007/11/05/wordpress-super-cache-01/\">nearly 10-year-old</a> plugin that is maintained by <a href=\"https://odd.blog/\">Donncha Ó Caoimh</a> and is actively installed on more than a million sites. Releases have been far and few between, but Ó Caoimh <a href=\"https://odd.blog/2017/02/03/wp-super-cache-1-4-9/\">has released</a> WP Super Cache 1.4.9 that patches cross-site-scripting vulnerabilities on the settings page.</p>\n<p>&#8220;Those pages are only accessible by admin users so an anonymous visitor to your site can’t come along and enable it to steal your login cookies but along with those fixes come many bug fixes so it’s worth upgrading if you’re using an old version,&#8221; Ó Caoimh said.</p>\n<p>In addition to patching security vulnerabilities, this release also contains a number of bug fixes. There&#8217;s <a href=\"https://github.com/Automattic/wp-super-cache/pull/174\">also a fix</a> in this version for those who host a lot of sites that use WP Super Cache and are running into issues with semaphores due to the possibility of users using file locking.</p>\n<p>If you&#8217;re running into this issue and need to disable file locking completely, Ó Caoimh suggests setting the WPSC_DISABLE_LOCKING constant in a global config file. &#8220;The file locking simply slowed down how fast cache files were created and is a hold-over from WP Cache when that plugin used to write directly to the cache files,&#8221; Ó Caoimh said.</p>\n<p>&#8220;This plugin writes to temporary files before moving to the final cache files so that locking isn’t really needed, but some sites still use it which is why it’s still around.&#8221;</p>\n<p>Ó Caoimh is already hard at work on the next version of WP Super Cache with an effort towards <a href=\"https://github.com/Automattic/wp-super-cache/pull/177\">moving legacy cache files</a> into supercache directories. This will improve performance and make the files easier to maintain.</p>\n<p>Users are encouraged to update to 1.4.9 as soon as possible. To see a detailed list of changes and bug fixes, visit the <a href=\"https://wordpress.org/plugins/wp-super-cache/changelog/\">plugin&#8217;s changelog</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 08 Feb 2017 04:26:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: WordPress for Android Closes Google+ Community for Beta Testers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65699\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"https://wptavern.com/wordpress-for-android-closes-google-community-for-beta-testers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2616:\"<p>The WordPress mobile app for Android is <a href=\"https://plus.google.com/u/0/+MaximeBiais/posts/8M796fTin9Q?cfem=1\" target=\"_blank\">shutting down its beta testing community</a> that was hosted on Google+ for the past three years. The mobile team switched to a completely open beta last year, enabling them to recruit 1,500 new testers.</p>\n<p>The Google+ community, which currently has 1,152 members, has been the main channel for communication to and from the app&#8217;s developers. It was previously used to announce new beta versions and users posted regularly to confirm bugs, leave feedback on their experiences, and ask questions about upcoming features.</p>\n<p>&#8220;We kept this Google+ Community opened since then but it became a place for spammers,&#8221; Automattic mobile engineer Maxime Biais said. &#8220;We decided to close it.&#8221;</p>\n<p>Beta testers who want to continue participating are encouraged to use the open source project&#8217;s issue tracker on <a href=\"https://github.com/wordpress-mobile/WordPress-Android\" target=\"_blank\">GitHub</a>. Testers can also join the #mobile channel on <a href=\"https://make.wordpress.org/chat/\" target=\"_blank\">WordPress Slack</a>. Any testers who want to lave the beta can visit the app&#8217;s testing page and tap &#8220;<a href=\"https://play.google.com/apps/testing/org.wordpress.android\" target=\"_blank\">Leave the Test</a>,&#8221; followed by uninstalling and then re-installing the app from the Play Store to get the official stable version.</p>\n<p>Despite having a healthy troop of beta testers, the open source app rarely receives any contributions from developers outside of Automattic. <a href=\"https://wptavern.com/wordpress-for-android-5-7-adds-path-to-upgrade-wordpress-com-plan\" target=\"_blank\">Recent releases</a> have included an expansion of Automattic&#8217;s monetization path with a link for users to manage and upgrade their WordPress.com plans. This has added fuel to the friction between the needs of self-hosted sites and the presence of WordPress.com features.</p>\n<p>Community members who have voiced complaints about the current features and goals of the app are welcome to participate in its development on GitHub. Beta testing is still open to all and new testers can <a href=\"https://play.google.com/apps/testing/org.wordpress.android\" target=\"_blank\">opt in on the Google Play Store testing page</a>. The Google+ Community will close on March 6, 2017, but questions and feedback are welcome in the #mobile Slack channel where the app&#8217;s developers are frequently available.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 08 Feb 2017 03:22:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: Google Updates AMP to Allow Sharing of Canonical URL\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65660\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"https://wptavern.com/google-updates-amp-to-allow-sharing-of-canonical-url\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4925:\"<a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2016/04/reading.jpg?ssl=1\"><img /></a><a href=\"https://stocksnap.io/photo/F55691D3FB\">RC Cipriano</a>\n<p>One of the main drawbacks of Google <a href=\"https://www.ampproject.org/\" target=\"_blank\">AMP</a> has been brand confusion when viewing and sharing articles. Google launched the AMP project to speed up the mobile web, but in exchange publishers have had to give up control of how their AMP&#8217;d content appears. One of the most irksome aspects of interacting with AMP pages is the convoluted URL structure, which causes users to be hesitant to share the content.</p>\n<p>AMP appends google.com/amp/ to the beginning of the URL when copying the link, opening it in a browser, or sharing an article. Visitors who want to find the canonical URL have to return to Google to search for it. To the casual observer, it appears the visitor has landed on and is attempting to share a Google story.</p>\n<p>After nearly a year, Google is finally looking to remedy this sharing problem with an update to the AMP Viewer header. In a <a href=\"https://developers.googleblog.com/2017/02/whats-in-amp-url.html\" target=\"_blank\">post</a> on the Google Developers blog, the company officially recognized this problem and announced a change that will allow visitors to share the canonical URL:</p>\n<blockquote><p>Many users have requested a way to access, copy, and share the canonical URL of a document. Today, we&#8217;re adding support for this functionality in form of an anchor button in the AMP Viewer header on Google Search. This feature allows users to use their browser&#8217;s native share functionality by long-tapping on the link that is displayed.\n</p></blockquote>\n<a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/02/google-amp-sharing-link.png?ssl=1\"><img /></a>photo credit: Google\n<p>The updated header with the anchor button is already available on the iOS Google app and will be coming to the Android app within a few weeks. Google is also working on using the <a href=\"https://developers.google.com/web/updates/2016/10/navigator-share\" target=\"_blank\">Web Share API</a> to let visitors use the platform&#8217;s native sharing flow with the original URL instead of the AMP viewer URL.</p>\n<p>&#8220;A thriving ecosystem is very important to us and attribution, user trust, and ownership are important pieces of this ecosystem,&#8221; Alex Fischer, Google software engineer, said.</p>\n<p>The ability to share the canonical URL is good news for existing AMP users but is probably not enough to convince skeptical publishers to start AMPing up their pages. Burying the publisher&#8217;s canonical link is just one of many reasons there has been such strong push back against the AMP project.</p>\n<p>Kyle Schreiber, whose post on <a href=\"https://80x24.net/post/the-problem-with-amp/\" target=\"_blank\">the problems with AMP</a> inspired discussions on <a href=\"https://news.ycombinator.com/item?id=13414570\" target=\"_blank\">Hacker News</a> and <a href=\"https://www.reddit.com/r/programming/comments/5oggtm/the_problem_with_amp/\" target=\"_blank\">Reddit</a>, believes that &#8220;AMP is bad for the open web and should be changed or eliminated.&#8221;</p>\n<p>Schreiber contends that Google has designed AMP to keep the visitor within its own ecosystem. Publishers get locked in when access to Google&#8217;s news carousel is reserved for AMP&#8217;d sites only.</p>\n<p>&#8220;Clicking on an AMP link feels like you never even leave the search page, and links to AMP content are displayed prominently in Google’s news carousel,&#8221; Schreiber said.</p>\n<p>Last year the <a href=\"https://www.wsj.com/articles/google-amp-gets-mixed-reviews-from-publishers-1477648838\" target=\"_blank\">Wall Street Journal</a> spoke with publishers who were critical with AMP but reluctant to speak publicly for fear of Google&#8217;s retaliation. Their AMP pages were generating around half as much revenue as pageviews on their full mobile sites due to Google&#8217;s limitations on the type of ad units available for AMP pages. Google&#8217;s response was that the company aims to drive more revenue to non-AMP pages but isn&#8217;t quite there yet.</p>\n<p>At the end of February the AMP project experiment will have been publicly launched for a year but many smaller publishers are still hesitant to get on board. They are concerned that AMP oversteps its reach without delivering enough value in return. The strategy of taking an absurd amount of control over publishers&#8217; content and then slowly doling it back out (as with the new button for sharing the canonical URL) demonstrates how easily Google has established itself as the de facto arbiter of the mobile web. If publishers continue to yield control of their mobile content, Google will have every incentive to make AMP support the next official ranking signal.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 07 Feb 2017 18:58:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"HeroPress: Hitting Rock Bottom\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1592\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://heropress.com/essays/hitting-rock-bottom/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5441:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/02/020817-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: We all need someone to listen. Someone to remind us that it gets better. That we will make it to tomorrow.\" /><p>I’d never been to The Capital Grille. I’d been to nice steak houses before, but this felt like a big deal. At least it should have. I was too busy freaking out because my wife wasn’t responding to one of my texts. That’s when I knew I hit rock bottom. That mental illness had taken full control. Ruining a $50 steak will make you realize that.</p>\n<p>I hit my rock bottom in the middle of WordCamp Orlando 2016. Sitting across from the wonderful Mike Hansen, sharing the best mashed potatoes I’d ever had, I was miserable. Not because Mike was bad company, but because I was so inside my head that I couldn’t control my thoughts. Dark thoughts. Suicidal thoughts. I was a mess, but Mike and the rest of the crew from BlueHost tried to keep me calm and engaged in conversation. I kept apologizing, but they stuck with me. It was pretty obvious I wasn’t okay, and they did their best. That’s what WordPress is. When you hear about “the community,” that’s what we’re really talking about.</p>\n<p>The next day, I was originally scheduled to speak, but had already backed out. As an organizer of the event, I felt awful. I know how much of a pain it is to rearrange the schedule last-minute because I’m the one, at least for the past 3 years, has made Orlando’s schedule. But the team rallied around me.</p>\n<blockquote><p>They knew I wasn’t okay, and supported me without me needing to ask.</p></blockquote>\n<p>But then something amazing happened.</p>\n<p>In the confusion of rescheduling speakers &#8211; caused by Hurricane Matthew, not Hurricane Mental Illness &#8211; a replacement speaker for one of our workshops had never actually been notified that he was speaking and didn’t show. Whoops. Even though I’d planned to just lay low in the developer workshop all day, as soon as I got word that a replacement was needed, I grabbed my laptop and headed to the next room. I don’t remember much of what I said, but I gave a talk on themes completely off the top of my head. And then it hit me. I know what I’m doing. I can do this. I’m going to be okay.</p>\n<h3>Road To Recovery</h3>\n<p>The next day, I went to see my doctor. I was diagnosed as bipolar. The dragon I’d been fighting for 15 years finally had a name. Two prescriptions later and I was on the road to recovery. I’m still on it, but WordPress is helping drive the engine.</p>\n<p>Since WordCamp Orlando, my business has taken off. I’ve started and completed more projects in the past 3 months than I did the entire rest of 2016. And all of that was possible because of the support I received that weekend. When we talk about how wonderful the WordPress community really is, we mean it. It saves lives.</p>\n<p>There’s a lot more to my story &#8211; coming out as non-binary, a shuttering business partnership to salvage a great friendship &#8211; but I don’t want to ramble.</p>\n<blockquote><p>It’s time to pay the support I received forward.</p></blockquote>\n<p>We all need someone to listen. Someone to remind us that it gets better. That we will make it to tomorrow.</p>\n<p>If you’re struggling, drop me a line on <a href=\"https://twitter.com/adamsoucie\">Twitter</a> or send an email. I’ll be waiting on the other end to lend an ear and a helping hand.</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Hitting Rock Bottom\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Hitting%20Rock%20Bottom&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fhitting-rock-bottom%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Hitting Rock Bottom\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fhitting-rock-bottom%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fhitting-rock-bottom%2F&title=Hitting+Rock+Bottom\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Hitting Rock Bottom\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/hitting-rock-bottom/&media=https://heropress.com/wp-content/uploads/2017/02/020817-150x150.jpg&description=Hitting Rock Bottom\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Hitting Rock Bottom\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/hitting-rock-bottom/\" title=\"Hitting Rock Bottom\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/hitting-rock-bottom/\">Hitting Rock Bottom</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 07 Feb 2017 12:00:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Adam Soucie\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:110:\"WPTavern: WordPress REST API Vulnerability is Being Actively Exploited, Hundreds of Thousands of Sites Defaced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65651\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"https://wptavern.com/wordpress-rest-api-vulnerability-is-being-actively-exploited-hundreds-of-thousands-of-sites-defaced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5617:\"<a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/needle.jpg?ssl=1\"><img /></a>photo credit: stevendepolo <a href=\"http://www.flickr.com/photos/10506540@N07/3020361085\">hypodermic needle IMG_7418</a> &#8211; <a href=\"https://creativecommons.org/licenses/by/2.0/\">(license)</a>\n<p>At the end of January, <a href=\"https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\" target=\"_blank\">WordPress 4.7.2</a> was released to fix four security issues, three of which were disclosed at the time of the release. These included a SQL injection vulnerability in WP_Query, a cross-site scripting (XSS) vulnerability in the posts list table, and the Press This feature allowing users without permission to assign taxonomy terms. The fourth and most critical issue, an unauthenticated privilege escalation vulnerability in a REST API endpoint, was fixed silently and <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/\" target=\"_blank\">disclosed a week after the release</a>.</p>\n<p>Contributors on the release opted to delay disclosure in order to mitigate the potential for mass exploitation, given that any site running 4.7 or 4.7.1 is at risk. This allowed time for users to update manually and for automatic updates to roll out.</p>\n<p>&#8220;We believe transparency is in the public’s best interest,&#8221; WordPress Core Security Team Lead Aaron Campbell said. &#8220;It is our stance that security issues should always be disclosed. In this case, we intentionally delayed disclosing this issue by one week to ensure the safety of millions of additional WordPress sites.&#8221;</p>\n<p>WordPress worked with <a href=\"https://sucuri.net/\" target=\"_blank\">Sucuri</a>, the company that discovered the issue, along with other WAF vendors and hosting companies to add protections before the vulnerability was publicly disclosed.</p>\n<p>The vulnerability has been public for less than a week and is now being actively exploited. Thousands of WordPress sites have been defaced with messages like “<a href=\"https://wordpress.org/support/topic/wordpress-4-7-1-hacked-by-ng689skw/\" target=\"_blank\">Hacked by NG689Skw</a>” or &#8220;Hacked by w4l3XzY3&#8221; or similar. Googling for information about these particular hacks returns thousands of other hacked sites in the results.</p>\n<p>Sucuri founder and CTO Daniel Cid said his team saw exploits in the wild less than 24 hours after the disclosure. The attacks are primarily simple defacements so far.</p>\n<p>&#8220;There are some good bad guys updating the post excerpt with the message: &#8216;Update WordPress or you will be hacked,&#8217; which is kind weird,&#8221; Cid said. &#8220;But overall we&#8217;re seeing just simple defacement attempts, using modified versions of the exploit that was shared publicly.&#8221;</p>\n<h3>Multiple Campaigns Have Defaced Hundreds of Thousands of WordPress Sites</h3>\n<p>Sucuri is monitoring multiple defacement campaigns, each with varying degrees of success. The company <a href=\"https://blog.sucuri.net/2017/02/wordpress-rest-api-vulnerability-abused-in-defacement-campaigns.html\" target=\"_blank\">published an update</a> on the active attacks as well as the IP addresses they are originating from.</p>\n<p>&#8220;We are currently tracking four different hacking (defacement) groups doing mass scans and exploits attempts across the internet,&#8221; Cid said. &#8220;We see the same IP addresses and defacers hitting almost every one of our honeypots and network.&#8221;</p>\n<p>One defacement campaign Sucuri is tracking already has more than 68,000 pages indexed on Google. After perusing the WordPress.org forums, the problem seems to have a much larger reach than Sucuri&#8217;s network has initially detected. For example, &#8220;Hacked by NG689Skw&#8221; returns approximately 200K indexed results. &#8220;Hacked By SA3D HaCk3D&#8221; returns more than 100K results. There are multiple permutations of this defacement in play on WordPress websites across the web.  Not all results that share this same campaign structure are guaranteed to be associated with this vulnerability, but the few listed above were recent posts on the WordPress.org forum from users who failed to update to 4.7.2 in time.</p>\n<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/02/hacked-wordpress-sites.png?ssl=1\"><img /></a></p>\n<p>&#8220;On our end, we are seeing a big growth on exploit attempts, specially for defacement,&#8221; Cid said. &#8220;But SPAM SEO is slowly growing too.&#8221;</p>\n<p>Cid said the vulnerability allows attackers to inject content into a post or page by default, but defacement is the easy first step, along with SEO spam. If a site has a plugin like <a href=\"https://wordpress.org/plugins/insert-php/\" target=\"_blank\">Insert PHP</a> or <a href=\"https://wordpress.org/plugins/php-code-widget/\" target=\"_blank\">PHP Code Widget</a> installed, the vulnerability can lead to remote code execution. These two plugins have more than 300K combined active installs and there are others that perform similar functions.</p>\n<p>&#8220;The core of the issue is people not updating,&#8221; Cid said. &#8220;Even with auto and simple updates, people still do not update their sites.&#8221;</p>\n<p>Needless to say, if you haven&#8217;t updated to 4.7.2 and your site is running 4.7.0 or 4.7.1, you are at risk for  content injection. For most sites that have been defaced, the simplest solution is to update to the latest version of WordPress and rollback the defaced post(s) to a revision.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 07 Feb 2017 00:36:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: BlogVault Security Breach Infects Customers’ Sites With Malware\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65658\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"https://wptavern.com/blogvault-security-breach-infects-customers-sites-with-malware\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2120:\"<img />photo credit: Anonymous Account <a href=\"http://www.flickr.com/photos/37053322@N00/2291139919\">Code</a> &#8211; <a href=\"https://creativecommons.org/licenses/by/2.0/\">(license)</a>\n<p><a href=\"https://blogvault.net/\">BlogVault</a>, a real-time backup and migration service with a <a href=\"https://wordpress.org/plugins/blogvault-real-time-backup/\">WordPress plugin</a> that&#8217;s active on more than 20K sites, <a href=\"https://blogvault.net/security-notification/\">announced</a> over the weekend that it suffered a security breach that exposed data. Akshat Choudhary, founder of BlogVault, <a href=\"https://blogvault.net/help/info\">explains</a> that some customer sites were accessed without authorization and were infected with malware.</p>\n<p>BlogVault is contacting customers whose sites are affected and removing malware to secure the data. According to Choudhary, all backups generated by BlogVault are safe. FTP, login credentials, and payment related data is safe. The service doesn&#8217;t store credit card information as payments are processed through <a href=\"https://stripe.com/\">Stripe</a>.</p>\n<p>The service has carried out a series of security precautions including, updating <a href=\"https://wordpress.org/plugins/blogvault-real-time-backup/\">the plugin to 1.45</a>, resetting passwords for all customer accounts, and is meticulously analyzing its systems. Customer passwords were encrypted, making them difficult to retrieve.</p>\n<p>BlogVault is sharing information about the breach as it becomes available. &#8220;We understand that it can be frustrating for you; as it is for us, to not have all the information,&#8221; Choudhary said. &#8220;We aim to be comprehensive in our response to the issue. Once we have safeguarded our customers’ data, and our investigation is complete we will be able to share more details.&#8221;</p>\n<p>Customers are encouraged to update the BlogVault plugin to 1.45 as soon as possible and to keep an eye on the service&#8217;s <a href=\"https://blogvault.net/help/info\">security updates page</a> for new information.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 06 Feb 2017 22:04:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"WPTavern: Content Creation Is About More Than an Editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65626\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://wptavern.com/content-creation-is-about-more-than-an-editor\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:16655:\"<a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/02/ReidPeifer.jpeg?ssl=1\"><img /></a>Reid Peifer\n<p>This is a guest post written by <span class=\"st\"><a href=\"https://twitter.com/reidpeifer?lang=en\">Reid Peifer</a>, Partner and Art Director at <a href=\"http://tri.be/\">Modern Tribe</a>. In this post, Peifer shares his experience, opinions, and things to consider as the content creation experience in WordPress <a href=\"https://make.wordpress.org/core/2017/01/17/editor-technical-overview/\">is revamped</a>.<br />\n</span></p>\n<hr />\n<p>Let’s imagine a world where the tools that we have don’t limit us, but instead enable us to create unique, contextual, and thoughtful content. We don&#8217;t fight with them, we don&#8217;t quibble over line breaks and margins.</p>\n<p>We don&#8217;t argue about whether or not two images should line up. We’re not limited to bold, italic, underline, and bullet points to express our ideas. We’re not limited to taxonomies for our organization and obtuse relational algorithms to determine complementary content.</p>\n<p>This is the reality that we should have. Content management should be more than TinyMCE and meta boxes. While WordPress has continued to grow into a mature platform, the focus on what should be its core mission has taken a second seat.</p>\n<p>We (the WordPress community at large) have gotten so excited about making WordPress awesome, we lost sight of our charge &#8211; to enable WordPress to make awesome things. To democratize publishing. To get the stories out of people&#8217;s heads and hearts and out to the world.</p>\n<p>We forgot about content. Without content, WordPress and all its bits and bobs amount to much ado about nothing. While it’s true that WordPress has grown to an almost unimaginable scale, the content it creates today isn’t going to support the needs of tomorrow’s web.</p>\n<p>I couldn’t make it to WordCamp US, but I’ll admit that I sat slack-jawed with joy listening to the <a href=\"https://wordpress.tv/2016/12/07/matt-mullenweg-state-of-the-word-2016/\">video</a> calling for a focus on the editor in 2017.</p>\n<p>The <a href=\"https://make.wordpress.org/core/2017/01/17/editor-technical-overview/\">initial discussions</a> happening on make.wordpress.org and within slack are incredibly encouraging. The community has taken this charge and is moving forward with a passion that reflects the importance of the task at hand.</p>\n<p>While I absolutely applaud their effort, and think the conversation thus far has been valuable &#8211; it immediately went to the editor itself. What makes a good editor? The discussion is focused on the UI, what format the data should be stored in, should shortcodes be used etc. All good questions, but if we answer them first &#8211; we limit the scope of our inquiry.</p>\n<p>The first question should be ‘what makes good content’? What is ‘content’? Does content only live on the post or the page? What are its essential elements? How do those elements interact and relate to each other? What’s the life cycle of content? Where and how does it surface throughout the site? Does content behave differently in different scenarios or positions?</p>\n<p>If we start with these questions, their answers become our objectives for the UI. The question &#8216;what makes a good editor&#8217; has a clear answer &#8211; one that makes achieving these goals delightful and effortless.</p>\n<h2>The Need for a More Robust Content Creation Tool Is Not New</h2>\n<p>Years ago, when ‘magazine layout’ was the new hot thing, we had the privilege of working with some large publications. In our design discovery, we learned how they thought about the presentation of their content, how layouts would change based on the content they were presenting that day.</p>\n<p>The rigid templates of the web that we were used to building couldn’t possibly meet the strategy that they had employed for ages in print. The sports, business, and lifestyle sections all needed to be able to leverage different layouts and presentation depending on their immediate needs.</p>\n<p>They needed to change day after day. We were going to toss out what we knew about building sites in WordPress. We were going to have to ditch the template hierarchy and start from scratch. The taxonomy term page in the admin wasn’t going to cut it.</p>\n<p>Meanwhile, ‘art directed’ or ‘editorial posts’ became a thing. Folks like Jason Santa Maria and Trent Walton were pumping out beautiful, bespoke articles rich in editorial design. I’ve never been more excited about the web’s potential than when I saw those first Jason Santa Maria articles &#8211; I’m a sucker for good content design.</p>\n<p>At some point shortly thereafter the NY Times published <a href=\"http://www.nytimes.com/projects/2012/snow-fall/#/?part=tunnel-creek\">Snowfall</a>, and everyone we talked to needed ‘long form’ (even if they had no idea why or what that could mean). I ran my own experiments trying to recreate that functionality in WordPress &#8211; at the time that meant full markup and a reams of custom CSS all cooked into the WYSIWYG. Beautiful output, crappy experience.</p>\n<p>These are two really common (and old) examples of how the content needs more than the tool can offer.</p>\n<p>We toiled away at these challenges over the years and have solved them for our particular use cases. Every project pushes our own solutions forward. Here’s some of what we learned.</p>\n<p><em>(So we’re all talking in the same terms, below when I reference Content Creation I mean the act of creating a new piece of content. When I reference content management, I mean both the content model, and the organization and presentation of content throughout the site.)</em></p>\n<h2>We Should Learn From Modular Development &amp; Atomic Design</h2>\n<p>We should be applying modular development and atomic design principles to both content creation and content management.</p>\n<a href=\"http://bradfrost.com/blog/post/atomic-web-design/\"><img /></a>Atomic Design Principle as Explained by Brad Frost\n<p>We’ve adopted a modular and systematic thinking to our coding practices, breaking once monolithic templates into smaller reusable parts. We’ve applied design systems thinking and atomic approaches to our UI/UX and visual design work.</p>\n<p>Small pieces come together to create components, which come together to create pages which come together to create full experiences. It’s the LEGO blocks school of design and build. This is a refrain that many of us know well.</p>\n<h2>Extending That Philosophy to Content Creation and Management</h2>\n<p>While we’ve embraced this idea of systemic thinking in how we design and the infrastructure of what we build &#8211; we haven’t gotten to thinking about how to approach content creation and content management (content strategy) in a similarly modular fashion.</p>\n<p>This is primarily because our tools won’t let us apply modular thinking to content creation and management. CMSs, including WordPress, are generally limited to predefined structures and organizational models.</p>\n<p>The role of templating in the overall CMS architecture limits the flexibility of our content creators. Today, content strategy occurs before, and then is at the mercy of development. In a better world, our content strategy could use design and development to grow, adapt, and change over time gracefully. Our publishing tools could become the method by which our ongoing content strategy evolves.</p>\n<h2>Modular Content Creation</h2>\n<p>Let’s think about the idea of content on the web. Much of what we see on the web today is a logical baby step forward from print. Titles and headlines, paragraphs of copy, images, pull quotes. Those pieces are a 1:1 analog. Because it’s a digital medium, and we’re oh so clever, we’ve included videos, image galleries, those dang carousels, and whatnots as well.</p>\n<p>For most of you, those elements are plopped onto a webpage using a WYSIWYG editor. You fight with TinyMCE for supremacy. Perhaps your theme or plugin has dedicated meta boxes for special elements. There may be a slide show or gallery at the top of the page.</p>\n<p>When we look at most executions of content on the web, they are in fact less interesting, less engaging, and less beautiful than what our print counterparts have been doing for ages (and I mean literal ages).</p>\n<p>We have all of the advantages but fail at creating anything more interesting than a preformatted spew of content. Our insistence that content and presentation need to be separate is an overstep &#8211; they are related at their very core. Was there an earth shattering news story yesterday? Too bad, you get the same 400px featured image slot that every other story gets.</p>\n<p><strong>I refuse to believe this is the best we can do.</strong></p>\n<p><strong>TinyMCE is not the pinnacle of content creation tools.</strong></p>\n<p>The platform that can figure out how to make content creation engaging and powerful is the platform that is going to continue to grow. While Calypso is an interesting engineering feat and is a helpful model for future development, it did little to push forward what it actually means to create content within the WordPress framework.</p>\n<p><strong>Trying to fight this out in a single WYSIWYG sucks</strong></p>\n<p>Our content creation tools should allow us to approach content creation the same way that we think about design. What are the atomic elements of my content strategy? How can I remix, reassemble, and work with those elements to create interesting content?</p>\n<p>It must be systemic. All of the elements and components must work as part of an overall structure and strategy to form a coherent whole. Just like our design work, and our development work. Our strategy, design, and development process is focused on identifying and creating patterns.</p>\n<p>Throughout the content strategy and design portion of the project, we’re focused on identifying what those patterns are at their very core; how do we break them down into their smallest parts? Then, through design and development, we start putting those pieces together in a way that supports internal objectives and end-user objectives.</p>\n<ul>\n<li>Elements &#8211; the simplest unit. Strings of text, single images, videos, a form input field or button</li>\n<li>Components or blocks &#8211; groupings of elements that form a cohesive unit</li>\n<li>Modules &#8211; groupings of complementary components to for a larger whole</li>\n<li>Pages (or posts, or CPTS or whatever) &#8211; groupings of modules to form a complete piece of content</li>\n</ul>\n<p>To push WordPress’ content creation tools forward, we must look at what those elements, components, and modules could be, how they relate to each other. Are they created on the fly, are they opinionated or flexible. Then how do we create them. How do they relate to themes and data sanctity. And on and on.</p>\n<h2>Modular Content Management (modular content strategy)</h2>\n<p>While there are enough visual references to start to imagine what a modular content creation tool looks like, modular content management is a bit tougher to visualize so hang with me.</p>\n<p>Within modern CMSs we’ve got a couple of tools at our disposal. Tags and categories, coupled with parent / child relationships, are the primary organization structures cooked into WordPress. Of course those can be extended to include any number of taxonomical structures imaginable.</p>\n<p>Tools like Post to Posts (P2P) provide and create an interesting peer-to-peer layer allowing you to create 1:1, 1:many, or many:many relationships.</p>\n<p>That’s pretty much it. The mechanics of relationships are defined and subject to code. I can assign content into those defined buckets. I have fixed templates that display those buckets in predetermined ways. If I want to vary from that, if I want to create relationships and remix content as a content manager or a content creator, I’m outta luck.</p>\n<p>Think about the category term screen within WordPress. What sort of content management tools do you have at your disposal there? What can you do? What can you <em>manage</em>? Not much at all. Look back over the history of WordPress releases &#8211; when has that screen changed?</p>\n<p>We are not living up to our potential if we stop at a taxonomical organization as the be-all-end-all of content management.</p>\n<p>The Loop is one of the central concepts of WordPress content management. While it is incredibly powerful and key to understanding how to think about your content, it’s the beginning, not the end, of content management. We cannot stop at the &#8216;list&#8217; as the pinnacle of our content strategy.</p>\n<h3>Needs Change Over Time</h3>\n<p>We do a lot of work for universities and schools. Each and every one has a category landing page dedicated to current students. Throughout the year, they want to gather and surface all kinds of different elements, pieces of content, and tools for those students.</p>\n<p>In WordPress terms, we’ve got pages, blog posts, events, tools, resources, key dates, applications and files, on top of video galleries and who knows what other CPTs your content strategy has formed.</p>\n<p>The needs of those students change through the year &#8211; welcome materials in the fall, midterm information in the winter, job support and internship programs in the spring. If our university friends were tied to templates where those needs were articulated in code, they’d need to go back under the hood to update their content strategy and approach it at least quarterly.</p>\n<h3>Relationships Should Be Richer Than Taxonomy Terms</h3>\n<p>Real content management would enable content creators to package and present the things they’ve made in thoughtful and unique ways&#8211;where the relationships and connections have value beyond each individual piece. Together they become a cohesive whole. That’s a content strategy that’s worth a damn. If you can’t do that, your content strategy is really just a thoughtful list of categories and tags.</p>\n<p>Our content management tools should enable and empower you to gather your content and present it how you need to. You shouldn’t be limited solely by lists and algorithms. We want our clients to be able to create unique cross-sections of content where they need, not where they happen to have pre-baked templates that allow them do so.</p>\n<p>An example to help visualize: Sticking with our college student, imagine the registrar publishes a deadline for financial aid application. The residential life department has updated forms for getting a spot in the dorms.</p>\n<p>The student life department publishes a list of events for new students to meet each other. Each piece of content lives in its own silo in disparate places on the university website. Now imagine you’re in the communications department, and you’ve been charged with ensuring that new students get the information they need.</p>\n<p>Do you <strong>A:</strong> manually type excerpts to those pieces of content in a sidebar widget, hardcode some links trying to apply a specific class that makes the links look like buttons but you can’t remember if it’s .btn_round or .btnround or .round_btn_blue_large, and pray it stays in the same place <strong>OR B:</strong> create a &#8216;Key Info for New Students&#8217; module by referencing each piece of content dynamically and dragging it at the top of the homepage displacing the out of date commencement gallery that you forgot to take down last spring?</p>\n<p>Old school is option A. New School option B (and it’s not the cool old school, it’s the lame frustrating old school).</p>\n<h3>The Way Forward Is Modular</h3>\n<p>If you’re new the concept of atomic design, read <a href=\"http://bradfrost.com/blog/post/atomic-web-design/\">this piece</a> by Brad Frost first. If you want to see how we solved some of these problems specifically &#8211; there’s a couple of WordPress.TV talks where I harp on this stuff <a href=\"https://wordpress.tv/2015/10/26/reid-peifer-reimagining-content-creation/\">here</a> and <a href=\"https://wordpress.tv/2014/05/08/reid-peifer-so-long-fixed-templates-and-thanks-for-all-the-fish-modular-content-with-wordpress/\">here</a>.</p>\n<p>We’ve got to strive for more than just an updated WYSIWYG editor. We’ve got to aspire to a bigger and broader understanding of what content is and could be. When we’ve got that vision, we’ll be able to build tools to help realize it.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 04 Feb 2017 05:32:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"WPTavern: More Than 50% of Web Traffic is Now Encrypted\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65505\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"https://wptavern.com/more-than-50-of-web-traffic-is-now-encrypted\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6155:\"<a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/01/lock.jpg?ssl=1\"><img /></a>photo credit: <a href=\"https://stocksnap.io/photo/550FJBDFSW\">Chris Anderson</a>\n<p>In October 2016 <a href=\"https://support.mozilla.org/en-US/kb/share-telemetry-data-mozilla-help-improve-firefox\" target=\"_blank\">Mozilla Telemetry</a> showed <a href=\"https://twitter.com/letsencrypt/status/786977436109934592\" target=\"_blank\">more than 50% of page loads were encrypted with HTTPS</a>. This week Let&#8217;s Encrypt is reporting that more than 50% HTTPS page loads is now the norm, a major milestone for HTTPS adoption across the web.</p>\n<blockquote class=\"twitter-tweet\">\n<p lang=\"en\" dir=\"ltr\">Per <a href=\"https://twitter.com/firefox\">@Firefox</a> Telemetry, more than 50% HTTPS page loads is now the norm! <a href=\"https://t.co/7mo8VPrpbq\">pic.twitter.com/7mo8VPrpbq</a></p>\n<p>&mdash; Let\'s Encrypt (@letsencrypt) <a href=\"https://twitter.com/letsencrypt/status/826198258355572736\">January 30, 2017</a></p></blockquote>\n<p></p>\n<p><a href=\"https://www.google.com/transparencyreport/https/metrics/?hl=en\" target=\"_blank\">Google&#8217;s Transparency Report</a> shows similar numbers for HTTPS usage, confirming that secure browsing has become the norm. Google found that HTTPS is less prevalent on mobile devices than desktop but the percentage of pages loaded over HTTPS is steadily on the rise across the board.</p>\n<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/01/percentage-pages-loaded-over-https.png?ssl=1\"><img /></a></p>\n<p>The launch of <a href=\"https://letsencrypt.org/\" target=\"_blank\">Let&#8217;s Encrypt</a>, the new free and open certificate authority, is one of the main factors causing the rapid rise in secure traffic. Thanks to sponsorships and partnerships with hosting companies and services, Let&#8217;s Encrypt closed out 2016 with more than <a href=\"https://wptavern.com/lets-encrypt-passes-20-million-active-certificates-in-2016\" target=\"_blank\">20 million active certificates</a>.</p>\n<p>Google&#8217;s influence has also been one of the driving factors in HTTPS adoption after the search engine <a href=\"https://webmasters.googleblog.com/2014/08/https-as-ranking-signal.html\" target=\"_blank\">announced</a> in 2014 that it was starting to use HTTPS as a ranking signal. As of 2017, Google Chrome is<a href=\"https://wptavern.com/chrome-to-add-security-warning-to-http-sites-beginning-2017\" target=\"_blank\"> adding a prominent security warning for HTTP sites</a>.</p>\n<p>Throughout 2016 many major publications moved to HTTPS, including the <a href=\"https://www.theguardian.com/info/developer-blog/2016/nov/29/the-guardian-has-moved-to-https\" target=\"_blank\">Guardian</a>, <a href=\"https://developer.washingtonpost.com/pb/blog/post/2015/12/10/moving-the-washington-post-to-https/\" target=\"_blank\">Washington Post</a>, <a href=\"https://www.wired.com/2016/09/wired-completely-encrypted/\" target=\"_blank\">Wired</a>, <a href=\"https://www.engadget.com/2016/06/10/engadget-moved-to-https-because-we-love-you/\" target=\"_blank\">Engadget</a>, <a href=\"https://arstechnica.com/information-technology/2017/01/ars-announces-https-by-default-finally/\" target=\"_blank\">Ars Technica</a>, and <a href=\"https://open.blogs.nytimes.com/2017/01/10/https-on-nytimes-com/?_r=0\" target=\"_blank\">New York Times</a>, to name a few. Nearly all of them publicly documented the challenges and triumphs of their HTTPS transitions.</p>\n<p>In July 2016, security researcher Scott Helme crawled the Alexa Top 1 million sites to measure how security is progressing on the web. In his previous scans, which included August 2015 and February 2016, the top million sites saw a 42% increase in HTTPS adoption. <a href=\"https://scotthelme.co.uk/alexa-top-1-million-crawl-aug-2016/\" target=\"_blank\">Helme&#8217;s July 2016 crawl</a> showed a 46% increase from February 2016.</p>\n<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/01/helme-https-adoption-stats.png?ssl=1\"><img /></a></p>\n<p>Despite the overall growth, the number of HTTPS-enabled sites is just 13.75% of Alexa&#8217;s top million. However, these are the sites that serve the most traffic: Google, YouTube, Facebook, Amazon, and others. These results are consistent with Electronic Frontier Foundation&#8217;s (EFF) <a href=\"https://www.eff.org/deeplinks/2016/10/lets-encrypt-largest-certificate-authority-web\" target=\"_blank\">reports</a> that HTTPS adoption is growing the fastest with smaller, previously-unencrypted sites.</p>\n<p>Let&#8217;s Encrypt&#8217;s launch has also had a ripple effect on commercial certificate authorities who are now moving to offer domain validated SSL certificates for free in order to promote their other security products. Symantec is now partnering with hosting companies to issue free certificates as part of its <a href=\"https://www.symantec.com/content/dam/symantec/docs/other-resources/ee-program-guide-combined-en.pdf\" target=\"_blank\">Encryption Everywhere</a> program. Comodo also <a href=\"https://www.comodo.com/news/press_releases/2016/12/worlds-largest-CA-comodo-and-web-hosting-platform-leader-cPanel.html\" target=\"_blank\">announced</a> a partnership with cPanel in December 2016 to automatically issue SSL certificates at no additional costs to consumers via cPanel&#8217;s AutoSSL feature.</p>\n<p>Securing half the web&#8217;s traffic is a major landmark on the road to a fully encrypted web, but encryption advocates will need to continue educating website owners on the benefits of making the switch to HTTPS. With the necessary infrastructure now in place for anyone to get an auto-renewing SSL certificate for free, Let&#8217;s Encrypt director Josh Aas is optimistic about progress on the remaining 50% of the web.</p>\n<p>&#8220;As exciting as 2016 was for encryption on the Web, 2017 seems set to be an even more incredible year,&#8221; Aas said &#8220;Much of the infrastructure and many of the plans necessary for a 100 percent encrypted Web really solidified in 2016, and the Web will reap the rewards in 2017. Let’s Encrypt is proud to have been a key part of that.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 03 Feb 2017 23:36:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"Donncha: WP Super Cache 1.4.9\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"https://odd.blog/?p=89500145\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://odd.blog/2017/02/03/wp-super-cache-1-4-9/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5137:\"<p>There&#8217;s a new release of <a href=\"https://wordpress.org/plugins/wp-super-cache/\">WP Super Cache</a> out and it&#8217;s a security release to fix XSS problems in the settings pages. Those pages are only accessible by admin users so an anonymous visitor to your site can&#8217;t come along and enable it to steal your login cookies but along with those fixes come many bug fixes so it&#8217;s worth upgrading if you&#8217;re using an old version.</p>\n<p>From the Changelog:</p>\n<blockquote>\n<ul>\n<li>Fixed bug when not running sem_remove after sem_release. See <a href=\"https://github.com/Automattic/wp-super-cache/issues/85\" rel=\"nofollow\">https://github.com/Automattic/wp-super-cache/issues/85</a></li>\n<li>Fixed a PHP error impacting PHP 7.1.</li>\n<li>Fixed a bug where we cached PUT and DELETE requests. We&#8217;re treating them like POST requests now.</li>\n<li>Delete supercache cache files, even when supercache is disabled, because mod_rewrite rules might still be active.</li>\n<li>Updated the settings page, moving things around. <a href=\"https://github.com/Automattic/wp-super-cache/pull/173\" rel=\"nofollow\">#173</a></li>\n<li>Make file locking less attractive on the settings page and fixed the WPSC_DISABLE_LOCKING constant so it really disables file locking even if the user has enabled it already.</li>\n<li>Added a WPSC_REMOVE_SEMAPHORE constant that must be defined if sem_remove() is to be used as it may cause problems.  <a href=\"https://github.com/Automattic/wp-super-cache/pull/174\" rel=\"nofollow\">#174</a></li>\n<li>Added a &#8220;wpsc_delete_related_pages_on_edit&#8221; filter that on returning 0 will disable deletion of pages outside of page being edited. <a href=\"https://github.com/Automattic/wp-super-cache/pull/175\" rel=\"nofollow\">#175</a></li>\n<li>Fixed plugin deleting all cached pages when a site had a static homepage. <a href=\"https://github.com/Automattic/wp-super-cache/pull/175\" rel=\"nofollow\">#175</a></li>\n<li>Make sure $cache_path has a trailing slash <a href=\"https://github.com/Automattic/wp-super-cache/pull/77\" rel=\"nofollow\">#177</a></li>\n<li>Remove flush() <a href=\"https://github.com/Automattic/wp-super-cache/pull/127\" rel=\"nofollow\">#127</a> but also check if headers are empty and flush and get headers again. <a href=\"https://github.com/Automattic/wp-super-cache/pull/179\" rel=\"nofollow\">#179</a></li>\n<li>Add fix for customizer <a href=\"https://github.com/Automattic/wp-super-cache/pull/161\" rel=\"nofollow\">#161</a> and don&#8217;t cache PUT AND DELETE requests <a href=\"https://github.com/Automattic/wp-super-cache/pull/178\" rel=\"nofollow\">#178</a></li>\n<li>Check for superglobals before using them. <a href=\"https://github.com/Automattic/wp-super-cache/pull/131\" rel=\"nofollow\">#131</a></li>\n</ul>\n</blockquote>\n<p>You can click through to each of the Github pull requests above to see discussion around each bug fix.</p>\n<p>If you&#8217;re hosting many sites that use WP Super Cache and you&#8217;re seeing issues with semaphores it may mean that your users are using file locking. It&#8217;s really not needed and in <a href=\"https://github.com/Automattic/wp-super-cache/pull/174\">#174</a> there&#8217;s a fix that went into this release. You can disable file locking completely by setting the constant &#8220;WPSC_DISABLE_LOCKING&#8221; in a global configuration file. The file locking simply slowed down how fast cache files were created and is a hold-over from WP Cache when that plugin used to write directly to the cache files. This plugin writes to temporary files before moving to the final cache files so that locking isn&#8217;t really needed, but some sites still use it which is why it&#8217;s still around.</p>\n<p>I&#8217;ve already been working on the next release with efforts <a href=\"https://github.com/Automattic/wp-super-cache/pull/177\">to move the legacy cache files</a> into the supercache directories. This will make it easier to maintain them and improve performance. We really need to find a better name for this caching method however. It caches everything &#8211; page contents and http headers so it&#8217;s quite useful!<br />\nIf you&#8217;re going to test that PR, try <a href=\"https://github.com/Automattic/wp-super-cache/pull/176\">#176</a> too. The plugin only deletes index.html type files right now but this chunk of code cleans up various for loops in the plugin and also deletes any file in the named directory. There are some restrictions on it so it won&#8217;t delete anything outside the cache directory.</p>\n<p>Thanks to everyone who contributed to this release!</p>\n\n<p><strong>Related Posts</strong><ul><li> <a href=\"https://odd.blog/2008/10/24/wp-super-cache-084-the-garbage-collector/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.8.4, the garbage collector\">WP Super Cache 0.8.4, the garbage collector</a></li><li> <a href=\"https://odd.blog/2009/01/09/wp-super-cache-087/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.8.7\">WP Super Cache 0.8.7</a></li><li> <a href=\"https://odd.blog/2010/02/08/wp-super-cache-099/\" rel=\"bookmark\" title=\"Permanent Link: WP Super Cache 0.9.9\">WP Super Cache 0.9.9</a></li></ul></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 03 Feb 2017 17:46:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Donncha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WPTavern: WP-CLI 1.1.0 Released, Project Shifts to Expand Package Index\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65553\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"https://wptavern.com/wp-cli-1-1-0-released-project-shifts-to-expand-package-index\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2920:\"<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2016/05/wp-cli.png?ssl=1\"><img /></a></p>\n<p>WP-CLI <a href=\"https://make.wordpress.org/cli/2017/02/01/version-1-1-0/\" target=\"_blank\">1.1.0</a> is now available, two months after 1.0.0 was released. The project shifted after 1.0.0 to focus on its <a href=\"https://wp-cli.org/package-index/\" target=\"_blank\">package ecosystem</a>, encouraging new features to be built as standalone packages instead of rolling them all into WP-CLI core. Daniel Bachhuber, the project&#8217;s maintainer, moved WP-CLI in this new direction to better distribute the maintenance burden among package maintainers.</p>\n<p>Version 1.1.0 includes 23 command improvements, 8 framework enhancements, and dozens of bug fixes. The release had a 16% increase in the number of contributors from 1.0.0. It is the first major release since the project was <a href=\"https://wptavern.com/wp-cli-gets-official-wordpress-org-support\" target=\"_blank\">brought under the umbrella of WordPress.org</a> at the beginning of 2017.</p>\n<p><a href=\"https://i2.wp.com/wptavern.com/wp-content/uploads/2017/02/wp-cli-handbook.png?ssl=1\"><img /></a></p>\n<p>The process of migrating the wp-cli.org website to wordpress.org will take a couple of months, but the website documentation has already found a new home at <a href=\"https://make.wordpress.org/cli/handbook/\" target=\"_blank\">make.wordpress.org/cli/handbook/</a>. Contributors can edit documentation by clicking on the button at the top of any page, which links to the handbook&#8217;s GitHub repository.</p>\n<h3>WP-CLI to Expand Package Index</h3>\n<p>As part of the new focus on the WP-CLI package ecosystem, Bachhuber has created a GitHub repository for logging <a href=\"https://github.com/wp-cli/ideas\" target=\"_blank\">ideas for new packages</a>. The best ideas will be maintained as canonical community packages.</p>\n<p>&#8220;The end goal for the WP-CLI package index is to be a directory of well-maintained, canonical features,&#8221; Bachhuber said. &#8220;Packages will be considered community projects shepherded by one or more maintainers, instead of the domain of a specific author.&#8221;</p>\n<p>Bachhuber is looking to hire someone to assist in maintaining the project in a part-time capacity for 5-10 hours per week. This person will work on supporting package maintainers and vetting ideas for new packages.</p>\n<p>The next release cycle will focus on <a href=\"https://github.com/wp-cli/wp-cli/issues/3728\" target=\"_blank\">splitting internal commands into separate packages</a> with the goal of having official maintainers for them in the future. Contributors are also planning to create new pages on WordPress.org for the <a href=\"http://wp-cli.org/commands/\" target=\"_blank\">WP-CLI commands</a> directory and <a href=\"http://wp-cli.org/docs/internal-api/\" target=\"_blank\">internal API docs</a>.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Feb 2017 18:16:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"Post Status: Editing and customization core focus areas — Draft Podcast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://poststatus.com/?p=33385\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"https://poststatus.com/editing-customization-core-focus-areas-draft-podcast/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2085:\"<p>Welcome to the Post Status <a href=\"https://poststatus.com/category/draft\">Draft podcast</a>, which you can find <a href=\"https://itunes.apple.com/us/podcast/post-status-draft-wordpress/id976403008\">on iTunes</a>, <a href=\"https://play.google.com/music/m/Ih5egfxskgcec4qadr3f4zfpzzm?t=Post_Status__Draft_WordPress_Podcast\">Google Play</a>, <a href=\"http://www.stitcher.com/podcast/krogsgard/post-status-draft-wordpress-podcast\">Stitcher</a>, and <a href=\"http://simplecast.fm/podcasts/1061/rss\">via RSS</a> for your favorite podcatcher. Post Status Draft is hosted by Joe Hoyle &#8212; the CTO of Human Made &#8212; and Brian Krogsgard.</p>\n<p>In this episode, Joe and Brian talk about two of the three WordPress core focus areas &#8212; the customizer and the editor. There has been some news lately with initial ideas and mockups for each project, and we discuss the importance of these features, as well as what&#8217;s happening with these projects so far.</p>\n<a href=\"https://audio.simplecast.com/59336.mp3\">https://audio.simplecast.com/59336.mp3</a>\n<p><a href=\"https://audio.simplecast.com/59336.mp3\">Direct Download</a></p>\n<h3>Links</h3>\n<ul>\n<li><a href=\"https://make.wordpress.org/core/2017/01/19/customization-in-2017/\">Customizer opportunities</a></li>\n<li><a href=\"https://make.wordpress.org/design/2017/01/25/what-are-little-blocks-made-of/\">Editor mockups</a></li>\n<li><a href=\"https://make.wordpress.org/core/2017/01/17/editor-technical-overview/\">Editor technical challenges</a></li>\n<li><a href=\"https://commercenotebook.com\">Commerce Notebook</a></li>\n</ul>\n<h3>Sponsor: Pippin&#8217;s Plugins</h3>\n<p>This episode is sponsored by Pippin&#8217;s Plugins. <a href=\"http://pippinsplugins.com/\">Pippin&#8217;s Plugins</a> creates a suite of plugins that work great alone, or together. Whether you need to restrict content, sell downloads, or start an affiliate program, they&#8217;ve got you covered. For more information, check out their <a href=\"http://pippinsplugins.com/\">website</a> and thank you to Pippin&#8217;s Plugins for being a Post Status partner.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Feb 2017 17:49:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Katie Richards\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: WPWeekly Episode 261 – WordPress for Schools With Cameron Barrett\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wptavern.com?p=65559&preview=true&preview_id=65559\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"https://wptavern.com/wpweekly-episode-261-wordpress-for-schools-with-cameron-barrett\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2598:\"<p>In this episode, <a href=\"http://marcuscouch.com/\">Marcus Couch</a> and I are joined by <a href=\"http://camworld.org/\">Cameron Barrett</a>, founder of <a href=\"http://schoolpress.co/\">SchoolPresser, LLC</a>. Barrett explains how he negotiated and helped migrate Newark New Jersey&#8217;s public school system from a proprietary CMS to WordPress. He shares the pitfalls he experienced and the amount of money the district is saving since making the switch. Barrett also provides tips and suggestions on how to sell WordPress as a solution to school districts.</p>\n<p>We didn&#8217;t dive as deep as we wanted to on the topic but if you&#8217;d like to learn more, please watch the<a href=\"https://wordpress.tv/2016/12/11/cameron-barrett-wordpress-for-schools-3/\"> presentation</a> he did at WordCamp US. In it, he provides more details of the migration, financials, and there&#8217;s a great question and answer session at the end.</p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\">WordPress 4.7.2 Security Release</a></p>\n<h2>Plugins Picked By Marcus:</h2>\n<p><a href=\"https://wordpress.org/plugins/birthday-mails-bp/\">Birthday Mail BP</a> is an automated function for BuddyPress that sends birthday emails to members on their birthday. It&#8217;s a great way to express birthday wishes or to present a coupon or discount code to members.</p>\n<p><a href=\"https://wordpress.org/plugins/woo-document-preview/\">WC Document Preview</a> adds a document preview feature to WooCommerce similar to how Amazon allows you to preview books. This is handy for ebooks and digital products that lend themselves to previews.</p>\n<p><a href=\"https://wordpress.org/plugins/tm-style-switcher/\">TM Style Switcher</a> allows you to save a theme&#8217;s settings as skins, switch between them, and move skins from one WordPress site to another.</p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Wednesday, February 8th 3:00 P.M. Eastern</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"https://wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #261:</strong><br />\n</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Feb 2017 00:30:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"HeroPress: The Joy of Being with WordPress Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1586\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://heropress.com/essays/joy-wordpress-community/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:11955:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/02/020117-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: Above all, the global community of WordPress has been a major inspiration for me.\" /><p>When my friend Mahangu first recommended me to Topher to write an essay for HeroPress, I could not believe his words. Quite confused I asked Topher, he repeated the same ‘Share your story on HeroPress’. It was unbelievable yet a beautiful sentence that left me stunned with pride.</p>\n<p>HeroPress has been a place where I occasionally read the stories of the WordPress heroes. Reading the inspiring stories, I have always found new energy for Work every day. Never thought my story would be worth this platform, I was overwhelmed to receive that message from Topher.</p>\n<p>I am NO Hero but just another full stack WordPress developer. More than that, I am a 24 years young web dude from Nepal. Nepal is a small country that lies in the foothills of the immense and sensational Himalayas. Moreover, it is the land of incredible natural beauty, adventure, and ancient wisdom and enlightenment. And this land has always inspired me to take tiny steps of truth towards the mountain-high peak.</p>\n<p>I could not agree much with Mahangu and Topher but I decided to share my story on this amazing platform. After all, I am not any exceptional but someone who wants to be a hero like (almost) everyone.</p>\n<h3>How I started?</h3>\n<p>Even though I was highly interested to computer from early childhood, I got one of my own only when I was in the 4th grade. As a curious child, I learned about technical aspects of computer from my senior brother and within a year or so on I started fixing the neighbors and friends computer. Since then I had a will to get things “right” as opposed to just getting things “working”. I vividly recall those days when I used to spend hours of my holiday playing Mario. Honestly, that’s still one of my favourite game. <img src=\"https://s.w.org/images/core/emoji/2.2.1/72x72/1f609.png\" alt=\"😉\" class=\"wp-smiley\" /></p>\n<p>Back in those days, computer and internet were limited to few cyber cafes in town. I barely had any idea what they actually meant for except gaming.</p>\n<blockquote><p>I thought they were established for the foreigners as they were mostly visited by the international tourists.</p></blockquote>\n<p>After SLC examination (10th grade in Nepal), we have 3 months long vacation when students take extra classes such as bridge courses to prepare themselves for college. Since I was from the best school and was quite good at study I didn’t go for classes required for joining college. That was the time when I enrolled in a computer institute for hardware classes as I was quite interested to know how machine work. Thereafter, I joined college with Science faculty. The only motive behind joining the hardware class and choosing ‘Science’ was to prepare myself for mechanical engineering.</p>\n<p>But I could not do it. Physics, Chemistry barely made any sense to me and therefore started questioning its applicability in my day to day life. As a result, I failed formal education system.</p>\n<blockquote><p>This is how I faced the first and last (till now) “failure” in my life, I dropped down engineering dream right there.</p></blockquote>\n<p>Yet I no more worry, destiny had something other stored for me.</p>\n<p>Despite all, I had kept myself engaged with particular computer science, technology and web. I had somehow managed to learn basic HTML, CSS and designing stuff. I had made contacts with a number of people mostly senior to me who worked with programming, blogging. And one of them has a great role in shaping me as a ‘programmer’. Simultaneously, I read a lot of articles, followed people who mastered in programming which all supported my ‘new dream’ to become a ‘Programmer’.</p>\n<p>As suggested by a friend of mine, I created my first blog in 2010 using Blogger platform. Later, I came to know that WordPress was a better platform with more possibilities and finally switched to WordPress 3.2 after a recommendation from one of my seniors. To my surprise, it was more wonderful than what I actually heard. I loved WordPress. Thereafter, I started tweaking designs and other aspects. Since then, I haven’t looked back.</p>\n<h3>My Contributions / Together with WordPress</h3>\n<p>Above all, the global community of WordPress has been a major inspiration for me. I am always grateful to the community and millions of WordPress lovers for the generous resources. I have also been actively contributing to the WordPress translation.</p>\n<p>Greatly benefited by the works of others, I always wanted to give back to the community. The same instinct led me to the person I am today. Literally, volunteering for making WordPress platform for everyone has given me all the honors including this (feature on HeroPress).</p>\n<p>In 2014, among various WordPress possibilities, WooCommerce is the one which intrigued me from the very beginning. With the growing eCommerce market, I knew that it was going to be a excellent piece of software in the future because of its incredible features. Using the plugin and analyzing it from the user’s perspective, I made numerous enhancements on WooCommerce.</p>\n<p>I introduced Nepali currency symbol in WooCommerce version 2.2.3 which proved to be a milestone in developing eCommerce in my country Nepal. Additionally, I developed a Nepali payment gateway WooCommerce eSewa plugin without any incentive. The best thing about this whole thing is that, I got great help to deal with product platform from amazing folks like Mike Jolley, Claudio Sanches and James Koster. During the period, I learned so much about WooCommerce and coding in general. Since then, I have been reporting several bugs/issues and enhanced the plugin with 200+ pull requests on WooCommerce Github repository. Moreover I have also contributed to Storefront theme.</p>\n<p>Since I was already technical bent, I learned about Vagrant for development environment. My first instinct was to use Varying Vagrant vagrants (VVV). But as a developer, I wanted more flexibility over the stack I used. So I started looking for alternative and found PuPHPet. For those who don’t know, PuPHPet is &#8211; “a simple Vagrant/Puppet GUI”. In order to make it more robust, I started contributing to this project and have also introduced WP-CLI support.</p>\n<p>Afterward, I started automating my development approach. Since there was no good grunt package available to compile PO to MO files, I developed grunt-potomo.</p>\n<h3>Earning my Living with WordPress</h3>\n<p>Desperate as I had dropped from college, I was quite doubtful if I would ever get any job. Web development was at its beginning stage (not established as a job), there was little hope but it proved to be an advantage for me. I got an opportunity to work as a web developer in RealTech Computer Institute which is the same institute where I had learnt hardware and programming. I worked on new and innovative eCommerce sites, finished numerous time sensitive projects, trained new developers in utilizing front-end frameworks like BootStrap, Foundation, jQuery etc.</p>\n<p>Later in 2015, I joined a growing team of ThemeGrill as Lead Plugin Developer. Together with ThemeGrill team, I have developed several WordPress plugins. To name a few, Social Icons, RestaurantPress, ThemeGrill Demo Importer are free WordPress plugins I have developed which are available in official WP plugin repository. Additionally, I have built several internal automated tools to improve overall customer support. I am also responsible for troubleshooting production issues, assisting WooCommerce, sales and performance monitoring.</p>\n<p>WordPress has made my life much easier!</p>\n<h3>WordPress Community in Pokhara</h3>\n<p>My hometown Pokhara is 6 to 8 hours of drive from the capital city Kathmandu. I along with few WordPress enthusiast friends used to travel all the way to Kathmandu just to attend WordCamp Kathmandu (formerly WordCamp Nepal). I was fascinated by the awesome presentations by developers and networking opportunities provided there. Within a year or so the number of WordPress lovers grew in Pokhara but we didn’t have any such event there yet.</p>\n<blockquote><p>In love with WordPress, I thought of organizing WordPress people in Pokhara under common umbrella &#8211; WordPress Pokhara.</p></blockquote>\n<p>By then, I created a Facebook group with some friends, who were involved in WordPress projects. We organized several WordPress meetups and talk about WordPress. The group has grown from 3-4 members to 1000 members in Facebook right now. Mostly I have seen students and professionals coming together and helping each other in projects. Since I am away from Pokhara, Yam B. chetri and team are involved to organize regular WordPress Pokhara meetups. Thanks to his helpful behaviour, we are rapidly growing.</p>\n<h3>Wrapping Up</h3>\n<p>Since I switched to WordPress, I have been working with a motive to program a better solution for users which is surely a challenging task. So I am taking every small step to climb the cliff and still doing homework to reach the right destination.</p>\n<p>To be frank, I don’t want to explore how business work and I am not made for it. But I am quite confident on the fact that I am good at understanding public-facing issues to tackle with a right solution.</p>\n<p>This is just an ordinary story like yours as I said in the beginning. And I repeat that I am no hero yet my journey may be somehow different from yours.</p>\n<p>Just write to me if you have anything to say. ☺</p>\n<p>And thanks to HeroPress and WordPress. Let’s keep rising high as Everest! Together!!</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: The Joy of Being with WordPress Community\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=The%20Joy%20of%20Being%20with%20WordPress%20Community&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fjoy-wordpress-community%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: The Joy of Being with WordPress Community\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fjoy-wordpress-community%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fjoy-wordpress-community%2F&title=The+Joy+of+Being+with+WordPress+Community\" rel=\"nofollow\" target=\"_blank\" title=\"Share: The Joy of Being with WordPress Community\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/joy-wordpress-community/&media=https://heropress.com/wp-content/uploads/2017/02/020117-150x150.jpg&description=The Joy of Being with WordPress Community\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: The Joy of Being with WordPress Community\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/joy-wordpress-community/\" title=\"The Joy of Being with WordPress Community\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/joy-wordpress-community/\">The Joy of Being with WordPress Community</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 01 Feb 2017 12:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Shiva Poudel\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"WPTavern: WordPress Telemetry Proposal Addresses Long-Standing Privacy Concerns as GDPR Compliance Deadline Looms\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=64798\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"https://wptavern.com/wordpress-telemetry-proposal-addresses-long-standing-privacy-concerns-as-gdpr-compliance-deadline-looms\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14494:\"<p><a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/paper.jpg?ssl=1\"><img /></a></p>\n<p>At the end of October 2016, Morten Rand-Hendriksen created a <a href=\"https://core.trac.wordpress.org/ticket/38418\" target=\"_blank\">proposal on WordPress trac</a> for adding telemetry to core, an opt-in feature that would collect anonymized data on how people are using the software. He proposed that the new feature be displayed on first install or update, disabled by default in the admin with a control available under Settings->General. One option he suggests is shipping it as a plugin that auto-installs on opt-in and auto-uninstalls on opt-out. He also identified a few examples of core data that could be tracked, including number of themes and plugins installed, frequency of use of specific views (Settings, Customizer, etc), current version, update status, locale, and language.</p>\n<p>&#8220;WordPress prides itself on being an application built by the user for the user,&#8221; Rand-Hendriksen <a href=\"https://mor10.com/the-case-for-wordpress-telemetry/\" target=\"_blank\">said</a>. &#8220;The problem is with the popularity and reach of WordPress today, the distance between the WordPress 1% (or even .1%) and the average user is becoming so vast we (the people who contribute to WordPress core) know almost nothing about the actual people who use WordPress or how they use the application.&#8221;</p>\n<p>During the WordPress 4.7 development cycle, Rand-Hendriksen said he was involved in several conversations where participants assumed the use of features without any data to back up their opinions. He contends that WordPress contributors do not have the necessary data to know how users are interacting with the application and its features.</p>\n<p>&#8220;The general argument was that based on the 80/20 rule, certain features should be added while others should be removed,&#8221; Rand-Hendriksen said. &#8220;I kept brining up the well known fact we don’t have a clue what features 80%, or even 20%, of WordPress users actually use so any claim of validity in the 80/20 rule is guesswork at best.&#8221;</p>\n<p>His proposal states that all the data collected should be public for transparency and also made available to end-users in the admin and on WordPress.org.</p>\n<p>The idea has had a few months to marinate and has generated some discussion about what a prototype would entail. Core committer Ella Van Dorpe created an experimental <a href=\"https://github.com/iseulde/wp-data\" target=\"_blank\">wp-data</a> standalone plugin for tracking a few simple interactions with the editor. Participants in the discussion recommended creating an Elasticsearch/Logstash setup for storing the data, technologies that the WordPress.org systems team have deployed before.</p>\n<p>&#8220;I think a good summary is that there are a lot of hurdles in the way and currently no one has time to work on it,&#8221; Greg Brown, a Data Wrangler at Automattic, said in a followup <a href=\"https://core.trac.wordpress.org/ticket/38418#comment:5\" target=\"_blank\">discussion on the ticket</a> three weeks ago. &#8220;Ultimately, I think the biggest blocker is getting someone with the time, inclination, and persistence to work on this. Getting it deployed onto .org is the right thing to do eventually, but I suspect it will take quite a while.&#8221;</p>\n<p>WordPress lead developer Dion Hulse <a href=\"https://core.trac.wordpress.org/ticket/38418#comment:6\" target=\"_blank\">confirmed</a> that WordPress is already tracking many of these stats and that creating a prototype on WordPress.org infrastructure would be the best option forward.</p>\n<p>&#8220;It would also be valuable to see how our existing stats system can compliment or be replaced by the proposal here though,&#8221; Hulse said. &#8220;I mention this as most of the stats from the original description are already tracked, just not exposed in any form. The only new thing mentioned here is the Frequency of use of specific views (Settings, Customizer, etc) and transparency part (which would still probably only be anonymized summaries, not exact data).&#8221;</p>\n<h3>WordPress Telemetry Project Provides a Solution to Long-Standing Privacy Concerns</h3>\n<p>Moving WordPress&#8217; current data tracking into a more transparent opt-in feature would also provide a solution to some long-standing privacy concerns raised by contributors in <a href=\"https://core.trac.wordpress.org/ticket/16778\" target=\"_blank\">a six-year-old trac ticket</a>. WordPress tracks the number of blogs and users in a given installation, along with the installation URL in the headers, in order to <a href=\"https://core.trac.wordpress.org/ticket/16778#comment:67\" target=\"_blank\">facilitate update requests</a> that may become problematic, particularly in the case of large multisite installations.</p>\n<p>&#8220;Even if a user knows that some data needs to be passed for a version check of core, plugins, or themes, the amount of data passed to remote is obviously more than needed to do the version check,&#8221; one contributor <a href=\"https://core.trac.wordpress.org/ticket/16778#comment:14\" target=\"_blank\">commented</a> on the ticket. &#8220;But users should be made aware upfront so they can freely decide on their own if they want to instead of being forced to support the project with their usage-data. They could be offered an opt-in to do so.&#8221;</p>\n<p>&#8220;The number of registered users I have on my site tied to the URL that is sent with tracking request gives out vital information on how well my business could be doing &#8211; information that is mine and mine only,&#8221; WordPress plugin developer Danny van Kooten said. &#8220;At the very least we could make it very clear that WordPress is tracking this information and what exactly it is doing with it. I really do not think there is any excuse for that.&#8221;</p>\n<p>Developers can filter the data to satisfy their privacy concerns but it is somewhat inextricable from the update process for larger multisite installations. It&#8217;s also too big of a technical hurdle for most regular users who would be better served by a simple UI allowing them to opt out of data collection.</p>\n<p>Rand-Hendriksen&#8217;s WordPress telemetry proposal gives the project an opportunity to formalize what data is being collected, state the purpose behind it, and allow users to choose if they want to be included.</p>\n<h3>Europe&#8217;s General Data Protection Regulation (GDPR) May Push WordPress Towards More Transparent Data Collection</h3>\n<p>Progress on both the Telemetry project and the ticket regarding privacy concerns has been slow. Neither seem to be a priority among contributors, but Europe&#8217;s <a href=\"http://eur-lex.europa.eu/legal-content/EN/TXT/?uri=OJ%3AL%3A2016%3A119%3ATOC\" target=\"_blank\">General Data Protection Regulation</a> (GDPR) may provide the impetus needed to push WordPress towards more transparent and responsible data collection.</p>\n<p>The GDPR is an overhaul of data protection law in Europe with far more stringent requirements than the previous laws. It requires full disclosure for any data collection and standardized privacy notices to help users understand where and how the data is being used. Consent to have data collected must be confirmed and users have the right to access their own data. It also includes the right of erasure or &#8220;the right to be forgotten,&#8221; which allows users to remove their data from the web. The GDPR goes into effect in May 2018.</p>\n<p><a href=\"https://webdevlaw.uk/\" target=\"_blank\">Heather Burns</a>, a digital law specialist who consults and speaks extensively on internet laws and policies, encouraged WordPress contributors to frame the discussion regarding privacy concerns in terms of working towards compliance with a specific framework.</p>\n<p>&#8220;For the purposes of this discussion, core should work to the GDPR standard for two reasons,&#8221; Burns said. &#8220;The first reason lies in cultural differences. The US does not have a single overarching data protection and privacy regulation, unlike Europe, where we have this data protection regime which applies to all personal data regardless of use, format, or sector. So GDPR gives developers &#8211; even those outside the EU &#8211; a robust, healthy, and very tough set of standards to follow. Given what we have seen coming out of the White House in the past week, GDPR also provides as good a starting point as any for defensive user protection.</p>\n<p>&#8220;The second is that GDPR is extraterritorial. It applies to the personal data of anyone in Europe regardless of where the online service is located. If your business is in the US or Australia or Israel but you have European users, you have to protect their data to European GDPR standards.&#8221;</p>\n<p>Pricewaterhouse Coopers recently surveyed 200 US-based multinational companies with more than 500 employees and found that <a href=\"https://www.pwc.com/us/en/increasing-it-effectiveness/publications/assets/pwc-gdpr-series-pulse-survey.pdf\" target=\"_blank\">77% plan to spend $1 million or more on GDPR compliance</a>. More than half of those surveyed cited GDPR readiness as the highest priority on their data-privacy and security agendas.</p>\n<p>The hefty penalties of noncompliance are one of the driving factors behind American companies spending millions of dollars on satisfying the requirements of this new European regulation.</p>\n<p>&#8220;GDPR is a complete overhaul of its dialup-era (1995) predecessor and one of the areas that has been beefed up is its teeth,&#8221; Burns said. &#8220;Businesses which are found to be in noncompliance by a European member state&#8217;s data protection regulator, whether that is your small app studio all the way up to Automattic, could face penalties of up to 4% of the business&#8217;s global annual turnover. Now there’s some solid context for the philosophical discussion.&#8221;</p>\n<p>However, not everyone is convinced that the GDPR will be beneficial to consumers. Kitty Kolding, CEO and president of <a href=\"http://www.infocore.com/\" target=\"_blank\">Infocore Inc</a>, an international company that specializes in sourcing market data, told <a href=\"https://www.exchangewire.com/blog/2016/07/07/an-american-perspective-the-three-worst-things-about-the-eu-gdpr/\" target=\"_blank\">ExchangeWire</a> that she believes the GDPR will undermine &#8220;the sanctity of consumers&#8217; data privacy and security&#8221; and hobble marketing and advertising worldwide.</p>\n<p>She contends that provisions like the &#8220;right to be forgotten,&#8221; which require customer data to be retained beyond the time that it&#8217;s in active use, will make that data more susceptible to hacking. Additionally, the enforcement body for the new legislation claims authority over companies, with the right to search and seize records, without any oversight or appeals.</p>\n<p>&#8220;Every company everywhere that handles data on EU citizens is also automatically subject to this group’s absolute power – though it’s anybody’s guess how the EU believes they can enforce such a broad mandate outside its own borders,&#8221; Kolding said.</p>\n<p>Currently, only two trac tickets <a href=\"https://core.trac.wordpress.org/search?q=GDPR\" target=\"_blank\">mention the GDPR</a> so it&#8217;s not yet clear how WordPress core will respond to the requirements of the new legislation. Burns recommends that WordPress core contributors go through the process of conducting a <a href=\"https://ico.org.uk/for-organisations/guide-to-data-protection/privacy-by-design/\" target=\"_blank\">privacy impact assessment</a> to determine the right way forward.</p>\n<p>Regardless of WordPress&#8217; response, companies and organizations that depend on the software  will need to assume the responsibility of their own compliance, as these requirements extend far beyond core. The GDPR applies to anything added into a website or app that collects users&#8217; data. For example, many contact form plugins store submissions inside the WordPress database and site owners will want to re-examine how users are notified of this.</p>\n<p>&#8220;One of the main changes with GDPR is called the accountability principle,&#8221; Burns said. &#8220;Businesses collecting personal data must be completely transparent and accountable over what data they are collecting, how they are storing it and where, who it is being passed to (such as third parties), who has access to it, and how long it is retained. Users also have the right to request that any data collected about them must be deleted.&#8221;</p>\n<p>There&#8217;s no WordPress plugin that will instantly make a site GDPR compatible. Drupal has a <a href=\"https://www.drupal.org/project/gdpr\" target=\"_blank\">GDPR module</a> that aims to make sure the site follows the guidelines and legislation set by the EU, but it doesn&#8217;t cover all requirements. Automating an assessment of privacy impact for a site using a CMS and potentially dozens of third-party extensions is a complex endeavor. This is one regulation that will require business owners to educate themselves and implement privacy practices that put users&#8217; interests first.</p>\n<p>With the deadline for compliance closing in, WordPress has an opportunity to re-evaluate how the project handles user privacy and make steps towards greater transparency. If contributors are looking into collecting more data to assist decision-making on features, as outlined in Rand-Hendriksen&#8217;s telemetry proposal, this project provides an avenue for working towards GDPR compliance. These privacy concerns are especially important to address when considering WordPress for government, healthcare, educational institutes, and other data sensitive websites.</p>\n<p>Burns views the GDPR&#8217;s compliance deadline as a fresh opportunity for WordPress to build better privacy structures and legal certainty using the regulation as a healthy baseline for all users.</p>\n<p>&#8220;Everyone needs to be working in implementations for their own businesses and sites in any case ahead of deadline day, in addition to any changes that need to be made in the WP code,&#8221; Burns said. &#8220;It&#8217;s important to remember that GDPR compliance is not a tick box you can squeeze in next April. This is about your processes, your workflows, and your systems of accountability. Start now.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 01 Feb 2017 00:10:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: Logging Into WooCommerce.com Now Requires a WordPress.com Account\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65488\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"https://wptavern.com/logging-into-woocommerce-com-now-requires-a-wordpress-com-account\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5935:\"<p>If you logged into <a href=\"https://woocommerce.com/\">WooCommerce.com</a> over the weekend, you may have noticed a distinct change. In order to sign into the site, users are now <a href=\"https://public-api.wordpress.com/oauth2/authorize?response_type=code&client_id=50916&state=26cc0ecf5f249227f5566d9b1bc392db&redirect_uri=https%3A%2F%2Fwoocommerce.com%2Fwc-api%2Fwpcom-signin%3Fnext%3Dmyaccount&blog_id=0&wpcom_connect=1&new-user=1\">required</a> to have a WordPress.com account. The change occurred without warning and surprised those who manage multiple WooCommerce stores for clients.</p>\n<a href=\"https://i0.wp.com/wptavern.com/wp-content/uploads/2017/01/WooCommerceWPComLoginScreen.png?ssl=1\"><img /></a>WooCommerce Login Screen Requiring a WP.com Account\n<p><a href=\"https://twitter.com/bradkgriffin?lang=en\">Brad Griffin</a>, who maintains a number of client sites that run WooCommerce, raised concerns over the change <a href=\"https://www.facebook.com/groups/advancedwp/permalink/1388565454538998/\">in a post</a> on the Advanced WordPress Facebook group.</p>\n<p>&#8220;When dealing with businesses, asking someone at a corporate level to take their email address and make a WordPress.com account is a bit problematic,&#8221; Griffin said. &#8220;They&#8217;re confused as to why they need to do this. They don&#8217;t have immediate access to that email address on a Saturday or Sunday.&#8221;</p>\n<p>&#8220;So, without warning, without notice, without a heads up or anything else, no one can now access anything in the back-end of the WooCommerce account unless there is a WP.com single sign on account using oAuth.&#8221;</p>\n<p>For those not interested in signing in with their WordPress.com account, WooCommerce.com attempts to alleviate concerns <a href=\"https://woocommerce.com/signin-with-wordpress/not-interested/\">in an article</a> that outlines the benefits. The benefits include an option to enable 2-Factor Authentication, access to eCommerce services, and viewing purchase history.</p>\n<p>After speaking to Todd Wilkens, Head of WooCommerce at Automattic, Griffin published <a href=\"https://www.youtube.com/watch?v=VXfugcpuD4Y\">video</a>, explaining the change and offers suggestions for those who manage multiple WooCommerce stores for clients. The suggestions are:</p>\n<ul>\n<li>Make 100% sure that you, your client, your store, your account, or anything else has a WordPress.COM account ~ not just WordPress.org!</li>\n<li>Once you&#8217;ve used an email and login and you are setup for WordPress.COM (not .org), make absolutely certain that you are using an incognito browser window when logging into WooCommerce.com.</li>\n</ul>\n<p>Using a private or incognito browser window won&#8217;t remember the login as the cookie is not saved. If you don&#8217;t use incognito mode and like, comment, or subscribe to items on WordPress.com or any site that uses <a href=\"https://developer.wordpress.com/docs/oauth2/\">WordPress.com&#8217;s oAuth protocol</a>, those actions will occur under the client&#8217;s account. &#8220;<span class=\"_5yl5\">Many users might not fully realize how far-reaching that one little oAuth endpoint <strong>actually is</strong> and the vastly significant number of touch-points it can affect,&#8221; Griffin said. </span></p>\n<p>Wilkens <a href=\"https://woocommerce.com/2017/01/woocommerce-requires-wordpress-account/\">published a post</a> on the official WooCommerce blog explaining why the login system was switched, &#8220;We found that a lot of customers were using <i>two accounts</i> to access services from <i>one</i> company,&#8221; he said.</p>\n<p>&#8220;To simplify that, we are centralizing on the WordPress.com login. Automattic has done this with previous acquisitions, like Polldaddy, for the same reasons. Now you can use only one login to access all Automattic services, including WooCommerce, Jetpack, VaultPress and more.&#8221;</p>\n<p>So far, the WooCommerce team has tracked more than 10K successful logins to the new system and are monitoring feedback on social media. Only a small subset of users have reported issues due to confusion, &#8220;Over half of the 1% of users who opened tickets were confused between having a WordPress.com login vs. the login they use for their self-hosted WordPress install,&#8221; Wilkens said.</p>\n<h2>A Better Way to Manage Multiple Client Accounts Is in the Works</h2>\n<p>WooCommerce.com joins a growing collection of Automattic services, sites, and products that require a WordPress.com user account. As the number of reasons to have an account increases, perhaps it&#8217;s time for Automattic to create a client management system. A system that allows users to assign people who can act on their behalf, similar to a <a href=\"https://en.wikipedia.org/wiki/Power_of_attorney\">power of attorney</a>.</p>\n<p>An example that comes to mind is <a href=\"https://www.godaddy.com/pro#reduce\">GoDaddy Pro</a>. GoDaddy Pro allows consultants to access all of their client&#8217;s products in one place. They can also manage aspects of their hosting and purchase products on their behalf.</p>\n<p>The change to WooCommerce.com has emphasized the unfriendliness of the site&#8217;s current system for those who manage multiple client accounts. &#8220;We had already re-prioritized a number of features on our roadmap to make life for developers managing dozens of client accounts much smoother, and hope to have something to be able to announce there soon,&#8221; Wilkens said.</p>\n<p>If you manage multiple client accounts and are affected by this change, Wilkens suggests <a href=\"https://woocommerce.com/my-account/create-a-ticket/\">opening a ticket</a> for advice. You can also provide feedback by voting on a poll at the <a href=\"https://woocommerce.com/2017/01/woocommerce-requires-wordpress-account/\">bottom of the post</a> that asks how your experience was switching to a WordPress.com login.</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 31 Jan 2017 20:02:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WPTavern: Micro.blog Project Surges Past $65K on Kickstarter, Gains Backing from DreamHost\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"https://wptavern.com/?p=65437\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"https://wptavern.com/micro-blog-project-surges-past-65k-on-kickstarter-gains-backing-from-dreamhost\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9480:\"<p><a href=\"https://i1.wp.com/wptavern.com/wp-content/uploads/2017/01/micro-blog-logo.png?ssl=1\"><img /></a></p>\n<p>With one week remaining on its Kickstarter campaign, the <a href=\"https://wptavern.com/micro-blog-surpasses-kickstarter-funding-goal-set-to-launch-new-social-network-for-independent-microblogs\" target=\"_blank\">Micro.blog indie microblogging project</a> has surged past its original $10K funding goal with $66,710 pledged by 2,381 backers. This puts project creator Manton Reece closer to his <a href=\"https://www.kickstarter.com/projects/manton/indie-microblogging-owning-your-short-form-writing/posts/1785295\" target=\"_blank\">stretch goal of $80K</a>, which would enable him to develop a Safe Replies feature to preemptively combat abuse on the platform and hire a part-time community manager.</p>\n<p>Micro.blog also <a href=\"https://www.dreamhost.com/blog/2017/01/24/pitching-support-open-web/\" target=\"_blank\">picked up support from DreamHost</a> this week, pushing the project past the $50K mark. The hosting company pledged $5,000 towards the campaign.</p>\n<p>&#8220;What ever happened to the vision of the open web as a distributed network of websites that were owned by their creators?&#8221; said Jonathan LaCour, SVP of Product and Technology at DreamHost. &#8220;We’d like to make it as easy as possible to launch a WordPress-powered microblog on DreamHost that integrates well with Manton’s upcoming Micro.blog service.&#8221;</p>\n<p>DreamHost (and all other hosting companies) obviously have a vested interest in getting people to see the need to have their own digital presence. However, the biggest obstacle for WordPress customers is making it convenient to join the IndieWeb. DreamHost is planning to take its support of Micro.blog one step further and create an easy way for customers to get started with independent microblogs.</p>\n<p>&#8220;As a followup to our contribution to Manton&#8217;s Kickstarter campaign, we&#8217;re planning on working on making a streamlined, pre-configured Indie microblog with WordPress at DreamHost,&#8221; LaCour said in the <a href=\"https://chat.indieweb.org/2017-01-25#bottom\" target=\"_blank\">#indieweb</a> channel on IRC yesterday. &#8220;I tend to agree that a simplified, pre-packaged WordPress setup would go a long way to driving Indieweb adoption.&#8221;</p>\n<p>When asked whether the company would be utilizing Micro.blog or some other service, LaCour said it has not been decided yet. He said the idea is that people could create an independent microblog hosted at DreamHost that is compatible with Micro.blog and other indie microblogs.</p>\n<p>&#8220;Our major focus at the moment is getting people excited about owning their own website (and entire digital identity),&#8221; LaCour said.</p>\n<h3>Micro.blog is Aiming for Incremental Webmention Support</h3>\n<p><a href=\"https://webmention.net/draft/\" target=\"_blank\">Webmention</a> is a protocol similar to pingback for notifying a URL when a website links to it and also for requesting notifications when another site mentions one of your URLs. It is an important part of facilitating decentralized communication across the web. On January 12, 2017, the <a href=\"https://www.w3.org/Social/WG\" target=\"_blank\">Social Web Working Group</a> published a <a href=\"https://www.w3.org/TR/2017/REC-webmention-20170112/#w3c-recommendation-12-january-2017\" target=\"_blank\">W3C Recommendation of Webmention</a> with the specification contributed by the <a href=\"https://indieweb.org/\" target=\"_blank\">IndieWeb</a> community.</p>\n<p>WordPress doesn&#8217;t natively offer <a href=\"https://webmention.net/draft/\" target=\"_blank\">Webmention</a> support and the core trac <a href=\"https://core.trac.wordpress.org/ticket/35435\" target=\"_blank\">ticket</a> for adding the feature has had little discussion.</p>\n<p>During a preliminary <a href=\"https://wordpress.slack.com/archives/core/p1452663582010063\" target=\"_blank\">discussion on Slack</a> last year, WordPress lead developer Dion Hulse said he thought Webmentions would be a great feature plugin and that there are a few people interested in it. There hasn&#8217;t been much movement on this front in core, but a <a href=\"https://wordpress.org/plugins/webmention/\" target=\"_blank\">Webmention plugin</a> is available in the directory.</p>\n<p>Reece is working on incorporating IndieWeb protocols into Micro.blog but said it will likely launch with incremental support for Webmention.</p>\n<p>&#8220;It might take a little while to get everything IndieWeb in there, but that&#8217;s the eventual goal,&#8221; Reece <a href=\"https://chat.indieweb.org/2017-01-25#t1485379721875000\" target=\"_blank\">said</a>. &#8220;I&#8217;m committed to Micropub and microformats and still exploring how best to support Webmention. (It might be partial support with more later.)&#8221;</p>\n<p>Micro.blog doesn&#8217;t currently handle mentions and replies using Webmention but Reece said his eventual goal is to include it.</p>\n<p>&#8220;The first step to me is getting more people their own microblog so that the infrastructure for cross-site replies is even possible,&#8221; Reece said.</p>\n<h3>Micro.blog Puts the Focus on Indie Microblogging, Instead of Replacing Twitter</h3>\n<p>Reece also <a href=\"http://www.manton.org/2017/01/microblogging-community-on-slack.html\" target=\"_blank\">launched a Slack community</a> where the project&#8217;s backers can discuss Micro.blog and other microblogging topics. He said he initially had reservations with starting something on Slack but was surprised to see the community has already grown to more than 300 members.</p>\n<p>&#8220;I didn’t want to distract from any posts that should happen in the open on blogs,&#8221; Reece said. &#8220;Some discussion just fits better in chat, though. There’s an emerging community of indie microbloggers. Having a place to share tips, tools, and ask questions about Micro.blog just makes sense.&#8221;</p>\n<p>Many of the project&#8217;s backers are eager to create a community of their own and are interested in using Micro.blog as a Twitter replacement. Other services have attempted to provide alternatives to posting directly on Twitter but none have caught on enough to significantly push IndieWeb adoption forward. <a href=\"http://app.net\" target=\"_blank\">App.net</a>, one of the most promising ad-free, microblogging networks, went into maintenance mode in 2014 and will be shutting down March 15, 2017.</p>\n<p>Reece, who was an early fan of App.net, <a href=\"http://www.manton.org/2017/01/thank-you-to-app-net.html\" target=\"_blank\">published a thank you note</a> to the service&#8217;s creators for trying something risky and creating a community around their ideas. He believes it&#8217;s the right time for another open platform to emerge.</p>\n<p>&#8220;We don’t need just another Twitter or Facebook clone,&#8221; Reece said. &#8220;We need a new platform that encourages blogging on the open web.&#8221;</p>\n<p>Nevertheless, Reece is preparing Micro.blog from the outset to be capable of replacing Twitter&#8217;s functionality, which is one of the reasons he is focusing so heavily on ensuring the platform <a href=\"https://twitter.com/manton2/status/821084145782759425\" target=\"_blank\">doesn&#8217;t get overrun with abuse</a>. Reece wants to avoid the pitfalls that have contributed to some of the more negative aspects of Twitter, but his focus is on encouraging people to blog from their own space.</p>\n<p>&#8220;Micro.blog is a success if more people blog,&#8221; Reece <a href=\"https://twitter.com/manton2/status/820372146375524359\" target=\"_blank\">said</a>. &#8220;To provide value it doesn’t need to replace Twitter, but it can.&#8221;</p>\n<p>The project&#8217;s mobile app is key to making it convenient for users to read other people&#8217;s posts and post directly to their own websites from the same interface. Reece shared another <a href=\"https://www.kickstarter.com/projects/manton/indie-microblogging-owning-your-short-form-writing/posts/1783438\" target=\"_blank\">preview of the iPhone and iPad app</a> that will be ready at launch and said he hopes there will be other apps developed by the community.</p>\n<p>&#8220;Most RSS traditional readers can&#8217;t post,&#8221; Reece said. &#8220;I think this makes for a more complete experience, and because it&#8217;s just a blog I can still use other apps and platforms to post.&#8221; He plans to give Micro.blog a 280 character limit before truncating the post.</p>\n<p>Keeping the timeline fast and making posting convenient will be critical to the platform&#8217;s success as an alternative to the dominant social media silos. Polling blogs for new content is not very aggressive in the current prototype but Reece is tuning this to provide a better experience. The platform uses rssCloud and WebSub (formerly PubSubHubbub) to provide a more Twitter-like, real-time experience.</p>\n<p>Micro.blog seems to be landing at the right time, as the idea has already resonated with more than 2,300 people willing to back the project. The service hasn&#8217;t even launched but the concept behind it is already attracting a supportive community eager to explore better ways of powering microblogging on the web.</p>\n<p>&#8220;You don’t replace Twitter overnight, or even try to,&#8221; Reece said. &#8220;But step by step, we’re going to end up with a better web, and I think independent microblogging is part of that.&#8221;</p>\n<div id=\"epoch-width-sniffer\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Jan 2017 22:56:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Dev Blog: WordPress 4.7.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"https://wordpress.org/news/?p=4676\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2141:\"<p>WordPress 4.7.2 is now available. This is a <strong>security release</strong> for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>WordPress versions 4.7.1 and earlier are affected by three security issues:</p>\n<ol>\n<li>The user interface for assigning taxonomy terms in Press This is shown to users who do not have permissions to use it. Reported by David Herrera of <a href=\"https://www.alleyinteractive.com/\">Alley Interactive</a>.</li>\n<li><code>WP_Query</code> is vulnerable to a SQL injection (SQLi) when passing unsafe data. WordPress core is not directly vulnerable to this issue, but we&#8217;ve added hardening to prevent plugins and themes from accidentally causing a vulnerability. Reported by <a href=\"https://github.com/mjangda\">Mo Jangda</a> (batmoo).</li>\n<li>A cross-site scripting (XSS) vulnerability was discovered in the posts list table. Reported by <a href=\"https://iandunn.name/\">Ian Dunn</a> of the WordPress Security Team.</li>\n<li>An unauthenticated privilege escalation vulnerability was discovered in a REST API endpoint. Reported by <a href=\"https://twitter.com/MarcS0h\">Marc-Alexandre Montpas</a> of Sucuri Security. *</li>\n</ol>\n<p>Thank you to the reporters of these issues for practicing <a href=\"https://make.wordpress.org/core/handbook/testing/reporting-security-vulnerabilities/\">responsible disclosure</a>.</p>\n<p><a href=\"https://wordpress.org/download/\">Download WordPress 4.7.2</a> or venture over to Dashboard → Updates and simply click “Update Now.” Sites that support automatic background updates are already beginning to update to WordPress 4.7.2.</p>\n<p>Thanks to everyone who contributed to 4.7.2.</p>\n<p>* Update: An additional serious vulnerability was fixed in this release and public disclosure was delayed. For more information on this vulnerability, additional mitigation steps taken, and an explanation for why disclosure was delayed, please read <a href=\"https://make.wordpress.org/core/2017/02/01/disclosure-of-additional-security-fix-in-wordpress-4-7-2/\">Disclosure of Additional Security Fix in WordPress 4.7.2</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 26 Jan 2017 19:34:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Aaron D. Campbell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"HeroPress: Screw the Blueprint. Design Your Own Path to Fulfillment.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://heropress.com/?post_type=heropress-essays&p=1579\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"https://heropress.com/essays/screw-blueprint-live-life-terms/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9274:\"<img width=\"960\" height=\"480\" src=\"http://20094-presscdn.pagely.netdna-cdn.com/wp-content/uploads/2017/01/012517-1024x512.jpg\" class=\"attachment-large size-large wp-post-image\" alt=\"Pull Quote: I wasn\'t following the blueprint, but I was having success and felt secure in the ways that mattered to me.\" /><p>Growing up, I bought into society’s notion of what made for a successful and rewarding life. For me, the blueprint for finding fulfillment looked something like this:</p>\n<p>Step 1. Get good grades in school.</p>\n<p>Step 2. Attend a nice college.</p>\n<p>Step 3. Land a secure job with an attractive salary and benefits.</p>\n<p>Step 4. Find a nice man that would make a good husband and father…and marry him.</p>\n<p>Step 5. Have children.</p>\n<p>Step 6. Die peacefully at an old age. (ha!)</p>\n<p>I was convinced that if I simply followed this blueprint, I’d find security and acceptance. And with the exception of Step #6 (a step I’m hoping to postpone for some time), I was able to accomplish everything I’d set out to do. My grades in school were outstanding, which set me up to pursue a degree in mechanical engineering at the University of Illinois. After graduating in 2000, I was presented with several job opportunities. Ultimately, I accepted a position at Procter &amp; Gamble as an engineer for Charmin. Within a year of starting that job, I met my future husband. We married in 2004 and had our first child in 2007. Another child followed in 2008. I was right on track with my blueprint!</p>\n<p>And then everything fell apart.</p>\n<h2><strong>A breakdown wasn’t in the plan</strong></h2>\n<p>In 2008, I suffered my first real breakdown. I spent several weeks doing my best to get through each day, doing what I needed to as an employee, wife, and mom and trying hard not to let other people down. I fought back tears when I needed to, only letting them flow in private. While the kids were sleeping, I’d escape into the world of TV sitcoms. I knew that something wasn’t right.</p>\n<p>While I had followed the blueprint for security, success, and happiness, I didn’t feel like I had achieved any of these things. I felt isolated at work. At home, I felt valued only if I were functioning as the perfect wife and mom. At the time, the solution seemed clear—quit my corporate job and focus 100% on my family. This, I was certain, would lead to ultimate happiness. So I took two extended maternity leaves, eventually leaving the corporate world to focus on being a stay-at-home mom.</p>\n<h2><strong>Who the hell am I?</strong></h2>\n<p>Being home with kids full-time, no matter how wonderful your kids may be, is by far the most challenging job. While I was grateful that I had the choice to be a stay-at-home-mom, being at home left me feeling alienated. I didn’t really know who I was anymore or how to get back to “myself.”</p>\n<p>So I started experimenting with things I simply felt like doing. These things weren’t part of any blueprint, and there was no guarantee of success or happiness. I just followed my heart.</p>\n<p>I needed something challenging to occupy my mind, so I dug out my sports card collection with the intent of finally organizing it. Looking through my old cards felt both nostalgic and therapeutic, and my head started spinning with other ideas. Business ideas. My dad had a successful e-bay business that seemed like a bit of fun, so I thought: <em>why not try selling sports cards on e-bay?</em> I didn’t want to sacrifice my personal collection, so over the course of a few months, I purchased nearly a million sports cards on Craigslist. After repackaging them into 1000-count boxes, I sold them for $10/box, doubling my money in a short period of time. I learned a lot about buying and selling on the Internet but more importantly, I felt like I had discovered something that was really “me.” It was challenging in a new and exciting way, and it fit in with my hectic mom schedule.</p>\n<p>This venture into the world of online business opened my eyes in a significant way. I started following entrepreneurs such as Gary Vaynerchuk and Chris Brogan, and flew to Houston for a Mom 2.0 Summit. I loved every blog post I read and all the people I was meeting. It was a whole new world filled with risk and uncertainty but grounded in the values of helping people and living a good life. THIS WAS PERFECT FOR ME.</p>\n<h2><strong>And then came WordPress</strong></h2>\n<p>In my newfound fascination with all things Internet-related, it wasn’t surprising that I stumbled upon this thing called WordPress. I had always wanted to build a website, and with the popularity of mom bloggers exploding, I naturally gravitated toward this “easy” platform for my blog. I started the ChicagoActons blog as a way to share our family adventures with others. Building the site was something I enjoyed more than I anticipated. It fed my love of problem solving and I felt great satisfaction in seeing something that I built on the Internet. And I could do it in between changing dirty diapers and cuddling with my kids.</p>\n<p>After building ChicagoActons and sharing it via social channels, I started to get requests to build sites for others. Some were paid assignments and some were not, but I was falling in love with using this tool and my brain to help others further efforts they were passionate about. I was finding myself again, and I felt happy.</p>\n<h2><strong>Where were WordCamps all my life?</strong></h2>\n<p>By 2010, two years into freelance WordPress development, I was ready to expand my horizons and see what others were doing with the platform. I heard about WordCamp Chicago, and bought a ticket to the event that would confirm that the path I was paving was the right one for me.</p>\n<p>At WordCamp Chicago 2010, I learned a great deal about developing with WordPress, but even more life changing were the people I met. They were such a diverse group and so different than I was, yet we all shared the same passion: to support one another in our pursuits to help others. And we all used WordPress as the tool to get the job done.</p>\n<p>The feeling of acceptance and growth that I experienced at my first WordCamp was the impetus I needed to continue down the path as a WordPress-based business entrepreneur. I wasn’t following a blueprint anymore, but I was finding success and security in ways that mattered to me.</p>\n<p>I was happy.</p>\n<h2><strong>Living my own blueprint</strong></h2>\n<p>Fast-forward to today. I couldn’t be more thankful for the life journey I’m on. My kids survived having me as a stay-at-home parent, and as a WordPress-based business entrepreneur, I feel challenged every day to be better at helping others build their passion-driven interests. I would not have gotten here had it not been for WordPress and the WordPress community, which emboldened me to abandon a blueprint for happiness that simply wasn’t working for me and instead embrace life on my own terms.</p>\n<div class=\"rtsocial-container rtsocial-container-align-right rtsocial-horizontal\"><div class=\"rtsocial-twitter-horizontal\"><div class=\"rtsocial-twitter-horizontal-button\"><a title=\"Tweet: Screw the Blueprint. Design Your Own Path to Fulfillment.\" class=\"rtsocial-twitter-button\" href=\"https://twitter.com/share?text=Screw%20the%20Blueprint.%20Design%20Your%20Own%20Path%20to%20Fulfillment.&via=heropress&url=https%3A%2F%2Fheropress.com%2Fessays%2Fscrew-blueprint-live-life-terms%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-fb-horizontal fb-light\"><div class=\"rtsocial-fb-horizontal-button\"><a title=\"Like: Screw the Blueprint. Design Your Own Path to Fulfillment.\" class=\"rtsocial-fb-button rtsocial-fb-like-light\" href=\"https://www.facebook.com/sharer.php?u=https%3A%2F%2Fheropress.com%2Fessays%2Fscrew-blueprint-live-life-terms%2F\" rel=\"nofollow\" target=\"_blank\"></a></div></div><div class=\"rtsocial-linkedin-horizontal\"><div class=\"rtsocial-linkedin-horizontal-button\"><a class=\"rtsocial-linkedin-button\" href=\"https://www.linkedin.com/shareArticle?mini=true&url=https%3A%2F%2Fheropress.com%2Fessays%2Fscrew-blueprint-live-life-terms%2F&title=Screw+the+Blueprint.+Design+Your+Own+Path+to+Fulfillment.\" rel=\"nofollow\" target=\"_blank\" title=\"Share: Screw the Blueprint. Design Your Own Path to Fulfillment.\"></a></div></div><div class=\"rtsocial-pinterest-horizontal\"><div class=\"rtsocial-pinterest-horizontal-button\"><a class=\"rtsocial-pinterest-button\" href=\"https://pinterest.com/pin/create/button/?url=https://heropress.com/essays/screw-blueprint-live-life-terms/&media=https://heropress.com/wp-content/uploads/2017/01/012517-150x150.jpg&description=Screw the Blueprint. Design Your Own Path to Fulfillment.\" rel=\"nofollow\" target=\"_blank\" title=\"Pin: Screw the Blueprint. Design Your Own Path to Fulfillment.\"></a></div></div><a rel=\"nofollow\" class=\"perma-link\" href=\"https://heropress.com/essays/screw-blueprint-live-life-terms/\" title=\"Screw the Blueprint. Design Your Own Path to Fulfillment.\"></a></div><p>The post <a rel=\"nofollow\" href=\"https://heropress.com/essays/screw-blueprint-live-life-terms/\">Screw the Blueprint. Design Your Own Path to Fulfillment.</a> appeared first on <a rel=\"nofollow\" href=\"https://heropress.com\">HeroPress</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 25 Jan 2017 12:00:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Heather Acton\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 24 Feb 2017 19:32:05 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"395678\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Fri, 24 Feb 2017 19:15:08 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20160704050813\";}", "no");
INSERT INTO `wp_options` VALUES("595", "_transient_timeout_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1488007926", "no");
INSERT INTO `wp_options` VALUES("596", "_transient_feed_mod_d117b5738fbd35bd8c0391cda1f2b5d9", "1487964726", "no");
INSERT INTO `wp_options` VALUES("597", "_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109", "1488007926", "no");
INSERT INTO `wp_options` VALUES("598", "_transient_feed_b9388c83948825c1edaef0d856b7b109", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:117:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"WordPress Plugins » View: Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"https://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"WordPress Plugins » View: Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 24 Feb 2017 19:17:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:30:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Duplicate Post\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/duplicate-post/#post-2646\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 05 Dec 2007 17:40:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2646@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Clone posts and pages.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Lopo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"WP-PageNavi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/wp-pagenavi/#post-363\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 23:17:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"363@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"Adds a more advanced paging navigation interface.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Lester Chan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"https://wordpress.org/plugins/tinymce-advanced/#post-2082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Jun 2007 15:00:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2082@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"Extends and enhances TinyMCE, the WordPress Visual Editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Yoast SEO\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"https://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the Yoast SEO plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Page Builder by SiteOrigin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/siteorigin-panels/#post-51888\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Apr 2013 10:36:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"51888@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"Build responsive page layouts using the widgets you know and love using this simple drag and drop page builder.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Greg Priday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"https://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"The one plugin you need for stats, related posts, search engine optimization, social sharing, protection, backups, speed, and email list management.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Automattic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Arne Brachhold\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"NextGEN Gallery - WordPress Gallery Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:123:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 16.5 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"https://wordpress.org/plugins/wp-super-cache/#post-2572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Nov 2007 11:40:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2572@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"A very fast caching engine for WordPress that produces static html files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Donncha O Caoimh\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"W3 Total Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"https://wordpress.org/plugins/w3-total-cache/#post-12073\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2009 18:46:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"12073@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:144:\"Search Engine (SEO) &#38; Performance Optimization (WPO) via caching. Integrated caching: CDN, Minify, Page, Object, Fragment, Database support.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Frederick Townes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Regenerate Thumbnails\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://wordpress.org/plugins/regenerate-thumbnails/#post-6743\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 23 Aug 2008 14:38:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"6743@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"Allows you to regenerate your thumbnails after changing the thumbnail sizes.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Alex Mills (Viper007Bond)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Advanced Custom Fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"https://wordpress.org/plugins/advanced-custom-fields/#post-25254\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Mar 2011 04:07:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"25254@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"Customise WordPress with powerful, professional and intuitive fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"elliotcondon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"UpdraftPlus WordPress Backup Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/updraftplus/#post-38058\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 21 May 2012 15:14:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"38058@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Backup and restoration made easy. Complete backups; manual or scheduled (backup to S3, Dropbox, Google Drive, Rackspace, FTP, SFTP, email + others).\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"David Anderson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"Google Analytics for WordPress by MonsterInsights\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"https://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Sep 2007 12:15:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2316@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"The best Google Analytics plugin for WordPress. See how visitors find and use your website, so you can keep them coming back.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Syed Balkhi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"The original SEO plugin for WordPress, downloaded over 30,000,000 times since 2007.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"https://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:146:\"Akismet checks your comments and contact form submissions against our global database of spam to protect you and your site from malicious content.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Hello Dolly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://wordpress.org/plugins/hello-dolly/#post-5790\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 May 2008 22:11:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"5790@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"This is not just a plugin, it symbolizes the hope and enthusiasm of an entire generation summed up in two words sung most famously by Louis Armstrong.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Really Simple CAPTCHA\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"https://wordpress.org/plugins/really-simple-captcha/#post-9542\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 09 Mar 2009 02:17:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"9542@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:138:\"Really Simple CAPTCHA is a CAPTCHA module intended to be called from other plugins. It is originally created for my Contact Form 7 plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Clef Two-Factor Authentication\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"https://wordpress.org/plugins/wpclef/#post-47509\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 27 Dec 2012 01:25:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"47509@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:139:\"Modern two-factor that people love to use: strong authentication without passwords or tokens; single sign on/off; magical login experience.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Dave Ross\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"https://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:149:\"Secure your website with the most comprehensive WordPress security plugin. Firewall, malware scan, blocking, live traffic, login security &#38; more.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"https://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"Google Analytics Dashboard for WP\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"https://wordpress.org/plugins/google-analytics-dashboard-for-wp/#post-50539\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 10 Mar 2013 17:07:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"50539@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"Displays Google Analytics stats in your WordPress Dashboard. Inserts the latest Google Analytics tracking code in your pages.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Alin Marcu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Duplicator\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"https://wordpress.org/plugins/duplicator/#post-26607\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 May 2011 12:15:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26607@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"Duplicate, clone, backup, move and transfer an entire site from one location to another.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Cory Lamle\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Disable Comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"https://wordpress.org/plugins/disable-comments/#post-26907\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 27 May 2011 04:42:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26907@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"Allows administrators to globally disable comments on their site. Comments can be disabled according to post type. Multisite friendly. Provides tool t\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Samir Shah\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WP Multibyte Patch\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/wp-multibyte-patch/#post-28395\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 14 Jul 2011 12:22:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"28395@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Multibyte functionality enhancement for the WordPress Japanese package.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"plugin-master\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Black Studio TinyMCE Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"https://wordpress.org/plugins/black-studio-tinymce-widget/#post-31973\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Nov 2011 15:06:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"31973@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"The visual editor widget for Wordpress.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Marco Chiesi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"SiteOrigin Widgets Bundle\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"https://wordpress.org/plugins/so-widgets-bundle/#post-67824\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 24 May 2014 14:27:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"67824@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:128:\"A collection of all widgets, neatly bundled into a single plugin. It&#039;s also a framework to code your own widgets on top of.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Greg Priday\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"iThemes Security (formerly Better WP Security)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"https://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:146:\"Take the guesswork out of WordPress security. iThemes Security offers 30+ ways to lock down WordPress in an easy-to-use WordPress security plugin.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"iThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:46:\"https://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Fri, 24 Feb 2017 19:32:06 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:25:\"strict-transport-security\";s:11:\"max-age=360\";s:13:\"last-modified\";s:29:\"Thu, 02 Aug 2007 12:45:03 GMT\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20160704050813\";}", "no");
INSERT INTO `wp_options` VALUES("599", "_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109", "1488007926", "no");
INSERT INTO `wp_options` VALUES("600", "_transient_feed_mod_b9388c83948825c1edaef0d856b7b109", "1487964726", "no");
INSERT INTO `wp_options` VALUES("601", "_transient_timeout_plugin_slugs", "1488051357", "no");
INSERT INTO `wp_options` VALUES("602", "_transient_plugin_slugs", "a:2:{i:0;s:25:\"duplicator/duplicator.php\";i:1;s:47:\"show-current-template/show-current-template.php\";}", "no");
INSERT INTO `wp_options` VALUES("603", "_transient_timeout_dash_88ae138922fe95674369b1cb3d215a2b", "1488007926", "no");
INSERT INTO `wp_options` VALUES("604", "_transient_dash_88ae138922fe95674369b1cb3d215a2b", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wordpress.org/news/2017/01/wordpress-4-7-2-security-release/\'>WordPress 4.7.2 Security Release</a> <span class=\"rss-date\">January 26, 2017</span><div class=\"rssSummary\">WordPress 4.7.2 is now available. This is a security release for all previous versions and we strongly encourage you to update your sites immediately. WordPress versions 4.7.1 and earlier are affected by three security issues: The user interface for assigning taxonomy terms in Press This is shown to users who do not have permissions to use it. [&hellip;]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'https://wptavern.com/cloudflare-memory-leak-exposes-private-data\'>WPTavern: Cloudflare Memory Leak Exposes Private Data</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/googles-new-perspective-project-filters-online-comments-based-on-toxicity\'>WPTavern: Google’s New Perspective Project Filters Online Comments Based on Toxicity</a></li><li><a class=\'rsswidget\' href=\'https://wptavern.com/wordpress-community-summit-2017-set-for-june-13-14-in-paris\'>WPTavern: WordPress Community Summit 2017 Set for June 13-14 in Paris</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\"dashboard-news-plugin\"><span>Popular Plugin:</span> Google Analytics Dashboard for WP&nbsp;<a href=\"plugin-install.php?tab=plugin-information&amp;plugin=google-analytics-dashboard-for-wp&amp;_wpnonce=83249272e4&amp;TB_iframe=true&amp;width=600&amp;height=800\" class=\"thickbox open-plugin-details-modal\" aria-label=\"Install Google Analytics Dashboard for WP\">(Install)</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("606", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("608", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-4.7.2.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-4.7.2.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-4.7.2-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-4.7.2-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"4.7.2\";s:7:\"version\";s:5:\"4.7.2\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"4.7\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1487964875;s:15:\"version_checked\";s:5:\"4.7.2\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("609", "can_compress_scripts", "1", "no");
INSERT INTO `wp_options` VALUES("611", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1487964957;s:7:\"checked\";a:2:{s:25:\"duplicator/duplicator.php\";s:6:\"1.1.32\";s:47:\"show-current-template/show-current-template.php\";s:5:\"0.3.0\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:2:{s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"22600\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:6:\"1.1.32\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:60:\"https://downloads.wordpress.org/plugin/duplicator.1.1.32.zip\";}s:47:\"show-current-template/show-current-template.php\";O:8:\"stdClass\":6:{s:2:\"id\";s:5:\"41022\";s:4:\"slug\";s:21:\"show-current-template\";s:6:\"plugin\";s:47:\"show-current-template/show-current-template.php\";s:11:\"new_version\";s:5:\"0.3.0\";s:3:\"url\";s:52:\"https://wordpress.org/plugins/show-current-template/\";s:7:\"package\";s:70:\"https://downloads.wordpress.org/plugin/show-current-template.0.3.0.zip\";}}}", "no");
INSERT INTO `wp_options` VALUES("613", "_site_transient_update_themes", "O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1487964951;s:7:\"checked\";a:1:{s:13:\"twentysixteen\";s:3:\"1.3\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}", "no");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("6", "11", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("8", "11", "_edit_lock", "1468296683:1");
INSERT INTO `wp_postmeta` VALUES("9", "12", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("11", "12", "_edit_lock", "1468296679:1");
INSERT INTO `wp_postmeta` VALUES("12", "13", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("14", "13", "_edit_lock", "1468296681:1");
INSERT INTO `wp_postmeta` VALUES("15", "14", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("17", "14", "_edit_lock", "1468296681:1");
INSERT INTO `wp_postmeta` VALUES("18", "15", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("20", "15", "_edit_lock", "1468304489:1");
INSERT INTO `wp_postmeta` VALUES("21", "16", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("23", "16", "_edit_lock", "1468296684:1");
INSERT INTO `wp_postmeta` VALUES("24", "17", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("26", "17", "_edit_lock", "1468296684:1");
INSERT INTO `wp_postmeta` VALUES("27", "18", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("29", "18", "_edit_lock", "1468296684:1");
INSERT INTO `wp_postmeta` VALUES("30", "19", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("32", "19", "_edit_lock", "1468296684:1");
INSERT INTO `wp_postmeta` VALUES("33", "20", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("35", "20", "_edit_lock", "1468296679:1");
INSERT INTO `wp_postmeta` VALUES("36", "21", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("38", "21", "_edit_lock", "1468296680:1");
INSERT INTO `wp_postmeta` VALUES("39", "22", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("41", "22", "_edit_lock", "1468296681:1");
INSERT INTO `wp_postmeta` VALUES("42", "23", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("44", "23", "_edit_lock", "1468296681:1");
INSERT INTO `wp_postmeta` VALUES("45", "24", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("47", "24", "_edit_lock", "1468296680:1");
INSERT INTO `wp_postmeta` VALUES("48", "25", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("50", "25", "_edit_lock", "1468296682:1");
INSERT INTO `wp_postmeta` VALUES("51", "26", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("53", "26", "_edit_lock", "1468296679:1");
INSERT INTO `wp_postmeta` VALUES("54", "27", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("56", "27", "_edit_lock", "1468296680:1");
INSERT INTO `wp_postmeta` VALUES("57", "28", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("59", "28", "_edit_lock", "1468296683:1");
INSERT INTO `wp_postmeta` VALUES("60", "29", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("62", "29", "_edit_lock", "1468296683:1");
INSERT INTO `wp_postmeta` VALUES("63", "30", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("64", "30", "_edit_lock", "1468296684:1");
INSERT INTO `wp_postmeta` VALUES("66", "31", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("68", "31", "_edit_lock", "1468296682:1");
INSERT INTO `wp_postmeta` VALUES("75", "34", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("77", "34", "_edit_lock", "1468296827:1");
INSERT INTO `wp_postmeta` VALUES("78", "35", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("80", "35", "_edit_lock", "1468296680:1");
INSERT INTO `wp_postmeta` VALUES("282", "137", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("283", "137", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("284", "137", "_menu_item_object_id", "2");
INSERT INTO `wp_postmeta` VALUES("285", "137", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("286", "137", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("287", "137", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("288", "137", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("289", "137", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("291", "138", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("292", "138", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("293", "138", "_menu_item_object_id", "3");
INSERT INTO `wp_postmeta` VALUES("294", "138", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("295", "138", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("296", "138", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("297", "138", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("298", "138", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("300", "139", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("301", "139", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("302", "139", "_menu_item_object_id", "4");
INSERT INTO `wp_postmeta` VALUES("303", "139", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("304", "139", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("305", "139", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("306", "139", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("307", "139", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("309", "140", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("310", "140", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("311", "140", "_menu_item_object_id", "5");
INSERT INTO `wp_postmeta` VALUES("312", "140", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("313", "140", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("314", "140", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("315", "140", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("316", "140", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("318", "141", "_menu_item_type", "taxonomy");
INSERT INTO `wp_postmeta` VALUES("319", "141", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("320", "141", "_menu_item_object_id", "6");
INSERT INTO `wp_postmeta` VALUES("321", "141", "_menu_item_object", "category");
INSERT INTO `wp_postmeta` VALUES("322", "141", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("323", "141", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("324", "141", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("325", "141", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("327", "142", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("328", "142", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("329", "142", "_menu_item_object_id", "142");
INSERT INTO `wp_postmeta` VALUES("330", "142", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("331", "142", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("332", "142", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("333", "142", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("334", "142", "_menu_item_url", "#");
INSERT INTO `wp_postmeta` VALUES("336", "143", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("337", "143", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("338", "143", "_menu_item_object_id", "143");
INSERT INTO `wp_postmeta` VALUES("339", "143", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("340", "143", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("341", "143", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("342", "143", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("343", "143", "_menu_item_url", "http://facebook.com");
INSERT INTO `wp_postmeta` VALUES("345", "144", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("346", "144", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("347", "144", "_menu_item_object_id", "144");
INSERT INTO `wp_postmeta` VALUES("348", "144", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("349", "144", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("350", "144", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("351", "144", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("352", "144", "_menu_item_url", "http://twitter.com");
INSERT INTO `wp_postmeta` VALUES("354", "145", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("355", "145", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("356", "145", "_menu_item_object_id", "145");
INSERT INTO `wp_postmeta` VALUES("357", "145", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("358", "145", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("359", "145", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("360", "145", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("361", "145", "_menu_item_url", "http://pinterest.com");
INSERT INTO `wp_postmeta` VALUES("363", "146", "_menu_item_type", "custom");
INSERT INTO `wp_postmeta` VALUES("364", "146", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("365", "146", "_menu_item_object_id", "146");
INSERT INTO `wp_postmeta` VALUES("366", "146", "_menu_item_object", "custom");
INSERT INTO `wp_postmeta` VALUES("367", "146", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("368", "146", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("369", "146", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("370", "146", "_menu_item_url", "http://youtube.com");
INSERT INTO `wp_postmeta` VALUES("420", "204", "_wp_attached_file", "2016/07/lightsnow.jpg");
INSERT INTO `wp_postmeta` VALUES("421", "204", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/lightsnow.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"lightsnow-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"lightsnow-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"lightsnow-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"lightsnow-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("422", "205", "_wp_attached_file", "2016/07/gyro.jpg");
INSERT INTO `wp_postmeta` VALUES("423", "205", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:16:\"2016/07/gyro.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:16:\"gyro-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:16:\"gyro-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:16:\"gyro-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:17:\"gyro-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("426", "207", "_wp_attached_file", "2016/07/geostairs.jpg");
INSERT INTO `wp_postmeta` VALUES("427", "207", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/geostairs.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"geostairs-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"geostairs-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"geostairs-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"geostairs-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("432", "210", "_wp_attached_file", "2016/07/docksteps.jpg");
INSERT INTO `wp_postmeta` VALUES("433", "210", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/docksteps.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"docksteps-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"docksteps-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"docksteps-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"docksteps-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("434", "211", "_wp_attached_file", "2016/07/SampleImage19.jpg");
INSERT INTO `wp_postmeta` VALUES("435", "211", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage19.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage19-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage19-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage19-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage19-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("436", "212", "_wp_attached_file", "2016/07/SampleImage18.jpg");
INSERT INTO `wp_postmeta` VALUES("437", "212", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage18.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage18-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage18-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage18-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage18-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("440", "214", "_wp_attached_file", "2016/07/SampleImage16.jpg");
INSERT INTO `wp_postmeta` VALUES("441", "214", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage16.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage16-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage16-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage16-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage16-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("442", "215", "_wp_attached_file", "2016/07/SampleImage14.jpg");
INSERT INTO `wp_postmeta` VALUES("443", "215", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage14.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage14-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage14-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage14-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage14-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("444", "216", "_wp_attached_file", "2016/07/SampleImage13.jpg");
INSERT INTO `wp_postmeta` VALUES("445", "216", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage13.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage13-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage13-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage13-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage13-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("448", "218", "_wp_attached_file", "2016/07/SampleImage10.jpg");
INSERT INTO `wp_postmeta` VALUES("449", "218", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1131;s:4:\"file\";s:25:\"2016/07/SampleImage10.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage10-300x177.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:177;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage10-768x452.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:452;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage10-1024x603.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:603;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("450", "219", "_wp_attached_file", "2016/07/SampleImage09.jpg");
INSERT INTO `wp_postmeta` VALUES("451", "219", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1917;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage09.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage09-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage09-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage09-768x513.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:513;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage09-1024x684.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:684;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("452", "220", "_wp_attached_file", "2016/07/SampleImage08.jpg");
INSERT INTO `wp_postmeta` VALUES("453", "220", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage08.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage08-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage08-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage08-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage08-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("454", "221", "_wp_attached_file", "2016/07/SampleImage06.jpg");
INSERT INTO `wp_postmeta` VALUES("455", "221", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage06.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage06-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage06-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage06-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage06-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("456", "222", "_wp_attached_file", "2016/07/SampleImage04.jpg");
INSERT INTO `wp_postmeta` VALUES("457", "222", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage04.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage04-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage04-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage04-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage04-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("458", "223", "_wp_attached_file", "2016/07/SampleImage05.jpg");
INSERT INTO `wp_postmeta` VALUES("459", "223", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage05.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage05-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage05-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage05-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage05-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("460", "224", "_wp_attached_file", "2016/07/SampleImage02.jpg");
INSERT INTO `wp_postmeta` VALUES("461", "224", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage02.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage02-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage02-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage02-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage02-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("464", "226", "_wp_attached_file", "2016/07/SampleImage01.jpg");
INSERT INTO `wp_postmeta` VALUES("465", "226", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage01.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage01-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage01-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage01-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage01-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("466", "227", "_wp_attached_file", "2016/07/NewYork10.jpg");
INSERT INTO `wp_postmeta` VALUES("467", "227", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/NewYork10.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"NewYork10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"NewYork10-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"NewYork10-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"NewYork10-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("468", "228", "_wp_attached_file", "2016/07/NewYork09.jpg");
INSERT INTO `wp_postmeta` VALUES("469", "228", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/NewYork09.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"NewYork09-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"NewYork09-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"NewYork09-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"NewYork09-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("470", "229", "_wp_attached_file", "2016/07/NewYork08.jpg");
INSERT INTO `wp_postmeta` VALUES("471", "229", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/NewYork08.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"NewYork08-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"NewYork08-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"NewYork08-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"NewYork08-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("472", "230", "_wp_attached_file", "2016/07/NewYork07.jpg");
INSERT INTO `wp_postmeta` VALUES("473", "230", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/NewYork07.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"NewYork07-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"NewYork07-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"NewYork07-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"NewYork07-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("474", "231", "_wp_attached_file", "2016/07/NewYork05.jpg");
INSERT INTO `wp_postmeta` VALUES("475", "231", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/NewYork05.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"NewYork05-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"NewYork05-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"NewYork05-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"NewYork05-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("476", "232", "_wp_attached_file", "2016/07/NewYork03.jpg");
INSERT INTO `wp_postmeta` VALUES("477", "232", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:21:\"2016/07/NewYork03.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:21:\"NewYork03-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:21:\"NewYork03-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:21:\"NewYork03-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:22:\"NewYork03-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:23:\"Image from UnSplash.com\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("480", "30", "_thumbnail_id", "232");
INSERT INTO `wp_postmeta` VALUES("481", "25", "_thumbnail_id", "231");
INSERT INTO `wp_postmeta` VALUES("482", "21", "_thumbnail_id", "230");
INSERT INTO `wp_postmeta` VALUES("483", "20", "_thumbnail_id", "222");
INSERT INTO `wp_postmeta` VALUES("485", "18", "_thumbnail_id", "211");
INSERT INTO `wp_postmeta` VALUES("486", "17", "_thumbnail_id", "215");
INSERT INTO `wp_postmeta` VALUES("487", "16", "_thumbnail_id", "214");
INSERT INTO `wp_postmeta` VALUES("489", "14", "_thumbnail_id", "224");
INSERT INTO `wp_postmeta` VALUES("490", "13", "_thumbnail_id", "226");
INSERT INTO `wp_postmeta` VALUES("491", "12", "_thumbnail_id", "221");
INSERT INTO `wp_postmeta` VALUES("492", "11", "_thumbnail_id", "227");
INSERT INTO `wp_postmeta` VALUES("493", "31", "_thumbnail_id", "210");
INSERT INTO `wp_postmeta` VALUES("494", "29", "_thumbnail_id", "205");
INSERT INTO `wp_postmeta` VALUES("495", "26", "_thumbnail_id", "207");
INSERT INTO `wp_postmeta` VALUES("498", "35", "_thumbnail_id", "221");
INSERT INTO `wp_postmeta` VALUES("499", "28", "_thumbnail_id", "228");
INSERT INTO `wp_postmeta` VALUES("500", "24", "_thumbnail_id", "229");
INSERT INTO `wp_postmeta` VALUES("502", "34", "_thumbnail_id", "223");
INSERT INTO `wp_postmeta` VALUES("503", "27", "_thumbnail_id", "219");
INSERT INTO `wp_postmeta` VALUES("504", "22", "_thumbnail_id", "226");
INSERT INTO `wp_postmeta` VALUES("506", "234", "_wp_attached_file", "2016/07/SampleImage17.jpg");
INSERT INTO `wp_postmeta` VALUES("507", "234", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1920;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2016/07/SampleImage17.jpg\";s:5:\"sizes\";a:4:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"SampleImage17-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"SampleImage17-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"SampleImage17-768x512.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:512;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"SampleImage17-1024x683.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:683;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("508", "15", "_thumbnail_id", "234");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("2", "1", "2016-07-03 19:28:11", "2016-07-03 19:28:11", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my website. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickeys to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://localhost:8888/theming-basics/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "publish", "closed", "open", "", "sample-page", "", "", "2016-07-03 19:28:11", "2016-07-03 19:28:11", "", "0", "http://localhost:8888/themingbasics/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2016-07-03 19:34:58", "2016-07-03 19:34:58", "<h2>Lorem ipsum.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ducimus repellat earum, impedit rerum commodi ea aperiam in deleniti necessitatibus asperiores, cum maiores illum, error totam! Placeat, hic laboriosam nemo corrupti debitis mollitia itaque molestias reprehenderit consectetur, harum dolores similique laudantium necessitatibus sit corporis repellat!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. At beatae pariatur dolore odit id dignissimos deleniti?</p>\r\n<p>At sit laudantium fugit libero quam quos maxime dignissimos saepe dolores. Doloremque itaque, reiciendis vero quaerat ut culpa neque, laborum vitae voluptates! Esse quia cumque culpa maiores amet aut magnam voluptates ducimus, dolores hic. Amet consequatur deleniti quae quam odio! Minus, recusandae expedita ad!</p>\r\n<h3>Vitae, quas labore nihil.</h3>\r\n<p>Quaerat dignissimos optio exercitationem omnis, numquam aliquam reiciendis, odit, illum porro quod est quis sapiente repudiandae.</p>\r\n<h5>Lorem ipsum dolor sit amet.</h5>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam deleniti, iure. Maiores perferendis culpa quam rerum error iusto saepe vero repellendus accusantium deleniti aperiam obcaecati, nam, ea blanditiis cumque, accusamus laudantium praesentium alias.</p>", "Lorem ipsum dolor.", "", "publish", "closed", "open", "", "lorem-ipsum-dolor", "", "", "2016-07-12 01:56:52", "2016-07-12 01:56:52", "", "0", "http://localhost:8888/themingbasics/?p=11", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2016-07-03 19:35:07", "2016-07-03 19:35:07", "<h2>Aspernatur, dolorem.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Saepe blanditiis amet distinctio inventore quibusdam dolorum eius sapiente molestiae laudantium nostrum labore fugit dolorem natus mollitia accusantium nulla exercitationem odit cumque facere quis, deserunt. Corporis doloremque cumque nesciunt consequatur debitis pariatur ea sit ducimus magni.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Unde iste provident consequatur dolorum non assumenda ipsam.</p>\r\n<p>Optio perferendis dolor ut beatae est dolorum vero hic vel quo earum nobis corporis, illo nihil nisi mollitia iure odio cum eligendi voluptatum, minima repudiandae ipsa reiciendis aliquid repellat officia. Id voluptatem possimus veritatis animi fugiat, eum quibusdam rerum voluptatum, ut pariatur suscipit, nostrum.</p>\r\n<h3>Dolor at debitis velit.</h3>\r\n<p>Necessitatibus dicta aliquid repellendus fuga laudantium vitae nisi voluptatem accusantium, quas neque fugit adipisci eligendi tenetur.</p>\r\n<h5>Voluptatum voluptas pariatur, saepe sequi?</h5>\r\n<p>Sunt non nihil quas possimus veniam dicta soluta ipsum deleniti, quos repellendus in inventore vero libero delectus enim voluptatem consectetur voluptatibus iure esse blanditiis! Delectus corrupti cupiditate quidem omnis et unde suscipit dolore.</p>", "Aliquam perspiciatis.", "", "publish", "closed", "open", "", "aliquam-animi-perspiciatis", "", "", "2016-07-12 02:00:27", "2016-07-12 02:00:27", "", "0", "http://localhost:8888/themingbasics/?p=12", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2016-07-03 19:35:14", "2016-07-03 19:35:14", "<h2>Magni, unde.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quasi, accusantium! Distinctio ipsam expedita non pariatur corporis neque vel deserunt accusantium asperiores iure totam, sunt perferendis quia eos temporibus veritatis eius itaque. Eligendi quo atque, non, porro optio reiciendis inventore ex minima facilis beatae accusamus.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Deleniti voluptas reiciendis perspiciatis iste in, ex alias.</p>\r\n<p>Dolorum officia deleniti impedit, magni nihil eligendi, aspernatur voluptatibus incidunt eum sit similique tenetur iure aperiam maxime repellat ea ipsa amet. Velit cumque voluptates doloremque iure fugit, deleniti sint eius dolores possimus unde perspiciatis, quae totam alias corrupti ducimus asperiores. Mollitia molestiae, earum nemo.</p>\r\n<h3>Nesciunt pariatur iste harum.</h3>\r\n<p>Repudiandae iste repellat consequatur iure cum inventore nam culpa voluptatibus repellendus maxime assumenda omnis, expedita nesciunt.</p>\r\n<h5>Dicta deserunt rerum doloribus. Laudantium.</h5>\r\n<p>Explicabo, necessitatibus minima consectetur, sed omnis fugiat obcaecati corporis libero ipsa aspernatur quod eaque, impedit culpa exercitationem? Voluptatem deserunt aperiam, iusto maxime corporis cum repudiandae quam architecto. Et omnis, tempore fugit debitis sed?</p>", "Porro, numquam, nisi!", "", "publish", "closed", "open", "", "porro-numquam-nisi", "", "", "2016-07-12 01:57:24", "2016-07-12 01:57:24", "", "0", "http://localhost:8888/themingbasics/?p=13", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2016-07-03 19:35:21", "2016-07-03 19:35:21", "<h2>Quos, veritatis.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Eaque temporibus, totam corporis voluptatibus voluptate accusamus repellendus, unde veniam magnam non sit magni molestiae ratione dolor velit expedita voluptas sequi ducimus nobis nam. Facere quod vel illum doloribus, rerum minima non harum. Pariatur, totam, officia.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate velit nam voluptates, accusamus perspiciatis! Maiores, ut?</p>\r\n<p>Qui accusantium sit dolorem nulla eum ut nemo praesentium ipsa quibusdam incidunt beatae obcaecati porro quisquam, voluptatum eveniet nostrum et, cumque iure aut. Asperiores molestiae maiores dolorum, commodi eaque necessitatibus autem dolore omnis quia, quos qui laborum eos. Accusamus facere architecto cupiditate adipisci ratione.</p>\r\n<h3>Culpa dolorum id, veritatis.</h3>\r\n<p>Ea hic dolorem tempora id doloribus. Minima libero quas nisi commodi, perferendis doloribus, possimus corporis rem!</p>\r\n<h5>Dicta, laborum ipsum tempore quibusdam?</h5>\r\n<p>Suscipit veritatis officiis hic commodi perspiciatis, autem illum nihil reprehenderit, possimus animi error provident quis alias, rem ipsa dolores eligendi ratione obcaecati fuga reiciendis unde, itaque quas. Officia praesentium quis vel iure hic.</p>", "Quibusdam enim.", "MESA was started by Randall Smith as a small repair shop which modified Fender Amplifiers, particularly the diminutive Fender Princeton. Smith\'s modifications gave the small amps much more input gain, making them much louder as well as creating a high-gain, distorted guitar tone. ", "publish", "closed", "open", "", "quibusdam-enim-corporis", "", "", "2016-07-12 02:06:15", "2016-07-12 02:06:15", "", "0", "http://localhost:8888/themingbasics/?p=14", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2016-07-03 19:35:29", "2016-07-03 19:35:29", "<h2>Sapiente, ipsum!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sed placeat, suscipit odit ea maiores ipsa blanditiis. Iusto nostrum nisi facere ratione molestias. Deleniti iste magni vel quae! Dolor blanditiis, incidunt temporibus et cumque maiores magnam architecto beatae! Tempore libero, voluptatum porro architecto ipsam vero.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quasi sint quod veritatis quaerat beatae laboriosam quis!</p>\r\n<p>Aperiam cum debitis, nobis consequatur natus placeat tenetur sint. Quae dicta, voluptatum dolores libero excepturi molestias eius! Debitis nobis sapiente illum et ex, dicta vero corrupti dolore iure ab nihil blanditiis deleniti, quia nemo animi aliquam. Illum, esse. Nesciunt ipsam enim explicabo, maiores eligendi!</p>\r\n<h3>Ut, officiis sint. Enim.</h3>\r\n<p>Quos incidunt blanditiis eius ratione dignissimos ipsum perspiciatis, non atque dolor, hic suscipit quo itaque, doloribus.</p>\r\n<h5>Mollitia nam amet assumenda id!</h5>\r\n<p>Alias ex enim molestias eligendi vitae, reiciendis dicta tenetur asperiores recusandae repellendus architecto nostrum ea labore est quam voluptas sapiente odit, eius pariatur et ullam quo suscipit velit. Dicta doloribus fugit totam cum.</p>", "Dolor, voluptatibus?", "", "publish", "closed", "open", "", "dolor-voluptatibus-doloremque", "", "", "2016-07-12 05:57:51", "2016-07-12 05:57:51", "", "0", "http://localhost:8888/themingbasics/?p=15", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("16", "2", "2016-07-03 19:35:37", "2016-07-03 19:35:37", "<h2>Dolorum, veritatis.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ea, sapiente fuga nisi doloribus cum fugit nobis reiciendis expedita sint repellendus. Ad minus at consectetur tempora assumenda, ullam fuga blanditiis eligendi natus a delectus eaque voluptatum obcaecati quod nesciunt, inventore doloribus ratione! Obcaecati, eaque, impedit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ipsam quisquam consequuntur dolorem, ad consectetur numquam in!</p>\r\n<p>Quaerat fugit numquam veritatis exercitationem itaque, perferendis earum nisi libero, ipsum facere ipsam quos non animi molestias illo quae modi tenetur nemo eligendi mollitia nam cupiditate error natus debitis vel! Earum illum neque aliquid ea commodi eaque similique, aliquam qui rerum, reprehenderit? Et, aperiam.</p>\r\n<h3>Nisi dolorem non sit.</h3>\r\n<p>Dolore mollitia eveniet voluptate aliquid quasi amet nam, eius! Id quia iste, praesentium repellat quaerat mollitia.</p>\r\n<h5>Iste vitae quisquam consequuntur laborum.</h5>\r\n<p>Nostrum non, repellat fugiat reprehenderit eaque, qui, odio error laborum consectetur nam veritatis tempora consequuntur tenetur officia earum, minus temporibus alias asperiores reiciendis quas esse eius quibusdam. Dolor quibusdam modi, laudantium nam beatae.</p>", "Iste, veritatis, odit?", "Good morning, gentlemen. This is a twelwe-storey block combining classical neo-Georgian features with the efficiency of modern techniques. The tenants arrive in the entrance hall here, and are carried along the corridor on a conveyor belt in extreme comfort and past murals depicting Mediterranean scenes, towards the rotating knives. The last twenty feet of the corridor are heavily soundproofed. The blood pours down these chutes and the mangled flesh slurps into these..", "publish", "closed", "open", "", "iste-veritatis-odit", "", "", "2016-07-12 01:56:52", "2016-07-12 01:56:52", "", "0", "http://localhost:8888/themingbasics/?p=16", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("17", "2", "2016-07-03 19:35:44", "2016-07-03 19:35:44", "<h2>Hic, ex.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio, molestiae, ducimus. Maiores, eos expedita itaque officia impedit voluptatem possimus, autem dignissimos laboriosam laudantium provident, natus? Sit soluta cumque ex placeat quisquam odit aperiam, minus. Odit quis natus, est rerum, reprehenderit voluptates dignissimos corporis amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Repellat delectus exercitationem, molestiae. Velit doloremque, doloribus impedit.</p>\r\n<p>Modi accusantium quia nam, hic distinctio possimus rem commodi cum beatae, pariatur, vel voluptatibus eos consectetur architecto consequuntur nemo a quaerat quo corporis iusto suscipit deleniti dolorem. Tempora laborum, est non dicta! Sed accusantium assumenda ex tenetur explicabo ad expedita neque dignissimos corrupti mollitia.</p>\r\n<h3>Modi sint, laudantium provident.</h3>\r\n<p>Sapiente debitis necessitatibus aspernatur, aut vero tempore atque magni molestias totam odio, non sint dignissimos ratione?</p>\r\n<h5>Sapiente porro illo dolor enim!</h5>\r\n<p>Laboriosam accusamus eius, deserunt odit fuga, voluptas maiores adipisci magnam officia iusto facere recusandae amet itaque molestiae animi! Porro libero excepturi laudantium provident repudiandae, iure rerum cupiditate voluptates praesentium explicabo. Dolores, error temporibus.</p>", "Sint, atque, minima?", "First to arrive is Mr. Wiggin, who describes his architectural design and modern construction, and then explains his killing technique starting with a conveyor belt and \'rotating knives\'. It turns out that Mr. Wiggin mainly designs slaughterhouses and has misunderstood the owners\' attitude to their tenants. ", "publish", "closed", "open", "", "sint-atque-minima", "", "", "2016-07-12 01:57:24", "2016-07-12 01:57:24", "", "0", "http://localhost:8888/themingbasics/?p=17", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("18", "5", "2016-07-03 19:35:52", "2016-07-03 19:35:52", "<h2>Placeat, ullam!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Corrupti, consequatur modi? Eius, pariatur, maiores reprehenderit, animi dolores velit cupiditate minus distinctio labore laudantium mollitia beatae neque at vero omnis corporis quos. Accusantium harum exercitationem, labore repellat autem voluptates dicta pariatur itaque doloribus sapiente rerum?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consectetur perspiciatis dolorem, eaque debitis aut eveniet commodi.</p>\r\n<p>Incidunt repellendus dolores amet earum asperiores accusantium magni dignissimos reiciendis repudiandae, ducimus non nostrum doloremque iste quos, minus veritatis nam architecto nihil aliquid, aperiam porro dolore illo. Aut magnam architecto, saepe id aliquid veritatis nihil labore reprehenderit voluptas accusantium, dolore at tempore, quis. Ea!</p>\r\n<h3>Velit, aperiam porro vitae!</h3>\r\n<p>Qui nostrum, alias vero, iste, expedita dolorum exercitationem modi facere eius, impedit veniam pariatur. Quod, ad.</p>\r\n<h5>Quasi eos qui sit nobis!</h5>\r\n<p>Delectus iusto repudiandae veniam corrupti repellendus quidem. Nulla autem voluptates totam voluptate, ex consequatur optio laboriosam. Odio distinctio possimus non, adipisci dolores totam doloribus ducimus a porro, tempore repellendus ipsam quisquam nihil atque.</p>", "Ab, aspernatur.", "Once Wiggin has been persuaded to leave, the second architect, Mr. Leavey (Eric Idle), arrives. As Mr. Leavey describes the strong construction and safety features of his design, his model collapses and catches fire in the manner of the recent Ronan Point disaster, accompanied by a large on-screen caption reading \'SATIRE\'.", "publish", "closed", "open", "", "ab-explicabo-aspernatur", "", "", "2016-07-12 01:58:09", "2016-07-12 01:58:09", "", "0", "http://localhost:8888/themingbasics/?p=18", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("19", "4", "2016-07-03 19:35:59", "2016-07-03 19:35:59", "<h2>Accusantium, qui.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequatur iure ab rerum voluptate aspernatur repellendus quis, temporibus quaerat quae, impedit sit fugit, accusamus, doloremque unde! Tempora, et, quod. Sunt tempora repellendus dolorem minima? Quos minus eligendi vel mollitia enim optio perspiciatis eaque cum, perferendis.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Veritatis modi natus assumenda obcaecati voluptates amet ut!</p>\r\n<p>Ratione iure pariatur tempore voluptatem quisquam aliquid minus placeat? Corporis necessitatibus molestias nesciunt quod ut error inventore minus porro nulla ea explicabo illo magni ab quae, incidunt, laudantium perferendis suscipit quos sed. Perspiciatis libero, cupiditate omnis laborum aliquid quia, laboriosam placeat illo distinctio vero!</p>\r\n<h3>Accusantium, eaque rem placeat?</h3>\r\n<p>Debitis libero qui accusantium cupiditate! Quos tempora quam fugit, autem assumenda quibusdam aliquam quo tenetur atque!</p>\r\n<h5>Eius beatae consequatur ullam tempora?</h5>\r\n<p>Quod commodi minima hic fugiat at unde ipsam qui. Facere architecto, maiores incidunt fugit delectus ab laboriosam quaerat iure ex! Eos reprehenderit magni laudantium cum autem harum nihil, fuga tempore, aliquam corrupti quo.</p>", "Harum, non quaerat.", "When Mr. Wiggin fails to persuade them to accept his \'real beaut\' of a design, he launches into an impassioned tirade against \'you non-creative garbage\' and blackballing Freemasons. When they still reject his design, however, he begs the increasingly uncomfortable City gents to accept him into the Freemasons.", "publish", "closed", "open", "", "harum-non-quaerat", "", "", "2016-07-12 01:57:24", "2016-07-12 01:57:24", "", "0", "http://localhost:8888/themingbasics/?p=19", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("20", "4", "2016-07-03 19:36:08", "2016-07-03 19:36:08", "<h2>Labore, repellendus?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente, quisquam, harum. Consequuntur consectetur, voluptatibus mollitia. Unde voluptate ullam doloremque eos commodi in doloribus suscipit, facilis nam quas tenetur ratione obcaecati, sit vel laboriosam. Iste porro quasi aliquid modi fugiat consectetur assumenda, accusantium dolor obcaecati?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Exercitationem et hic consequuntur eaque facere, totam expedita.</p>\r\n<p>Error sunt deleniti placeat recusandae, magni est labore pariatur necessitatibus. Quam harum dolorum quas sed optio esse eum nulla quibusdam. Provident laborum, sapiente error perspiciatis a fugit cumque modi mollitia laudantium architecto animi voluptatum, beatae dolores. Exercitationem quisquam atque tempora dicta ipsa, veniam quas.</p>\r\n<h3>Ea nesciunt ex totam?</h3>\r\n<p>Velit, asperiores iste odit porro beatae quis! Itaque ipsam, delectus culpa dolores deserunt non odio quae.</p>\r\n<h5>Nihil iusto fugiat sit, eveniet!</h5>\r\n<p>Ipsa neque, autem voluptates enim non provident. Magni culpa modi obcaecati dolorum vero. Nostrum deserunt harum deleniti, magni provident necessitatibus, sit, impedit dolor porro rerum quis, non. Tempora qui expedita enim, amet aut.</p>", "Exercitationem, dignissimos.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "publish", "closed", "open", "", "sunt-exercitationem-dignissimos", "", "", "2016-07-12 01:56:52", "2016-07-12 01:56:52", "", "0", "http://localhost:8888/themingbasics/?p=20", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("21", "5", "2016-07-03 19:36:16", "2016-07-03 19:36:16", "<h2>Perspiciatis, quas.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Neque perferendis et magni sunt, rerum modi quae commodi aliquam vitae libero facere soluta perspiciatis blanditiis repellat maxime repellendus, nesciunt totam. Aspernatur impedit animi labore magni quidem ut fugiat quod facilis natus similique? Eveniet quia, velit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente a dolor distinctio minima, in sed obcaecati!</p>\r\n<p>Numquam unde harum beatae eos modi iste esse inventore libero adipisci nobis nostrum accusamus necessitatibus quae molestiae, reprehenderit repellat. Exercitationem harum, minus veniam ad iste atque nesciunt enim assumenda. Atque quo eaque rerum commodi voluptas consequatur harum qui nisi, eligendi, vero, nesciunt alias, nam?</p>\r\n<h3>Deleniti esse, et ex.</h3>\r\n<p>Blanditiis praesentium vitae, consequatur dignissimos beatae itaque quis perferendis, unde, illo sint minima laborum dolorum, possimus.</p>\r\n<h5>Enim officiis facere repellendus odit.</h5>\r\n<p>Hic magnam alias recusandae minima praesentium ipsam dolore eligendi aut commodi maxime tempora nam laudantium, ab accusamus facere doloribus quidem soluta. At cum quasi suscipit nobis eos harum libero, soluta aspernatur, modi sequi.</p>", "Eius, maxime.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "publish", "closed", "open", "", "similique-eius-maxime", "", "", "2016-07-12 01:58:09", "2016-07-12 01:58:09", "", "0", "http://localhost:8888/themingbasics/?p=21", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("22", "2", "2015-10-03 19:36:23", "2015-10-03 19:36:23", "<h2>Voluptatum, minima.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugiat fugit veritatis veniam facere modi, inventore ipsum possimus quo quibusdam. Laborum possimus nulla ducimus quo ipsa provident dignissimos aliquam esse aut quae, ut fuga, dolorum quod expedita? Minima sint in laboriosam quia similique, dolor vitae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolor quae, blanditiis, reiciendis ab debitis repellat esse?</p>\r\n<p>Libero suscipit id dolore doloribus minima sequi fugit similique nulla, esse nobis nesciunt numquam saepe commodi velit repellendus eos illum molestiae ipsum quam! Neque voluptates atque aliquid impedit, cumque voluptatibus ab alias facere quasi odio maiores delectus commodi dolor blanditiis laudantium minima labore, tempora.</p>\r\n<h3>Optio odio blanditiis vitae.</h3>\r\n<p>Autem quam sint, aliquam ipsum beatae, dolorem, minima explicabo nobis earum cumque labore sapiente veniam! Fugit.</p>\r\n<h5>Illo praesentium, enim dolores eos.</h5>\r\n<p>Accusantium laborum molestiae, vitae neque cupiditate harum. Quasi molestias nemo fugiat excepturi modi facilis reprehenderit numquam hic, vitae ratione atque officiis blanditiis sint repudiandae maiores nisi minima autem in labore asperiores aspernatur at.</p>", "Placeat, est!", "Due to her pointed criticism of both the Leninist and the more moderate social democratic schools of socialism, Luxemburg has had a somewhat ambivalent reception among scholars and theorists of the political left.[3] Nonetheless, some have regarded Luxemburg and Liebknecht as martyrs of the socialist cause.", "publish", "closed", "open", "", "placeat-natus-est", "", "", "2016-07-12 02:06:39", "2016-07-12 02:06:39", "", "0", "http://localhost:8888/themingbasics/?p=22", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("23", "2", "2016-04-12 19:36:33", "2016-04-12 19:36:33", "<h2>Nostrum, facere.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Asperiores, earum. Quisquam nemo esse rem unde corporis, dolor delectus officia voluptates alias adipisci totam illum impedit quia libero rerum expedita exercitationem porro ex! Praesentium eveniet enim voluptatem perspiciatis explicabo quidem harum vitae nostrum dicta, ducimus.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Cupiditate reiciendis dolorum exercitationem ipsam aspernatur placeat necessitatibus!</p>\r\n<p>Pariatur perspiciatis libero porro, debitis. Rem maxime corrupti, cumque nisi architecto commodi reiciendis velit voluptates quae aspernatur minima facilis. Exercitationem ea, ex consequuntur nesciunt deleniti vitae accusantium, delectus error atque, quae eligendi soluta! Quasi totam corrupti veniam perferendis repellat ratione minus, perspiciatis sed harum!</p>\r\n<h3>Explicabo, incidunt itaque. Dolorem?</h3>\r\n<p>Eaque excepturi accusamus quidem quam ratione maxime porro impedit sint maiores id vero consequuntur, ex laudantium!</p>\r\n<h5>Tempora eius, veritatis incidunt nisi.</h5>\r\n<p>Consequuntur esse iste, consequatur est facilis soluta pariatur voluptatum repellendus minima? Non odio, quas, error est, nulla quia natus nesciunt officiis voluptas esse harum placeat numquam quasi. Et cumque repellat nulla eaque minus.</p>", "Molestiae. Debitis.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "publish", "closed", "open", "", "molestiae-deleniti-debitis", "", "", "2016-07-12 01:56:52", "2016-07-12 01:56:52", "", "0", "http://localhost:8888/themingbasics/?p=23", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("24", "2", "2016-03-13 19:36:42", "2016-03-13 19:36:42", "<h2>Dolores, adipisci!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam facilis, eveniet neque aut, similique amet ea fugiat minima sint hic. Doloremque odio consectetur enim, assumenda odit praesentium vero eligendi beatae maiores cumque libero nobis inventore omnis magni laborum error repudiandae, rem ex. Nemo, maiores.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate, quis a sit quibusdam! Assumenda, similique ullam!</p>\r\n<p>Deserunt tempora, pariatur ratione soluta maiores sint. Eligendi dignissimos officia provident voluptates rem facere iure expedita ea accusamus eveniet. Dolore sapiente velit culpa eaque saepe recusandae blanditiis totam placeat alias distinctio laboriosam asperiores sunt, qui ipsum ab quidem expedita amet laborum neque id praesentium.</p>\r\n<h3>Atque, deleniti rerum similique.</h3>\r\n<p>Asperiores nihil perspiciatis, culpa non. Aspernatur eaque aperiam repellendus tempore ab quia facere alias maxime sint.</p>\r\n<h5>Fuga, voluptates. Consectetur, labore, molestiae.</h5>\r\n<p>Odit error obcaecati architecto sed veniam consequatur quidem aliquam optio, laudantium consequuntur fugit laborum ab rerum doloremque. A provident quae id, iste modi, ex velit vitae nemo quaerat illum esse voluptatibus, quas maxime.</p>", "Incidunt, qui.", "Rosa Luxemburg (also Rozalia Luxenburg; Polish: Róża Luksemburg; 5 March 1871[1] – 15 January 1919) was a Marxist theorist, philosopher, economist and revolutionary socialist of Polish-Jewish descent who became a naturalized German citizen. She was, successively, a member of the Social Democracy of the Kingdom of Poland and Lithuania (SDKPiL), the Social Democratic Party of Germany (SPD), the Independent Social Democratic Party (USPD), and the Communist Party of Germany (KPD).", "publish", "closed", "open", "", "incidunt-dolore-qui", "", "", "2016-07-12 02:09:09", "2016-07-12 02:09:09", "", "0", "http://localhost:8888/themingbasics/?p=24", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("25", "3", "2016-07-03 19:36:50", "2016-07-03 19:36:50", "<h2>Earum, dicta?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Itaque similique consequatur nisi id consequuntur ipsum repudiandae ipsam beatae nulla sunt, fugit vel animi voluptas nesciunt, unde molestiae ducimus corrupti voluptates placeat velit quidem veritatis nobis aliquid? Rem, nam laudantium id aspernatur recusandae voluptatibus ratione.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Reprehenderit ipsum expedita quos sequi quidem recusandae commodi?</p>\r\n<p>Illo tempora debitis nisi et, sint, velit porro consequuntur quas officiis inventore quos aliquam dolores earum mollitia distinctio, corrupti doloribus culpa amet aliquid accusantium neque impedit maiores quisquam esse. Odit vero quaerat ipsam fugiat impedit non rerum nam, iusto sint, dignissimos sapiente, eligendi eum.</p>\r\n<h3>Ducimus sed impedit corporis?</h3>\r\n<p>Excepturi porro unde voluptate! Error at similique beatae pariatur optio, unde ullam omnis temporibus, dolorum perspiciatis?</p>\r\n<h5>Eaque ex recusandae assumenda cupiditate.</h5>\r\n<p>Nostrum aliquid, similique odit nobis tempore expedita, error vero, a tenetur aliquam aperiam placeat. Ex debitis voluptatum quibusdam, autem tenetur, eligendi dignissimos aspernatur, error libero nemo accusantium at quisquam reiciendis eaque voluptas non!</p>", "Nihil, amet minima.", "Often with emphasis on another effect such as scrambling, gating or tremolo. Some effects also utilize unusual features such as built in photoresistors, joysticks and effects loops. ", "publish", "closed", "open", "", "nihil-amet-minima", "", "", "2016-07-12 01:57:24", "2016-07-12 01:57:24", "", "0", "http://localhost:8888/themingbasics/?p=25", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("26", "5", "2016-05-18 19:36:58", "2016-05-18 19:36:58", "<h2>Temporibus, itaque!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quae ea eaque nulla est tempore, dolore laudantium at reprehenderit eius doloremque rem obcaecati ab accusantium, quisquam, cupiditate sequi hic! Quasi non autem debitis eveniet molestias quaerat, est reprehenderit optio totam necessitatibus temporibus tenetur, dolore consequatur!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis soluta, error explicabo atque nobis non neque.</p>\r\n<p>Accusamus praesentium laborum aut ullam provident veritatis excepturi quisquam reprehenderit obcaecati repudiandae. Porro iusto velit nulla unde cum minus saepe aliquid repellat a libero ullam reprehenderit praesentium sed laborum, doloribus fugiat natus perspiciatis veritatis minima? Officia provident delectus eum quas perferendis, ullam eligendi quos.</p>\r\n<h3>Aspernatur iste repudiandae obcaecati.</h3>\r\n<p>Consequuntur id eligendi provident, repellendus, ratione et facilis fuga. Ducimus consectetur cumque molestias nesciunt quas nam.</p>\r\n<h5>Autem soluta assumenda totam natus.</h5>\r\n<p>Voluptatum labore, ullam obcaecati odit natus maxime harum et debitis est, perspiciatis dolor rem facilis delectus! Expedita alias error blanditiis officiis officia. Cupiditate dolore est voluptas sapiente minus, molestiae nihil qui harum alias.</p>", "Facilis, dignissimos.", "Commodi harum quod sed minima ea voluptatem obcaecati modi adipisci quia eaque libero distinctio explicabo eius illum optio, voluptates dolore! Rerum!\r\n", "publish", "closed", "open", "", "facilis-nobis-dignissimos", "", "", "2016-07-12 01:58:09", "2016-07-12 01:58:09", "", "0", "http://localhost:8888/themingbasics/?p=26", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2016-01-02 19:37:06", "2016-01-02 19:37:06", "<h2>Omnis, corporis!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Recusandae voluptate doloribus aliquam minus, aut hic error quos amet totam, omnis, fugiat voluptates officiis natus voluptatem quaerat. Ratione optio voluptate quibusdam dolore natus, laboriosam quos culpa aliquam a expedita libero! Libero, animi. Iste, minus. Voluptas.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Nihil, laborum distinctio quisquam ratione repellendus, sunt voluptas!</p>\r\n<p>Maiores cupiditate dolorem neque sint ipsam incidunt qui inventore ea eos dolor eius accusamus quod sed maxime laboriosam sequi non quibusdam, vero, minima officiis cumque quam? Accusamus corporis ad blanditiis officia quidem, error ab nulla tempore dolorum eligendi. Veniam libero excepturi vitae sed expedita?</p>\r\n<h3>Sed tempore, culpa beatae.</h3>\r\n<p>Quia provident expedita vitae deleniti tenetur voluptatum, voluptates reprehenderit a, eum iure est quod, ipsa optio.</p>\r\n<h5>Praesentium reiciendis omnis autem aliquam.</h5>\r\n<p>Earum reprehenderit dolorum aliquid praesentium nostrum nemo eum iste veniam adipisci nisi! Illo adipisci non hic dolorem enim, commodi, recusandae unde minus alias molestiae quas saepe iusto architecto modi magnam eum, sunt vero.</p>", "Ex ducimus, accusamus?", "She considered the Spartacist uprising of January 1919 a blunder,[2] but supported it as events unfolded. Friedrich Ebert\'s majority Social Democratic government crushed the revolt and the Spartakusbund by sending in the Freikorps (government-sponsored paramilitary groups consisting mostly of World War I veterans). Freikorps troops captured and murdered Luxemburg and Liebknecht. Luxemburg\'s body was thrown in the Landwehr Canal in Berlin.\r\n", "publish", "closed", "open", "", "ex-ducimus-accusamus", "", "", "2016-07-12 02:09:09", "2016-07-12 02:09:09", "", "0", "http://localhost:8888/themingbasics/?p=27", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("28", "3", "2016-03-23 19:37:15", "2016-03-23 19:37:15", "<h2>Doloremque, officia!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Inventore explicabo, ab dicta libero eum eius corrupti consequatur, iure rerum maxime tempora sed modi quaerat officiis neque quis veritatis illo. Nulla vel quam consequuntur molestias reprehenderit veritatis, fuga dolor, obcaecati cupiditate neque dolores dolorum ipsa!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quaerat asperiores ducimus, at cum tempore veniam suscipit.</p>\r\n<p>Amet rerum veritatis rem, explicabo, ullam architecto doloribus velit expedita inventore consequuntur, laudantium iusto esse voluptates deserunt sunt eveniet distinctio dicta saepe cumque. Fuga ducimus doloremque dignissimos doloribus quos cum neque vero praesentium quae aspernatur, ipsa excepturi magnam nihil, voluptate asperiores in, suscipit iusto!</p>\r\n<h3>Saepe porro, dignissimos illo.</h3>\r\n<p>Reiciendis eum et laboriosam laborum voluptatibus officia consequatur cupiditate, eaque inventore ipsa nostrum necessitatibus quae a?</p>\r\n<h5>Nulla corrupti dignissimos quae rem.</h5>\r\n<p>Dolore enim accusantium, id numquam magni molestias. Facilis esse sed soluta, possimus tempore perferendis. Aperiam, eligendi, ab! Fuga sit laboriosam laborum doloribus dolorum sequi voluptatum quos architecto necessitatibus, ratione cupiditate quae veritatis accusantium.</p>", "A, delectus, cullom.", "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolores sint blanditiis odio adipisci, quam veritatis perspiciatis eligendi. Nobis nemo optio culpa fugiat quas delectus nisi reiciendis, totam, debitis, aut vitae.", "publish", "closed", "open", "", "a-delectus-cum", "", "", "2016-07-12 02:09:09", "2016-07-12 02:09:09", "", "0", "http://localhost:8888/themingbasics/?p=28", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("29", "3", "2016-06-03 19:37:23", "2016-06-03 19:37:23", "<h2>Deleniti, molestiae.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facilis voluptates molestias debitis ipsam similique eveniet qui blanditiis explicabo accusamus omnis eaque, nemo, cum facere. Dolor molestias tempora, assumenda eaque commodi, vero ea iusto nesciunt quod quos praesentium a iure rerum harum repudiandae totam. Reprehenderit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquam ea accusantium ex autem, quisquam animi itaque!</p>\r\n<p>Suscipit quis ad beatae ab voluptatum optio accusamus consequatur aut dolores nostrum ea adipisci, ipsam velit modi pariatur, nulla delectus odit veniam et dignissimos non ut iste doloremque tempore. Blanditiis ab aspernatur consequatur eaque rem dicta, reiciendis sed, repellendus, aliquam quaerat perferendis voluptates atque!</p>\r\n<h3>Illum ut fugit culpa.</h3>\r\n<p>Ab odio illum, dolorem, itaque porro quisquam impedit temporibus recusandae voluptatem, in quia eveniet vero libero.</p>\r\n<h5>Aspernatur nulla ut reprehenderit beatae.</h5>\r\n<p>Nesciunt quibusdam, consequatur unde minus dolorum ea, officia blanditiis, labore nulla velit illo nobis animi ab. Nostrum illo facere suscipit. Impedit ullam, omnis ab, ea aliquid nisi corporis, harum autem iure molestias odio.</p>", "Aliquid reiciendis.", "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolores sint blanditiis odio adipisci, quam veritatis perspiciatis eligendi. Nobis nemo optio culpa fugiat quas delectus nisi reiciendis, totam, debitis, aut vitae.", "publish", "closed", "open", "", "aliquid-reiciendis-minus", "", "", "2016-07-12 02:00:27", "2016-07-12 02:00:27", "", "0", "http://localhost:8888/themingbasics/?p=29", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("30", "4", "2016-07-03 19:37:32", "2016-07-03 19:37:32", "<h2>Eligendi, consequuntur.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia tempore ullam autem cupiditate voluptate natus omnis temporibus, totam beatae repellat nihil dolor pariatur impedit fuga voluptatibus dicta sit eum, est tempora amet. Sint in odio, dicta ut vero quaerat dolore aliquid itaque dolores quas!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto cumque, ducimus, facere minima velit fugit omnis.</p>\r\n<p>Eveniet, beatae quidem, excepturi quas dolor, aliquid doloribus perspiciatis rem fugit illum unde libero, numquam quibusdam aliquam architecto dolorem minus odit dicta consequatur. Impedit aperiam, ullam esse. Id dolore sint minima repellat, error doloribus, laudantium non, cumque assumenda expedita mollitia laborum laboriosam quo. Sit.</p>\r\n<h3>Cupiditate repudiandae doloribus voluptates.</h3>\r\n<p>Iure dolorum, doloribus ex, accusantium soluta qui cum asperiores iste aspernatur praesentium nostrum tenetur, ratione dolorem.</p>\r\n<h5>Quibusdam neque cupiditate voluptate expedita!</h5>\r\n<p>In voluptatibus sint, repellendus nostrum magni veritatis temporibus provident nesciunt totam, soluta minus quisquam consequatur, excepturi non culpa. Culpa dolor labore consectetur repellendus amet, dolore consequatur, aut. Enim voluptatum quia molestias commodi culpa!</p>", "Facere asperiores", "The Vexter Fuzz Factory is a five-knob fuzz using two new old-stock sixties germanium transistors. It’s one of the most versatile Fuzz pedals on the market. Its circuit is not modeled after any classic fuzz design", "publish", "closed", "open", "", "facere-asperiores-laudantium", "", "", "2016-07-12 01:57:24", "2016-07-12 01:57:24", "", "0", "http://localhost:8888/themingbasics/?p=30", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("31", "4", "2016-07-01 19:37:40", "2016-07-01 19:37:40", "<h2>Voluptates, iure.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ad ducimus laborum cumque, id, eligendi repellat deleniti. Deleniti odit impedit placeat in molestias ipsam nostrum voluptates explicabo, natus sed eos est quidem voluptatem modi vitae accusamus harum eaque quibusdam commodi quisquam! Iure, quam sunt amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia eos dicta rem sequi, iste quidem quae.</p>\r\n<p>Veniam, doloremque in sed magni aliquam, explicabo, saepe ut ab asperiores deserunt ducimus. Mollitia et nobis maxime ea incidunt animi error assumenda illo ipsam veniam minima cupiditate porro minus ratione fugiat aliquam vero, harum blanditiis deleniti pariatur necessitatibus molestiae doloribus odit suscipit. Minus, praesentium?</p>\r\n<h3>Dolores numquam exercitationem itaque!</h3>\r\n<p>Sed eius, ipsa tempora quos delectus officiis dolores, dolor harum totam tenetur recusandae, quaerat? Unde, ab.</p>\r\n<h5>Obcaecati commodi sit, reiciendis aut.</h5>\r\n<p>Ea esse, rem corporis alias eum iusto. Perferendis aut, quibusdam asperiores rerum dolor dolores aliquam id quia quis eum at, non voluptates quaerat. Ullam maiores voluptates quo laborum possimus cum ab commodi tempora?</p>", "Tenetur, facilis!", "Beatae voluptate quod placeat eos sunt, eveniet pariatur vitae assumenda debitis officiis dolor illum, nihil error velit ipsum mollitia quaerat. Praesentium.", "publish", "closed", "open", "", "tenetur-facilis-delectus", "", "", "2016-07-12 02:09:09", "2016-07-12 02:09:09", "", "0", "http://localhost:8888/themingbasics/?p=31", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("34", "5", "2016-01-03 19:38:07", "2016-01-03 19:38:07", "<h2>Consequuntur, quo.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Maiores soluta recusandae et, eaque quo ratione repellendus explicabo debitis, ipsum nisi excepturi quisquam deleniti accusamus necessitatibus. Ipsam ad quam tenetur, nisi at velit dolorum ducimus exercitationem veritatis, officia animi! Corrupti ratione dignissimos accusantium eum quae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequuntur sint magni officia, doloremque perferendis. Laborum, fugit.</p>\r\n<p>Non ut animi fugiat suscipit quisquam odio, est, distinctio temporibus ratione. Consequuntur, labore non maxime deleniti alias adipisci eos odio maiores debitis! Nisi maxime id eos. Odio dicta voluptatem doloremque, quo, iste quidem laboriosam laborum possimus illo alias amet placeat assumenda libero quasi vitae!</p>\r\n<h3>Ipsa, nam fugit quia.</h3>\r\n<p>Vel repellat quae recusandae omnis beatae dolor ut maiores, libero voluptates, rem, veniam tenetur eius at.</p>\r\n<h5>Eveniet minima fuga, illo saepe!</h5>\r\n<p>Nobis rerum error necessitatibus veritatis accusantium, ex quam hic eligendi magni dolore aliquam, optio excepturi nostrum deleniti vero maxime, ducimus iusto natus fugit. Ipsa ad quasi alias fugit inventore delectus, tempora minima ipsam!</p>", "Tempora, voluptate!", "In 1915, after the SPD supported German involvement in World War I, she and Karl Liebknecht co-founded the anti-war Spartacus League (Spartakusbund), which eventually became the KPD. During the November Revolution she co-founded the newspaper Die Rote Fahne (\"The Red Flag\"), the central organ of the Spartacist movement.", "publish", "closed", "open", "", "tempora-voluptate-quibusdam", "", "", "2016-07-12 04:10:24", "2016-07-12 04:10:24", "", "0", "http://localhost:8888/themingbasics/?p=34", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("35", "3", "2016-04-03 19:38:15", "2016-04-03 19:38:15", "<h2>Repudiandae, quidem!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Incidunt vero delectus quibusdam ipsam, tenetur exercitationem quasi. Debitis at, explicabo doloremque nesciunt consequuntur dicta qui quisquam. Perferendis illum vel veritatis autem quasi iusto nesciunt sequi, exercitationem odit ad aut, consequuntur ratione. Rem beatae repellat ex!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facere animi nesciunt qui accusamus, commodi quasi, repudiandae!</p>\r\n<p>Incidunt, quos accusantium eaque magnam perspiciatis sed sequi excepturi aliquid. Quo quos quod accusantium optio nihil ut excepturi, voluptatibus dolore temporibus. Obcaecati eius hic maiores ab, aspernatur ipsum eum adipisci repellendus. Et consequatur suscipit nulla obcaecati, repellat aspernatur iure! Omnis totam reiciendis et consequuntur.</p>\r\n<h3>Nulla placeat nesciunt suscipit?</h3>\r\n<p>Laudantium voluptatem reprehenderit fugit quibusdam magnam enim, quo aspernatur ea inventore molestias quasi veritatis placeat quas!</p>\r\n<h5>Autem atque minus quos facere?</h5>\r\n<p>At vitae numquam repudiandae. Quod neque nulla doloremque provident officiis. Numquam, non eos earum nulla, reiciendis voluptatem quam, reprehenderit dolore necessitatibus architecto aspernatur itaque iure animi id totam? Iusto incidunt earum quaerat, debitis!</p>", "Quod, suscipit.", "Repellendus aliquid, sunt! Ea maxime eligendi dicta, animi quas consequatur natus dolore placeat impedit, alias reiciendis. Veritatis consectetur veniam nisi porro.\r\n", "publish", "closed", "open", "", "quod-perferendis-suscipit", "", "", "2016-07-12 01:56:52", "2016-07-12 01:56:52", "", "0", "http://localhost:8888/themingbasics/?p=35", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2016-07-03 19:34:58", "2016-07-03 19:34:58", "", "Lorem ipsum dolor.", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2016-07-03 19:34:58", "2016-07-03 19:34:58", "", "11", "http://localhost:8888/themingbasics/2016/07/03/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2016-07-03 19:35:07", "2016-07-03 19:35:07", "", "Aliquam animi, perspiciatis.", "", "inherit", "closed", "closed", "", "12-revision-v1", "", "", "2016-07-03 19:35:07", "2016-07-03 19:35:07", "", "12", "http://localhost:8888/themingbasics/2016/07/03/12-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("38", "1", "2016-07-03 19:35:14", "2016-07-03 19:35:14", "", "Porro, numquam, nisi!", "", "inherit", "closed", "closed", "", "13-revision-v1", "", "", "2016-07-03 19:35:14", "2016-07-03 19:35:14", "", "13", "http://localhost:8888/themingbasics/2016/07/03/13-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("39", "1", "2016-07-03 19:35:21", "2016-07-03 19:35:21", "", "Quibusdam enim, corporis.", "", "inherit", "closed", "closed", "", "14-revision-v1", "", "", "2016-07-03 19:35:21", "2016-07-03 19:35:21", "", "14", "http://localhost:8888/themingbasics/2016/07/03/14-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("40", "1", "2016-07-03 19:35:29", "2016-07-03 19:35:29", "", "Dolor, voluptatibus, doloremque.", "", "inherit", "closed", "closed", "", "15-revision-v1", "", "", "2016-07-03 19:35:29", "2016-07-03 19:35:29", "", "15", "http://localhost:8888/themingbasics/2016/07/03/15-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("41", "1", "2016-07-03 19:35:37", "2016-07-03 19:35:37", "", "Iste, veritatis, odit?", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2016-07-03 19:35:37", "2016-07-03 19:35:37", "", "16", "http://localhost:8888/themingbasics/2016/07/03/16-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("42", "1", "2016-07-03 19:35:44", "2016-07-03 19:35:44", "", "Sint, atque, minima?", "", "inherit", "closed", "closed", "", "17-revision-v1", "", "", "2016-07-03 19:35:44", "2016-07-03 19:35:44", "", "17", "http://localhost:8888/themingbasics/2016/07/03/17-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("43", "1", "2016-07-03 19:35:52", "2016-07-03 19:35:52", "", "Ab, explicabo, aspernatur.", "", "inherit", "closed", "closed", "", "18-revision-v1", "", "", "2016-07-03 19:35:52", "2016-07-03 19:35:52", "", "18", "http://localhost:8888/themingbasics/2016/07/03/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("44", "1", "2016-07-03 19:35:59", "2016-07-03 19:35:59", "", "Harum, non quaerat.", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2016-07-03 19:35:59", "2016-07-03 19:35:59", "", "19", "http://localhost:8888/themingbasics/2016/07/03/19-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("45", "1", "2016-07-03 19:36:08", "2016-07-03 19:36:08", "", "Sunt, exercitationem, dignissimos.", "", "inherit", "closed", "closed", "", "20-revision-v1", "", "", "2016-07-03 19:36:08", "2016-07-03 19:36:08", "", "20", "http://localhost:8888/themingbasics/2016/07/03/20-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("46", "1", "2016-07-03 19:36:16", "2016-07-03 19:36:16", "", "Similique, eius, maxime.", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2016-07-03 19:36:16", "2016-07-03 19:36:16", "", "21", "http://localhost:8888/themingbasics/2016/07/03/21-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("47", "1", "2016-07-03 19:36:23", "2016-07-03 19:36:23", "", "Placeat, natus, est!", "", "inherit", "closed", "closed", "", "22-revision-v1", "", "", "2016-07-03 19:36:23", "2016-07-03 19:36:23", "", "22", "http://localhost:8888/themingbasics/2016/07/03/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2016-07-03 19:36:33", "2016-07-03 19:36:33", "", "Molestiae, deleniti. Debitis.", "", "inherit", "closed", "closed", "", "23-revision-v1", "", "", "2016-07-03 19:36:33", "2016-07-03 19:36:33", "", "23", "http://localhost:8888/themingbasics/2016/07/03/23-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("49", "1", "2016-07-03 19:36:42", "2016-07-03 19:36:42", "", "Incidunt, dolore qui.", "", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2016-07-03 19:36:42", "2016-07-03 19:36:42", "", "24", "http://localhost:8888/themingbasics/2016/07/03/24-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("50", "1", "2016-07-03 19:36:50", "2016-07-03 19:36:50", "", "Nihil, amet minima.", "", "inherit", "closed", "closed", "", "25-revision-v1", "", "", "2016-07-03 19:36:50", "2016-07-03 19:36:50", "", "25", "http://localhost:8888/themingbasics/2016/07/03/25-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("51", "1", "2016-07-03 19:36:58", "2016-07-03 19:36:58", "", "Facilis, nobis dignissimos.", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2016-07-03 19:36:58", "2016-07-03 19:36:58", "", "26", "http://localhost:8888/themingbasics/2016/07/03/26-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("52", "1", "2016-07-03 19:37:06", "2016-07-03 19:37:06", "", "Ex ducimus, accusamus?", "", "inherit", "closed", "closed", "", "27-revision-v1", "", "", "2016-07-03 19:37:06", "2016-07-03 19:37:06", "", "27", "http://localhost:8888/themingbasics/2016/07/03/27-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("53", "1", "2016-07-03 19:37:15", "2016-07-03 19:37:15", "", "A, delectus, cum.", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2016-07-03 19:37:15", "2016-07-03 19:37:15", "", "28", "http://localhost:8888/themingbasics/2016/07/03/28-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("54", "1", "2016-07-03 19:37:23", "2016-07-03 19:37:23", "", "Aliquid reiciendis, minus.", "", "inherit", "closed", "closed", "", "29-revision-v1", "", "", "2016-07-03 19:37:23", "2016-07-03 19:37:23", "", "29", "http://localhost:8888/themingbasics/2016/07/03/29-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("55", "1", "2016-07-03 19:37:32", "2016-07-03 19:37:32", "", "Facere asperiores, laudantium.", "", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2016-07-03 19:37:32", "2016-07-03 19:37:32", "", "30", "http://localhost:8888/themingbasics/2016/07/03/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("56", "1", "2016-07-03 19:37:40", "2016-07-03 19:37:40", "", "Tenetur, facilis delectus!", "", "inherit", "closed", "closed", "", "31-revision-v1", "", "", "2016-07-03 19:37:40", "2016-07-03 19:37:40", "", "31", "http://localhost:8888/themingbasics/2016/07/03/31-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("59", "1", "2016-07-03 19:38:07", "2016-07-03 19:38:07", "", "Tempora, voluptate, quibusdam.", "", "inherit", "closed", "closed", "", "34-revision-v1", "", "", "2016-07-03 19:38:07", "2016-07-03 19:38:07", "", "34", "http://localhost:8888/themingbasics/2016/07/03/34-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("60", "1", "2016-07-03 19:38:15", "2016-07-03 19:38:15", "", "Quod, perferendis, suscipit.", "", "inherit", "closed", "closed", "", "35-revision-v1", "", "", "2016-07-03 19:38:15", "2016-07-03 19:38:15", "", "35", "http://localhost:8888/themingbasics/2016/07/03/35-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("61", "1", "2016-07-03 19:43:11", "2016-07-03 19:43:11", "<h2>Lorem ipsum.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ducimus repellat earum, impedit rerum commodi ea aperiam in deleniti necessitatibus asperiores, cum maiores illum, error totam! Placeat, hic laboriosam nemo corrupti debitis mollitia itaque molestias reprehenderit consectetur, harum dolores similique laudantium necessitatibus sit corporis repellat!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. At beatae pariatur dolore odit id dignissimos deleniti?</p>\r\n<p>At sit laudantium fugit libero quam quos maxime dignissimos saepe dolores. Doloremque itaque, reiciendis vero quaerat ut culpa neque, laborum vitae voluptates! Esse quia cumque culpa maiores amet aut magnam voluptates ducimus, dolores hic. Amet consequatur deleniti quae quam odio! Minus, recusandae expedita ad!</p>\r\n<h3>Vitae, quas labore nihil.</h3>\r\n<p>Quaerat dignissimos optio exercitationem omnis, numquam aliquam reiciendis, odit, illum porro quod est quis sapiente repudiandae.</p>\r\n<h5>Lorem ipsum dolor sit amet.</h5>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam deleniti, iure. Maiores perferendis culpa quam rerum error iusto saepe vero repellendus accusantium deleniti aperiam obcaecati, nam, ea blanditiis cumque, accusamus laudantium praesentium alias.</p>", "Lorem ipsum dolor.", "", "inherit", "closed", "closed", "", "11-revision-v1", "", "", "2016-07-03 19:43:11", "2016-07-03 19:43:11", "", "11", "http://localhost:8888/themingbasics/politics/11-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("62", "1", "2016-07-03 19:43:25", "2016-07-03 19:43:25", "<h2>Aspernatur, dolorem.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Saepe blanditiis amet distinctio inventore quibusdam dolorum eius sapiente molestiae laudantium nostrum labore fugit dolorem natus mollitia accusantium nulla exercitationem odit cumque facere quis, deserunt. Corporis doloremque cumque nesciunt consequatur debitis pariatur ea sit ducimus magni.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Unde iste provident consequatur dolorum non assumenda ipsam.</p>\r\n<p>Optio perferendis dolor ut beatae est dolorum vero hic vel quo earum nobis corporis, illo nihil nisi mollitia iure odio cum eligendi voluptatum, minima repudiandae ipsa reiciendis aliquid repellat officia. Id voluptatem possimus veritatis animi fugiat, eum quibusdam rerum voluptatum, ut pariatur suscipit, nostrum.</p>\r\n<h3>Dolor at debitis velit.</h3>\r\n<p>Necessitatibus dicta aliquid repellendus fuga laudantium vitae nisi voluptatem accusantium, quas neque fugit adipisci eligendi tenetur.</p>\r\n<h5>Voluptatum voluptas pariatur, saepe sequi?</h5>\r\n<p>Sunt non nihil quas possimus veniam dicta soluta ipsum deleniti, quos repellendus in inventore vero libero delectus enim voluptatem consectetur voluptatibus iure esse blanditiis! Delectus corrupti cupiditate quidem omnis et unde suscipit dolore.</p>", "Aliquam animi, perspiciatis.", "", "inherit", "closed", "closed", "", "12-revision-v1", "", "", "2016-07-03 19:43:25", "2016-07-03 19:43:25", "", "12", "http://localhost:8888/themingbasics/politics/12-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("63", "1", "2016-07-03 19:43:40", "2016-07-03 19:43:40", "<h2>Magni, unde.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quasi, accusantium! Distinctio ipsam expedita non pariatur corporis neque vel deserunt accusantium asperiores iure totam, sunt perferendis quia eos temporibus veritatis eius itaque. Eligendi quo atque, non, porro optio reiciendis inventore ex minima facilis beatae accusamus.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Deleniti voluptas reiciendis perspiciatis iste in, ex alias.</p>\r\n<p>Dolorum officia deleniti impedit, magni nihil eligendi, aspernatur voluptatibus incidunt eum sit similique tenetur iure aperiam maxime repellat ea ipsa amet. Velit cumque voluptates doloremque iure fugit, deleniti sint eius dolores possimus unde perspiciatis, quae totam alias corrupti ducimus asperiores. Mollitia molestiae, earum nemo.</p>\r\n<h3>Nesciunt pariatur iste harum.</h3>\r\n<p>Repudiandae iste repellat consequatur iure cum inventore nam culpa voluptatibus repellendus maxime assumenda omnis, expedita nesciunt.</p>\r\n<h5>Dicta deserunt rerum doloribus. Laudantium.</h5>\r\n<p>Explicabo, necessitatibus minima consectetur, sed omnis fugiat obcaecati corporis libero ipsa aspernatur quod eaque, impedit culpa exercitationem? Voluptatem deserunt aperiam, iusto maxime corporis cum repudiandae quam architecto. Et omnis, tempore fugit debitis sed?</p>", "Porro, numquam, nisi!", "", "inherit", "closed", "closed", "", "13-revision-v1", "", "", "2016-07-03 19:43:40", "2016-07-03 19:43:40", "", "13", "http://localhost:8888/themingbasics/politics/13-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("64", "1", "2016-07-03 19:43:53", "2016-07-03 19:43:53", "<h2>Quos, veritatis.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Eaque temporibus, totam corporis voluptatibus voluptate accusamus repellendus, unde veniam magnam non sit magni molestiae ratione dolor velit expedita voluptas sequi ducimus nobis nam. Facere quod vel illum doloribus, rerum minima non harum. Pariatur, totam, officia.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate velit nam voluptates, accusamus perspiciatis! Maiores, ut?</p>\r\n<p>Qui accusantium sit dolorem nulla eum ut nemo praesentium ipsa quibusdam incidunt beatae obcaecati porro quisquam, voluptatum eveniet nostrum et, cumque iure aut. Asperiores molestiae maiores dolorum, commodi eaque necessitatibus autem dolore omnis quia, quos qui laborum eos. Accusamus facere architecto cupiditate adipisci ratione.</p>\r\n<h3>Culpa dolorum id, veritatis.</h3>\r\n<p>Ea hic dolorem tempora id doloribus. Minima libero quas nisi commodi, perferendis doloribus, possimus corporis rem!</p>\r\n<h5>Dicta, laborum ipsum tempore quibusdam?</h5>\r\n<p>Suscipit veritatis officiis hic commodi perspiciatis, autem illum nihil reprehenderit, possimus animi error provident quis alias, rem ipsa dolores eligendi ratione obcaecati fuga reiciendis unde, itaque quas. Officia praesentium quis vel iure hic.</p>", "Quibusdam enim, corporis.", "", "inherit", "closed", "closed", "", "14-revision-v1", "", "", "2016-07-03 19:43:53", "2016-07-03 19:43:53", "", "14", "http://localhost:8888/themingbasics/politics/14-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("65", "1", "2016-07-03 19:44:09", "2016-07-03 19:44:09", "<h2>Sapiente, ipsum!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sed placeat, suscipit odit ea maiores ipsa blanditiis. Iusto nostrum nisi facere ratione molestias. Deleniti iste magni vel quae! Dolor blanditiis, incidunt temporibus et cumque maiores magnam architecto beatae! Tempore libero, voluptatum porro architecto ipsam vero.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quasi sint quod veritatis quaerat beatae laboriosam quis!</p>\r\n<p>Aperiam cum debitis, nobis consequatur natus placeat tenetur sint. Quae dicta, voluptatum dolores libero excepturi molestias eius! Debitis nobis sapiente illum et ex, dicta vero corrupti dolore iure ab nihil blanditiis deleniti, quia nemo animi aliquam. Illum, esse. Nesciunt ipsam enim explicabo, maiores eligendi!</p>\r\n<h3>Ut, officiis sint. Enim.</h3>\r\n<p>Quos incidunt blanditiis eius ratione dignissimos ipsum perspiciatis, non atque dolor, hic suscipit quo itaque, doloribus.</p>\r\n<h5>Mollitia nam amet assumenda id!</h5>\r\n<p>Alias ex enim molestias eligendi vitae, reiciendis dicta tenetur asperiores recusandae repellendus architecto nostrum ea labore est quam voluptas sapiente odit, eius pariatur et ullam quo suscipit velit. Dicta doloribus fugit totam cum.</p>", "Dolor, voluptatibus, doloremque.", "", "inherit", "closed", "closed", "", "15-revision-v1", "", "", "2016-07-03 19:44:09", "2016-07-03 19:44:09", "", "15", "http://localhost:8888/themingbasics/politics/15-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2016-07-03 19:44:19", "2016-07-03 19:44:19", "<h2>Dolorum, veritatis.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ea, sapiente fuga nisi doloribus cum fugit nobis reiciendis expedita sint repellendus. Ad minus at consectetur tempora assumenda, ullam fuga blanditiis eligendi natus a delectus eaque voluptatum obcaecati quod nesciunt, inventore doloribus ratione! Obcaecati, eaque, impedit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ipsam quisquam consequuntur dolorem, ad consectetur numquam in!</p>\r\n<p>Quaerat fugit numquam veritatis exercitationem itaque, perferendis earum nisi libero, ipsum facere ipsam quos non animi molestias illo quae modi tenetur nemo eligendi mollitia nam cupiditate error natus debitis vel! Earum illum neque aliquid ea commodi eaque similique, aliquam qui rerum, reprehenderit? Et, aperiam.</p>\r\n<h3>Nisi dolorem non sit.</h3>\r\n<p>Dolore mollitia eveniet voluptate aliquid quasi amet nam, eius! Id quia iste, praesentium repellat quaerat mollitia.</p>\r\n<h5>Iste vitae quisquam consequuntur laborum.</h5>\r\n<p>Nostrum non, repellat fugiat reprehenderit eaque, qui, odio error laborum consectetur nam veritatis tempora consequuntur tenetur officia earum, minus temporibus alias asperiores reiciendis quas esse eius quibusdam. Dolor quibusdam modi, laudantium nam beatae.</p>", "Iste, veritatis, odit?", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2016-07-03 19:44:19", "2016-07-03 19:44:19", "", "16", "http://localhost:8888/themingbasics/politics/16-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("67", "1", "2016-07-03 19:44:29", "2016-07-03 19:44:29", "<h2>Hic, ex.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio, molestiae, ducimus. Maiores, eos expedita itaque officia impedit voluptatem possimus, autem dignissimos laboriosam laudantium provident, natus? Sit soluta cumque ex placeat quisquam odit aperiam, minus. Odit quis natus, est rerum, reprehenderit voluptates dignissimos corporis amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Repellat delectus exercitationem, molestiae. Velit doloremque, doloribus impedit.</p>\r\n<p>Modi accusantium quia nam, hic distinctio possimus rem commodi cum beatae, pariatur, vel voluptatibus eos consectetur architecto consequuntur nemo a quaerat quo corporis iusto suscipit deleniti dolorem. Tempora laborum, est non dicta! Sed accusantium assumenda ex tenetur explicabo ad expedita neque dignissimos corrupti mollitia.</p>\r\n<h3>Modi sint, laudantium provident.</h3>\r\n<p>Sapiente debitis necessitatibus aspernatur, aut vero tempore atque magni molestias totam odio, non sint dignissimos ratione?</p>\r\n<h5>Sapiente porro illo dolor enim!</h5>\r\n<p>Laboriosam accusamus eius, deserunt odit fuga, voluptas maiores adipisci magnam officia iusto facere recusandae amet itaque molestiae animi! Porro libero excepturi laudantium provident repudiandae, iure rerum cupiditate voluptates praesentium explicabo. Dolores, error temporibus.</p>", "Sint, atque, minima?", "", "inherit", "closed", "closed", "", "17-revision-v1", "", "", "2016-07-03 19:44:29", "2016-07-03 19:44:29", "", "17", "http://localhost:8888/themingbasics/politics/17-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("68", "1", "2016-07-03 19:44:43", "2016-07-03 19:44:43", "<h2>Placeat, ullam!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Corrupti, consequatur modi? Eius, pariatur, maiores reprehenderit, animi dolores velit cupiditate minus distinctio labore laudantium mollitia beatae neque at vero omnis corporis quos. Accusantium harum exercitationem, labore repellat autem voluptates dicta pariatur itaque doloribus sapiente rerum?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consectetur perspiciatis dolorem, eaque debitis aut eveniet commodi.</p>\r\n<p>Incidunt repellendus dolores amet earum asperiores accusantium magni dignissimos reiciendis repudiandae, ducimus non nostrum doloremque iste quos, minus veritatis nam architecto nihil aliquid, aperiam porro dolore illo. Aut magnam architecto, saepe id aliquid veritatis nihil labore reprehenderit voluptas accusantium, dolore at tempore, quis. Ea!</p>\r\n<h3>Velit, aperiam porro vitae!</h3>\r\n<p>Qui nostrum, alias vero, iste, expedita dolorum exercitationem modi facere eius, impedit veniam pariatur. Quod, ad.</p>\r\n<h5>Quasi eos qui sit nobis!</h5>\r\n<p>Delectus iusto repudiandae veniam corrupti repellendus quidem. Nulla autem voluptates totam voluptate, ex consequatur optio laboriosam. Odio distinctio possimus non, adipisci dolores totam doloribus ducimus a porro, tempore repellendus ipsam quisquam nihil atque.</p>", "Ab, explicabo, aspernatur.", "", "inherit", "closed", "closed", "", "18-revision-v1", "", "", "2016-07-03 19:44:43", "2016-07-03 19:44:43", "", "18", "http://localhost:8888/themingbasics/politics/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2016-07-03 19:44:55", "2016-07-03 19:44:55", "<h2>Accusantium, qui.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequatur iure ab rerum voluptate aspernatur repellendus quis, temporibus quaerat quae, impedit sit fugit, accusamus, doloremque unde! Tempora, et, quod. Sunt tempora repellendus dolorem minima? Quos minus eligendi vel mollitia enim optio perspiciatis eaque cum, perferendis.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Veritatis modi natus assumenda obcaecati voluptates amet ut!</p>\r\n<p>Ratione iure pariatur tempore voluptatem quisquam aliquid minus placeat? Corporis necessitatibus molestias nesciunt quod ut error inventore minus porro nulla ea explicabo illo magni ab quae, incidunt, laudantium perferendis suscipit quos sed. Perspiciatis libero, cupiditate omnis laborum aliquid quia, laboriosam placeat illo distinctio vero!</p>\r\n<h3>Accusantium, eaque rem placeat?</h3>\r\n<p>Debitis libero qui accusantium cupiditate! Quos tempora quam fugit, autem assumenda quibusdam aliquam quo tenetur atque!</p>\r\n<h5>Eius beatae consequatur ullam tempora?</h5>\r\n<p>Quod commodi minima hic fugiat at unde ipsam qui. Facere architecto, maiores incidunt fugit delectus ab laboriosam quaerat iure ex! Eos reprehenderit magni laudantium cum autem harum nihil, fuga tempore, aliquam corrupti quo.</p>", "Harum, non quaerat.", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2016-07-03 19:44:55", "2016-07-03 19:44:55", "", "19", "http://localhost:8888/themingbasics/politics/19-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2016-07-03 19:45:10", "2016-07-03 19:45:10", "<h2>Labore, repellendus?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente, quisquam, harum. Consequuntur consectetur, voluptatibus mollitia. Unde voluptate ullam doloremque eos commodi in doloribus suscipit, facilis nam quas tenetur ratione obcaecati, sit vel laboriosam. Iste porro quasi aliquid modi fugiat consectetur assumenda, accusantium dolor obcaecati?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Exercitationem et hic consequuntur eaque facere, totam expedita.</p>\r\n<p>Error sunt deleniti placeat recusandae, magni est labore pariatur necessitatibus. Quam harum dolorum quas sed optio esse eum nulla quibusdam. Provident laborum, sapiente error perspiciatis a fugit cumque modi mollitia laudantium architecto animi voluptatum, beatae dolores. Exercitationem quisquam atque tempora dicta ipsa, veniam quas.</p>\r\n<h3>Ea nesciunt ex totam?</h3>\r\n<p>Velit, asperiores iste odit porro beatae quis! Itaque ipsam, delectus culpa dolores deserunt non odio quae.</p>\r\n<h5>Nihil iusto fugiat sit, eveniet!</h5>\r\n<p>Ipsa neque, autem voluptates enim non provident. Magni culpa modi obcaecati dolorum vero. Nostrum deserunt harum deleniti, magni provident necessitatibus, sit, impedit dolor porro rerum quis, non. Tempora qui expedita enim, amet aut.</p>", "Sunt, exercitationem, dignissimos.", "", "inherit", "closed", "closed", "", "20-revision-v1", "", "", "2016-07-03 19:45:10", "2016-07-03 19:45:10", "", "20", "http://localhost:8888/themingbasics/politics/20-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("71", "1", "2016-07-03 19:45:22", "2016-07-03 19:45:22", "<h2>Perspiciatis, quas.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Neque perferendis et magni sunt, rerum modi quae commodi aliquam vitae libero facere soluta perspiciatis blanditiis repellat maxime repellendus, nesciunt totam. Aspernatur impedit animi labore magni quidem ut fugiat quod facilis natus similique? Eveniet quia, velit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente a dolor distinctio minima, in sed obcaecati!</p>\r\n<p>Numquam unde harum beatae eos modi iste esse inventore libero adipisci nobis nostrum accusamus necessitatibus quae molestiae, reprehenderit repellat. Exercitationem harum, minus veniam ad iste atque nesciunt enim assumenda. Atque quo eaque rerum commodi voluptas consequatur harum qui nisi, eligendi, vero, nesciunt alias, nam?</p>\r\n<h3>Deleniti esse, et ex.</h3>\r\n<p>Blanditiis praesentium vitae, consequatur dignissimos beatae itaque quis perferendis, unde, illo sint minima laborum dolorum, possimus.</p>\r\n<h5>Enim officiis facere repellendus odit.</h5>\r\n<p>Hic magnam alias recusandae minima praesentium ipsam dolore eligendi aut commodi maxime tempora nam laudantium, ab accusamus facere doloribus quidem soluta. At cum quasi suscipit nobis eos harum libero, soluta aspernatur, modi sequi.</p>", "Similique, eius, maxime.", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2016-07-03 19:45:22", "2016-07-03 19:45:22", "", "21", "http://localhost:8888/themingbasics/politics/21-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2016-07-03 19:45:33", "2016-07-03 19:45:33", "<h2>Voluptatum, minima.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugiat fugit veritatis veniam facere modi, inventore ipsum possimus quo quibusdam. Laborum possimus nulla ducimus quo ipsa provident dignissimos aliquam esse aut quae, ut fuga, dolorum quod expedita? Minima sint in laboriosam quia similique, dolor vitae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolor quae, blanditiis, reiciendis ab debitis repellat esse?</p>\r\n<p>Libero suscipit id dolore doloribus minima sequi fugit similique nulla, esse nobis nesciunt numquam saepe commodi velit repellendus eos illum molestiae ipsum quam! Neque voluptates atque aliquid impedit, cumque voluptatibus ab alias facere quasi odio maiores delectus commodi dolor blanditiis laudantium minima labore, tempora.</p>\r\n<h3>Optio odio blanditiis vitae.</h3>\r\n<p>Autem quam sint, aliquam ipsum beatae, dolorem, minima explicabo nobis earum cumque labore sapiente veniam! Fugit.</p>\r\n<h5>Illo praesentium, enim dolores eos.</h5>\r\n<p>Accusantium laborum molestiae, vitae neque cupiditate harum. Quasi molestias nemo fugiat excepturi modi facilis reprehenderit numquam hic, vitae ratione atque officiis blanditiis sint repudiandae maiores nisi minima autem in labore asperiores aspernatur at.</p>", "Placeat, natus, est!", "", "inherit", "closed", "closed", "", "22-revision-v1", "", "", "2016-07-03 19:45:33", "2016-07-03 19:45:33", "", "22", "http://localhost:8888/themingbasics/politics/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("73", "1", "2016-07-03 19:45:44", "2016-07-03 19:45:44", "<h2>Nostrum, facere.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Asperiores, earum. Quisquam nemo esse rem unde corporis, dolor delectus officia voluptates alias adipisci totam illum impedit quia libero rerum expedita exercitationem porro ex! Praesentium eveniet enim voluptatem perspiciatis explicabo quidem harum vitae nostrum dicta, ducimus.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Cupiditate reiciendis dolorum exercitationem ipsam aspernatur placeat necessitatibus!</p>\r\n<p>Pariatur perspiciatis libero porro, debitis. Rem maxime corrupti, cumque nisi architecto commodi reiciendis velit voluptates quae aspernatur minima facilis. Exercitationem ea, ex consequuntur nesciunt deleniti vitae accusantium, delectus error atque, quae eligendi soluta! Quasi totam corrupti veniam perferendis repellat ratione minus, perspiciatis sed harum!</p>\r\n<h3>Explicabo, incidunt itaque. Dolorem?</h3>\r\n<p>Eaque excepturi accusamus quidem quam ratione maxime porro impedit sint maiores id vero consequuntur, ex laudantium!</p>\r\n<h5>Tempora eius, veritatis incidunt nisi.</h5>\r\n<p>Consequuntur esse iste, consequatur est facilis soluta pariatur voluptatum repellendus minima? Non odio, quas, error est, nulla quia natus nesciunt officiis voluptas esse harum placeat numquam quasi. Et cumque repellat nulla eaque minus.</p>", "Molestiae, deleniti. Debitis.", "", "inherit", "closed", "closed", "", "23-revision-v1", "", "", "2016-07-03 19:45:44", "2016-07-03 19:45:44", "", "23", "http://localhost:8888/themingbasics/politics/23-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2016-07-03 19:46:00", "2016-07-03 19:46:00", "<h2>Dolores, adipisci!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam facilis, eveniet neque aut, similique amet ea fugiat minima sint hic. Doloremque odio consectetur enim, assumenda odit praesentium vero eligendi beatae maiores cumque libero nobis inventore omnis magni laborum error repudiandae, rem ex. Nemo, maiores.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate, quis a sit quibusdam! Assumenda, similique ullam!</p>\r\n<p>Deserunt tempora, pariatur ratione soluta maiores sint. Eligendi dignissimos officia provident voluptates rem facere iure expedita ea accusamus eveniet. Dolore sapiente velit culpa eaque saepe recusandae blanditiis totam placeat alias distinctio laboriosam asperiores sunt, qui ipsum ab quidem expedita amet laborum neque id praesentium.</p>\r\n<h3>Atque, deleniti rerum similique.</h3>\r\n<p>Asperiores nihil perspiciatis, culpa non. Aspernatur eaque aperiam repellendus tempore ab quia facere alias maxime sint.</p>\r\n<h5>Fuga, voluptates. Consectetur, labore, molestiae.</h5>\r\n<p>Odit error obcaecati architecto sed veniam consequatur quidem aliquam optio, laudantium consequuntur fugit laborum ab rerum doloremque. A provident quae id, iste modi, ex velit vitae nemo quaerat illum esse voluptatibus, quas maxime.</p>", "Incidunt, dolore qui.", "", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2016-07-03 19:46:00", "2016-07-03 19:46:00", "", "24", "http://localhost:8888/themingbasics/politics/24-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2016-07-03 19:46:10", "2016-07-03 19:46:10", "<h2>Earum, dicta?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Itaque similique consequatur nisi id consequuntur ipsum repudiandae ipsam beatae nulla sunt, fugit vel animi voluptas nesciunt, unde molestiae ducimus corrupti voluptates placeat velit quidem veritatis nobis aliquid? Rem, nam laudantium id aspernatur recusandae voluptatibus ratione.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Reprehenderit ipsum expedita quos sequi quidem recusandae commodi?</p>\r\n<p>Illo tempora debitis nisi et, sint, velit porro consequuntur quas officiis inventore quos aliquam dolores earum mollitia distinctio, corrupti doloribus culpa amet aliquid accusantium neque impedit maiores quisquam esse. Odit vero quaerat ipsam fugiat impedit non rerum nam, iusto sint, dignissimos sapiente, eligendi eum.</p>\r\n<h3>Ducimus sed impedit corporis?</h3>\r\n<p>Excepturi porro unde voluptate! Error at similique beatae pariatur optio, unde ullam omnis temporibus, dolorum perspiciatis?</p>\r\n<h5>Eaque ex recusandae assumenda cupiditate.</h5>\r\n<p>Nostrum aliquid, similique odit nobis tempore expedita, error vero, a tenetur aliquam aperiam placeat. Ex debitis voluptatum quibusdam, autem tenetur, eligendi dignissimos aspernatur, error libero nemo accusantium at quisquam reiciendis eaque voluptas non!</p>", "Nihil, amet minima.", "", "inherit", "closed", "closed", "", "25-revision-v1", "", "", "2016-07-03 19:46:10", "2016-07-03 19:46:10", "", "25", "http://localhost:8888/themingbasics/politics/25-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2016-07-03 19:46:23", "2016-07-03 19:46:23", "<h2>Temporibus, itaque!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quae ea eaque nulla est tempore, dolore laudantium at reprehenderit eius doloremque rem obcaecati ab accusantium, quisquam, cupiditate sequi hic! Quasi non autem debitis eveniet molestias quaerat, est reprehenderit optio totam necessitatibus temporibus tenetur, dolore consequatur!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis soluta, error explicabo atque nobis non neque.</p>\r\n<p>Accusamus praesentium laborum aut ullam provident veritatis excepturi quisquam reprehenderit obcaecati repudiandae. Porro iusto velit nulla unde cum minus saepe aliquid repellat a libero ullam reprehenderit praesentium sed laborum, doloribus fugiat natus perspiciatis veritatis minima? Officia provident delectus eum quas perferendis, ullam eligendi quos.</p>\r\n<h3>Aspernatur iste repudiandae obcaecati.</h3>\r\n<p>Consequuntur id eligendi provident, repellendus, ratione et facilis fuga. Ducimus consectetur cumque molestias nesciunt quas nam.</p>\r\n<h5>Autem soluta assumenda totam natus.</h5>\r\n<p>Voluptatum labore, ullam obcaecati odit natus maxime harum et debitis est, perspiciatis dolor rem facilis delectus! Expedita alias error blanditiis officiis officia. Cupiditate dolore est voluptas sapiente minus, molestiae nihil qui harum alias.</p>", "Facilis, nobis dignissimos.", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2016-07-03 19:46:23", "2016-07-03 19:46:23", "", "26", "http://localhost:8888/themingbasics/politics/26-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("77", "1", "2016-07-03 19:46:32", "2016-07-03 19:46:32", "<h2>Omnis, corporis!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Recusandae voluptate doloribus aliquam minus, aut hic error quos amet totam, omnis, fugiat voluptates officiis natus voluptatem quaerat. Ratione optio voluptate quibusdam dolore natus, laboriosam quos culpa aliquam a expedita libero! Libero, animi. Iste, minus. Voluptas.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Nihil, laborum distinctio quisquam ratione repellendus, sunt voluptas!</p>\r\n<p>Maiores cupiditate dolorem neque sint ipsam incidunt qui inventore ea eos dolor eius accusamus quod sed maxime laboriosam sequi non quibusdam, vero, minima officiis cumque quam? Accusamus corporis ad blanditiis officia quidem, error ab nulla tempore dolorum eligendi. Veniam libero excepturi vitae sed expedita?</p>\r\n<h3>Sed tempore, culpa beatae.</h3>\r\n<p>Quia provident expedita vitae deleniti tenetur voluptatum, voluptates reprehenderit a, eum iure est quod, ipsa optio.</p>\r\n<h5>Praesentium reiciendis omnis autem aliquam.</h5>\r\n<p>Earum reprehenderit dolorum aliquid praesentium nostrum nemo eum iste veniam adipisci nisi! Illo adipisci non hic dolorem enim, commodi, recusandae unde minus alias molestiae quas saepe iusto architecto modi magnam eum, sunt vero.</p>", "Ex ducimus, accusamus?", "", "inherit", "closed", "closed", "", "27-revision-v1", "", "", "2016-07-03 19:46:32", "2016-07-03 19:46:32", "", "27", "http://localhost:8888/themingbasics/politics/27-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2016-07-03 19:46:44", "2016-07-03 19:46:44", "<h2>Doloremque, officia!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Inventore explicabo, ab dicta libero eum eius corrupti consequatur, iure rerum maxime tempora sed modi quaerat officiis neque quis veritatis illo. Nulla vel quam consequuntur molestias reprehenderit veritatis, fuga dolor, obcaecati cupiditate neque dolores dolorum ipsa!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quaerat asperiores ducimus, at cum tempore veniam suscipit.</p>\r\n<p>Amet rerum veritatis rem, explicabo, ullam architecto doloribus velit expedita inventore consequuntur, laudantium iusto esse voluptates deserunt sunt eveniet distinctio dicta saepe cumque. Fuga ducimus doloremque dignissimos doloribus quos cum neque vero praesentium quae aspernatur, ipsa excepturi magnam nihil, voluptate asperiores in, suscipit iusto!</p>\r\n<h3>Saepe porro, dignissimos illo.</h3>\r\n<p>Reiciendis eum et laboriosam laborum voluptatibus officia consequatur cupiditate, eaque inventore ipsa nostrum necessitatibus quae a?</p>\r\n<h5>Nulla corrupti dignissimos quae rem.</h5>\r\n<p>Dolore enim accusantium, id numquam magni molestias. Facilis esse sed soluta, possimus tempore perferendis. Aperiam, eligendi, ab! Fuga sit laboriosam laborum doloribus dolorum sequi voluptatum quos architecto necessitatibus, ratione cupiditate quae veritatis accusantium.</p>", "A, delectus, cum.", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2016-07-03 19:46:44", "2016-07-03 19:46:44", "", "28", "http://localhost:8888/themingbasics/politics/28-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("79", "1", "2016-07-03 19:46:56", "2016-07-03 19:46:56", "<h2>Doloremque, officia!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Inventore explicabo, ab dicta libero eum eius corrupti consequatur, iure rerum maxime tempora sed modi quaerat officiis neque quis veritatis illo. Nulla vel quam consequuntur molestias reprehenderit veritatis, fuga dolor, obcaecati cupiditate neque dolores dolorum ipsa!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quaerat asperiores ducimus, at cum tempore veniam suscipit.</p>\r\n<p>Amet rerum veritatis rem, explicabo, ullam architecto doloribus velit expedita inventore consequuntur, laudantium iusto esse voluptates deserunt sunt eveniet distinctio dicta saepe cumque. Fuga ducimus doloremque dignissimos doloribus quos cum neque vero praesentium quae aspernatur, ipsa excepturi magnam nihil, voluptate asperiores in, suscipit iusto!</p>\r\n<h3>Saepe porro, dignissimos illo.</h3>\r\n<p>Reiciendis eum et laboriosam laborum voluptatibus officia consequatur cupiditate, eaque inventore ipsa nostrum necessitatibus quae a?</p>\r\n<h5>Nulla corrupti dignissimos quae rem.</h5>\r\n<p>Dolore enim accusantium, id numquam magni molestias. Facilis esse sed soluta, possimus tempore perferendis. Aperiam, eligendi, ab! Fuga sit laboriosam laborum doloribus dolorum sequi voluptatum quos architecto necessitatibus, ratione cupiditate quae veritatis accusantium.</p>", "A, delectus, cullom.", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2016-07-03 19:46:56", "2016-07-03 19:46:56", "", "28", "http://localhost:8888/themingbasics/politics/28-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2016-07-03 19:47:09", "2016-07-03 19:47:09", "<h2>Deleniti, molestiae.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facilis voluptates molestias debitis ipsam similique eveniet qui blanditiis explicabo accusamus omnis eaque, nemo, cum facere. Dolor molestias tempora, assumenda eaque commodi, vero ea iusto nesciunt quod quos praesentium a iure rerum harum repudiandae totam. Reprehenderit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquam ea accusantium ex autem, quisquam animi itaque!</p>\r\n<p>Suscipit quis ad beatae ab voluptatum optio accusamus consequatur aut dolores nostrum ea adipisci, ipsam velit modi pariatur, nulla delectus odit veniam et dignissimos non ut iste doloremque tempore. Blanditiis ab aspernatur consequatur eaque rem dicta, reiciendis sed, repellendus, aliquam quaerat perferendis voluptates atque!</p>\r\n<h3>Illum ut fugit culpa.</h3>\r\n<p>Ab odio illum, dolorem, itaque porro quisquam impedit temporibus recusandae voluptatem, in quia eveniet vero libero.</p>\r\n<h5>Aspernatur nulla ut reprehenderit beatae.</h5>\r\n<p>Nesciunt quibusdam, consequatur unde minus dolorum ea, officia blanditiis, labore nulla velit illo nobis animi ab. Nostrum illo facere suscipit. Impedit ullam, omnis ab, ea aliquid nisi corporis, harum autem iure molestias odio.</p>", "Aliquid reiciendis, minus.", "", "inherit", "closed", "closed", "", "29-revision-v1", "", "", "2016-07-03 19:47:09", "2016-07-03 19:47:09", "", "29", "http://localhost:8888/themingbasics/politics/29-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("81", "1", "2016-07-03 19:47:21", "2016-07-03 19:47:21", "<h2>Eligendi, consequuntur.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia tempore ullam autem cupiditate voluptate natus omnis temporibus, totam beatae repellat nihil dolor pariatur impedit fuga voluptatibus dicta sit eum, est tempora amet. Sint in odio, dicta ut vero quaerat dolore aliquid itaque dolores quas!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto cumque, ducimus, facere minima velit fugit omnis.</p>\r\n<p>Eveniet, beatae quidem, excepturi quas dolor, aliquid doloribus perspiciatis rem fugit illum unde libero, numquam quibusdam aliquam architecto dolorem minus odit dicta consequatur. Impedit aperiam, ullam esse. Id dolore sint minima repellat, error doloribus, laudantium non, cumque assumenda expedita mollitia laborum laboriosam quo. Sit.</p>\r\n<h3>Cupiditate repudiandae doloribus voluptates.</h3>\r\n<p>Iure dolorum, doloribus ex, accusantium soluta qui cum asperiores iste aspernatur praesentium nostrum tenetur, ratione dolorem.</p>\r\n<h5>Quibusdam neque cupiditate voluptate expedita!</h5>\r\n<p>In voluptatibus sint, repellendus nostrum magni veritatis temporibus provident nesciunt totam, soluta minus quisquam consequatur, excepturi non culpa. Culpa dolor labore consectetur repellendus amet, dolore consequatur, aut. Enim voluptatum quia molestias commodi culpa!</p>", "Facere asperiores, laudantium.", "", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2016-07-03 19:47:21", "2016-07-03 19:47:21", "", "30", "http://localhost:8888/themingbasics/politics/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("82", "1", "2016-07-03 19:47:34", "2016-07-03 19:47:34", "<h2>Voluptates, iure.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ad ducimus laborum cumque, id, eligendi repellat deleniti. Deleniti odit impedit placeat in molestias ipsam nostrum voluptates explicabo, natus sed eos est quidem voluptatem modi vitae accusamus harum eaque quibusdam commodi quisquam! Iure, quam sunt amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia eos dicta rem sequi, iste quidem quae.</p>\r\n<p>Veniam, doloremque in sed magni aliquam, explicabo, saepe ut ab asperiores deserunt ducimus. Mollitia et nobis maxime ea incidunt animi error assumenda illo ipsam veniam minima cupiditate porro minus ratione fugiat aliquam vero, harum blanditiis deleniti pariatur necessitatibus molestiae doloribus odit suscipit. Minus, praesentium?</p>\r\n<h3>Dolores numquam exercitationem itaque!</h3>\r\n<p>Sed eius, ipsa tempora quos delectus officiis dolores, dolor harum totam tenetur recusandae, quaerat? Unde, ab.</p>\r\n<h5>Obcaecati commodi sit, reiciendis aut.</h5>\r\n<p>Ea esse, rem corporis alias eum iusto. Perferendis aut, quibusdam asperiores rerum dolor dolores aliquam id quia quis eum at, non voluptates quaerat. Ullam maiores voluptates quo laborum possimus cum ab commodi tempora?</p>", "Tenetur, facilis delectus!", "", "inherit", "closed", "closed", "", "31-revision-v1", "", "", "2016-07-03 19:47:34", "2016-07-03 19:47:34", "", "31", "http://localhost:8888/themingbasics/politics/31-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("85", "1", "2016-07-03 19:48:53", "2016-07-03 19:48:53", "<h2>Consequuntur, quo.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Maiores soluta recusandae et, eaque quo ratione repellendus explicabo debitis, ipsum nisi excepturi quisquam deleniti accusamus necessitatibus. Ipsam ad quam tenetur, nisi at velit dolorum ducimus exercitationem veritatis, officia animi! Corrupti ratione dignissimos accusantium eum quae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequuntur sint magni officia, doloremque perferendis. Laborum, fugit.</p>\r\n<p>Non ut animi fugiat suscipit quisquam odio, est, distinctio temporibus ratione. Consequuntur, labore non maxime deleniti alias adipisci eos odio maiores debitis! Nisi maxime id eos. Odio dicta voluptatem doloremque, quo, iste quidem laboriosam laborum possimus illo alias amet placeat assumenda libero quasi vitae!</p>\r\n<h3>Ipsa, nam fugit quia.</h3>\r\n<p>Vel repellat quae recusandae omnis beatae dolor ut maiores, libero voluptates, rem, veniam tenetur eius at.</p>\r\n<h5>Eveniet minima fuga, illo saepe!</h5>\r\n<p>Nobis rerum error necessitatibus veritatis accusantium, ex quam hic eligendi magni dolore aliquam, optio excepturi nostrum deleniti vero maxime, ducimus iusto natus fugit. Ipsa ad quasi alias fugit inventore delectus, tempora minima ipsam!</p>", "Tempora, voluptate, quibusdam.", "", "inherit", "closed", "closed", "", "34-revision-v1", "", "", "2016-07-03 19:48:53", "2016-07-03 19:48:53", "", "34", "http://localhost:8888/themingbasics/politics/34-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2016-07-03 19:49:05", "2016-07-03 19:49:05", "<h2>Repudiandae, quidem!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Incidunt vero delectus quibusdam ipsam, tenetur exercitationem quasi. Debitis at, explicabo doloremque nesciunt consequuntur dicta qui quisquam. Perferendis illum vel veritatis autem quasi iusto nesciunt sequi, exercitationem odit ad aut, consequuntur ratione. Rem beatae repellat ex!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facere animi nesciunt qui accusamus, commodi quasi, repudiandae!</p>\r\n<p>Incidunt, quos accusantium eaque magnam perspiciatis sed sequi excepturi aliquid. Quo quos quod accusantium optio nihil ut excepturi, voluptatibus dolore temporibus. Obcaecati eius hic maiores ab, aspernatur ipsum eum adipisci repellendus. Et consequatur suscipit nulla obcaecati, repellat aspernatur iure! Omnis totam reiciendis et consequuntur.</p>\r\n<h3>Nulla placeat nesciunt suscipit?</h3>\r\n<p>Laudantium voluptatem reprehenderit fugit quibusdam magnam enim, quo aspernatur ea inventore molestias quasi veritatis placeat quas!</p>\r\n<h5>Autem atque minus quos facere?</h5>\r\n<p>At vitae numquam repudiandae. Quod neque nulla doloremque provident officiis. Numquam, non eos earum nulla, reiciendis voluptatem quam, reprehenderit dolore necessitatibus architecto aspernatur itaque iure animi id totam? Iusto incidunt earum quaerat, debitis!</p>", "Quod, perferendis, suscipit.", "", "inherit", "closed", "closed", "", "35-revision-v1", "", "", "2016-07-03 19:49:05", "2016-07-03 19:49:05", "", "35", "http://localhost:8888/themingbasics/politics/35-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("137", "1", "2016-07-03 20:46:41", "2016-07-03 20:46:41", " ", "", "", "publish", "closed", "closed", "", "137", "", "", "2016-07-03 22:11:15", "2016-07-03 22:11:15", "", "0", "http://localhost:8888/themingbasics/?p=137", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("138", "1", "2016-07-03 20:46:41", "2016-07-03 20:46:41", " ", "", "", "publish", "closed", "closed", "", "138", "", "", "2016-07-03 22:11:15", "2016-07-03 22:11:15", "", "0", "http://localhost:8888/themingbasics/?p=138", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("139", "1", "2016-07-03 20:46:41", "2016-07-03 20:46:41", " ", "", "", "publish", "closed", "closed", "", "139", "", "", "2016-07-03 22:11:15", "2016-07-03 22:11:15", "", "0", "http://localhost:8888/themingbasics/?p=139", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("140", "1", "2016-07-03 20:46:41", "2016-07-03 20:46:41", " ", "", "", "publish", "closed", "closed", "", "140", "", "", "2016-07-03 22:11:15", "2016-07-03 22:11:15", "", "0", "http://localhost:8888/themingbasics/?p=140", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("141", "1", "2016-07-03 20:46:41", "2016-07-03 20:46:41", " ", "", "", "publish", "closed", "closed", "", "141", "", "", "2016-07-03 22:11:15", "2016-07-03 22:11:15", "", "0", "http://localhost:8888/themingbasics/?p=141", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("142", "1", "2016-07-03 20:46:41", "2016-07-03 20:46:41", "", "Contact", "", "publish", "closed", "closed", "", "contact", "", "", "2016-07-03 22:11:15", "2016-07-03 22:11:15", "", "0", "http://localhost:8888/themingbasics/?p=142", "6", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("143", "1", "2016-07-03 20:47:10", "2016-07-03 20:47:10", "", "Facebook", "", "publish", "closed", "closed", "", "facebook", "", "", "2016-07-14 05:48:40", "2016-07-14 05:48:40", "", "0", "http://localhost:8888/themingbasics/?p=143", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("144", "1", "2016-07-03 20:47:43", "2016-07-03 20:47:43", "", "Twitter", "", "publish", "closed", "closed", "", "twitter", "", "", "2016-07-14 05:48:40", "2016-07-14 05:48:40", "", "0", "http://localhost:8888/themingbasics/?p=144", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("145", "1", "2016-07-03 20:47:43", "2016-07-03 20:47:43", "", "Pinterest", "", "publish", "closed", "closed", "", "pinterest", "", "", "2016-07-14 05:48:40", "2016-07-14 05:48:40", "", "0", "http://localhost:8888/themingbasics/?p=145", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("146", "1", "2016-07-03 20:47:43", "2016-07-03 20:47:43", "", "YouTube", "", "publish", "closed", "closed", "", "youtube", "", "", "2016-07-14 05:48:40", "2016-07-14 05:48:40", "", "0", "http://localhost:8888/themingbasics/?p=146", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("147", "1", "2016-07-03 21:05:25", "2016-07-03 21:05:25", "<h2>Repudiandae, quidem!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Incidunt vero delectus quibusdam ipsam, tenetur exercitationem quasi. Debitis at, explicabo doloremque nesciunt consequuntur dicta qui quisquam. Perferendis illum vel veritatis autem quasi iusto nesciunt sequi, exercitationem odit ad aut, consequuntur ratione. Rem beatae repellat ex!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facere animi nesciunt qui accusamus, commodi quasi, repudiandae!</p>\r\n<p>Incidunt, quos accusantium eaque magnam perspiciatis sed sequi excepturi aliquid. Quo quos quod accusantium optio nihil ut excepturi, voluptatibus dolore temporibus. Obcaecati eius hic maiores ab, aspernatur ipsum eum adipisci repellendus. Et consequatur suscipit nulla obcaecati, repellat aspernatur iure! Omnis totam reiciendis et consequuntur.</p>\r\n<h3>Nulla placeat nesciunt suscipit?</h3>\r\n<p>Laudantium voluptatem reprehenderit fugit quibusdam magnam enim, quo aspernatur ea inventore molestias quasi veritatis placeat quas!</p>\r\n<h5>Autem atque minus quos facere?</h5>\r\n<p>At vitae numquam repudiandae. Quod neque nulla doloremque provident officiis. Numquam, non eos earum nulla, reiciendis voluptatem quam, reprehenderit dolore necessitatibus architecto aspernatur itaque iure animi id totam? Iusto incidunt earum quaerat, debitis!</p>", "Quod, perferendis, suscipit.", "Repellendus aliquid, sunt! Ea maxime eligendi dicta, animi quas consequatur natus dolore placeat impedit, alias reiciendis. Veritatis consectetur veniam nisi porro.\r\n", "inherit", "closed", "closed", "", "35-revision-v1", "", "", "2016-07-03 21:05:25", "2016-07-03 21:05:25", "", "35", "http://localhost:8888/themingbasics/politics/35-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("148", "1", "2016-07-03 21:05:50", "2016-07-03 21:05:50", "<h2>Consequuntur, quo.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Maiores soluta recusandae et, eaque quo ratione repellendus explicabo debitis, ipsum nisi excepturi quisquam deleniti accusamus necessitatibus. Ipsam ad quam tenetur, nisi at velit dolorum ducimus exercitationem veritatis, officia animi! Corrupti ratione dignissimos accusantium eum quae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequuntur sint magni officia, doloremque perferendis. Laborum, fugit.</p>\r\n<p>Non ut animi fugiat suscipit quisquam odio, est, distinctio temporibus ratione. Consequuntur, labore non maxime deleniti alias adipisci eos odio maiores debitis! Nisi maxime id eos. Odio dicta voluptatem doloremque, quo, iste quidem laboriosam laborum possimus illo alias amet placeat assumenda libero quasi vitae!</p>\r\n<h3>Ipsa, nam fugit quia.</h3>\r\n<p>Vel repellat quae recusandae omnis beatae dolor ut maiores, libero voluptates, rem, veniam tenetur eius at.</p>\r\n<h5>Eveniet minima fuga, illo saepe!</h5>\r\n<p>Nobis rerum error necessitatibus veritatis accusantium, ex quam hic eligendi magni dolore aliquam, optio excepturi nostrum deleniti vero maxime, ducimus iusto natus fugit. Ipsa ad quasi alias fugit inventore delectus, tempora minima ipsam!</p>", "Tempora, voluptate, quibusdam.", "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugiat hic vitae ab minima totam laudantium provident doloremque similique, non accusantium architecto!", "inherit", "closed", "closed", "", "34-revision-v1", "", "", "2016-07-03 21:05:50", "2016-07-03 21:05:50", "", "34", "http://localhost:8888/themingbasics/politics/34-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("152", "1", "2016-07-03 21:07:02", "2016-07-03 21:07:02", "<h2>Voluptates, iure.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ad ducimus laborum cumque, id, eligendi repellat deleniti. Deleniti odit impedit placeat in molestias ipsam nostrum voluptates explicabo, natus sed eos est quidem voluptatem modi vitae accusamus harum eaque quibusdam commodi quisquam! Iure, quam sunt amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia eos dicta rem sequi, iste quidem quae.</p>\r\n<p>Veniam, doloremque in sed magni aliquam, explicabo, saepe ut ab asperiores deserunt ducimus. Mollitia et nobis maxime ea incidunt animi error assumenda illo ipsam veniam minima cupiditate porro minus ratione fugiat aliquam vero, harum blanditiis deleniti pariatur necessitatibus molestiae doloribus odit suscipit. Minus, praesentium?</p>\r\n<h3>Dolores numquam exercitationem itaque!</h3>\r\n<p>Sed eius, ipsa tempora quos delectus officiis dolores, dolor harum totam tenetur recusandae, quaerat? Unde, ab.</p>\r\n<h5>Obcaecati commodi sit, reiciendis aut.</h5>\r\n<p>Ea esse, rem corporis alias eum iusto. Perferendis aut, quibusdam asperiores rerum dolor dolores aliquam id quia quis eum at, non voluptates quaerat. Ullam maiores voluptates quo laborum possimus cum ab commodi tempora?</p>", "Tenetur, facilis delectus!", "Beatae voluptate quod placeat eos sunt, eveniet pariatur vitae assumenda debitis officiis dolor illum, nihil error velit ipsum mollitia quaerat. Praesentium.", "inherit", "closed", "closed", "", "31-revision-v1", "", "", "2016-07-03 21:07:02", "2016-07-03 21:07:02", "", "31", "http://localhost:8888/themingbasics/politics/31-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("153", "1", "2016-07-03 21:07:27", "2016-07-03 21:07:27", "<h2>Deleniti, molestiae.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facilis voluptates molestias debitis ipsam similique eveniet qui blanditiis explicabo accusamus omnis eaque, nemo, cum facere. Dolor molestias tempora, assumenda eaque commodi, vero ea iusto nesciunt quod quos praesentium a iure rerum harum repudiandae totam. Reprehenderit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquam ea accusantium ex autem, quisquam animi itaque!</p>\r\n<p>Suscipit quis ad beatae ab voluptatum optio accusamus consequatur aut dolores nostrum ea adipisci, ipsam velit modi pariatur, nulla delectus odit veniam et dignissimos non ut iste doloremque tempore. Blanditiis ab aspernatur consequatur eaque rem dicta, reiciendis sed, repellendus, aliquam quaerat perferendis voluptates atque!</p>\r\n<h3>Illum ut fugit culpa.</h3>\r\n<p>Ab odio illum, dolorem, itaque porro quisquam impedit temporibus recusandae voluptatem, in quia eveniet vero libero.</p>\r\n<h5>Aspernatur nulla ut reprehenderit beatae.</h5>\r\n<p>Nesciunt quibusdam, consequatur unde minus dolorum ea, officia blanditiis, labore nulla velit illo nobis animi ab. Nostrum illo facere suscipit. Impedit ullam, omnis ab, ea aliquid nisi corporis, harum autem iure molestias odio.</p>", "Aliquid reiciendis, minus.", "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolores sint blanditiis odio adipisci, quam veritatis perspiciatis eligendi. Nobis nemo optio culpa fugiat quas delectus nisi reiciendis, totam, debitis, aut vitae.", "inherit", "closed", "closed", "", "29-revision-v1", "", "", "2016-07-03 21:07:27", "2016-07-03 21:07:27", "", "29", "http://localhost:8888/themingbasics/politics/29-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("154", "1", "2016-07-03 21:07:59", "2016-07-03 21:07:59", "<h2>Doloremque, officia!</h2>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Inventore explicabo, ab dicta libero eum eius corrupti consequatur, iure rerum maxime tempora sed modi quaerat officiis neque quis veritatis illo. Nulla vel quam consequuntur molestias reprehenderit veritatis, fuga dolor, obcaecati cupiditate neque dolores dolorum ipsa!</p>\n<h3>Lorem ipsum dolor sit.</h3>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quaerat asperiores ducimus, at cum tempore veniam suscipit.</p>\n<p>Amet rerum veritatis rem, explicabo, ullam architecto doloribus velit expedita inventore consequuntur, laudantium iusto esse voluptates deserunt sunt eveniet distinctio dicta saepe cumque. Fuga ducimus doloremque dignissimos doloribus quos cum neque vero praesentium quae aspernatur, ipsa excepturi magnam nihil, voluptate asperiores in, suscipit iusto!</p>\n<h3>Saepe porro, dignissimos illo.</h3>\n<p>Reiciendis eum et laboriosam laborum voluptatibus officia consequatur cupiditate, eaque inventore ipsa nostrum necessitatibus quae a?</p>\n<h5>Nulla corrupti dignissimos quae rem.</h5>\n<p>Dolore enim accusantium, id numquam magni molestias. Facilis esse sed soluta, possimus tempore perferendis. Aperiam, eligendi, ab! Fuga sit laboriosam laborum doloribus dolorum sequi voluptatum quos architecto necessitatibus, ratione cupiditate quae veritatis accusantium.</p>", "A, delectus, cullom.", "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolores sint blanditiis odio adipisci, quam veritatis perspiciatis eligendi. Nobis nemo optio culpa fugiat quas delectus nisi reiciendis, totam, debitis, aut vitae.", "inherit", "closed", "closed", "", "28-autosave-v1", "", "", "2016-07-03 21:07:59", "2016-07-03 21:07:59", "", "28", "http://localhost:8888/themingbasics/politics/28-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("155", "1", "2016-07-03 21:08:12", "2016-07-03 21:08:12", "<h2>Doloremque, officia!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Inventore explicabo, ab dicta libero eum eius corrupti consequatur, iure rerum maxime tempora sed modi quaerat officiis neque quis veritatis illo. Nulla vel quam consequuntur molestias reprehenderit veritatis, fuga dolor, obcaecati cupiditate neque dolores dolorum ipsa!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quaerat asperiores ducimus, at cum tempore veniam suscipit.</p>\r\n<p>Amet rerum veritatis rem, explicabo, ullam architecto doloribus velit expedita inventore consequuntur, laudantium iusto esse voluptates deserunt sunt eveniet distinctio dicta saepe cumque. Fuga ducimus doloremque dignissimos doloribus quos cum neque vero praesentium quae aspernatur, ipsa excepturi magnam nihil, voluptate asperiores in, suscipit iusto!</p>\r\n<h3>Saepe porro, dignissimos illo.</h3>\r\n<p>Reiciendis eum et laboriosam laborum voluptatibus officia consequatur cupiditate, eaque inventore ipsa nostrum necessitatibus quae a?</p>\r\n<h5>Nulla corrupti dignissimos quae rem.</h5>\r\n<p>Dolore enim accusantium, id numquam magni molestias. Facilis esse sed soluta, possimus tempore perferendis. Aperiam, eligendi, ab! Fuga sit laboriosam laborum doloribus dolorum sequi voluptatum quos architecto necessitatibus, ratione cupiditate quae veritatis accusantium.</p>", "A, delectus, cullom.", "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolores sint blanditiis odio adipisci, quam veritatis perspiciatis eligendi. Nobis nemo optio culpa fugiat quas delectus nisi reiciendis, totam, debitis, aut vitae.", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2016-07-03 21:08:12", "2016-07-03 21:08:12", "", "28", "http://localhost:8888/themingbasics/politics/28-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("156", "1", "2016-07-03 21:08:38", "2016-07-03 21:08:38", "<h2>Omnis, corporis!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Recusandae voluptate doloribus aliquam minus, aut hic error quos amet totam, omnis, fugiat voluptates officiis natus voluptatem quaerat. Ratione optio voluptate quibusdam dolore natus, laboriosam quos culpa aliquam a expedita libero! Libero, animi. Iste, minus. Voluptas.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Nihil, laborum distinctio quisquam ratione repellendus, sunt voluptas!</p>\r\n<p>Maiores cupiditate dolorem neque sint ipsam incidunt qui inventore ea eos dolor eius accusamus quod sed maxime laboriosam sequi non quibusdam, vero, minima officiis cumque quam? Accusamus corporis ad blanditiis officia quidem, error ab nulla tempore dolorum eligendi. Veniam libero excepturi vitae sed expedita?</p>\r\n<h3>Sed tempore, culpa beatae.</h3>\r\n<p>Quia provident expedita vitae deleniti tenetur voluptatum, voluptates reprehenderit a, eum iure est quod, ipsa optio.</p>\r\n<h5>Praesentium reiciendis omnis autem aliquam.</h5>\r\n<p>Earum reprehenderit dolorum aliquid praesentium nostrum nemo eum iste veniam adipisci nisi! Illo adipisci non hic dolorem enim, commodi, recusandae unde minus alias molestiae quas saepe iusto architecto modi magnam eum, sunt vero.</p>", "Ex ducimus, accusamus?", "Eius amet iste tempore hic in sapiente inventore, animi, numquam beatae eveniet, aliquid odio accusantium obcaecati nisi nobis voluptatum ad nam!\r\n", "inherit", "closed", "closed", "", "27-revision-v1", "", "", "2016-07-03 21:08:38", "2016-07-03 21:08:38", "", "27", "http://localhost:8888/themingbasics/politics/27-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("157", "1", "2016-07-03 21:08:59", "2016-07-03 21:08:59", "<h2>Temporibus, itaque!</h2>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quae ea eaque nulla est tempore, dolore laudantium at reprehenderit eius doloremque rem obcaecati ab accusantium, quisquam, cupiditate sequi hic! Quasi non autem debitis eveniet molestias quaerat, est reprehenderit optio totam necessitatibus temporibus tenetur, dolore consequatur!</p>\n<h3>Lorem ipsum dolor sit.</h3>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis soluta, error explicabo atque nobis non neque.</p>\n<p>Accusamus praesentium laborum aut ullam provident veritatis excepturi quisquam reprehenderit obcaecati repudiandae. Porro iusto velit nulla unde cum minus saepe aliquid repellat a libero ullam reprehenderit praesentium sed laborum, doloribus fugiat natus perspiciatis veritatis minima? Officia provident delectus eum quas perferendis, ullam eligendi quos.</p>\n<h3>Aspernatur iste repudiandae obcaecati.</h3>\n<p>Consequuntur id eligendi provident, repellendus, ratione et facilis fuga. Ducimus consectetur cumque molestias nesciunt quas nam.</p>\n<h5>Autem soluta assumenda totam natus.</h5>\n<p>Voluptatum labore, ullam obcaecati odit natus maxime harum et debitis est, perspiciatis dolor rem facilis delectus! Expedita alias error blanditiis officiis officia. Cupiditate dolore est voluptas sapiente minus, molestiae nihil qui harum alias.</p>", "Facilis, nobis dignissimos.", "Commodi harum quod sed minima ea voluptatem obcaecati modi adipisci quia eaque libero distinctio explicabo eius illum optio, voluptates dolore! Rerum!\n", "inherit", "closed", "closed", "", "26-autosave-v1", "", "", "2016-07-03 21:08:59", "2016-07-03 21:08:59", "", "26", "http://localhost:8888/themingbasics/politics/26-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("158", "1", "2016-07-03 21:09:02", "2016-07-03 21:09:02", "<h2>Temporibus, itaque!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quae ea eaque nulla est tempore, dolore laudantium at reprehenderit eius doloremque rem obcaecati ab accusantium, quisquam, cupiditate sequi hic! Quasi non autem debitis eveniet molestias quaerat, est reprehenderit optio totam necessitatibus temporibus tenetur, dolore consequatur!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis soluta, error explicabo atque nobis non neque.</p>\r\n<p>Accusamus praesentium laborum aut ullam provident veritatis excepturi quisquam reprehenderit obcaecati repudiandae. Porro iusto velit nulla unde cum minus saepe aliquid repellat a libero ullam reprehenderit praesentium sed laborum, doloribus fugiat natus perspiciatis veritatis minima? Officia provident delectus eum quas perferendis, ullam eligendi quos.</p>\r\n<h3>Aspernatur iste repudiandae obcaecati.</h3>\r\n<p>Consequuntur id eligendi provident, repellendus, ratione et facilis fuga. Ducimus consectetur cumque molestias nesciunt quas nam.</p>\r\n<h5>Autem soluta assumenda totam natus.</h5>\r\n<p>Voluptatum labore, ullam obcaecati odit natus maxime harum et debitis est, perspiciatis dolor rem facilis delectus! Expedita alias error blanditiis officiis officia. Cupiditate dolore est voluptas sapiente minus, molestiae nihil qui harum alias.</p>", "Facilis, nobis dignissimos.", "Commodi harum quod sed minima ea voluptatem obcaecati modi adipisci quia eaque libero distinctio explicabo eius illum optio, voluptates dolore! Rerum!\r\n", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2016-07-03 21:09:02", "2016-07-03 21:09:02", "", "26", "http://localhost:8888/themingbasics/politics/26-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("159", "1", "2016-07-03 21:10:09", "2016-07-03 21:10:09", "<h2>Earum, dicta?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Itaque similique consequatur nisi id consequuntur ipsum repudiandae ipsam beatae nulla sunt, fugit vel animi voluptas nesciunt, unde molestiae ducimus corrupti voluptates placeat velit quidem veritatis nobis aliquid? Rem, nam laudantium id aspernatur recusandae voluptatibus ratione.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Reprehenderit ipsum expedita quos sequi quidem recusandae commodi?</p>\r\n<p>Illo tempora debitis nisi et, sint, velit porro consequuntur quas officiis inventore quos aliquam dolores earum mollitia distinctio, corrupti doloribus culpa amet aliquid accusantium neque impedit maiores quisquam esse. Odit vero quaerat ipsam fugiat impedit non rerum nam, iusto sint, dignissimos sapiente, eligendi eum.</p>\r\n<h3>Ducimus sed impedit corporis?</h3>\r\n<p>Excepturi porro unde voluptate! Error at similique beatae pariatur optio, unde ullam omnis temporibus, dolorum perspiciatis?</p>\r\n<h5>Eaque ex recusandae assumenda cupiditate.</h5>\r\n<p>Nostrum aliquid, similique odit nobis tempore expedita, error vero, a tenetur aliquam aperiam placeat. Ex debitis voluptatum quibusdam, autem tenetur, eligendi dignissimos aspernatur, error libero nemo accusantium at quisquam reiciendis eaque voluptas non!</p>", "Nihil, amet minima.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "25-revision-v1", "", "", "2016-07-03 21:10:09", "2016-07-03 21:10:09", "", "25", "http://localhost:8888/themingbasics/politics/25-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("160", "1", "2016-07-03 21:10:30", "2016-07-03 21:10:30", "<h2>Dolores, adipisci!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam facilis, eveniet neque aut, similique amet ea fugiat minima sint hic. Doloremque odio consectetur enim, assumenda odit praesentium vero eligendi beatae maiores cumque libero nobis inventore omnis magni laborum error repudiandae, rem ex. Nemo, maiores.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate, quis a sit quibusdam! Assumenda, similique ullam!</p>\r\n<p>Deserunt tempora, pariatur ratione soluta maiores sint. Eligendi dignissimos officia provident voluptates rem facere iure expedita ea accusamus eveniet. Dolore sapiente velit culpa eaque saepe recusandae blanditiis totam placeat alias distinctio laboriosam asperiores sunt, qui ipsum ab quidem expedita amet laborum neque id praesentium.</p>\r\n<h3>Atque, deleniti rerum similique.</h3>\r\n<p>Asperiores nihil perspiciatis, culpa non. Aspernatur eaque aperiam repellendus tempore ab quia facere alias maxime sint.</p>\r\n<h5>Fuga, voluptates. Consectetur, labore, molestiae.</h5>\r\n<p>Odit error obcaecati architecto sed veniam consequatur quidem aliquam optio, laudantium consequuntur fugit laborum ab rerum doloremque. A provident quae id, iste modi, ex velit vitae nemo quaerat illum esse voluptatibus, quas maxime.</p>", "Incidunt, dolore qui.", "Assumenda dolorem excepturi molestiae quos. Ratione temporibus, dolor aperiam tenetur ipsa autem, rem, odit dolorum, tempore dolores nihil atque architecto saepe.", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2016-07-03 21:10:30", "2016-07-03 21:10:30", "", "24", "http://localhost:8888/themingbasics/politics/24-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("161", "1", "2016-07-03 21:10:44", "2016-07-03 21:10:44", "<h2>Nostrum, facere.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Asperiores, earum. Quisquam nemo esse rem unde corporis, dolor delectus officia voluptates alias adipisci totam illum impedit quia libero rerum expedita exercitationem porro ex! Praesentium eveniet enim voluptatem perspiciatis explicabo quidem harum vitae nostrum dicta, ducimus.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Cupiditate reiciendis dolorum exercitationem ipsam aspernatur placeat necessitatibus!</p>\r\n<p>Pariatur perspiciatis libero porro, debitis. Rem maxime corrupti, cumque nisi architecto commodi reiciendis velit voluptates quae aspernatur minima facilis. Exercitationem ea, ex consequuntur nesciunt deleniti vitae accusantium, delectus error atque, quae eligendi soluta! Quasi totam corrupti veniam perferendis repellat ratione minus, perspiciatis sed harum!</p>\r\n<h3>Explicabo, incidunt itaque. Dolorem?</h3>\r\n<p>Eaque excepturi accusamus quidem quam ratione maxime porro impedit sint maiores id vero consequuntur, ex laudantium!</p>\r\n<h5>Tempora eius, veritatis incidunt nisi.</h5>\r\n<p>Consequuntur esse iste, consequatur est facilis soluta pariatur voluptatum repellendus minima? Non odio, quas, error est, nulla quia natus nesciunt officiis voluptas esse harum placeat numquam quasi. Et cumque repellat nulla eaque minus.</p>", "Molestiae, deleniti. Debitis.", "Eius amet iste tempore hic in sapiente inventore, animi, numquam beatae eveniet, aliquid odio accusantium obcaecati nisi nobis voluptatum ad nam!", "inherit", "closed", "closed", "", "23-revision-v1", "", "", "2016-07-03 21:10:44", "2016-07-03 21:10:44", "", "23", "http://localhost:8888/themingbasics/politics/23-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("162", "1", "2016-07-03 21:11:00", "2016-07-03 21:11:00", "<h2>Nostrum, facere.</h2>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Asperiores, earum. Quisquam nemo esse rem unde corporis, dolor delectus officia voluptates alias adipisci totam illum impedit quia libero rerum expedita exercitationem porro ex! Praesentium eveniet enim voluptatem perspiciatis explicabo quidem harum vitae nostrum dicta, ducimus.</p>\n<h3>Lorem ipsum dolor sit.</h3>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Cupiditate reiciendis dolorum exercitationem ipsam aspernatur placeat necessitatibus!</p>\n<p>Pariatur perspiciatis libero porro, debitis. Rem maxime corrupti, cumque nisi architecto commodi reiciendis velit voluptates quae aspernatur minima facilis. Exercitationem ea, ex consequuntur nesciunt deleniti vitae accusantium, delectus error atque, quae eligendi soluta! Quasi totam corrupti veniam perferendis repellat ratione minus, perspiciatis sed harum!</p>\n<h3>Explicabo, incidunt itaque. Dolorem?</h3>\n<p>Eaque excepturi accusamus quidem quam ratione maxime porro impedit sint maiores id vero consequuntur, ex laudantium!</p>\n<h5>Tempora eius, veritatis incidunt nisi.</h5>\n<p>Consequuntur esse iste, consequatur est facilis soluta pariatur voluptatum repellendus minima? Non odio, quas, error est, nulla quia natus nesciunt officiis voluptas esse harum placeat numquam quasi. Et cumque repellat nulla eaque minus.</p>", "Molestiae, deleniti. Debitis.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "23-autosave-v1", "", "", "2016-07-03 21:11:00", "2016-07-03 21:11:00", "", "23", "http://localhost:8888/themingbasics/politics/23-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("163", "1", "2016-07-03 21:11:04", "2016-07-03 21:11:04", "<h2>Nostrum, facere.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Asperiores, earum. Quisquam nemo esse rem unde corporis, dolor delectus officia voluptates alias adipisci totam illum impedit quia libero rerum expedita exercitationem porro ex! Praesentium eveniet enim voluptatem perspiciatis explicabo quidem harum vitae nostrum dicta, ducimus.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Cupiditate reiciendis dolorum exercitationem ipsam aspernatur placeat necessitatibus!</p>\r\n<p>Pariatur perspiciatis libero porro, debitis. Rem maxime corrupti, cumque nisi architecto commodi reiciendis velit voluptates quae aspernatur minima facilis. Exercitationem ea, ex consequuntur nesciunt deleniti vitae accusantium, delectus error atque, quae eligendi soluta! Quasi totam corrupti veniam perferendis repellat ratione minus, perspiciatis sed harum!</p>\r\n<h3>Explicabo, incidunt itaque. Dolorem?</h3>\r\n<p>Eaque excepturi accusamus quidem quam ratione maxime porro impedit sint maiores id vero consequuntur, ex laudantium!</p>\r\n<h5>Tempora eius, veritatis incidunt nisi.</h5>\r\n<p>Consequuntur esse iste, consequatur est facilis soluta pariatur voluptatum repellendus minima? Non odio, quas, error est, nulla quia natus nesciunt officiis voluptas esse harum placeat numquam quasi. Et cumque repellat nulla eaque minus.</p>", "Molestiae, deleniti. Debitis.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "23-revision-v1", "", "", "2016-07-03 21:11:04", "2016-07-03 21:11:04", "", "23", "http://localhost:8888/themingbasics/politics/23-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("164", "1", "2016-07-03 21:11:21", "2016-07-03 21:11:21", "<h2>Voluptatum, minima.</h2>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugiat fugit veritatis veniam facere modi, inventore ipsum possimus quo quibusdam. Laborum possimus nulla ducimus quo ipsa provident dignissimos aliquam esse aut quae, ut fuga, dolorum quod expedita? Minima sint in laboriosam quia similique, dolor vitae.</p>\n<h3>Lorem ipsum dolor sit.</h3>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolor quae, blanditiis, reiciendis ab debitis repellat esse?</p>\n<p>Libero suscipit id dolore doloribus minima sequi fugit similique nulla, esse nobis nesciunt numquam saepe commodi velit repellendus eos illum molestiae ipsum quam! Neque voluptates atque aliquid impedit, cumque voluptatibus ab alias facere quasi odio maiores delectus commodi dolor blanditiis laudantium minima labore, tempora.</p>\n<h3>Optio odio blanditiis vitae.</h3>\n<p>Autem quam sint, aliquam ipsum beatae, dolorem, minima explicabo nobis earum cumque labore sapiente veniam! Fugit.</p>\n<h5>Illo praesentium, enim dolores eos.</h5>\n<p>Accusantium laborum molestiae, vitae neque cupiditate harum. Quasi molestias nemo fugiat excepturi modi facilis reprehenderit numquam hic, vitae ratione atque officiis blanditiis sint repudiandae maiores nisi minima autem in labore asperiores aspernatur at.</p>", "Placeat, natus, est!", "Repellendus aliquid, sunt! Ea maxime eligendi dicta, animi quas consequatur natus dolore placeat impedit, alias reiciendis. Veritatis consectetur veniam nisi porro.", "inherit", "closed", "closed", "", "22-autosave-v1", "", "", "2016-07-03 21:11:21", "2016-07-03 21:11:21", "", "22", "http://localhost:8888/themingbasics/politics/22-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("165", "1", "2016-07-03 21:11:23", "2016-07-03 21:11:23", "<h2>Voluptatum, minima.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugiat fugit veritatis veniam facere modi, inventore ipsum possimus quo quibusdam. Laborum possimus nulla ducimus quo ipsa provident dignissimos aliquam esse aut quae, ut fuga, dolorum quod expedita? Minima sint in laboriosam quia similique, dolor vitae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolor quae, blanditiis, reiciendis ab debitis repellat esse?</p>\r\n<p>Libero suscipit id dolore doloribus minima sequi fugit similique nulla, esse nobis nesciunt numquam saepe commodi velit repellendus eos illum molestiae ipsum quam! Neque voluptates atque aliquid impedit, cumque voluptatibus ab alias facere quasi odio maiores delectus commodi dolor blanditiis laudantium minima labore, tempora.</p>\r\n<h3>Optio odio blanditiis vitae.</h3>\r\n<p>Autem quam sint, aliquam ipsum beatae, dolorem, minima explicabo nobis earum cumque labore sapiente veniam! Fugit.</p>\r\n<h5>Illo praesentium, enim dolores eos.</h5>\r\n<p>Accusantium laborum molestiae, vitae neque cupiditate harum. Quasi molestias nemo fugiat excepturi modi facilis reprehenderit numquam hic, vitae ratione atque officiis blanditiis sint repudiandae maiores nisi minima autem in labore asperiores aspernatur at.</p>", "Placeat, natus, est!", "Repellendus aliquid, sunt! Ea maxime eligendi dicta, animi quas consequatur natus dolore placeat impedit, alias reiciendis. Veritatis consectetur veniam nisi porro.", "inherit", "closed", "closed", "", "22-revision-v1", "", "", "2016-07-03 21:11:23", "2016-07-03 21:11:23", "", "22", "http://localhost:8888/themingbasics/politics/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("166", "1", "2016-07-03 21:11:32", "2016-07-03 21:11:32", "<h2>Perspiciatis, quas.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Neque perferendis et magni sunt, rerum modi quae commodi aliquam vitae libero facere soluta perspiciatis blanditiis repellat maxime repellendus, nesciunt totam. Aspernatur impedit animi labore magni quidem ut fugiat quod facilis natus similique? Eveniet quia, velit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente a dolor distinctio minima, in sed obcaecati!</p>\r\n<p>Numquam unde harum beatae eos modi iste esse inventore libero adipisci nobis nostrum accusamus necessitatibus quae molestiae, reprehenderit repellat. Exercitationem harum, minus veniam ad iste atque nesciunt enim assumenda. Atque quo eaque rerum commodi voluptas consequatur harum qui nisi, eligendi, vero, nesciunt alias, nam?</p>\r\n<h3>Deleniti esse, et ex.</h3>\r\n<p>Blanditiis praesentium vitae, consequatur dignissimos beatae itaque quis perferendis, unde, illo sint minima laborum dolorum, possimus.</p>\r\n<h5>Enim officiis facere repellendus odit.</h5>\r\n<p>Hic magnam alias recusandae minima praesentium ipsam dolore eligendi aut commodi maxime tempora nam laudantium, ab accusamus facere doloribus quidem soluta. At cum quasi suscipit nobis eos harum libero, soluta aspernatur, modi sequi.</p>", "Similique, eius, maxime.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2016-07-03 21:11:32", "2016-07-03 21:11:32", "", "21", "http://localhost:8888/themingbasics/politics/21-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("167", "1", "2016-07-03 21:11:42", "2016-07-03 21:11:42", "<h2>Labore, repellendus?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente, quisquam, harum. Consequuntur consectetur, voluptatibus mollitia. Unde voluptate ullam doloremque eos commodi in doloribus suscipit, facilis nam quas tenetur ratione obcaecati, sit vel laboriosam. Iste porro quasi aliquid modi fugiat consectetur assumenda, accusantium dolor obcaecati?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Exercitationem et hic consequuntur eaque facere, totam expedita.</p>\r\n<p>Error sunt deleniti placeat recusandae, magni est labore pariatur necessitatibus. Quam harum dolorum quas sed optio esse eum nulla quibusdam. Provident laborum, sapiente error perspiciatis a fugit cumque modi mollitia laudantium architecto animi voluptatum, beatae dolores. Exercitationem quisquam atque tempora dicta ipsa, veniam quas.</p>\r\n<h3>Ea nesciunt ex totam?</h3>\r\n<p>Velit, asperiores iste odit porro beatae quis! Itaque ipsam, delectus culpa dolores deserunt non odio quae.</p>\r\n<h5>Nihil iusto fugiat sit, eveniet!</h5>\r\n<p>Ipsa neque, autem voluptates enim non provident. Magni culpa modi obcaecati dolorum vero. Nostrum deserunt harum deleniti, magni provident necessitatibus, sit, impedit dolor porro rerum quis, non. Tempora qui expedita enim, amet aut.</p>", "Sunt, exercitationem, dignissimos.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "20-revision-v1", "", "", "2016-07-03 21:11:42", "2016-07-03 21:11:42", "", "20", "http://localhost:8888/themingbasics/politics/20-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("168", "1", "2016-07-03 21:11:46", "2016-07-03 21:11:46", "<h2>Accusantium, qui.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequatur iure ab rerum voluptate aspernatur repellendus quis, temporibus quaerat quae, impedit sit fugit, accusamus, doloremque unde! Tempora, et, quod. Sunt tempora repellendus dolorem minima? Quos minus eligendi vel mollitia enim optio perspiciatis eaque cum, perferendis.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Veritatis modi natus assumenda obcaecati voluptates amet ut!</p>\r\n<p>Ratione iure pariatur tempore voluptatem quisquam aliquid minus placeat? Corporis necessitatibus molestias nesciunt quod ut error inventore minus porro nulla ea explicabo illo magni ab quae, incidunt, laudantium perferendis suscipit quos sed. Perspiciatis libero, cupiditate omnis laborum aliquid quia, laboriosam placeat illo distinctio vero!</p>\r\n<h3>Accusantium, eaque rem placeat?</h3>\r\n<p>Debitis libero qui accusantium cupiditate! Quos tempora quam fugit, autem assumenda quibusdam aliquam quo tenetur atque!</p>\r\n<h5>Eius beatae consequatur ullam tempora?</h5>\r\n<p>Quod commodi minima hic fugiat at unde ipsam qui. Facere architecto, maiores incidunt fugit delectus ab laboriosam quaerat iure ex! Eos reprehenderit magni laudantium cum autem harum nihil, fuga tempore, aliquam corrupti quo.</p>", "Harum, non quaerat.", "Repellendus aliquid, sunt! Ea maxime eligendi dicta, animi quas consequatur natus dolore placeat impedit, alias reiciendis. Veritatis consectetur veniam nisi porro.", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2016-07-03 21:11:46", "2016-07-03 21:11:46", "", "19", "http://localhost:8888/themingbasics/politics/19-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("169", "1", "2016-07-03 21:11:55", "2016-07-03 21:11:55", "<h2>Placeat, ullam!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Corrupti, consequatur modi? Eius, pariatur, maiores reprehenderit, animi dolores velit cupiditate minus distinctio labore laudantium mollitia beatae neque at vero omnis corporis quos. Accusantium harum exercitationem, labore repellat autem voluptates dicta pariatur itaque doloribus sapiente rerum?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consectetur perspiciatis dolorem, eaque debitis aut eveniet commodi.</p>\r\n<p>Incidunt repellendus dolores amet earum asperiores accusantium magni dignissimos reiciendis repudiandae, ducimus non nostrum doloremque iste quos, minus veritatis nam architecto nihil aliquid, aperiam porro dolore illo. Aut magnam architecto, saepe id aliquid veritatis nihil labore reprehenderit voluptas accusantium, dolore at tempore, quis. Ea!</p>\r\n<h3>Velit, aperiam porro vitae!</h3>\r\n<p>Qui nostrum, alias vero, iste, expedita dolorum exercitationem modi facere eius, impedit veniam pariatur. Quod, ad.</p>\r\n<h5>Quasi eos qui sit nobis!</h5>\r\n<p>Delectus iusto repudiandae veniam corrupti repellendus quidem. Nulla autem voluptates totam voluptate, ex consequatur optio laboriosam. Odio distinctio possimus non, adipisci dolores totam doloribus ducimus a porro, tempore repellendus ipsam quisquam nihil atque.</p>", "Ab, explicabo, aspernatur.", "Assumenda dolorem excepturi molestiae quos. Ratione temporibus, dolor aperiam tenetur ipsa autem, rem, odit dolorum, tempore dolores nihil atque architecto saepe.", "inherit", "closed", "closed", "", "18-revision-v1", "", "", "2016-07-03 21:11:55", "2016-07-03 21:11:55", "", "18", "http://localhost:8888/themingbasics/politics/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("170", "1", "2016-07-03 21:12:10", "2016-07-03 21:12:10", "<h2>Hic, ex.</h2>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio, molestiae, ducimus. Maiores, eos expedita itaque officia impedit voluptatem possimus, autem dignissimos laboriosam laudantium provident, natus? Sit soluta cumque ex placeat quisquam odit aperiam, minus. Odit quis natus, est rerum, reprehenderit voluptates dignissimos corporis amet.</p>\n<h3>Lorem ipsum dolor sit.</h3>\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Repellat delectus exercitationem, molestiae. Velit doloremque, doloribus impedit.</p>\n<p>Modi accusantium quia nam, hic distinctio possimus rem commodi cum beatae, pariatur, vel voluptatibus eos consectetur architecto consequuntur nemo a quaerat quo corporis iusto suscipit deleniti dolorem. Tempora laborum, est non dicta! Sed accusantium assumenda ex tenetur explicabo ad expedita neque dignissimos corrupti mollitia.</p>\n<h3>Modi sint, laudantium provident.</h3>\n<p>Sapiente debitis necessitatibus aspernatur, aut vero tempore atque magni molestias totam odio, non sint dignissimos ratione?</p>\n<h5>Sapiente porro illo dolor enim!</h5>\n<p>Laboriosam accusamus eius, deserunt odit fuga, voluptas maiores adipisci magnam officia iusto facere recusandae amet itaque molestiae animi! Porro libero excepturi laudantium provident repudiandae, iure rerum cupiditate voluptates praesentium explicabo. Dolores, error temporibus.</p>", "Sint, atque, minima?", "Repellendus aliquid, sunt! Ea maxime eligendi dicta, animi quas consequatur natus dolore placeat impedit, alias reiciendis. Veritatis consectetur veniam nisi porro.", "inherit", "closed", "closed", "", "17-autosave-v1", "", "", "2016-07-03 21:12:10", "2016-07-03 21:12:10", "", "17", "http://localhost:8888/themingbasics/politics/17-autosave-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("171", "1", "2016-07-03 21:12:40", "2016-07-03 21:12:40", "<h2>Hic, ex.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio, molestiae, ducimus. Maiores, eos expedita itaque officia impedit voluptatem possimus, autem dignissimos laboriosam laudantium provident, natus? Sit soluta cumque ex placeat quisquam odit aperiam, minus. Odit quis natus, est rerum, reprehenderit voluptates dignissimos corporis amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Repellat delectus exercitationem, molestiae. Velit doloremque, doloribus impedit.</p>\r\n<p>Modi accusantium quia nam, hic distinctio possimus rem commodi cum beatae, pariatur, vel voluptatibus eos consectetur architecto consequuntur nemo a quaerat quo corporis iusto suscipit deleniti dolorem. Tempora laborum, est non dicta! Sed accusantium assumenda ex tenetur explicabo ad expedita neque dignissimos corrupti mollitia.</p>\r\n<h3>Modi sint, laudantium provident.</h3>\r\n<p>Sapiente debitis necessitatibus aspernatur, aut vero tempore atque magni molestias totam odio, non sint dignissimos ratione?</p>\r\n<h5>Sapiente porro illo dolor enim!</h5>\r\n<p>Laboriosam accusamus eius, deserunt odit fuga, voluptas maiores adipisci magnam officia iusto facere recusandae amet itaque molestiae animi! Porro libero excepturi laudantium provident repudiandae, iure rerum cupiditate voluptates praesentium explicabo. Dolores, error temporibus.</p>", "Sint, atque, minima?", "First to arrive is Mr. Wiggin (John Cleese), who describes his architectural design and modern construction, and then explains his killing technique starting with a conveyor belt and \'rotating knives\'. It turns out that Mr. Wiggin mainly designs slaughterhouses and has misunderstood the owners\' attitude to their tenants. When Mr. Wiggin fails to persuade them to accept his \'real beaut\' of a design, he launches into an impassioned tirade against \'you non-creative garbage\' and blackballing Freemasons. When they still reject his design, however, he begs the increasingly uncomfortable City gents to accept him into the Freemasons.", "inherit", "closed", "closed", "", "17-revision-v1", "", "", "2016-07-03 21:12:40", "2016-07-03 21:12:40", "", "17", "http://localhost:8888/themingbasics/politics/17-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("172", "1", "2016-07-03 21:13:26", "2016-07-03 21:13:26", "<h2>Placeat, ullam!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Corrupti, consequatur modi? Eius, pariatur, maiores reprehenderit, animi dolores velit cupiditate minus distinctio labore laudantium mollitia beatae neque at vero omnis corporis quos. Accusantium harum exercitationem, labore repellat autem voluptates dicta pariatur itaque doloribus sapiente rerum?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consectetur perspiciatis dolorem, eaque debitis aut eveniet commodi.</p>\r\n<p>Incidunt repellendus dolores amet earum asperiores accusantium magni dignissimos reiciendis repudiandae, ducimus non nostrum doloremque iste quos, minus veritatis nam architecto nihil aliquid, aperiam porro dolore illo. Aut magnam architecto, saepe id aliquid veritatis nihil labore reprehenderit voluptas accusantium, dolore at tempore, quis. Ea!</p>\r\n<h3>Velit, aperiam porro vitae!</h3>\r\n<p>Qui nostrum, alias vero, iste, expedita dolorum exercitationem modi facere eius, impedit veniam pariatur. Quod, ad.</p>\r\n<h5>Quasi eos qui sit nobis!</h5>\r\n<p>Delectus iusto repudiandae veniam corrupti repellendus quidem. Nulla autem voluptates totam voluptate, ex consequatur optio laboriosam. Odio distinctio possimus non, adipisci dolores totam doloribus ducimus a porro, tempore repellendus ipsam quisquam nihil atque.</p>", "Ab, explicabo, aspernatur.", "Once Wiggin has been persuaded to leave, the second architect, Mr. Leavey (Eric Idle), arrives. As Mr. Leavey describes the strong construction and safety features of his design, his model collapses and catches fire in the manner of the recent Ronan Point disaster, accompanied by a large on-screen caption reading \'SATIRE\'.", "inherit", "closed", "closed", "", "18-revision-v1", "", "", "2016-07-03 21:13:26", "2016-07-03 21:13:26", "", "18", "http://localhost:8888/themingbasics/politics/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("173", "1", "2016-07-03 21:13:56", "2016-07-03 21:13:56", "<h2>Dolorum, veritatis.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ea, sapiente fuga nisi doloribus cum fugit nobis reiciendis expedita sint repellendus. Ad minus at consectetur tempora assumenda, ullam fuga blanditiis eligendi natus a delectus eaque voluptatum obcaecati quod nesciunt, inventore doloribus ratione! Obcaecati, eaque, impedit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ipsam quisquam consequuntur dolorem, ad consectetur numquam in!</p>\r\n<p>Quaerat fugit numquam veritatis exercitationem itaque, perferendis earum nisi libero, ipsum facere ipsam quos non animi molestias illo quae modi tenetur nemo eligendi mollitia nam cupiditate error natus debitis vel! Earum illum neque aliquid ea commodi eaque similique, aliquam qui rerum, reprehenderit? Et, aperiam.</p>\r\n<h3>Nisi dolorem non sit.</h3>\r\n<p>Dolore mollitia eveniet voluptate aliquid quasi amet nam, eius! Id quia iste, praesentium repellat quaerat mollitia.</p>\r\n<h5>Iste vitae quisquam consequuntur laborum.</h5>\r\n<p>Nostrum non, repellat fugiat reprehenderit eaque, qui, odio error laborum consectetur nam veritatis tempora consequuntur tenetur officia earum, minus temporibus alias asperiores reiciendis quas esse eius quibusdam. Dolor quibusdam modi, laudantium nam beatae.</p>", "Iste, veritatis, odit?", "Good morning, gentlemen. This is a twelwe-storey block combining classical neo-Georgian features with the efficiency of modern techniques. The tenants arrive in the entrance hall here, and are carried along the corridor on a conveyor belt in extreme comfort and past murals depicting Mediterranean scenes, towards the rotating knives. The last twenty feet of the corridor are heavily soundproofed. The blood pours down these chutes and the mangled flesh slurps into these..", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2016-07-03 21:13:56", "2016-07-03 21:13:56", "", "16", "http://localhost:8888/themingbasics/politics/16-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("174", "1", "2016-07-03 21:17:09", "2016-07-03 21:17:09", "<h2>Dolores, adipisci!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam facilis, eveniet neque aut, similique amet ea fugiat minima sint hic. Doloremque odio consectetur enim, assumenda odit praesentium vero eligendi beatae maiores cumque libero nobis inventore omnis magni laborum error repudiandae, rem ex. Nemo, maiores.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate, quis a sit quibusdam! Assumenda, similique ullam!</p>\r\n<p>Deserunt tempora, pariatur ratione soluta maiores sint. Eligendi dignissimos officia provident voluptates rem facere iure expedita ea accusamus eveniet. Dolore sapiente velit culpa eaque saepe recusandae blanditiis totam placeat alias distinctio laboriosam asperiores sunt, qui ipsum ab quidem expedita amet laborum neque id praesentium.</p>\r\n<h3>Atque, deleniti rerum similique.</h3>\r\n<p>Asperiores nihil perspiciatis, culpa non. Aspernatur eaque aperiam repellendus tempore ab quia facere alias maxime sint.</p>\r\n<h5>Fuga, voluptates. Consectetur, labore, molestiae.</h5>\r\n<p>Odit error obcaecati architecto sed veniam consequatur quidem aliquam optio, laudantium consequuntur fugit laborum ab rerum doloremque. A provident quae id, iste modi, ex velit vitae nemo quaerat illum esse voluptatibus, quas maxime.</p>", "Incidunt, dolore qui.", "Rosa Luxemburg (also Rozalia Luxenburg; Polish: Róża Luksemburg; 5 March 1871[1] – 15 January 1919) was a Marxist theorist, philosopher, economist and revolutionary socialist of Polish-Jewish descent who became a naturalized German citizen. She was, successively, a member of the Social Democracy of the Kingdom of Poland and Lithuania (SDKPiL), the Social Democratic Party of Germany (SPD), the Independent Social Democratic Party (USPD), and the Communist Party of Germany (KPD).", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2016-07-03 21:17:09", "2016-07-03 21:17:09", "", "24", "http://localhost:8888/themingbasics/politics/24-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("175", "1", "2016-07-03 21:17:18", "2016-07-03 21:17:18", "<h2>Consequuntur, quo.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Maiores soluta recusandae et, eaque quo ratione repellendus explicabo debitis, ipsum nisi excepturi quisquam deleniti accusamus necessitatibus. Ipsam ad quam tenetur, nisi at velit dolorum ducimus exercitationem veritatis, officia animi! Corrupti ratione dignissimos accusantium eum quae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequuntur sint magni officia, doloremque perferendis. Laborum, fugit.</p>\r\n<p>Non ut animi fugiat suscipit quisquam odio, est, distinctio temporibus ratione. Consequuntur, labore non maxime deleniti alias adipisci eos odio maiores debitis! Nisi maxime id eos. Odio dicta voluptatem doloremque, quo, iste quidem laboriosam laborum possimus illo alias amet placeat assumenda libero quasi vitae!</p>\r\n<h3>Ipsa, nam fugit quia.</h3>\r\n<p>Vel repellat quae recusandae omnis beatae dolor ut maiores, libero voluptates, rem, veniam tenetur eius at.</p>\r\n<h5>Eveniet minima fuga, illo saepe!</h5>\r\n<p>Nobis rerum error necessitatibus veritatis accusantium, ex quam hic eligendi magni dolore aliquam, optio excepturi nostrum deleniti vero maxime, ducimus iusto natus fugit. Ipsa ad quasi alias fugit inventore delectus, tempora minima ipsam!</p>", "Tempora, voluptate, quibusdam.", "In 1915, after the SPD supported German involvement in World War I, she and Karl Liebknecht co-founded the anti-war Spartacus League (Spartakusbund), which eventually became the KPD. During the November Revolution she co-founded the newspaper Die Rote Fahne (\"The Red Flag\"), the central organ of the Spartacist movement.", "inherit", "closed", "closed", "", "34-revision-v1", "", "", "2016-07-03 21:17:18", "2016-07-03 21:17:18", "", "34", "http://localhost:8888/themingbasics/politics/34-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("176", "1", "2016-07-03 21:17:33", "2016-07-03 21:17:33", "<h2>Omnis, corporis!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Recusandae voluptate doloribus aliquam minus, aut hic error quos amet totam, omnis, fugiat voluptates officiis natus voluptatem quaerat. Ratione optio voluptate quibusdam dolore natus, laboriosam quos culpa aliquam a expedita libero! Libero, animi. Iste, minus. Voluptas.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Nihil, laborum distinctio quisquam ratione repellendus, sunt voluptas!</p>\r\n<p>Maiores cupiditate dolorem neque sint ipsam incidunt qui inventore ea eos dolor eius accusamus quod sed maxime laboriosam sequi non quibusdam, vero, minima officiis cumque quam? Accusamus corporis ad blanditiis officia quidem, error ab nulla tempore dolorum eligendi. Veniam libero excepturi vitae sed expedita?</p>\r\n<h3>Sed tempore, culpa beatae.</h3>\r\n<p>Quia provident expedita vitae deleniti tenetur voluptatum, voluptates reprehenderit a, eum iure est quod, ipsa optio.</p>\r\n<h5>Praesentium reiciendis omnis autem aliquam.</h5>\r\n<p>Earum reprehenderit dolorum aliquid praesentium nostrum nemo eum iste veniam adipisci nisi! Illo adipisci non hic dolorem enim, commodi, recusandae unde minus alias molestiae quas saepe iusto architecto modi magnam eum, sunt vero.</p>", "Ex ducimus, accusamus?", "She considered the Spartacist uprising of January 1919 a blunder,[2] but supported it as events unfolded. Friedrich Ebert\'s majority Social Democratic government crushed the revolt and the Spartakusbund by sending in the Freikorps (government-sponsored paramilitary groups consisting mostly of World War I veterans). Freikorps troops captured and murdered Luxemburg and Liebknecht. Luxemburg\'s body was thrown in the Landwehr Canal in Berlin.\r\n", "inherit", "closed", "closed", "", "27-revision-v1", "", "", "2016-07-03 21:17:33", "2016-07-03 21:17:33", "", "27", "http://localhost:8888/themingbasics/politics/27-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("177", "1", "2016-07-03 21:17:42", "2016-07-03 21:17:42", "<h2>Voluptatum, minima.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugiat fugit veritatis veniam facere modi, inventore ipsum possimus quo quibusdam. Laborum possimus nulla ducimus quo ipsa provident dignissimos aliquam esse aut quae, ut fuga, dolorum quod expedita? Minima sint in laboriosam quia similique, dolor vitae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolor quae, blanditiis, reiciendis ab debitis repellat esse?</p>\r\n<p>Libero suscipit id dolore doloribus minima sequi fugit similique nulla, esse nobis nesciunt numquam saepe commodi velit repellendus eos illum molestiae ipsum quam! Neque voluptates atque aliquid impedit, cumque voluptatibus ab alias facere quasi odio maiores delectus commodi dolor blanditiis laudantium minima labore, tempora.</p>\r\n<h3>Optio odio blanditiis vitae.</h3>\r\n<p>Autem quam sint, aliquam ipsum beatae, dolorem, minima explicabo nobis earum cumque labore sapiente veniam! Fugit.</p>\r\n<h5>Illo praesentium, enim dolores eos.</h5>\r\n<p>Accusantium laborum molestiae, vitae neque cupiditate harum. Quasi molestias nemo fugiat excepturi modi facilis reprehenderit numquam hic, vitae ratione atque officiis blanditiis sint repudiandae maiores nisi minima autem in labore asperiores aspernatur at.</p>", "Placeat, natus, est!", "Due to her pointed criticism of both the Leninist and the more moderate social democratic schools of socialism, Luxemburg has had a somewhat ambivalent reception among scholars and theorists of the political left.[3] Nonetheless, some have regarded Luxemburg and Liebknecht as martyrs of the socialist cause.", "inherit", "closed", "closed", "", "22-revision-v1", "", "", "2016-07-03 21:17:42", "2016-07-03 21:17:42", "", "22", "http://localhost:8888/themingbasics/politics/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("178", "1", "2016-07-03 21:19:04", "2016-07-03 21:19:04", "<h2>Eligendi, consequuntur.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia tempore ullam autem cupiditate voluptate natus omnis temporibus, totam beatae repellat nihil dolor pariatur impedit fuga voluptatibus dicta sit eum, est tempora amet. Sint in odio, dicta ut vero quaerat dolore aliquid itaque dolores quas!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto cumque, ducimus, facere minima velit fugit omnis.</p>\r\n<p>Eveniet, beatae quidem, excepturi quas dolor, aliquid doloribus perspiciatis rem fugit illum unde libero, numquam quibusdam aliquam architecto dolorem minus odit dicta consequatur. Impedit aperiam, ullam esse. Id dolore sint minima repellat, error doloribus, laudantium non, cumque assumenda expedita mollitia laborum laboriosam quo. Sit.</p>\r\n<h3>Cupiditate repudiandae doloribus voluptates.</h3>\r\n<p>Iure dolorum, doloribus ex, accusantium soluta qui cum asperiores iste aspernatur praesentium nostrum tenetur, ratione dolorem.</p>\r\n<h5>Quibusdam neque cupiditate voluptate expedita!</h5>\r\n<p>In voluptatibus sint, repellendus nostrum magni veritatis temporibus provident nesciunt totam, soluta minus quisquam consequatur, excepturi non culpa. Culpa dolor labore consectetur repellendus amet, dolore consequatur, aut. Enim voluptatum quia molestias commodi culpa!</p>", "Facere asperiores, laudantium.", "The Vexter Fuzz Factory is a five-knob fuzz using two new old-stock sixties germanium transistors. It’s one of the most versatile Fuzz pedals on the market. Its circuit is not modeled after any classic fuzz design", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2016-07-03 21:19:04", "2016-07-03 21:19:04", "", "30", "http://localhost:8888/themingbasics/politics/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("179", "1", "2016-07-03 21:19:58", "2016-07-03 21:19:58", "<h2>Earum, dicta?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Itaque similique consequatur nisi id consequuntur ipsum repudiandae ipsam beatae nulla sunt, fugit vel animi voluptas nesciunt, unde molestiae ducimus corrupti voluptates placeat velit quidem veritatis nobis aliquid? Rem, nam laudantium id aspernatur recusandae voluptatibus ratione.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Reprehenderit ipsum expedita quos sequi quidem recusandae commodi?</p>\r\n<p>Illo tempora debitis nisi et, sint, velit porro consequuntur quas officiis inventore quos aliquam dolores earum mollitia distinctio, corrupti doloribus culpa amet aliquid accusantium neque impedit maiores quisquam esse. Odit vero quaerat ipsam fugiat impedit non rerum nam, iusto sint, dignissimos sapiente, eligendi eum.</p>\r\n<h3>Ducimus sed impedit corporis?</h3>\r\n<p>Excepturi porro unde voluptate! Error at similique beatae pariatur optio, unde ullam omnis temporibus, dolorum perspiciatis?</p>\r\n<h5>Eaque ex recusandae assumenda cupiditate.</h5>\r\n<p>Nostrum aliquid, similique odit nobis tempore expedita, error vero, a tenetur aliquam aperiam placeat. Ex debitis voluptatum quibusdam, autem tenetur, eligendi dignissimos aspernatur, error libero nemo accusantium at quisquam reiciendis eaque voluptas non!</p>", "Nihil, amet minima.", "Often with emphasis on another effect such as scrambling, gating or tremolo. Some effects also utilize unusual features such as built in photoresistors, joysticks and effects loops. ", "inherit", "closed", "closed", "", "25-revision-v1", "", "", "2016-07-03 21:19:58", "2016-07-03 21:19:58", "", "25", "http://localhost:8888/themingbasics/politics/25-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("180", "1", "2016-07-03 21:21:19", "2016-07-03 21:21:19", "<h2>Hic, ex.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Optio, molestiae, ducimus. Maiores, eos expedita itaque officia impedit voluptatem possimus, autem dignissimos laboriosam laudantium provident, natus? Sit soluta cumque ex placeat quisquam odit aperiam, minus. Odit quis natus, est rerum, reprehenderit voluptates dignissimos corporis amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Repellat delectus exercitationem, molestiae. Velit doloremque, doloribus impedit.</p>\r\n<p>Modi accusantium quia nam, hic distinctio possimus rem commodi cum beatae, pariatur, vel voluptatibus eos consectetur architecto consequuntur nemo a quaerat quo corporis iusto suscipit deleniti dolorem. Tempora laborum, est non dicta! Sed accusantium assumenda ex tenetur explicabo ad expedita neque dignissimos corrupti mollitia.</p>\r\n<h3>Modi sint, laudantium provident.</h3>\r\n<p>Sapiente debitis necessitatibus aspernatur, aut vero tempore atque magni molestias totam odio, non sint dignissimos ratione?</p>\r\n<h5>Sapiente porro illo dolor enim!</h5>\r\n<p>Laboriosam accusamus eius, deserunt odit fuga, voluptas maiores adipisci magnam officia iusto facere recusandae amet itaque molestiae animi! Porro libero excepturi laudantium provident repudiandae, iure rerum cupiditate voluptates praesentium explicabo. Dolores, error temporibus.</p>", "Sint, atque, minima?", "First to arrive is Mr. Wiggin, who describes his architectural design and modern construction, and then explains his killing technique starting with a conveyor belt and \'rotating knives\'. It turns out that Mr. Wiggin mainly designs slaughterhouses and has misunderstood the owners\' attitude to their tenants. ", "inherit", "closed", "closed", "", "17-revision-v1", "", "", "2016-07-03 21:21:19", "2016-07-03 21:21:19", "", "17", "http://localhost:8888/themingbasics/politics/17-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("181", "1", "2016-07-03 21:21:40", "2016-07-03 21:21:40", "<h2>Accusantium, qui.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequatur iure ab rerum voluptate aspernatur repellendus quis, temporibus quaerat quae, impedit sit fugit, accusamus, doloremque unde! Tempora, et, quod. Sunt tempora repellendus dolorem minima? Quos minus eligendi vel mollitia enim optio perspiciatis eaque cum, perferendis.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Veritatis modi natus assumenda obcaecati voluptates amet ut!</p>\r\n<p>Ratione iure pariatur tempore voluptatem quisquam aliquid minus placeat? Corporis necessitatibus molestias nesciunt quod ut error inventore minus porro nulla ea explicabo illo magni ab quae, incidunt, laudantium perferendis suscipit quos sed. Perspiciatis libero, cupiditate omnis laborum aliquid quia, laboriosam placeat illo distinctio vero!</p>\r\n<h3>Accusantium, eaque rem placeat?</h3>\r\n<p>Debitis libero qui accusantium cupiditate! Quos tempora quam fugit, autem assumenda quibusdam aliquam quo tenetur atque!</p>\r\n<h5>Eius beatae consequatur ullam tempora?</h5>\r\n<p>Quod commodi minima hic fugiat at unde ipsam qui. Facere architecto, maiores incidunt fugit delectus ab laboriosam quaerat iure ex! Eos reprehenderit magni laudantium cum autem harum nihil, fuga tempore, aliquam corrupti quo.</p>", "Harum, non quaerat.", "When Mr. Wiggin fails to persuade them to accept his \'real beaut\' of a design, he launches into an impassioned tirade against \'you non-creative garbage\' and blackballing Freemasons. When they still reject his design, however, he begs the increasingly uncomfortable City gents to accept him into the Freemasons.", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2016-07-03 21:21:40", "2016-07-03 21:21:40", "", "19", "http://localhost:8888/themingbasics/politics/19-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("182", "1", "2016-07-03 21:22:57", "2016-07-03 21:22:57", "<h2>Quos, veritatis.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Eaque temporibus, totam corporis voluptatibus voluptate accusamus repellendus, unde veniam magnam non sit magni molestiae ratione dolor velit expedita voluptas sequi ducimus nobis nam. Facere quod vel illum doloribus, rerum minima non harum. Pariatur, totam, officia.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate velit nam voluptates, accusamus perspiciatis! Maiores, ut?</p>\r\n<p>Qui accusantium sit dolorem nulla eum ut nemo praesentium ipsa quibusdam incidunt beatae obcaecati porro quisquam, voluptatum eveniet nostrum et, cumque iure aut. Asperiores molestiae maiores dolorum, commodi eaque necessitatibus autem dolore omnis quia, quos qui laborum eos. Accusamus facere architecto cupiditate adipisci ratione.</p>\r\n<h3>Culpa dolorum id, veritatis.</h3>\r\n<p>Ea hic dolorem tempora id doloribus. Minima libero quas nisi commodi, perferendis doloribus, possimus corporis rem!</p>\r\n<h5>Dicta, laborum ipsum tempore quibusdam?</h5>\r\n<p>Suscipit veritatis officiis hic commodi perspiciatis, autem illum nihil reprehenderit, possimus animi error provident quis alias, rem ipsa dolores eligendi ratione obcaecati fuga reiciendis unde, itaque quas. Officia praesentium quis vel iure hic.</p>", "Quibusdam enim, corporis.", "MESA was started by Randall Smith as a small repair shop which modified Fender Amplifiers, particularly the diminutive Fender Princeton. Smith\'s modifications gave the small amps much more input gain, making them much louder as well as creating a high-gain, distorted guitar tone. ", "inherit", "closed", "closed", "", "14-revision-v1", "", "", "2016-07-03 21:22:57", "2016-07-03 21:22:57", "", "14", "http://localhost:8888/themingbasics/politics/14-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("184", "1", "2016-07-12 01:52:29", "2016-07-12 01:52:29", "<h2>Eligendi, consequuntur.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia tempore ullam autem cupiditate voluptate natus omnis temporibus, totam beatae repellat nihil dolor pariatur impedit fuga voluptatibus dicta sit eum, est tempora amet. Sint in odio, dicta ut vero quaerat dolore aliquid itaque dolores quas!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Architecto cumque, ducimus, facere minima velit fugit omnis.</p>\r\n<p>Eveniet, beatae quidem, excepturi quas dolor, aliquid doloribus perspiciatis rem fugit illum unde libero, numquam quibusdam aliquam architecto dolorem minus odit dicta consequatur. Impedit aperiam, ullam esse. Id dolore sint minima repellat, error doloribus, laudantium non, cumque assumenda expedita mollitia laborum laboriosam quo. Sit.</p>\r\n<h3>Cupiditate repudiandae doloribus voluptates.</h3>\r\n<p>Iure dolorum, doloribus ex, accusantium soluta qui cum asperiores iste aspernatur praesentium nostrum tenetur, ratione dolorem.</p>\r\n<h5>Quibusdam neque cupiditate voluptate expedita!</h5>\r\n<p>In voluptatibus sint, repellendus nostrum magni veritatis temporibus provident nesciunt totam, soluta minus quisquam consequatur, excepturi non culpa. Culpa dolor labore consectetur repellendus amet, dolore consequatur, aut. Enim voluptatum quia molestias commodi culpa!</p>", "Facere asperiores", "The Vexter Fuzz Factory is a five-knob fuzz using two new old-stock sixties germanium transistors. It’s one of the most versatile Fuzz pedals on the market. Its circuit is not modeled after any classic fuzz design", "inherit", "closed", "closed", "", "30-revision-v1", "", "", "2016-07-12 01:52:29", "2016-07-12 01:52:29", "", "30", "http://localhost:8888/theming-basics/politics/30-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("185", "1", "2016-07-12 01:52:37", "2016-07-12 01:52:37", "<h2>Labore, repellendus?</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente, quisquam, harum. Consequuntur consectetur, voluptatibus mollitia. Unde voluptate ullam doloremque eos commodi in doloribus suscipit, facilis nam quas tenetur ratione obcaecati, sit vel laboriosam. Iste porro quasi aliquid modi fugiat consectetur assumenda, accusantium dolor obcaecati?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Exercitationem et hic consequuntur eaque facere, totam expedita.</p>\r\n<p>Error sunt deleniti placeat recusandae, magni est labore pariatur necessitatibus. Quam harum dolorum quas sed optio esse eum nulla quibusdam. Provident laborum, sapiente error perspiciatis a fugit cumque modi mollitia laudantium architecto animi voluptatum, beatae dolores. Exercitationem quisquam atque tempora dicta ipsa, veniam quas.</p>\r\n<h3>Ea nesciunt ex totam?</h3>\r\n<p>Velit, asperiores iste odit porro beatae quis! Itaque ipsam, delectus culpa dolores deserunt non odio quae.</p>\r\n<h5>Nihil iusto fugiat sit, eveniet!</h5>\r\n<p>Ipsa neque, autem voluptates enim non provident. Magni culpa modi obcaecati dolorum vero. Nostrum deserunt harum deleniti, magni provident necessitatibus, sit, impedit dolor porro rerum quis, non. Tempora qui expedita enim, amet aut.</p>", "Exercitationem, dignissimos.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "20-revision-v1", "", "", "2016-07-12 01:52:37", "2016-07-12 01:52:37", "", "20", "http://localhost:8888/theming-basics/politics/20-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("186", "1", "2016-07-12 01:52:50", "2016-07-12 01:52:50", "<h2>Perspiciatis, quas.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Neque perferendis et magni sunt, rerum modi quae commodi aliquam vitae libero facere soluta perspiciatis blanditiis repellat maxime repellendus, nesciunt totam. Aspernatur impedit animi labore magni quidem ut fugiat quod facilis natus similique? Eveniet quia, velit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sapiente a dolor distinctio minima, in sed obcaecati!</p>\r\n<p>Numquam unde harum beatae eos modi iste esse inventore libero adipisci nobis nostrum accusamus necessitatibus quae molestiae, reprehenderit repellat. Exercitationem harum, minus veniam ad iste atque nesciunt enim assumenda. Atque quo eaque rerum commodi voluptas consequatur harum qui nisi, eligendi, vero, nesciunt alias, nam?</p>\r\n<h3>Deleniti esse, et ex.</h3>\r\n<p>Blanditiis praesentium vitae, consequatur dignissimos beatae itaque quis perferendis, unde, illo sint minima laborum dolorum, possimus.</p>\r\n<h5>Enim officiis facere repellendus odit.</h5>\r\n<p>Hic magnam alias recusandae minima praesentium ipsam dolore eligendi aut commodi maxime tempora nam laudantium, ab accusamus facere doloribus quidem soluta. At cum quasi suscipit nobis eos harum libero, soluta aspernatur, modi sequi.</p>", "Eius, maxime.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2016-07-12 01:52:50", "2016-07-12 01:52:50", "", "21", "http://localhost:8888/theming-basics/politics/21-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("188", "1", "2016-07-12 01:53:08", "2016-07-12 01:53:08", "<h2>Aspernatur, dolorem.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Saepe blanditiis amet distinctio inventore quibusdam dolorum eius sapiente molestiae laudantium nostrum labore fugit dolorem natus mollitia accusantium nulla exercitationem odit cumque facere quis, deserunt. Corporis doloremque cumque nesciunt consequatur debitis pariatur ea sit ducimus magni.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Unde iste provident consequatur dolorum non assumenda ipsam.</p>\r\n<p>Optio perferendis dolor ut beatae est dolorum vero hic vel quo earum nobis corporis, illo nihil nisi mollitia iure odio cum eligendi voluptatum, minima repudiandae ipsa reiciendis aliquid repellat officia. Id voluptatem possimus veritatis animi fugiat, eum quibusdam rerum voluptatum, ut pariatur suscipit, nostrum.</p>\r\n<h3>Dolor at debitis velit.</h3>\r\n<p>Necessitatibus dicta aliquid repellendus fuga laudantium vitae nisi voluptatem accusantium, quas neque fugit adipisci eligendi tenetur.</p>\r\n<h5>Voluptatum voluptas pariatur, saepe sequi?</h5>\r\n<p>Sunt non nihil quas possimus veniam dicta soluta ipsum deleniti, quos repellendus in inventore vero libero delectus enim voluptatem consectetur voluptatibus iure esse blanditiis! Delectus corrupti cupiditate quidem omnis et unde suscipit dolore.</p>", "Aliquam perspiciatis.", "", "inherit", "closed", "closed", "", "12-revision-v1", "", "", "2016-07-12 01:53:08", "2016-07-12 01:53:08", "", "12", "http://localhost:8888/theming-basics/politics/12-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("189", "1", "2016-07-12 01:53:17", "2016-07-12 01:53:17", "<h2>Placeat, ullam!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Corrupti, consequatur modi? Eius, pariatur, maiores reprehenderit, animi dolores velit cupiditate minus distinctio labore laudantium mollitia beatae neque at vero omnis corporis quos. Accusantium harum exercitationem, labore repellat autem voluptates dicta pariatur itaque doloribus sapiente rerum?</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consectetur perspiciatis dolorem, eaque debitis aut eveniet commodi.</p>\r\n<p>Incidunt repellendus dolores amet earum asperiores accusantium magni dignissimos reiciendis repudiandae, ducimus non nostrum doloremque iste quos, minus veritatis nam architecto nihil aliquid, aperiam porro dolore illo. Aut magnam architecto, saepe id aliquid veritatis nihil labore reprehenderit voluptas accusantium, dolore at tempore, quis. Ea!</p>\r\n<h3>Velit, aperiam porro vitae!</h3>\r\n<p>Qui nostrum, alias vero, iste, expedita dolorum exercitationem modi facere eius, impedit veniam pariatur. Quod, ad.</p>\r\n<h5>Quasi eos qui sit nobis!</h5>\r\n<p>Delectus iusto repudiandae veniam corrupti repellendus quidem. Nulla autem voluptates totam voluptate, ex consequatur optio laboriosam. Odio distinctio possimus non, adipisci dolores totam doloribus ducimus a porro, tempore repellendus ipsam quisquam nihil atque.</p>", "Ab, aspernatur.", "Once Wiggin has been persuaded to leave, the second architect, Mr. Leavey (Eric Idle), arrives. As Mr. Leavey describes the strong construction and safety features of his design, his model collapses and catches fire in the manner of the recent Ronan Point disaster, accompanied by a large on-screen caption reading \'SATIRE\'.", "inherit", "closed", "closed", "", "18-revision-v1", "", "", "2016-07-12 01:53:17", "2016-07-12 01:53:17", "", "18", "http://localhost:8888/theming-basics/politics/18-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("190", "1", "2016-07-12 01:53:25", "2016-07-12 01:53:25", "<h2>Temporibus, itaque!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quae ea eaque nulla est tempore, dolore laudantium at reprehenderit eius doloremque rem obcaecati ab accusantium, quisquam, cupiditate sequi hic! Quasi non autem debitis eveniet molestias quaerat, est reprehenderit optio totam necessitatibus temporibus tenetur, dolore consequatur!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis soluta, error explicabo atque nobis non neque.</p>\r\n<p>Accusamus praesentium laborum aut ullam provident veritatis excepturi quisquam reprehenderit obcaecati repudiandae. Porro iusto velit nulla unde cum minus saepe aliquid repellat a libero ullam reprehenderit praesentium sed laborum, doloribus fugiat natus perspiciatis veritatis minima? Officia provident delectus eum quas perferendis, ullam eligendi quos.</p>\r\n<h3>Aspernatur iste repudiandae obcaecati.</h3>\r\n<p>Consequuntur id eligendi provident, repellendus, ratione et facilis fuga. Ducimus consectetur cumque molestias nesciunt quas nam.</p>\r\n<h5>Autem soluta assumenda totam natus.</h5>\r\n<p>Voluptatum labore, ullam obcaecati odit natus maxime harum et debitis est, perspiciatis dolor rem facilis delectus! Expedita alias error blanditiis officiis officia. Cupiditate dolore est voluptas sapiente minus, molestiae nihil qui harum alias.</p>", "Facilis dignissimos.", "Commodi harum quod sed minima ea voluptatem obcaecati modi adipisci quia eaque libero distinctio explicabo eius illum optio, voluptates dolore! Rerum!\r\n", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2016-07-12 01:53:25", "2016-07-12 01:53:25", "", "26", "http://localhost:8888/theming-basics/politics/26-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("192", "1", "2016-07-12 01:54:13", "2016-07-12 01:54:13", "<h2>Consequuntur, quo.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Maiores soluta recusandae et, eaque quo ratione repellendus explicabo debitis, ipsum nisi excepturi quisquam deleniti accusamus necessitatibus. Ipsam ad quam tenetur, nisi at velit dolorum ducimus exercitationem veritatis, officia animi! Corrupti ratione dignissimos accusantium eum quae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Consequuntur sint magni officia, doloremque perferendis. Laborum, fugit.</p>\r\n<p>Non ut animi fugiat suscipit quisquam odio, est, distinctio temporibus ratione. Consequuntur, labore non maxime deleniti alias adipisci eos odio maiores debitis! Nisi maxime id eos. Odio dicta voluptatem doloremque, quo, iste quidem laboriosam laborum possimus illo alias amet placeat assumenda libero quasi vitae!</p>\r\n<h3>Ipsa, nam fugit quia.</h3>\r\n<p>Vel repellat quae recusandae omnis beatae dolor ut maiores, libero voluptates, rem, veniam tenetur eius at.</p>\r\n<h5>Eveniet minima fuga, illo saepe!</h5>\r\n<p>Nobis rerum error necessitatibus veritatis accusantium, ex quam hic eligendi magni dolore aliquam, optio excepturi nostrum deleniti vero maxime, ducimus iusto natus fugit. Ipsa ad quasi alias fugit inventore delectus, tempora minima ipsam!</p>", "Tempora, voluptate!", "In 1915, after the SPD supported German involvement in World War I, she and Karl Liebknecht co-founded the anti-war Spartacus League (Spartakusbund), which eventually became the KPD. During the November Revolution she co-founded the newspaper Die Rote Fahne (\"The Red Flag\"), the central organ of the Spartacist movement.", "inherit", "closed", "closed", "", "34-revision-v1", "", "", "2016-07-12 01:54:13", "2016-07-12 01:54:13", "", "34", "http://localhost:8888/theming-basics/politics/34-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("193", "1", "2016-07-12 01:54:20", "2016-07-12 01:54:20", "<h2>Dolores, adipisci!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Magnam facilis, eveniet neque aut, similique amet ea fugiat minima sint hic. Doloremque odio consectetur enim, assumenda odit praesentium vero eligendi beatae maiores cumque libero nobis inventore omnis magni laborum error repudiandae, rem ex. Nemo, maiores.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate, quis a sit quibusdam! Assumenda, similique ullam!</p>\r\n<p>Deserunt tempora, pariatur ratione soluta maiores sint. Eligendi dignissimos officia provident voluptates rem facere iure expedita ea accusamus eveniet. Dolore sapiente velit culpa eaque saepe recusandae blanditiis totam placeat alias distinctio laboriosam asperiores sunt, qui ipsum ab quidem expedita amet laborum neque id praesentium.</p>\r\n<h3>Atque, deleniti rerum similique.</h3>\r\n<p>Asperiores nihil perspiciatis, culpa non. Aspernatur eaque aperiam repellendus tempore ab quia facere alias maxime sint.</p>\r\n<h5>Fuga, voluptates. Consectetur, labore, molestiae.</h5>\r\n<p>Odit error obcaecati architecto sed veniam consequatur quidem aliquam optio, laudantium consequuntur fugit laborum ab rerum doloremque. A provident quae id, iste modi, ex velit vitae nemo quaerat illum esse voluptatibus, quas maxime.</p>", "Incidunt, qui.", "Rosa Luxemburg (also Rozalia Luxenburg; Polish: Róża Luksemburg; 5 March 1871[1] – 15 January 1919) was a Marxist theorist, philosopher, economist and revolutionary socialist of Polish-Jewish descent who became a naturalized German citizen. She was, successively, a member of the Social Democracy of the Kingdom of Poland and Lithuania (SDKPiL), the Social Democratic Party of Germany (SPD), the Independent Social Democratic Party (USPD), and the Communist Party of Germany (KPD).", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2016-07-12 01:54:20", "2016-07-12 01:54:20", "", "24", "http://localhost:8888/theming-basics/politics/24-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("194", "1", "2016-07-12 01:54:29", "2016-07-12 01:54:29", "<h2>Repudiandae, quidem!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Incidunt vero delectus quibusdam ipsam, tenetur exercitationem quasi. Debitis at, explicabo doloremque nesciunt consequuntur dicta qui quisquam. Perferendis illum vel veritatis autem quasi iusto nesciunt sequi, exercitationem odit ad aut, consequuntur ratione. Rem beatae repellat ex!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facere animi nesciunt qui accusamus, commodi quasi, repudiandae!</p>\r\n<p>Incidunt, quos accusantium eaque magnam perspiciatis sed sequi excepturi aliquid. Quo quos quod accusantium optio nihil ut excepturi, voluptatibus dolore temporibus. Obcaecati eius hic maiores ab, aspernatur ipsum eum adipisci repellendus. Et consequatur suscipit nulla obcaecati, repellat aspernatur iure! Omnis totam reiciendis et consequuntur.</p>\r\n<h3>Nulla placeat nesciunt suscipit?</h3>\r\n<p>Laudantium voluptatem reprehenderit fugit quibusdam magnam enim, quo aspernatur ea inventore molestias quasi veritatis placeat quas!</p>\r\n<h5>Autem atque minus quos facere?</h5>\r\n<p>At vitae numquam repudiandae. Quod neque nulla doloremque provident officiis. Numquam, non eos earum nulla, reiciendis voluptatem quam, reprehenderit dolore necessitatibus architecto aspernatur itaque iure animi id totam? Iusto incidunt earum quaerat, debitis!</p>", "Quod, suscipit.", "Repellendus aliquid, sunt! Ea maxime eligendi dicta, animi quas consequatur natus dolore placeat impedit, alias reiciendis. Veritatis consectetur veniam nisi porro.\r\n", "inherit", "closed", "closed", "", "35-revision-v1", "", "", "2016-07-12 01:54:29", "2016-07-12 01:54:29", "", "35", "http://localhost:8888/theming-basics/politics/35-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("195", "1", "2016-07-12 01:54:38", "2016-07-12 01:54:38", "<h2>Nostrum, facere.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Asperiores, earum. Quisquam nemo esse rem unde corporis, dolor delectus officia voluptates alias adipisci totam illum impedit quia libero rerum expedita exercitationem porro ex! Praesentium eveniet enim voluptatem perspiciatis explicabo quidem harum vitae nostrum dicta, ducimus.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Cupiditate reiciendis dolorum exercitationem ipsam aspernatur placeat necessitatibus!</p>\r\n<p>Pariatur perspiciatis libero porro, debitis. Rem maxime corrupti, cumque nisi architecto commodi reiciendis velit voluptates quae aspernatur minima facilis. Exercitationem ea, ex consequuntur nesciunt deleniti vitae accusantium, delectus error atque, quae eligendi soluta! Quasi totam corrupti veniam perferendis repellat ratione minus, perspiciatis sed harum!</p>\r\n<h3>Explicabo, incidunt itaque. Dolorem?</h3>\r\n<p>Eaque excepturi accusamus quidem quam ratione maxime porro impedit sint maiores id vero consequuntur, ex laudantium!</p>\r\n<h5>Tempora eius, veritatis incidunt nisi.</h5>\r\n<p>Consequuntur esse iste, consequatur est facilis soluta pariatur voluptatum repellendus minima? Non odio, quas, error est, nulla quia natus nesciunt officiis voluptas esse harum placeat numquam quasi. Et cumque repellat nulla eaque minus.</p>", "Molestiae. Debitis.", "Iste, voluptates praesentium, sunt deleniti voluptatem ipsum eaque ab itaque consequatur a, ex recusandae dolor at porro. Quibusdam qui accusantium cumque.", "inherit", "closed", "closed", "", "23-revision-v1", "", "", "2016-07-12 01:54:38", "2016-07-12 01:54:38", "", "23", "http://localhost:8888/theming-basics/politics/23-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("196", "1", "2016-07-12 01:54:45", "2016-07-12 01:54:45", "<h2>Temporibus, itaque!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quae ea eaque nulla est tempore, dolore laudantium at reprehenderit eius doloremque rem obcaecati ab accusantium, quisquam, cupiditate sequi hic! Quasi non autem debitis eveniet molestias quaerat, est reprehenderit optio totam necessitatibus temporibus tenetur, dolore consequatur!</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Debitis soluta, error explicabo atque nobis non neque.</p>\r\n<p>Accusamus praesentium laborum aut ullam provident veritatis excepturi quisquam reprehenderit obcaecati repudiandae. Porro iusto velit nulla unde cum minus saepe aliquid repellat a libero ullam reprehenderit praesentium sed laborum, doloribus fugiat natus perspiciatis veritatis minima? Officia provident delectus eum quas perferendis, ullam eligendi quos.</p>\r\n<h3>Aspernatur iste repudiandae obcaecati.</h3>\r\n<p>Consequuntur id eligendi provident, repellendus, ratione et facilis fuga. Ducimus consectetur cumque molestias nesciunt quas nam.</p>\r\n<h5>Autem soluta assumenda totam natus.</h5>\r\n<p>Voluptatum labore, ullam obcaecati odit natus maxime harum et debitis est, perspiciatis dolor rem facilis delectus! Expedita alias error blanditiis officiis officia. Cupiditate dolore est voluptas sapiente minus, molestiae nihil qui harum alias.</p>", "Facilis, dignissimos.", "Commodi harum quod sed minima ea voluptatem obcaecati modi adipisci quia eaque libero distinctio explicabo eius illum optio, voluptates dolore! Rerum!\r\n", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2016-07-12 01:54:45", "2016-07-12 01:54:45", "", "26", "http://localhost:8888/theming-basics/politics/26-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("197", "1", "2016-07-12 01:54:54", "2016-07-12 01:54:54", "<h2>Deleniti, molestiae.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Facilis voluptates molestias debitis ipsam similique eveniet qui blanditiis explicabo accusamus omnis eaque, nemo, cum facere. Dolor molestias tempora, assumenda eaque commodi, vero ea iusto nesciunt quod quos praesentium a iure rerum harum repudiandae totam. Reprehenderit.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Aliquam ea accusantium ex autem, quisquam animi itaque!</p>\r\n<p>Suscipit quis ad beatae ab voluptatum optio accusamus consequatur aut dolores nostrum ea adipisci, ipsam velit modi pariatur, nulla delectus odit veniam et dignissimos non ut iste doloremque tempore. Blanditiis ab aspernatur consequatur eaque rem dicta, reiciendis sed, repellendus, aliquam quaerat perferendis voluptates atque!</p>\r\n<h3>Illum ut fugit culpa.</h3>\r\n<p>Ab odio illum, dolorem, itaque porro quisquam impedit temporibus recusandae voluptatem, in quia eveniet vero libero.</p>\r\n<h5>Aspernatur nulla ut reprehenderit beatae.</h5>\r\n<p>Nesciunt quibusdam, consequatur unde minus dolorum ea, officia blanditiis, labore nulla velit illo nobis animi ab. Nostrum illo facere suscipit. Impedit ullam, omnis ab, ea aliquid nisi corporis, harum autem iure molestias odio.</p>", "Aliquid reiciendis.", "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolores sint blanditiis odio adipisci, quam veritatis perspiciatis eligendi. Nobis nemo optio culpa fugiat quas delectus nisi reiciendis, totam, debitis, aut vitae.", "inherit", "closed", "closed", "", "29-revision-v1", "", "", "2016-07-12 01:54:54", "2016-07-12 01:54:54", "", "29", "http://localhost:8888/theming-basics/politics/29-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("198", "1", "2016-07-12 01:55:03", "2016-07-12 01:55:03", "<h2>Voluptates, iure.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Ad ducimus laborum cumque, id, eligendi repellat deleniti. Deleniti odit impedit placeat in molestias ipsam nostrum voluptates explicabo, natus sed eos est quidem voluptatem modi vitae accusamus harum eaque quibusdam commodi quisquam! Iure, quam sunt amet.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quia eos dicta rem sequi, iste quidem quae.</p>\r\n<p>Veniam, doloremque in sed magni aliquam, explicabo, saepe ut ab asperiores deserunt ducimus. Mollitia et nobis maxime ea incidunt animi error assumenda illo ipsam veniam minima cupiditate porro minus ratione fugiat aliquam vero, harum blanditiis deleniti pariatur necessitatibus molestiae doloribus odit suscipit. Minus, praesentium?</p>\r\n<h3>Dolores numquam exercitationem itaque!</h3>\r\n<p>Sed eius, ipsa tempora quos delectus officiis dolores, dolor harum totam tenetur recusandae, quaerat? Unde, ab.</p>\r\n<h5>Obcaecati commodi sit, reiciendis aut.</h5>\r\n<p>Ea esse, rem corporis alias eum iusto. Perferendis aut, quibusdam asperiores rerum dolor dolores aliquam id quia quis eum at, non voluptates quaerat. Ullam maiores voluptates quo laborum possimus cum ab commodi tempora?</p>", "Tenetur, facilis!", "Beatae voluptate quod placeat eos sunt, eveniet pariatur vitae assumenda debitis officiis dolor illum, nihil error velit ipsum mollitia quaerat. Praesentium.", "inherit", "closed", "closed", "", "31-revision-v1", "", "", "2016-07-12 01:55:03", "2016-07-12 01:55:03", "", "31", "http://localhost:8888/theming-basics/politics/31-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("199", "1", "2016-07-12 01:55:12", "2016-07-12 01:55:12", "<h2>Sapiente, ipsum!</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Sed placeat, suscipit odit ea maiores ipsa blanditiis. Iusto nostrum nisi facere ratione molestias. Deleniti iste magni vel quae! Dolor blanditiis, incidunt temporibus et cumque maiores magnam architecto beatae! Tempore libero, voluptatum porro architecto ipsam vero.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Quasi sint quod veritatis quaerat beatae laboriosam quis!</p>\r\n<p>Aperiam cum debitis, nobis consequatur natus placeat tenetur sint. Quae dicta, voluptatum dolores libero excepturi molestias eius! Debitis nobis sapiente illum et ex, dicta vero corrupti dolore iure ab nihil blanditiis deleniti, quia nemo animi aliquam. Illum, esse. Nesciunt ipsam enim explicabo, maiores eligendi!</p>\r\n<h3>Ut, officiis sint. Enim.</h3>\r\n<p>Quos incidunt blanditiis eius ratione dignissimos ipsum perspiciatis, non atque dolor, hic suscipit quo itaque, doloribus.</p>\r\n<h5>Mollitia nam amet assumenda id!</h5>\r\n<p>Alias ex enim molestias eligendi vitae, reiciendis dicta tenetur asperiores recusandae repellendus architecto nostrum ea labore est quam voluptas sapiente odit, eius pariatur et ullam quo suscipit velit. Dicta doloribus fugit totam cum.</p>", "Dolor, voluptatibus?", "", "inherit", "closed", "closed", "", "15-revision-v1", "", "", "2016-07-12 01:55:12", "2016-07-12 01:55:12", "", "15", "http://localhost:8888/theming-basics/politics/15-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("200", "1", "2016-07-12 02:06:15", "2016-07-12 02:06:15", "<h2>Quos, veritatis.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Eaque temporibus, totam corporis voluptatibus voluptate accusamus repellendus, unde veniam magnam non sit magni molestiae ratione dolor velit expedita voluptas sequi ducimus nobis nam. Facere quod vel illum doloribus, rerum minima non harum. Pariatur, totam, officia.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Voluptate velit nam voluptates, accusamus perspiciatis! Maiores, ut?</p>\r\n<p>Qui accusantium sit dolorem nulla eum ut nemo praesentium ipsa quibusdam incidunt beatae obcaecati porro quisquam, voluptatum eveniet nostrum et, cumque iure aut. Asperiores molestiae maiores dolorum, commodi eaque necessitatibus autem dolore omnis quia, quos qui laborum eos. Accusamus facere architecto cupiditate adipisci ratione.</p>\r\n<h3>Culpa dolorum id, veritatis.</h3>\r\n<p>Ea hic dolorem tempora id doloribus. Minima libero quas nisi commodi, perferendis doloribus, possimus corporis rem!</p>\r\n<h5>Dicta, laborum ipsum tempore quibusdam?</h5>\r\n<p>Suscipit veritatis officiis hic commodi perspiciatis, autem illum nihil reprehenderit, possimus animi error provident quis alias, rem ipsa dolores eligendi ratione obcaecati fuga reiciendis unde, itaque quas. Officia praesentium quis vel iure hic.</p>", "Quibusdam enim.", "MESA was started by Randall Smith as a small repair shop which modified Fender Amplifiers, particularly the diminutive Fender Princeton. Smith\'s modifications gave the small amps much more input gain, making them much louder as well as creating a high-gain, distorted guitar tone. ", "inherit", "closed", "closed", "", "14-revision-v1", "", "", "2016-07-12 02:06:15", "2016-07-12 02:06:15", "", "14", "http://localhost:8888/theming-basics/politics/14-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("202", "1", "2016-07-12 02:06:39", "2016-07-12 02:06:39", "<h2>Voluptatum, minima.</h2>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Fugiat fugit veritatis veniam facere modi, inventore ipsum possimus quo quibusdam. Laborum possimus nulla ducimus quo ipsa provident dignissimos aliquam esse aut quae, ut fuga, dolorum quod expedita? Minima sint in laboriosam quia similique, dolor vitae.</p>\r\n<h3>Lorem ipsum dolor sit.</h3>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolor quae, blanditiis, reiciendis ab debitis repellat esse?</p>\r\n<p>Libero suscipit id dolore doloribus minima sequi fugit similique nulla, esse nobis nesciunt numquam saepe commodi velit repellendus eos illum molestiae ipsum quam! Neque voluptates atque aliquid impedit, cumque voluptatibus ab alias facere quasi odio maiores delectus commodi dolor blanditiis laudantium minima labore, tempora.</p>\r\n<h3>Optio odio blanditiis vitae.</h3>\r\n<p>Autem quam sint, aliquam ipsum beatae, dolorem, minima explicabo nobis earum cumque labore sapiente veniam! Fugit.</p>\r\n<h5>Illo praesentium, enim dolores eos.</h5>\r\n<p>Accusantium laborum molestiae, vitae neque cupiditate harum. Quasi molestias nemo fugiat excepturi modi facilis reprehenderit numquam hic, vitae ratione atque officiis blanditiis sint repudiandae maiores nisi minima autem in labore asperiores aspernatur at.</p>", "Placeat, est!", "Due to her pointed criticism of both the Leninist and the more moderate social democratic schools of socialism, Luxemburg has had a somewhat ambivalent reception among scholars and theorists of the political left.[3] Nonetheless, some have regarded Luxemburg and Liebknecht as martyrs of the socialist cause.", "inherit", "closed", "closed", "", "22-revision-v1", "", "", "2016-07-12 02:06:39", "2016-07-12 02:06:39", "", "22", "http://localhost:8888/theming-basics/politics/22-revision-v1/", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("204", "1", "2016-07-12 04:05:49", "2016-07-12 04:05:49", "", "lightsnow", "", "inherit", "closed", "closed", "", "lightsnow", "", "", "2016-07-12 04:05:49", "2016-07-12 04:05:49", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/lightsnow.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("205", "1", "2016-07-12 04:05:50", "2016-07-12 04:05:50", "", "gyro", "", "inherit", "closed", "closed", "", "gyro", "", "", "2016-07-12 04:05:50", "2016-07-12 04:05:50", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/gyro.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("207", "1", "2016-07-12 04:05:51", "2016-07-12 04:05:51", "", "geostairs", "", "inherit", "closed", "closed", "", "geostairs", "", "", "2016-07-12 04:05:51", "2016-07-12 04:05:51", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/geostairs.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("210", "1", "2016-07-12 04:05:54", "2016-07-12 04:05:54", "", "docksteps", "", "inherit", "closed", "closed", "", "docksteps", "", "", "2016-07-12 04:05:54", "2016-07-12 04:05:54", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/docksteps.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("211", "1", "2016-07-12 04:05:55", "2016-07-12 04:05:55", "", "SampleImage19", "", "inherit", "closed", "closed", "", "sampleimage19", "", "", "2016-07-12 04:05:55", "2016-07-12 04:05:55", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage19.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("212", "1", "2016-07-12 04:05:56", "2016-07-12 04:05:56", "", "SampleImage18", "", "inherit", "closed", "closed", "", "sampleimage18", "", "", "2016-07-12 04:05:56", "2016-07-12 04:05:56", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage18.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("214", "1", "2016-07-12 04:05:58", "2016-07-12 04:05:58", "", "SampleImage16", "", "inherit", "closed", "closed", "", "sampleimage16", "", "", "2016-07-12 04:05:58", "2016-07-12 04:05:58", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage16.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("215", "1", "2016-07-12 04:05:58", "2016-07-12 04:05:58", "", "SampleImage14", "", "inherit", "closed", "closed", "", "sampleimage14", "", "", "2016-07-12 04:05:58", "2016-07-12 04:05:58", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage14.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("216", "1", "2016-07-12 04:05:59", "2016-07-12 04:05:59", "", "SampleImage13", "", "inherit", "closed", "closed", "", "sampleimage13", "", "", "2016-07-12 04:05:59", "2016-07-12 04:05:59", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage13.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("218", "1", "2016-07-12 04:06:01", "2016-07-12 04:06:01", "", "SampleImage10", "", "inherit", "closed", "closed", "", "sampleimage10", "", "", "2016-07-12 04:06:01", "2016-07-12 04:06:01", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage10.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("219", "1", "2016-07-12 04:06:02", "2016-07-12 04:06:02", "", "SampleImage09", "", "inherit", "closed", "closed", "", "sampleimage09", "", "", "2016-07-12 04:06:02", "2016-07-12 04:06:02", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage09.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("220", "1", "2016-07-12 04:06:03", "2016-07-12 04:06:03", "", "SampleImage08", "", "inherit", "closed", "closed", "", "sampleimage08", "", "", "2016-07-12 04:06:03", "2016-07-12 04:06:03", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage08.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("221", "1", "2016-07-12 04:06:04", "2016-07-12 04:06:04", "", "SampleImage06", "", "inherit", "closed", "closed", "", "sampleimage06", "", "", "2016-07-12 04:06:04", "2016-07-12 04:06:04", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage06.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("222", "1", "2016-07-12 04:06:05", "2016-07-12 04:06:05", "", "SampleImage04", "", "inherit", "closed", "closed", "", "sampleimage04", "", "", "2016-07-12 04:06:05", "2016-07-12 04:06:05", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage04.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("223", "1", "2016-07-12 04:06:06", "2016-07-12 04:06:06", "", "SampleImage05", "", "inherit", "closed", "closed", "", "sampleimage05", "", "", "2016-07-12 04:06:06", "2016-07-12 04:06:06", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage05.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("224", "1", "2016-07-12 04:06:07", "2016-07-12 04:06:07", "", "SampleImage02", "", "inherit", "closed", "closed", "", "sampleimage02", "", "", "2016-07-12 04:06:07", "2016-07-12 04:06:07", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage02.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("226", "1", "2016-07-12 04:06:08", "2016-07-12 04:06:08", "", "SampleImage01", "", "inherit", "closed", "closed", "", "sampleimage01", "", "", "2016-07-12 04:06:08", "2016-07-12 04:06:08", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage01.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("227", "1", "2016-07-12 04:06:09", "2016-07-12 04:06:09", "", "NewYork10", "", "inherit", "closed", "closed", "", "newyork10", "", "", "2016-07-12 04:06:09", "2016-07-12 04:06:09", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/NewYork10.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("228", "1", "2016-07-12 04:06:10", "2016-07-12 04:06:10", "", "NewYork09", "", "inherit", "closed", "closed", "", "newyork09", "", "", "2016-07-12 04:06:10", "2016-07-12 04:06:10", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/NewYork09.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("229", "1", "2016-07-12 04:06:11", "2016-07-12 04:06:11", "", "NewYork08", "", "inherit", "closed", "closed", "", "newyork08", "", "", "2016-07-12 04:06:11", "2016-07-12 04:06:11", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/NewYork08.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("230", "1", "2016-07-12 04:06:12", "2016-07-12 04:06:12", "", "NewYork07", "", "inherit", "closed", "closed", "", "newyork07", "", "", "2016-07-12 04:06:12", "2016-07-12 04:06:12", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/NewYork07.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("231", "1", "2016-07-12 04:06:13", "2016-07-12 04:06:13", "", "NewYork05", "", "inherit", "closed", "closed", "", "newyork05", "", "", "2016-07-12 04:06:13", "2016-07-12 04:06:13", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/NewYork05.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("232", "1", "2016-07-12 04:06:14", "2016-07-12 04:06:14", "", "NewYork03", "", "inherit", "closed", "closed", "", "newyork03", "", "", "2016-07-12 04:06:14", "2016-07-12 04:06:14", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/NewYork03.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("234", "1", "2016-07-12 05:56:39", "2016-07-12 05:56:39", "", "SampleImage17", "", "inherit", "closed", "closed", "", "sampleimage17", "", "", "2016-07-12 05:56:39", "2016-07-12 05:56:39", "", "0", "http://localhost:8888/theming-basics/wp-content/uploads/2016/07/SampleImage17.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("235", "1", "2017-02-24 19:32:03", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "closed", "closed", "", "", "", "", "2017-02-24 19:32:03", "0000-00-00 00:00:00", "", "0", "http://localhost:8888/theming-basics/?p=235", "0", "post", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("11", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("11", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("11", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("11", "11", "0");
INSERT INTO `wp_term_relationships` VALUES("11", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("11", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("11", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "28", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "29", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "30", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "31", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "32", "0");
INSERT INTO `wp_term_relationships` VALUES("12", "33", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("14", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("15", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "11", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("16", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("17", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("18", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "11", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("20", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("22", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "11", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "34", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "35", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("24", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "21", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "22", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "23", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "24", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "25", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "26", "0");
INSERT INTO `wp_term_relationships` VALUES("26", "27", "0");
INSERT INTO `wp_term_relationships` VALUES("27", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("27", "34", "0");
INSERT INTO `wp_term_relationships` VALUES("27", "35", "0");
INSERT INTO `wp_term_relationships` VALUES("27", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("27", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("27", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "34", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "35", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("28", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "28", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "29", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "30", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "31", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "32", "0");
INSERT INTO `wp_term_relationships` VALUES("29", "33", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "15", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "16", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "17", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "18", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "19", "0");
INSERT INTO `wp_term_relationships` VALUES("30", "20", "0");
INSERT INTO `wp_term_relationships` VALUES("31", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("31", "34", "0");
INSERT INTO `wp_term_relationships` VALUES("31", "35", "0");
INSERT INTO `wp_term_relationships` VALUES("31", "36", "0");
INSERT INTO `wp_term_relationships` VALUES("31", "37", "0");
INSERT INTO `wp_term_relationships` VALUES("31", "38", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "28", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "29", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "30", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "31", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "32", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "33", "0");
INSERT INTO `wp_term_relationships` VALUES("35", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("35", "9", "0");
INSERT INTO `wp_term_relationships` VALUES("35", "10", "0");
INSERT INTO `wp_term_relationships` VALUES("35", "11", "0");
INSERT INTO `wp_term_relationships` VALUES("35", "12", "0");
INSERT INTO `wp_term_relationships` VALUES("35", "13", "0");
INSERT INTO `wp_term_relationships` VALUES("35", "14", "0");
INSERT INTO `wp_term_relationships` VALUES("137", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("138", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("139", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("140", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("141", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("142", "7", "0");
INSERT INTO `wp_term_relationships` VALUES("143", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("144", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("145", "8", "0");
INSERT INTO `wp_term_relationships` VALUES("146", "8", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "category", "\"The people who cast the votes decide nothing. The people who count the votes decide everything. \"\r\n\r\nJoseph Stalin\r\n", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "category", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "category", "\"Children are the vessels into which adults pour their poison.\"\r\n\r\nSalman Rushdie", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "category", "\"A waffle is like a pancake with a syrup trap.\"\r\n\r\nMitch Hedberg", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "category", "\"It\'s the movies that have really been running things in America ever since they were invented. They show you what to do, how to do it, when to do it, how to feel about it, and how to look how you feel about it.\"\r\n\r\nAndy Warhol", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("7", "7", "nav_menu", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("8", "8", "nav_menu", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("9", "9", "post_tag", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("10", "10", "post_tag", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("11", "11", "post_tag", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("12", "12", "post_tag", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("13", "13", "post_tag", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("14", "14", "post_tag", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("15", "15", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("16", "16", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("17", "17", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("18", "18", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("19", "19", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("20", "20", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("21", "21", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("22", "22", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("23", "23", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("24", "24", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("25", "25", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("26", "26", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("27", "27", "post_tag", "", "0", "6");
INSERT INTO `wp_term_taxonomy` VALUES("28", "28", "post_tag", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("29", "29", "post_tag", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("30", "30", "post_tag", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("31", "31", "post_tag", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("32", "32", "post_tag", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("33", "33", "post_tag", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("34", "34", "post_tag", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("35", "35", "post_tag", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("36", "36", "post_tag", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("37", "37", "post_tag", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("38", "38", "post_tag", "", "0", "4");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Uncategorized", "uncategorized", "0");
INSERT INTO `wp_terms` VALUES("2", "Politics", "politics", "0");
INSERT INTO `wp_terms` VALUES("3", "Sports", "sports", "0");
INSERT INTO `wp_terms` VALUES("4", "Culture", "culture", "0");
INSERT INTO `wp_terms` VALUES("5", "Food", "food", "0");
INSERT INTO `wp_terms` VALUES("6", "Movies", "movies", "0");
INSERT INTO `wp_terms` VALUES("7", "Main Menu", "main-menu", "0");
INSERT INTO `wp_terms` VALUES("8", "Social Menu", "social-menu", "0");
INSERT INTO `wp_terms` VALUES("9", "cat", "cat", "0");
INSERT INTO `wp_terms` VALUES("10", "dog", "dog", "0");
INSERT INTO `wp_terms` VALUES("11", "chicken", "chicken", "0");
INSERT INTO `wp_terms` VALUES("12", "newt", "newt", "0");
INSERT INTO `wp_terms` VALUES("13", "salamandar", "salamandar", "0");
INSERT INTO `wp_terms` VALUES("14", "fish", "fish", "0");
INSERT INTO `wp_terms` VALUES("15", "india", "india", "0");
INSERT INTO `wp_terms` VALUES("16", "pakistan", "pakistan", "0");
INSERT INTO `wp_terms` VALUES("17", "china", "china", "0");
INSERT INTO `wp_terms` VALUES("18", "canada", "canada", "0");
INSERT INTO `wp_terms` VALUES("19", "ireland", "ireland", "0");
INSERT INTO `wp_terms` VALUES("20", "finland", "finland", "0");
INSERT INTO `wp_terms` VALUES("21", "distortion", "distortion", "0");
INSERT INTO `wp_terms` VALUES("22", "delay", "delay", "0");
INSERT INTO `wp_terms` VALUES("23", "chorus", "chorus", "0");
INSERT INTO `wp_terms` VALUES("24", "fuzz", "fuzz", "0");
INSERT INTO `wp_terms` VALUES("25", "overdrive", "overdrive", "0");
INSERT INTO `wp_terms` VALUES("26", "tremolo", "tremolo", "0");
INSERT INTO `wp_terms` VALUES("27", "wah wah", "wah-wah", "0");
INSERT INTO `wp_terms` VALUES("28", "joyce", "joyce", "0");
INSERT INTO `wp_terms` VALUES("29", "camus", "camus", "0");
INSERT INTO `wp_terms` VALUES("30", "acker", "acker", "0");
INSERT INTO `wp_terms` VALUES("31", "cixous", "cixous", "0");
INSERT INTO `wp_terms` VALUES("32", "califia", "califia", "0");
INSERT INTO `wp_terms` VALUES("33", "carter", "carter", "0");
INSERT INTO `wp_terms` VALUES("34", "Araya", "araya", "0");
INSERT INTO `wp_terms` VALUES("35", "Hanneman", "hanneman", "0");
INSERT INTO `wp_terms` VALUES("36", "King", "king", "0");
INSERT INTO `wp_terms` VALUES("37", "Holt", "holt", "0");
INSERT INTO `wp_terms` VALUES("38", "Lombardo", "lombardo", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "kevinmcmillan");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "Langara &amp; Emily Carr Employee. Staff writer.");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("12", "1", "dismissed_wp_pointers", "");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("14", "1", "session_tokens", "a:1:{s:64:\"873fc4cb18a62fa4085b841d5fb58a2f3dec94942c62dad95f1d731fe96afd96\";a:4:{s:10:\"expiration\";i:1488137523;s:2:\"ip\";s:3:\"::1\";s:2:\"ua\";s:120:\"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36\";s:5:\"login\";i:1487964723;}}");
INSERT INTO `wp_usermeta` VALUES("15", "1", "wp_dashboard_quick_press_last_post_id", "235");
INSERT INTO `wp_usermeta` VALUES("16", "1", "wp_user-settings", "editor=html&libraryContent=browse&posts_list_mode=list");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_user-settings-time", "1467611061");
INSERT INTO `wp_usermeta` VALUES("18", "1", "closedpostboxes_post", "a:3:{i:0;s:9:\"formatdiv\";i:1;s:11:\"categorydiv\";i:2;s:16:\"tagsdiv-post_tag\";}");
INSERT INTO `wp_usermeta` VALUES("19", "1", "metaboxhidden_post", "a:7:{i:0;s:12:\"revisionsdiv\";i:1;s:13:\"trackbacksdiv\";i:2;s:10:\"postcustom\";i:3;s:16:\"commentstatusdiv\";i:4;s:11:\"commentsdiv\";i:5;s:7:\"slugdiv\";i:6;s:9:\"authordiv\";}");
INSERT INTO `wp_usermeta` VALUES("20", "1", "meta-box-order_post", "a:3:{s:4:\"side\";s:61:\"submitdiv,postimagediv,formatdiv,categorydiv,tagsdiv-post_tag\";s:6:\"normal\";s:96:\"revisionsdiv,postexcerpt,trackbacksdiv,postcustom,commentstatusdiv,commentsdiv,slugdiv,authordiv\";s:8:\"advanced\";s:0:\"\";}");
INSERT INTO `wp_usermeta` VALUES("21", "1", "screen_layout_post", "2");
INSERT INTO `wp_usermeta` VALUES("22", "1", "managenav-menuscolumnshidden", "a:4:{i:0;s:11:\"link-target\";i:1;s:15:\"title-attribute\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";}");
INSERT INTO `wp_usermeta` VALUES("23", "1", "metaboxhidden_nav-menus", "a:2:{i:0;s:12:\"add-post_tag\";i:1;s:15:\"add-post_format\";}");
INSERT INTO `wp_usermeta` VALUES("24", "2", "nickname", "walterwhite");
INSERT INTO `wp_usermeta` VALUES("25", "2", "first_name", "Walter");
INSERT INTO `wp_usermeta` VALUES("26", "2", "last_name", "White");
INSERT INTO `wp_usermeta` VALUES("27", "2", "description", "Famed for cooking skill. Staff writer.");
INSERT INTO `wp_usermeta` VALUES("28", "2", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("29", "2", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("30", "2", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("31", "2", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("32", "2", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("33", "2", "wp_capabilities", "a:1:{s:6:\"author\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("34", "2", "wp_user_level", "2");
INSERT INTO `wp_usermeta` VALUES("35", "2", "dismissed_wp_pointers", "");
INSERT INTO `wp_usermeta` VALUES("36", "3", "nickname", "jessiepinkman");
INSERT INTO `wp_usermeta` VALUES("37", "3", "first_name", "Jessie");
INSERT INTO `wp_usermeta` VALUES("38", "3", "last_name", "Pinkman");
INSERT INTO `wp_usermeta` VALUES("39", "3", "description", "Walter\'s cooking partner and former student.  Staff writer.");
INSERT INTO `wp_usermeta` VALUES("40", "3", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("41", "3", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("42", "3", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("43", "3", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("44", "3", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("45", "3", "wp_capabilities", "a:1:{s:6:\"author\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("46", "3", "wp_user_level", "2");
INSERT INTO `wp_usermeta` VALUES("47", "3", "dismissed_wp_pointers", "");
INSERT INTO `wp_usermeta` VALUES("48", "4", "nickname", "saulgoodman");
INSERT INTO `wp_usermeta` VALUES("49", "4", "first_name", "Saul");
INSERT INTO `wp_usermeta` VALUES("50", "4", "last_name", "Goodman");
INSERT INTO `wp_usermeta` VALUES("51", "4", "description", "Crooked strip mall lawyer.  Staff writer.");
INSERT INTO `wp_usermeta` VALUES("52", "4", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("53", "4", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("54", "4", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("55", "4", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("56", "4", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("57", "4", "wp_capabilities", "a:1:{s:6:\"author\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("58", "4", "wp_user_level", "2");
INSERT INTO `wp_usermeta` VALUES("59", "4", "dismissed_wp_pointers", "");
INSERT INTO `wp_usermeta` VALUES("60", "5", "nickname", "mikeehrmantraut");
INSERT INTO `wp_usermeta` VALUES("61", "5", "first_name", "Mike");
INSERT INTO `wp_usermeta` VALUES("62", "5", "last_name", "Erhmantraut");
INSERT INTO `wp_usermeta` VALUES("63", "5", "description", "Gus\' fixer and hitman. Staff writer.");
INSERT INTO `wp_usermeta` VALUES("64", "5", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("65", "5", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("66", "5", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("67", "5", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("68", "5", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("69", "5", "wp_capabilities", "a:1:{s:6:\"author\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("70", "5", "wp_user_level", "2");
INSERT INTO `wp_usermeta` VALUES("71", "5", "dismissed_wp_pointers", "");
INSERT INTO `wp_usermeta` VALUES("72", "1", "nav_menu_recently_edited", "8");
INSERT INTO `wp_usermeta` VALUES("73", "1", "edit_post_per_page", "40");
INSERT INTO `wp_usermeta` VALUES("74", "1", "wp_media_library_mode", "list");
INSERT INTO `wp_usermeta` VALUES("75", "1", "upload_per_page", "40");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "kevinmcmillan", "$P$B.DBDsTDdIxRAXRlYt3eZbUloYkc/k/", "kevinmcmillan", "kmcmillan@langara.bc.ca", "", "2016-07-03 19:28:11", "", "0", "kevinmcmillan");
INSERT INTO `wp_users` VALUES("2", "walterwhite", "$P$BxYBidPlhPq6RTAydt0AKih8znIck/1", "walterwhite", "walterwhite@kevinmc.ca", "", "2016-07-03 20:49:41", "", "0", "Walter White");
INSERT INTO `wp_users` VALUES("3", "jessiepinkman", "$P$BGXVUXJWfz6nTYc0RDcBmYZuGkiP8U/", "jessiepinkman", "km1@kevinmc.ca", "", "2016-07-03 20:50:40", "", "0", "Jessie Pinkman");
INSERT INTO `wp_users` VALUES("4", "saulgoodman", "$P$B4oOdkfiVE379VXTyta2qE93rwtMea1", "saulgoodman", "saulgoodman@kevinmc.ca", "", "2016-07-03 20:51:13", "", "0", "Saul Goodman");
INSERT INTO `wp_users` VALUES("5", "mikeehrmantraut", "$P$BAIHc9sY161XVJ4YzWG8RjtFvSzTTp0", "mikeehrmantraut", "mikeehrmantraut@kevinmc.ca", "", "2016-07-03 20:51:50", "", "0", "Mike Erhmantraut");

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2017-02-24 19:36:38*/
/* DUPLICATOR_MYSQLDUMP_EOF */
